<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>Login Form</title>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
<style>
  body {
    font-family: Arial, sans-serif;
    background-color: lightgray;
    margin: 0;
    padding: 0;
    display: flex;
    justify-content: center;
    align-items: center;
    height: 100vh;
    background-image: url('SmartAccounting2.png'); /* Specify the URL of your background image */
    background-size: cover; /* Cover the entire viewport */
    background-position: center; /* Center the background image */
  }
  .login-container {
    text-align: center;
    background-color: rgba(255, 255, 255, 0.8); /* Add transparency */
    padding: 30px;
    border-radius: 10px;
    box-shadow: 0px 0px 10px 0px rgba(0,0,0,0.2);
    max-width: 400px; /* Set maximum width */
    width: 100%; /* Take full width */
    background-color:#fff;
    height: 87vh; /* Reduced height */
  }
  .login-container img {
    height: 300px; /* Adjusted height */
    width: 300px; /* Adjusted width */
    margin-bottom: 20px;
  }
  .login-container h2 {
    margin-bottom: 20px;
    padding-top: 10px; /* Added padding to the top */
    margin-top: -120px; /* Adjusted margin to move the text up */
    color: #f3a02a; /* Adjusted text color */
  }
  .login-form {
    max-width: 300px; /* Adjusted maximum width */
    margin: 0 auto; /* Center align the form */
  }
  .input-container {
    position: relative;
    margin-bottom: 15px;
  }
.input-container {
  display: -ms-flexbox; /* IE10 */
  display: flex;
  width: 100%;
  margin-bottom: 15px;
}

.icon {
  padding: 10px;
  background: #2d2860;
  color: #f3a02a;
  min-width: 50px;
  text-align: center;
  border:2px solid #f3a02a;
 
}

.input-field {
  width: 100%;
  padding: 10px;
  outline: none;
  border:2px solid #2d2860;

}

.input-field:focus {
  border: 2px solid #f3a02a;
}

/* Set a style for the submit button */
.btn {
  background-color: #2d2860;
  color: #f3a02a;
  padding: 15px 20px;
  border: none;
  cursor: pointer;
  width: 100%;
  opacity: 0.9;
  border:2px solid #f3a02a;
  border-radius:10px;
}

.btn:hover {
  opacity: 1;
}
.forgot-password {
    float: left;
    text-align: left;
    margin-top: 10px; /* Adjusted margin */
    margin-bottom: 20px; /* Adjusted margin */
    width: 100%;
    color: #666; /* Color of the forgot password text */
  }
  .forgot-password a {
    color: #2d2860; /* Link color */
    text-decoration: none;
    transition: color 0.3s ease;
  }
  .forgot-password a:hover {
    color: #1e1a41; /* Link color on hover */
  }
  .centered {
    text-align: center;
	padding-bottom:20px;
}
</style>
</head>
<body>
  <div class="login-container">
    <img src="SmartAccountingLogo.png" alt="DOMSTAR">
    <h2>DOMSTAR</h2>
    <div class="login-form">
      <form action="/action_page.php" method="post">
        <div class="input-container">
			<i class="fa fa-envelope icon"></i>
			<input class="input-field" type="text" placeholder="Email (optional)" name="email">
		</div>
        <div class="input-container">
          <i class="fa fa-phone icon"></i>
          <input class="input-field" type="text" placeholder="Tel. number format 255713333333" name="telNumber" required>
        </div>
        <button type="submit" class="btn"><b>Submit</b></button>
		<p class ="centered">&copy; <span style="color:#2d2860;font-weight:bold;">2024 SAFCO LTD</span> - All rights reserved.</p><br><br> <!-- Adjusted padding-top -->
      </form>
    </div>
 
  </div>
</body>
</html>
