<?php
require_once '../../db/connection.php';
if (isset($_POST['finish'])) {
    $branchno = $_POST['branchno'];
    $name = $_POST['name'];
    $mkoa = $_POST['mkoa'];

    if ($name == '' || $mkoa == '' || $branchno == '') {
        $err = "<p class='alert alert-danger'>Please fill in all fields!</p>";
    } else {
        // Establish a PDO connection (replace with your own connection details)
        
        try {
            $pdo = new PDO($dsn, $username, $password);
            $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

            $stmt = $pdo->prepare("SELECT * FROM branch WHERE branchno = :branchno");
            $stmt->bindParam(':branchno', $branchno);
            $stmt->execute();
            $num = $stmt->rowCount();

            if ($num == 0) {
                $stmt = $pdo->prepare("INSERT INTO branch VALUES(NULL, :name, :mkoa, :branchno)");
                $stmt->bindParam(':name', $name);
                $stmt->bindParam(':mkoa', $mkoa);
                $stmt->bindParam(':branchno', $branchno);
                $success = $stmt->execute();

                if ($success) {
                    $err = "<p class='alert alert-success'>Data successfully recorded!</p>";
                } else {
                    $err = "<p class='alert alert-danger'>Something went wrong! Contact system administrator.</p>";
                }
            } else {
                $err = "<p class='alert alert-danger'>This branch already exists in our database. Please use a different branch number.</p>";
            }
        } catch (PDOException $e) {
            $err = "<p class='alert alert-danger'>Database Error: " . $e->getMessage() . "</p>";
        }
    }
}
