<?php
if(isset($_POST['submit'])){
    // Ensure that the required fields are not empty
    if(!empty($_POST['leave_type']) && !empty($_POST['leave_start_date']) && !empty($_POST['leave_end_date']) && !empty($_POST['leave_message'])) {
        // Escape user inputs for security
        $leave_type = mysqli_real_escape_string($con, $_POST['leave_type']);
        $other_leave_type_input = mysqli_real_escape_string($con, $_POST['other_leave_type_input']);
        $leave_start_date = mysqli_real_escape_string($con, $_POST['leave_start_date']);
        $leave_end_date = mysqli_real_escape_string($con, $_POST['leave_end_date']);
        $leave_days_requested = mysqli_real_escape_string($con, $_POST['leave_days_requested']);
        $leave_message = mysqli_real_escape_string($con, $_POST['leave_message']);
        $attachment = ''; // We're not handling file uploads in this example
        $branch = $_SESSION['Branch'];

        // Insert data into the database
        $insertQuery = mysqli_query($con, "INSERT INTO LeaveManagement (leave_type, other_leave_type, start_date, end_date, leave_days, leave_message, attachment, Branch) 
                        VALUES ('$leave_type', '$other_leave_type_input', '$leave_start_date', '$leave_end_date', '$leave_days_requested', '$leave_message', '$attachment', '$branch')");

        // Check if the insertion was successful
        if($insertQuery){
            $err = '<div class="alert alert-success" role="alert">
                <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                <strong>Well done!</strong> You successfully inserted data.
            </div>';
        } else {
            // Handle insertion failure
            $err = '<div class="alert alert-danger" role="alert">
                <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                <strong>Wrong!</strong> There is something wrong with the database. Please contact your system administrator.
            </div>';
        }
    } else {
        // Handle case where required fields are empty
        $err = '<div class="alert alert-danger" role="alert">
            <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
            <strong>Error!</strong> Please fill out all required fields.
        </div>';
    }
}
?>

<!-- CSS INCLUDE -->        
        <link rel="stylesheet" type="text/css" id="theme" href="css/theme-default.css"/>
		
		<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.9.0/css/bootstrap-datepicker.min.css">
		<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.9.0/js/bootstrap-datepicker.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.9.0/locales/bootstrap-datepicker.en-GB.min.js"></script>

        <!-- EOF CSS INCLUDE -->    
 <div class="col-md-9">

                            <!-- START TIMELINE -->
                        <div class="row">
                           <div class="col-md-12">

                            <div class="panel panel-default">
							<div class="panel-heading">
                                    <h3 class="panel-title" style="color: rgb(174, 169, 169);"><strong>Leave list</strong></h3>
                                    <ul class="panel-controls">
                                        <li><a href="#" class="panel-remove"><span class="fa fa-times"></span></a></li>
                                    </ul>
                                </div>
							<div class="panel-body">
                                    <div class="table-responsive">
									<?php if ( $_SESSION['role'] == '2' ) { ?>
                                        
                                         <table id="allleaves" class="table datatable">
										<thead>
											<tr>
												<th>#</th>
												<th>EMP CODE</th>
												<th>EMP NAME</th>
												<th>SUBJECT</th>
												<th>DATE FROM</th>
												<th>DATE TO</th>
												<th>REASON FOR LEAVE</th>
												<th>TYPE</th>
												<th>STATUS</th>
												<th>ACTIONS</th>
											</tr>
										</thead>
										<tbody>
                                                <tr>
                                                    <td>1</td>
                                                    <td>PF001</td>
                                                    <td>YUSTINO NYENDEZA</td>
                                                    <td>Leave application</td>
                                                    <td>20/03/2024</td>
                                                    <td>20/04/2024</td>
                                                    <td>I would like to request for annual leave</td>
                                                    <td>Annual Leave</td>
                                                    <td>Approved</td>
                                                    <td>Edit</td>
                                                </tr>
                                                
                                            </tbody>
										</table>
										<?php } else { ?>
						<div class="col-lg-4">
							<div class="box">
								<div class="box-header">
									<h3 class="box-title">Apply for Leave</h3>
								</div>
								<div class="box-body">
								    
<div id="success-alert" class="alert alert-success alert-dismissible fade in" style="display:none;">
 
    <strong>Success!</strong> Leave request has been successfully submitted.
</div>

<!-- Add the success sound -->
<audio id="success-sound" src="" preload="auto"></audio>
									<!-- Update the form fields for leave application -->
<form id="leave-form" method="post" role="form" data-toggle="validator" action="">
    <?php echo $err; ?>
    <div class="form-group">
        <label for="leave_type">Leave Type</label>
        <select class="form-control" name="leave_type" id="leave_type" required>
            <option value="">Please choose</option>
            <option value="Annual Leave">Annual Leave</option>
            <option value="Sick Leave">Sick Leave</option>
            <option value="Maternity Leave">Maternity Leave</option>
            <option value="Paternity Leave">Paternity Leave</option>
            <option value="Compassionate Leave">Compassionate Leave</option>
            <option value="Study Leave">Study Leave</option>
            <option value="Emergency Leave">Emergency Leave</option>
            <option value="Other">Other</option>
            <!-- Add more leave types relevant to HR policies in Tanzania as needed -->
        </select>
    </div>
	<!-- Other leave type input field -->
    <div class="form-group" id="other_leave_type" style="display: none;">
        <label for="other_leave_type_input">Specify Other Leave Type</label>
        <input type="text" class="form-control" name="other_leave_type_input" id="other_leave_type_input" required />
    </div>
  <div class="form-group">
    <label for="leave_start_date">Leave Start Date</label>
    <div class="input-group date">
        <input type="text" class="form-control datepicker" name="leave_start_date" id="leave_start_date" required />
        <span class="input-group-addon">
            <span class="glyphicon glyphicon-calendar"></span>
        </span>
    </div>
</div>
<div class="form-group">
    <label for="leave_end_date">Leave End Date</label>
    <div class="input-group date">
        <input type="text" class="form-control datepicker" name="leave_end_date" id="leave_end_date" required />
        <span class="input-group-addon">
            <span class="glyphicon glyphicon-calendar"></span>
        </span>
    </div>
</div>

	<div class="form-group">
		<label for="leave_days_requested">Number of Days Requested</label>
		<input type="text" class="form-control" name="leave_days_requested" style="color:black" id="leave_days_requested" readonly />
	</div>
    <div class="form-group">
        <label for="leave_message">Reason for Leave request</label>
        <textarea class="form-control" name="leave_message" id="leave_message" rows="10" required></textarea>
    </div>
	<div class="form-group">
    <label for="attachment">Attachment</label>
    <input type="file" class="form-control-file" id="attachment" name="attachment">
    <small class="form-text text-muted">Attach any supporting documents (optional)</small>
</div>
    
    <div class="form-group">
        <button type="submit" class="btn btn-primary" id="submit_button" name="submit">Apply for Leave</button>
    </div>
</form>

								</div>
							</div>
						</div>
						<div class="col-lg-8">
							<div class="box">
								<div class="box-header">
									<h3 class="box-title">My Leaves</h3>
								</div>
								<div class="box-body">
									<table id="myleaves" class="table table-bordered table-stripe">
										<thead>
											<tr>
												<th>#</th>
												<th>SUBJECT</th>
												<th>DATE FROM</th>
												<th>DATE TO</th>
												<th>REASON FOR LEAVE</th>
												<th>TYPE</th>
												<th>STATUS</th>
											</tr>
										</thead>
										<tbody>
											<tr>
												<td>1</td>
												<td>Leave application</td>
												<td>20/03/2024</td>
												<td>20/04/2024</td>
												<td>I would like to request for annual Leave</td>
												<td>Annual</td>
												<td>Approved</td>
											</tr>
										</tbody>
									</table>
								</div>
							</div>
						</div>
					<?php } ?>
                            <!-- END DEFAULT DATATABLE -->

                <!-- PAGE CONTENT WRAPPER -->                                
            </div>    
            <!-- END PAGE CONTENT -->
        </div>
        <!-- END PAGE CONTAINER -->       
        </div>
		</div>
    
		</div>
        <!-- END MESSAGE BOX-->

        <!-- START PRELOADS -->
        <audio id="audio-alert" src="audio/alert.mp3" preload="auto"></audio>
        <audio id="audio-fail" src="audio/fail.mp3" preload="auto"></audio>
        <!-- END PRELOADS -->                       
        
    <!-- START SCRIPTS -->

 

	<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.9.0/js/bootstrap-datepicker.min.js"></script>

<script>
$(document).ready(function(){
    // Function to calculate the number of days requested
    function calculateDaysRequested() {
        var startDate = $('#leave_start_date').datepicker('getDate');
        var endDate = $('#leave_end_date').datepicker('getDate');
        
        // Calculate the difference in days between the start and end dates
        var daysDifference = Math.ceil((endDate - startDate) / (1000 * 60 * 60 * 24));
        
        // Update the value of the leave days requested input field
        $('#leave_days_requested').val(daysDifference);
    }

    // Datepicker initialization
    $('#leave_start_date, #leave_end_date').datepicker({
        format: 'dd/mm/yyyy',
        autoclose: true,
        todayHighlight: true
    });
    
    // Trigger the calculation when the leave end date changes
    $('#leave_end_date').change(function() {
        calculateDaysRequested();
    });

    // Preload the audio file
    var audio = document.getElementById('audio-alert');
    audio.addEventListener('canplaythrough', function() {
        console.log('Audio loaded successfully');
    });

    // Form submission handling
    $('#leave-form').submit(function(e){
    e.preventDefault();
    console.log('Form submitted');
        
        // Perform AJAX or form submission here
        
        // Show success alert
        $('#success-alert').fadeIn(500).delay(2500).fadeOut(500);
        
        // Play success sound
        audio.play();
    });

    // Function to show/hide other_leave_type input field
    $('#leave_type').change(function(){
        var selectedOption = $(this).val();
        if(selectedOption === "Other") {
            $('#other_leave_type').show();
        } else {
            $('#other_leave_type').hide();
        }
    });
});
</script>
