<?php
if (session_status() === PHP_SESSION_NONE) {
    session_start(); // Start session if not already started
}

require_once '../db/db.php';
error_reporting(E_ALL);
ini_set('display_errors', 1);

$err = ""; // Initialize error message variable

if(isset($_POST['submit'])){
    $payhead_name = mysqli_real_escape_string($con, $_POST['payhead_name']);
    $payhead_desc = mysqli_real_escape_string($con, $_POST['payhead_desc']);
    $payhead_type = mysqli_real_escape_string($con, $_POST['payhead_type']);
    $branch = $_SESSION['Branch'];
    
    $product = mysqli_query($con, "SELECT * FROM Payslip_Items WHERE Name = '$payhead_name'");
    $num = mysqli_num_rows($product);

    if($num == 0){
        $insertQuery = mysqli_query($con, "INSERT INTO Payslip_Items (Name, Description, Itype, Branch) 
        VALUES ('$payhead_name','$payhead_desc','$payhead_type','$branch')");
        
        if($insertQuery){
            $id = mysqli_insert_id($con);
            $err = "<p class='alert alert-success'>Data successfully recorded </p>";
        } else {
            $err = "<p class='alert alert-danger'>Error: " . mysqli_error($con) . "</p>";
        }
    } else {
        $err = "<p class='alert alert-danger'>This item exists in our database.</p>";
    }
}
?>

<!-- HTML Form -->
<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=accounting" style="color: rgb(7, 133, 164)">Payslip settings</a></li>
                <li><a href="index.php?p=Payslipitems" style="color: rgb(7, 133, 164)">Payslip Items</a></li>
                <li class="active">Payslip Contribution Items</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title" style="color: rgb(174, 169, 169);"><strong>Payroll items</strong></h3>
                    <div class="panel-footer">
                        <!-- Change type to "submit" -->
                        <button id="openPayheadModal" class="btn btn-warning pull-right" type="submit" name="submit"><span class="fa fa-plus-circle"></span> Create New Payslip item</button>
                        <!-- Display error message -->
                        <?php echo $err; ?>
                    </div>
                </div>
                <div class="panel-body">
                    <div class="table-responsive">
                        <table id="payheads" class="table datatable">
                            <thead>
                                <tr>
                                    <th class="text-center">#</th>
                                    <th>PAYSLIP ITEM NAME</th>
                                    <th>DESCRIPTION</th>
                                    <th class="text-center">PAYSLIP ITEM TYPE</th>
                                    <th class="text-center">ACTIONS</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td class="text-center">1</td>
                                    <td>Basic salary</td>
                                    <td>Basic salary</td>
                                    <td class="text-center">Earnings</td>
                                    <td class="text-center">Edit</td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>
         
         <div class="modal fade" id="PayheadsModal" tabindex="-1" role="dialog" aria-labelledby="payheadModalLabel" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title">Payslip Items</h4>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <form method="POST" role="form" action="" data-toggle="validator" id="payhead-form">
                    <div class="modal-body">
                        <div class="form-group">
                            <label for="payhead_name">Payslip items Name</label>
                            <input type="text" class="form-control" id="payhead_name" name="payhead_name" placeholder="Payslip Name" required />
                        </div>
                        <div class="form-group">
                            <label for="payhead_desc">Payslip items Description</label>
                            <textarea class="form-control" id="payhead_desc" name="payhead_desc" placeholder="Payslip Description" required></textarea>
                        </div>
                        <div class="form-group">
                            <label for="payhead_type">Payslip items Type:</label>
                            <select class="form-control" id="payhead_type" name="payhead_type" required>
                                <option value="">---Select Payslip item Type---</option>
                                <option value="earnings">Earnings</option>
                                <option value="deductions">Deductions</option>
                                <option value="deductions">Contributions</option>
                            </select>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <input type="hidden" name="payhead_id" id="payhead_id" />
                        <button type="submit" name="submit" class="btn btn-primary">Save Payslip item</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
 
  <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.bundle.min.js"></script>

<script>
    $(document).ready(function() {
        // Attach click event listener to the "Create New Payslip Item" button
        $("#openPayheadModal").click(function() {
            // Show the modal when the button is clicked
            $("#PayheadsModal").modal("show");
        });
    });
</script>