<?php
session_start();
include '../db/db.php';

// Validate and sanitize input
$date1 = mysqli_real_escape_string($con, $_GET['date1']);
$date2 = mysqli_real_escape_string($con, $_GET['date2']);
$branch = mysqli_real_escape_string($con, $_GET['branch']);
$note = mysqli_real_escape_string($con, $_GET['description']);

$date1_obj = new DateTime($date1);
$date2_obj = new DateTime($date2);

// Subtract one year to get the comparative period
$date1_comparative = $date1_obj->modify('-1 year')->format('Y-m-d');
$date2_comparative = $date2_obj->modify('-1 year')->format('Y-m-d');

?>
<!DOCTYPE html>
<html>
<head>
    <style>
        table {
            border-collapse: collapse;
            border: 1px solid black;
            width: 100%;
        }
        th, td {
            border: 1px solid black;
            padding: 8px;
            color: black;
        }
        th{
            background-color:lightgray;
        }
        h3{
            color:black;
        }
        td, th {
    border: 1px solid black;
    padding: 8px;
    text-align: left; /* Default alignment */
    }
    
    th {
        background-color: lightgray;
    }
    
    td.right-align {
        text-align: right;
    }
    
    td.total {
        font-weight: bold;
    }

    </style>
</head>
<body>
<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=accounting" style="color: rgb(7, 133, 164)"></a>Accounting Menu</li>
                <li class="active">Accounting Notes</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b><?php echo $note;?></b></h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()">
                            <span class="fa fa-arrow-left"></span> Go Back
                        </button>
                        <button class="btn btn-default" onclick="printTable()">
                            <span class="fa fa-print"></span> Print Report
                        </button>
                        <button class="btn btn-default" onclick="exportToExcel()">
                            <span class="fa fa-file-excel-o"></span> Export To Excel
                        </button>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                    <div id="printingArea">
                        <!-- Income Statement Table -->
                        <br>
                        
        <table id="myTable">
               <h3>Income Statement</h3>
        <thead>
            <tr>
                <th>Financial Statement Line Item</th>
                <th>Ledger Account</th>
                <th>Current Year</th>
                <th>Comparative Period</th>
            </tr>
        </thead>
        <tbody>
            <!-- Revenue Line Item -->
            <?php
             $query = mysqli_query($con,"SELECT DISTINCT ct.id,ct.nameeng FROM chart_types ct
             INNER JOIN gl_transaction gt ON ct.id = gt.fsli AND ct.classname = 'Revenue'");
             
             foreach($query as $rows):
                 $query_inner = mysqli_query($con,"SELECT SUM(gt.amount) as amount,gt.account,cm.account_name 
                 FROM gl_transaction gt INNER JOIN chart_master cm ON gt.account = cm.account_code 
                 AND gt.fsli = '".$rows['id']."' AND gt.date BETWEEN '$date1' AND '$date2' GROUP BY gt.account");
              
        // Query for comparative period
        $query_inner_comparative = mysqli_query($con, "
            SELECT 
                SUM(gt.amount) AS amount, 
                gt.account 
            FROM gl_transaction gt 
            WHERE gt.fsli = '" . $rows['id'] . "' 
              AND gt.date BETWEEN '$date1_comparative' AND '$date2_comparative' 
            GROUP BY gt.account
        ");
        
        // Store comparative results in an associative array for quick access of data
        $comparative_data = [];
        foreach ($query_inner_comparative as $comp_row) {
            $comparative_data[$comp_row['account']] = $comp_row['amount'];
        }
            ?>
            <tr class="line-item-header">
                <td><b><?php echo $rows['nameeng'];?></b></td>
                <td colspan="3"></td>
            </tr>
            <?php
            $sum_rev = 0;
            $sum_rev1 = 0;
             foreach($query_inner as $rws){
                 $sum_rev+=$rws['amount']; 
                  $comparative_amount = isset($comparative_data[$rws['account']]) ? $comparative_data[$rws['account']] : 0;
                  $sum_rev1+=$comparative_amount;
            ?>
            <tr>
                <td></td>
                <td><?php echo $rws['account_name'];?></td>
                <td class = "right-align"><?php echo number_format($rws['amount'],2);?></td>
                <td class = "right-align"><?php echo number_format($comparative_amount, 2); ?></td>
            </tr>
            <?php
             }
            ?> 
             <tr>
                <td><b>Total</b></td>
                <td></td>
                <td class="right-align total"><?php echo number_format($sum_rev, 2); ?></td>
                <td class="right-align total"><?php echo number_format($sum_rev1, 2); ?></td>
            </tr>

            <?php
             endforeach;
            ?>
            
            <!-- Expense Line Item -->
            <?php
             $query = mysqli_query($con,"SELECT DISTINCT ct.id,ct.nameeng FROM chart_types ct
             INNER JOIN gl_transaction gt ON ct.id = gt.fsli AND ct.classname = 'Expense'");
             $sum_exp = 0;
             foreach($query as $rows):
                 $query_inner = mysqli_query($con,"SELECT SUM(gt.amount) as amount,gt.account,cm.account_name 
                 FROM gl_transaction gt INNER JOIN chart_master cm ON gt.account = cm.account_code 
                 AND gt.fsli = '".$rows['id']."' AND gt.date BETWEEN '$date1' AND '$date2' GROUP BY gt.account");
            
        // Query for comparative period
        $query_inner_comparative = mysqli_query($con, "
            SELECT 
                SUM(gt.amount) AS amount, 
                gt.account 
            FROM gl_transaction gt 
            WHERE gt.fsli = '" . $rows['id'] . "' 
              AND gt.date BETWEEN '$date1_comparative' AND '$date2_comparative' 
            GROUP BY gt.account
        ");
        
        // Store comparative results in an associative array for quick access
        $comparative_data = [];
        foreach ($query_inner_comparative as $comp_row) {
            $comparative_data[$comp_row['account']] = $comp_row['amount'];
        }
            ?>
            <tr class="line-item-header">
                <td><b><?php echo $rows['nameeng'];?></b></td>
                <td colspan="3"></td>
            </tr>
            <?php
            $sum_exp = 0;
            $sum_exp1=0;
             foreach($query_inner as $rws){
                 $sum_exp+= $rws['amount'];
                  $comparative_amount = isset($comparative_data[$rws['account']]) ? $comparative_data[$rws['account']] : 0;
                  $sum_exp1+=$comparative_amount;
            ?>
            <tr>
                <td></td>
                <td><?php echo $rws['account_name'];?></td>
                <td class="right-align"><?php echo number_format($rws['amount'],2);?></td>
                <td class="right-align"><?php echo number_format($comparative_amount, 2); ?></td>
            </tr>
            <?php
             }
            ?> 
             <tr>
                <td><b>Total</b></td>
                <td></td>
                <td class="right-align total"><?php echo number_format($sum_exp,2);?></td>
                <td class="right-align total"><?php echo number_format($sum_exp1, 2); ?></td>
            </tr>
            <?php
             endforeach;
            ?>

        </tbody>
    </table>
    <!-- Balance Sheet Table -->
    <br><br>
    
    <table id="myTable">
        <h3>Balance Sheet</h3>
        <thead>
            <tr>
                <th>Financial Statement Line Item</th>
                <th>Ledger Account</th>
                <th>Current Year</th>
                <th>Comparative Period</th>
            </tr>
        </thead>
        <tbody>
            <!-- Assets Line Item -->
            <tr class="line-item-header">
                <td colspan="4"><b>Assets</b></td>
            </tr>
            <?php
             $query = mysqli_query($con,"SELECT DISTINCT ct.id,ct.nameeng FROM chart_types ct
             INNER JOIN gl_transaction gt ON ct.id = gt.fsli AND ct.classname = 'Asset'");
             foreach($query as $rows):
                 
                 $query_inner = mysqli_query($con, "SELECT 
                        COALESCE(SUM(CASE WHEN nature = 'Debit' THEN amount ELSE 0 END), 0) AS Total_Debit,
                        COALESCE(SUM(CASE WHEN nature = 'Credit' THEN amount ELSE 0 END), 0) AS Total_Credit,
                        COALESCE(SUM(CASE WHEN nature = 'Debit' THEN amount ELSE 0 END), 0) - 
                            COALESCE(SUM(CASE WHEN nature = 'Credit' THEN amount ELSE 0 END), 0) AS amount,cm.account_name
                    FROM 
                        gl_transaction gt INNER JOIN chart_master cm ON gt.account = cm.account_code
                        AND gt.fsli = '".$rows['id']."' AND gt.date <='$date2' GROUP BY gt.account");
                 
        // Query for comparative period
        $query_inner_comparative = mysqli_query($con, "SELECT 
                        COALESCE(SUM(CASE WHEN nature = 'Debit' THEN amount ELSE 0 END), 0) AS Total_Debit,
                        COALESCE(SUM(CASE WHEN nature = 'Credit' THEN amount ELSE 0 END), 0) AS Total_Credit,
                        COALESCE(SUM(CASE WHEN nature = 'Debit' THEN amount ELSE 0 END), 0) - 
                            COALESCE(SUM(CASE WHEN nature = 'Credit' THEN amount ELSE 0 END), 0) AS amount,cm.account_name
                    FROM 
                        gl_transaction gt INNER JOIN chart_master cm ON gt.account = cm.account_code
                        AND gt.fsli = '".$rows['id']."' AND gt.date <='$date2_comparative' GROUP BY gt.account");
        
        // Store comparative results in an associative array for quick access
        $comparative_data = [];
        foreach ($query_inner_comparative as $comp_row) {
            $comparative_data[$comp_row['account']] = $comp_row['amount'];
        }
            ?>
            <tr class="line-item-header">
                <td><b><?php echo $rows['nameeng'];?></b></td>
                <td colspan="3"></td>
            </tr>
            <?php
            $sum_asset = 0;
            $sum_asset1 = 0;
             foreach($query_inner as $rws){
                 $sum_asset+=$rws['amount'];
                  $comparative_amount = isset($comparative_data[$rws['account']]) ? $comparative_data[$rws['account']] : 0;
                  $sum_asset1+=$comparative_amount;
            ?>
            <tr>
                <td></td>
                <td><?php echo $rws['account_name']; ?></td>
                <td class="right-align"><?php echo number_format($rws['amount'], 2); ?></td>
                <td class="right-align"><?php echo number_format($comparative_amount, 2); ?></td>
            </tr>

            <?php
             }
            ?> 
             <tr>
                <td><b>Total</b></td>
                <td></td>
                <td class="right-align total"><?php echo number_format($sum_asset,2);?></td>
                <td class="right-align total"><?php echo number_format($sum_asset1, 2); ?></td>
            </tr>
            <?php
             endforeach;
            ?>
            
                <!-- Equity Line Item -->
            <tr class="line-item-header">
                <td colspan="4"><b>Equity</b></td>
            </tr>
            <?php
             $query = mysqli_query($con,"SELECT DISTINCT ct.id,ct.nameeng FROM chart_types ct
             INNER JOIN gl_transaction gt ON ct.id = gt.fsli AND ct.classname = 'Equity'");
             foreach($query as $rows):
                 
                 $query_inner = mysqli_query($con, "
                        SELECT 
                            COALESCE(SUM(CASE WHEN nature = 'Debit' THEN amount ELSE 0 END), 0) AS Total_Debit,
                            COALESCE(SUM(CASE WHEN nature = 'Credit' THEN amount ELSE 0 END), 0) AS Total_Credit,
                            COALESCE(SUM(CASE WHEN nature = 'Credit' THEN amount ELSE 0 END), 0) - 
                            COALESCE(SUM(CASE WHEN nature = 'Debit' THEN amount ELSE 0 END), 0) AS amount,
                            cm.account_name
                        FROM 
                            gl_transaction gt 
                        INNER JOIN 
                            chart_master cm 
                            ON gt.account = cm.account_code
                        WHERE 
                            gt.fsli = '" . $rows['id'] . "' 
                            AND gt.date <= '$date2' 
                        GROUP BY 
                            gt.account
                    ");
                 
        // Query for comparative period
       $query_inner_comparative = mysqli_query($con, "
                        SELECT 
                            COALESCE(SUM(CASE WHEN nature = 'Debit' THEN amount ELSE 0 END), 0) AS Total_Debit,
                            COALESCE(SUM(CASE WHEN nature = 'Credit' THEN amount ELSE 0 END), 0) AS Total_Credit,
                            COALESCE(SUM(CASE WHEN nature = 'Credit' THEN amount ELSE 0 END), 0) - 
                            COALESCE(SUM(CASE WHEN nature = 'Debit' THEN amount ELSE 0 END), 0) AS amount,
                            cm.account_name
                        FROM 
                            gl_transaction gt 
                        INNER JOIN 
                            chart_master cm 
                            ON gt.account = cm.account_code
                        WHERE 
                            gt.fsli = '" . $rows['id'] . "' 
                            AND gt.date <= '$date2_comparative' 
                        GROUP BY 
                            gt.account
                    ");
        
        // Store comparative results in an associative array for quick access
        $comparative_data = [];
        foreach ($query_inner_comparative as $comp_row) {
            $comparative_data[$comp_row['account']] = $comp_row['amount'];
        }
            ?>
            <tr class="line-item-header">
                <td><b><?php echo $rows['nameeng'];?></b></td>
                <td colspan="3"></td>
            </tr>
            <?php
            $sum_equity = 0;
            $sum_equity1 = 0;
             foreach($query_inner as $rws){
                 $sum_equity+=$rws['amount'];
                  $comparative_amount = isset($comparative_data[$rws['account']]) ? $comparative_data[$rws['account']] : 0;
                  $sum_equity1+=$comparative_amount;
            ?>
            <tr>
                <td></td>
                <td><?php echo $rws['account_name'];?></td>
                <td class="right-align"><?php echo number_format($rws['amount'],2);?></td>
                <td class="right-align"><?php echo number_format($comparative_amount, 2); ?></td>
            </tr>
            <?php
             }
            ?> 
             <tr>
                <td><b>Total</b></td>
                <td></td>
                <td class="right-align total"><?php echo number_format($sum_equity,2);?></td>
                <td class="right-align total"><?php echo number_format($sum_equity1, 2); ?></td>
            </tr>
            <?php
             endforeach;
            ?>
            
                <!-- Liability Line Item -->
            <tr class="line-item-header">
                <td colspan="4"><b>Liabilities</b></td>
            </tr>
            <?php
             $query = mysqli_query($con,"SELECT DISTINCT ct.id,ct.nameeng FROM chart_types ct
             INNER JOIN gl_transaction gt ON ct.id = gt.fsli AND ct.classname = 'Liability'");
             foreach($query as $rows):
                 
                  $query_inner = mysqli_query($con, "
                        SELECT 
                            COALESCE(SUM(CASE WHEN nature = 'Debit' THEN amount ELSE 0 END), 0) AS Total_Debit,
                            COALESCE(SUM(CASE WHEN nature = 'Credit' THEN amount ELSE 0 END), 0) AS Total_Credit,
                            COALESCE(SUM(CASE WHEN nature = 'Credit' THEN amount ELSE 0 END), 0) - 
                            COALESCE(SUM(CASE WHEN nature = 'Debit' THEN amount ELSE 0 END), 0) AS amount,
                            cm.account_name
                        FROM 
                            gl_transaction gt 
                        INNER JOIN 
                            chart_master cm 
                            ON gt.account = cm.account_code
                        WHERE 
                            gt.fsli = '" . $rows['id'] . "' 
                            AND gt.date <= '$date2' 
                        GROUP BY 
                            gt.account
                    ");
                 
        // Query for comparative period

        $query_inner_comparative = mysqli_query($con, "
                        SELECT 
                            COALESCE(SUM(CASE WHEN nature = 'Debit' THEN amount ELSE 0 END), 0) AS Total_Debit,
                            COALESCE(SUM(CASE WHEN nature = 'Credit' THEN amount ELSE 0 END), 0) AS Total_Credit,
                            COALESCE(SUM(CASE WHEN nature = 'Credit' THEN amount ELSE 0 END), 0) - 
                            COALESCE(SUM(CASE WHEN nature = 'Debit' THEN amount ELSE 0 END), 0) AS amount,
                            cm.account_name
                        FROM 
                            gl_transaction gt 
                        INNER JOIN 
                            chart_master cm 
                            ON gt.account = cm.account_code
                        WHERE 
                            gt.fsli = '" . $rows['id'] . "' 
                            AND gt.date <= '$date2_comparative' 
                        GROUP BY 
                            gt.account
                    ");
        
        // Store comparative results in an associative array for quick access
        $comparative_data = [];
        foreach ($query_inner_comparative as $comp_row) {
            $comparative_data[$comp_row['account']] = $comp_row['amount'];
        }
            ?>
            <tr class="line-item-header">
                <td><b><?php echo $rows['nameeng'];?></b></td>
                <td colspan="3"></td>
            </tr>
            <?php
            $sum_liability = 0;
            $sum_liability1 = 0;
             foreach($query_inner as $rws){
                 $sum_liability+=$rws['amount'];
                  $comparative_amount = isset($comparative_data[$rws['account']]) ? $comparative_data[$rws['account']] : 0;
                  $sum_liability1+=$comparative_amount;
            ?>
            <tr>
                <td></td>
                <td><?php echo $rws['account_name'];?></td>
                <td class="right-align"><?php echo number_format($rws['amount'],2);?></td>
                <td class="right-align"><?php echo number_format($comparative_amount, 2); ?></td>
            </tr>
            <?php
             }
            ?> 
             <tr>
                <td><b>Total</b></td>
                <td></td>
                <td class="right-align total"><?php echo number_format($sum_liability,2);?></td>
                <td class="right-align total"><?php echo number_format($sum_liability1, 2); ?></td>
            </tr>
            <?php
             endforeach;
            ?>
            
        </tbody>
    </table>
                    </div>
                </div>
                <div class="panel-footer">
                </div>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>
<script>
function printTable() {
    var printContent = document.getElementById('printingArea').innerHTML;
    var printWindow = window.open('', '_blank');
    printWindow.document.open();
    printWindow.document.write('<html><head><title>Print Report</title>');
    printWindow.document.write('<style>');
    printWindow.document.write('body { font-family: "Times New Roman", Times, serif; }');
    printWindow.document.write('table { border-collapse: collapse; width: 100%; margin-top: 20px; }');
    printWindow.document.write('th, td { border: 1px solid black; padding: 5px; font-size: 16px; }');
    printWindow.document.write('th { background-color: lightgray; color: black; }'); // Set background color for <th>
    printWindow.document.write('h3 { text-align: left; }');
    
    // Align all columns with "right-align" class to the right
    printWindow.document.write('td.right-align { text-align: right; }');
    
    // Make all rows or cells with "total" class bold
    printWindow.document.write('.total { font-weight: bold; }');

    // Add @media print to force background color for print
    printWindow.document.write('@media print { th { background-color: lightgray !important; -webkit-print-color-adjust: exact; color-adjust: exact; } }');

    printWindow.document.write('</style></head><body>');
    printWindow.document.write(printContent);
    printWindow.document.write('</body></html>');
    printWindow.document.close();
    printWindow.print();
}


function exportToExcel() {
    var table = document.getElementById('printingArea');
    var wb = XLSX.utils.table_to_book(table);
    var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });
    var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

    var link = document.createElement('a');
    link.href = window.URL.createObjectURL(blob);
    link.download = 'Accounting_Notes_report.xlsx';
    link.click();
}

function s2ab(s) {
    var buf = new ArrayBuffer(s.length);
    var view = new Uint8Array(buf);
    for (var i = 0; i < s.length; i++) {
        view[i] = s.charCodeAt(i) & 0xFF;
    }
    return buf;
}
</script>
</body>
</html>