<?php
// Connect to your database
include '../db/db.php';
// Query to fetch balance sheet data
// Query to fetch balance sheet data
$sql = "SELECT 
            maingroup,
            fsli,
            SUM(CASE WHEN nature = 'Debit' THEN amount ELSE -amount END) AS balance
        FROM 
            gl_transaction
        GROUP BY 
            maingroup, fsli
        UNION
        SELECT 
            'Total Assets' AS maingroup,
            '' AS fsli,
            SUM(CASE WHEN maingroup = 'Asset' THEN amount ELSE 0 END) AS balance
        FROM 
            gl_transaction
        UNION
        SELECT 
            'Total Liabilities' AS maingroup,
            '' AS fsli,
            SUM(CASE WHEN maingroup = 'Liability' THEN amount ELSE 0 END) AS balance
        FROM 
            gl_transaction
        UNION
        SELECT 
            'Total Equity' AS maingroup,
            '' AS fsli,
            SUM(CASE WHEN maingroup = 'Equity' THEN amount ELSE 0 END) AS balance
        FROM 
            gl_transaction";

$result = $con->query($sql);

if ($result->num_rows > 0) {
    // Output table header
    echo "<table border='1'>";
    echo "<tr><th>Main Group</th><th>FSLI</th><th>Balance</th></tr>";

    // Output data of each row
    while($row = $result->fetch_assoc()) {
        echo "<tr>";
        echo "<td>" . $row["maingroup"] . "</td>";
        echo "<td>" . $row["fsli"] . "</td>";
        echo "<td>" . $row["balance"] . "</td>";
        echo "</tr>";
    }
    echo "</table>";
} else {
    echo "0 results";
}
?>
