<?php
// Define the date range and account number
$start_date = $_GET['date1'];
$end_date = $_GET['date2'];
$account_number = $_GET['account'];

$bank_account = mysqli_query($con, "SELECT * FROM chart_master WHERE account_code = '$account_number'");

if (!$bank_account) {
    die("Error: " . mysqli_error($con));
}

$rows = mysqli_fetch_array($bank_account);

if (!$rows) {
    echo "No matching record found for account number: $account_number";
} else {
    $acc_name = $rows['account_name'];
    //echo "Account Name: $acc_name";
}

$sql_opening_balance = "SELECT COALESCE(SUM(CASE WHEN nature = 'Debit' THEN amount 
                                    WHEN nature = 'Credit' THEN -amount END), 0) AS opening_balance
                        FROM gl_transaction 
                        WHERE account = ? AND date < ?";
$stmt_opening_balance = $con->prepare($sql_opening_balance);
$stmt_opening_balance->bind_param("is", $account_number, $start_date);
$stmt_opening_balance->execute();
$stmt_opening_balance->bind_result($opening_balance);
$stmt_opening_balance->fetch();
$stmt_opening_balance->close();

// SQL query to fetch transactions within the date range for the specified account
$sql = "SELECT date, notes,id, 
        CASE WHEN nature = 'Credit' THEN amount ELSE '' END AS credit_amount,
        CASE WHEN nature = 'Debit' THEN amount ELSE '' END AS debit_amount
        FROM gl_transaction 
        WHERE account = ? AND date BETWEEN ? AND ? ORDER BY date ASC";
$stmt = $con->prepare($sql);
$stmt->bind_param("iss", $account_number, $start_date, $end_date);
$stmt->execute();
$result = $stmt->get_result();
?>
    <style>
        /* CSS to style the table */
        table {
            border-collapse: collapse;
            border: 1px solid black; /* Set border color and thickness */
            width: 100%; /* Set table width to 100% of its container */
        }

        th {
            border: 1px solid black; /* Set border for table cells */
            padding: 8px; /* Add padding for better readability */
            text-align: center; /* Center-align text within cells */
            height:20px;
            color:black;
        }
        td {
            border: 1px solid black; /* Set border for table cells */
            padding: 8px; /* Add padding for better readability */
            height:20px;
            color:black;
        }
    </style>
                       <div class="col-md-9">

                            <!-- START TIMELINE -->
                            <div class="row">
                            <div class="col-md-12">

                               <div class="panel panel-default">
                                <div class="panel-heading">
                                    <h3 class="panel-title"><b>ACCOUNT HISTORY <span style="color:#999"><?php echo strtoupper($acc_name);?></span></b></h3>
                                   <div class="pull-right">
                                    <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                                    <button class="btn btn-default" onclick="printTable()">
                                        <span class="fa fa-print"></span> Print Report
                                    </button>
                                    <button class="btn btn-default" onclick="exportToExcel()">
                                        <span class="fa fa-download"></span> Export To Excel
                                    </button>
                                </div>
                                </div>
                                   <div class="panel-body" id="printingArea">
                                    <?php
                                     echo "<table>
                                          <tr>
                                            <th colspan=4>".$_SESSION['Company']."</th>
                                          </tr>
                                          <tr>
                                             <th colspan=4>BRANCH: ". $_SESSION['Branch']."</th>
                                           </tr>
                                           <tr>
                                              <th colspan=4>BANK TRANSACTIONS ".strtoupper($acc_name)."</th>
                                          </tr>
                                          <tr>
                                               <th colspan=4>FROM ".date('d-m-Y',strtotime($_GET['date1']))." TO ".date('d-m-Y',strtotime($_GET['date2']))."</th>
                                          </tr>
                                          <tr style='color:black;font-weight:bold;font-size:14px;background-color:#f5f5f5'>
                                              <td style='width:20%'>Date</td>
                                              <td style='width:50%'>Description</td>
                                              <td style='width:15%'>Payments</td>
                                              <td style='width:15%'>Receipts</td>
                                          </tr>
                                          
                                          <tr>
                                              <td>".$_GET['date1']."</td>
                                              <td>Opening Balance</td>
                                              <td></td>
                                              <td align='right'>".number_format($opening_balance,2)."</td>
                                         </tr>
                                        ";
$credit_total = 0;
$debit_total = 0;

// Display transactions
while ($row = $result->fetch_assoc()) {
    echo "<tr>";
    echo "<td>" . $row['date'] . "</td>";
    echo "<td>" . $row['notes'] . "</td>";
    echo "<td align='right'>" . number_format($row['credit_amount'], 2) . "</td>";
    echo "<td align='right'><a href='index.php?p=bank_transaction_edit&id=" . $row['id'] . "'>" . number_format($row['debit_amount'], 2) . "</a></td>";
    echo "</tr>";

    // Calculate credit and debit totals
    $credit_total += $row['credit_amount'];
    $debit_total += $row['debit_amount'];
}

// Calculate opening balance

// Calculate closing balance
$closing_balance = $opening_balance + ($debit_total - $credit_total);
$net = $debit_total - $credit_total;


// Display totals and closing balance row
echo "<tr style='color:black;font-weight:bold;font-size:14px;'><td colspan='2'><b>Total Payments:</b></td><td align='right'>" . number_format($credit_total) . "</td><td></td></tr>";
echo "<tr style='color:black;font-weight:bold;font-size:14px;'><td colspan='2'><b>Total Receipts:</b></td><td></td><td align='right'>" . number_format($debit_total) . "</td></tr>";
echo "<tr style='color:black;font-weight:bold;font-size:14px;'><td colspan='2'><b>Net Difference:</b></td><td></td><td align='right'>" . number_format($net) . "</td></tr>";
echo "<tr style='color:black;font-weight:bold;font-size:14px;'><td colspan='2' ><b>Opening Balance:</b></td><td colspan='2' align='right'>" . number_format($opening_balance) . "</td></tr>";
echo "<tr style='color:black;font-weight:bold;font-size:14px;'><td colspan='2' ><b>Closing Balance:</b></td><td colspan='2' align='right'>" . number_format($closing_balance) . "</td></tr>";

echo "</table>";

// Close statement and connection
$stmt->close();
$con->close();
?>
                                    </div>
                                  </div>
                                 </div>
                                <div class="panel-footer">                      
                                    </div>
                            </div>
                          </div>
                        </div>


                            
                        </div>
        <script>
function printTable() {
    var content = document.getElementById('printingArea').innerHTML;
    var printWindow = window.open('', '_blank');
    printWindow.document.write('<html><head><title>Print Table</title></head><body>');
    printWindow.document.write('<style>table { border-collapse: collapse; width: 100%; } th, td { border: 1px solid black; padding: 8px; } a{text-decoration:none; color:black}</style>');
    printWindow.document.write(content);
    printWindow.document.write('</body></html>');
    printWindow.document.close();
    printWindow.print();
}

function exportToExcel() {
    var table = document.getElementById('myTable'); // Correct ID of the table

    var wb = XLSX.utils.table_to_book(table);
    var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });
    var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

    var link = document.createElement('a');
    link.href = window.URL.createObjectURL(blob);
    link.download = 'purchase_report.xlsx'; // Change 'filename' to your desired filename
    link.click();
}

function s2ab(s) {
    var buf = new ArrayBuffer(s.length);
    var view = new Uint8Array(buf);
    for (var i = 0; i < s.length; i++) {
        view[i] = s.charCodeAt(i) & 0xFF;
    }
    return buf;
}
</script>
