<?php
$date1 = $_GET['date1'];
$date2 = $_GET['date2'];
$branch = $_GET['branch'];
$account = $_GET['account'];
$date3 = date('d-m-Y', strtotime($_GET['date1']));
$date4 = date('d-m-Y', strtotime($_GET['date2']));


if ($date1 !== $date2) {
    $date_condition = "gl.date BETWEEN '$date1' AND '$date2'";
    $note = "FOR THE PERIOD FROM {$date3} TO {$date4}";
} else {
    $date_condition = "gl.date = '$date1'";
    $note = "FOR THE PERIOD ENDED {$date3}";
}

if ($branch == 'All') {
    if ($account == 'All') {
        // Calculate the opening balance
        $sql_opening_balance = "SELECT (SUM(CASE WHEN gl.nature = 'debit' THEN gl.amount ELSE 0 END) - 
                                      SUM(CASE WHEN gl.nature = 'credit' THEN gl.amount ELSE 0 END)) AS opening_balance
                               FROM gl_transaction AS gl
                               INNER JOIN bank_accounts AS ba ON gl.account = ba.account_code
                               WHERE gl.date < ?";

        $stmt_opening_balance = $con->prepare($sql_opening_balance);
        $stmt_opening_balance->bind_param("s", $date1);
        $stmt_opening_balance->execute();
        $result_opening_balance = $stmt_opening_balance->get_result();
        $row_opening_balance = $result_opening_balance->fetch_assoc();
        $opening_balance = $row_opening_balance['opening_balance'];

        $sql = "SELECT
                    gl.date,
                    gl.notes,
                    gl.transid,
                    gl.cat,
                    gl.branchno,
                    CASE WHEN gl.nature = 'debit' THEN gl.amount ELSE '' END AS debit_amount,
                    CASE WHEN gl.nature = 'credit' THEN gl.amount ELSE '' END AS credit_amount,
                    ba.account_code
                FROM
                    gl_transaction AS gl
                INNER JOIN
                    bank_accounts AS ba ON gl.account = ba.account_code
                WHERE
                    $date_condition
                ORDER BY
                    gl.date ASC";

        $stmt = $con->prepare($sql);
        $stmt->execute();
        $result = $stmt->get_result();
    } else {
        // Calculate the opening balance for a specific account
        $sql_opening_balance = "SELECT (SUM(CASE WHEN gl.nature = 'debit' THEN gl.amount ELSE 0 END) - 
                                      SUM(CASE WHEN gl.nature = 'credit' THEN gl.amount ELSE 0 END)) AS opening_balance
                               FROM gl_transaction AS gl
                               INNER JOIN bank_accounts AS ba ON gl.account = ba.account_code
                               WHERE gl.date < ? AND gl.account = ?";

        $stmt_opening_balance = $con->prepare($sql_opening_balance);
        $stmt_opening_balance->bind_param("si", $date1, $account);
        $stmt_opening_balance->execute();
        $result_opening_balance = $stmt_opening_balance->get_result();
        $row_opening_balance = $result_opening_balance->fetch_assoc();
        $opening_balance = $row_opening_balance['opening_balance'];

        $sql = "SELECT
                    gl.date,
                    gl.notes,
                    gl.transid,
                    gl.cat,
                    gl.branchno,
                    CASE WHEN gl.nature = 'debit' THEN gl.amount ELSE '' END AS debit_amount,
                    CASE WHEN gl.nature = 'credit' THEN gl.amount ELSE '' END AS credit_amount,
                    ba.account_code
                FROM
                    gl_transaction AS gl
                INNER JOIN
                    bank_accounts AS ba ON gl.account = ba.account_code
                WHERE
                    $date_condition AND gl.account = ?
                ORDER BY
                    gl.date ASC";

        $stmt = $con->prepare($sql);
        $stmt->bind_param("i", $account);
        $stmt->execute();
        $result = $stmt->get_result();
    }
} else { // For a specific branch name
    if ($account == 'All') {
        // Calculate the opening balance for a specific branch
        $sql_opening_balance = "SELECT (SUM(CASE WHEN gl.nature = 'debit' THEN gl.amount ELSE 0 END) - 
                                      SUM(CASE WHEN gl.nature = 'credit' THEN gl.amount ELSE 0 END)) AS opening_balance
                               FROM gl_transaction AS gl
                               INNER JOIN bank_accounts AS ba ON gl.account = ba.account_code
                               WHERE gl.date < ? AND gl.branchno = ?";

        $stmt_opening_balance = $con->prepare($sql_opening_balance);
        $stmt_opening_balance->bind_param("ss", $date1, $branch);
        $stmt_opening_balance->execute();
        $result_opening_balance = $stmt_opening_balance->get_result();
        $row_opening_balance = $result_opening_balance->fetch_assoc();
        $opening_balance = $row_opening_balance['opening_balance'];

        $sql = "SELECT
                    gl.date,
                    gl.notes,
                    gl.transid,
                    gl.cat,
                    gl.branchno,
                    CASE WHEN gl.nature = 'debit' THEN gl.amount ELSE '' END AS debit_amount,
                    CASE WHEN gl.nature = 'credit' THEN gl.amount ELSE '' END AS credit_amount,
                    ba.account_code
                FROM
                    gl_transaction AS gl
                INNER JOIN
                    bank_accounts AS ba ON gl.account = ba.account_code
                WHERE
                    $date_condition AND gl.branchno = ?
                ORDER BY
                    gl.date ASC";

        $stmt = $con->prepare($sql);
        $stmt->bind_param("s", $branch);
        $stmt->execute();
        $result = $stmt->get_result();
    } else {
        // Calculate the opening balance for a specific branch and account
        $sql_opening_balance = "SELECT (SUM(CASE WHEN gl.nature = 'debit' THEN gl.amount ELSE 0 END) - 
                                      SUM(CASE WHEN gl.nature = 'credit' THEN gl.amount ELSE 0 END)) AS opening_balance
                               FROM gl_transaction AS gl
                               INNER JOIN bank_accounts AS ba ON gl.account = ba.account_code
                               WHERE gl.date < ? AND gl.account = ? AND gl.branchno = ?";

        $stmt_opening_balance = $con->prepare($sql_opening_balance);
        $stmt_opening_balance->bind_param("sis", $date1, $account, $branch);
        $stmt_opening_balance->execute();
        $result_opening_balance = $stmt_opening_balance->get_result();
        $row_opening_balance = $result_opening_balance->fetch_assoc();
        $opening_balance = $row_opening_balance['opening_balance'];

        $sql = "SELECT
                    gl.date,
                    gl.notes,
                    gl.transid,
                    gl.cat,
                    gl.branchno,
                    CASE WHEN gl.nature = 'debit' THEN gl.amount ELSE '' END AS debit_amount,
                    CASE WHEN gl.nature = 'credit' THEN gl.amount ELSE '' END AS credit_amount,
                    ba.account_code
                FROM
                    gl_transaction AS gl
                INNER JOIN
                    bank_accounts AS ba ON gl.account = ba.account_code
                WHERE
                    $date_condition AND gl.account = ? AND gl.branchno = ?
                ORDER BY
                    gl.date ASC";

        $stmt = $con->prepare($sql);
        $stmt->bind_param("is", $account, $branch);
        $stmt->execute();
        $result = $stmt->get_result();
    }
}
?>
<style>
    table {
        border-collapse: collapse;
        border: 1px solid black;
        width: 100%;
    }

    th, td {
        border: 1px solid black;
        padding: 8px;
        text-align: center;
        color: black;
    }
</style>
<div class="col-md-9">
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>CASH BOOK REPORT</b></h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                        <button class="btn btn-default" onclick="printContent()">
                            <span class="fa fa-print"></span> Print Report
                        </button>
                        <button class="btn btn-default" onclick="exportToExcel()">
                            <span class="fa fa-print"></span> Export To Excel
                        </button>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                    <div id="printingArea">
                        <table id="myTable">
                            <tr>
                                <th colspan=8><?php echo $_SESSION['Company'];?></th>
                            </tr>
                            <tr>
                                <th colspan=8>BRANCH: <?php echo $_GET['branch'];?></th>
                            </tr>
                            <tr>
                                <th colspan=8><?php echo $_GET['description'];?></th>
                            </tr>
                            <tr>
                                <th colspan=8><?php echo $note;?></th>
                            </tr>
                            <tr style="font-weight:bold">
                                <td>DATE</td>
                                <td>DESCRIPTION</td>
                                <td>BANK ACCOUNT</td>
                                <td>REFERENCE NO.</td>
                                <td>RECEIPT</td>
                                <td>PAYMENT</td>
                                <td>BALANCE</td>
                                <td>BRANCH</td>
                            </tr>
                            <tr>
                                <td colspan="6" style="text-align: right; font-weight:bold">Opening Balance</td>
                                <td><?php echo number_format($opening_balance, 2);?></td>
                            </tr>

                             <?php
                            $total_debit = 0;
                            $total_credit = 0;
                            $balance = $opening_balance;
                            foreach($result as $rows) {
                                $account = mysqli_query($con, "SELECT * FROM chart_master WHERE account_code = '".$rows['account_code']."'");
                                $rs = mysqli_fetch_array($account);

                                $debit_amount = $rows['debit_amount'] ?: 0;
                                $credit_amount = $rows['credit_amount'] ?: 0;

                                $total_debit += $debit_amount;
                                $total_credit += $credit_amount;
                                $balance += ($debit_amount - $credit_amount);

                                if ($rows['cat'] === 'Receipt') {
                                    $transid = "RV-" . $rows['transid'];  
                                } elseif ($rows['cat'] === 'payment') {
                                    $transid = "PV-" . $rows['transid'];  
                                } else {
                                    $transid = "TR-" . $rows['transid']; 
                                }
                            ?>
                                <tr>
                                    <td><?php echo date('d-m-Y', strtotime($rows['date']));?></td>
                                    <td><?php echo $rows['notes'];?></td>
                                    <td><?php echo $rs['account_name'];?></td>
                                    <td><?php echo $transid; ?></td> <!-- Display the transid with the correct prefix -->
                                    <td><?php echo number_format($debit_amount, 2);?></td>
                                    <td><?php echo number_format($credit_amount, 2);?></td>
                                    <td><?php echo number_format($balance, 2);?></td>
                                    <td><?php echo $rows['branchno'];?></td>
                                </tr>
                            <?php
                            }
                            ?>
                            <tr>
                                <td colspan="4" style="text-align: right; font-weight:bold">Total</td>
                                <td><?php echo number_format($total_debit, 2);?></td>
                                <td><?php echo number_format($total_credit, 2);?></td>
                                <td><?php echo number_format($balance, 2);?></td>
                            </tr>
                            <tr>
                                <td colspan="6" style="text-align: right; font-weight:bold">Closing Balance</td>
                                <td><?php echo number_format($balance, 2);?></td>
                            </tr>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<script>
    function printContent() {
        var content = document.getElementById('printingArea').innerHTML;
        var printWindow = window.open('', '_blank');
        printWindow.document.write('<html><head><title>Print</title>');
        printWindow.document.write('<style>table { border-collapse: collapse; border: 1px solid black; width: 100%; } th, td { border: 1px solid black; padding: 8px; text-align: center; height: 20px; color: black; } a { color: black; text-decoration: none; } </style>');
        printWindow.document.write('</head><body>');
        printWindow.document.write(content);
        printWindow.document.write('</body></html>');
        printWindow.document.close();
        printWindow.print();
    }

    function exportToExcel() {
        // Get the HTML table element
        var table = document.getElementById('printingArea'); // Replace 'tableId' with the ID of your table

        // Convert the HTML table to a worksheet
        var wb = XLSX.utils.table_to_book(table);

        // Generate a binary string from the XLSX workbook
        var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });

        // Create a Blob object representing the data as an Excel file
        var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

        // Create a temporary anchor element and trigger a download
        var link = document.createElement('a');
        link.href = window.URL.createObjectURL(blob);
        link.download = 'cash_book_report.xlsx'; // Change 'filename' to your desired filename
        link.click();
    }

    // Utility function to convert a string to an ArrayBuffer
    function s2ab(s) {
        var buf = new ArrayBuffer(s.length);
        var view = new Uint8Array(buf);
        for (var i = 0; i < s.length; i++) {
            view[i] = s.charCodeAt(i) & 0xFF;
        }
        return buf;
    }
</script>
