<?php
 // Validate and sanitize input
$date1 = mysqli_real_escape_string($con, $_GET['date1']);
$date2 = mysqli_real_escape_string($con, $_GET['date2']);
$branch = mysqli_real_escape_string($con, $_GET['branch']);
$note = mysqli_real_escape_string($con, $_GET['description']);

//share capital 2110  retain 2120 dividends

function getAmount($con, $account, $date) {
    // Query to calculate Credit - Debit for the balance
    $check_balance = mysqli_query($con, "
        SELECT 
            COALESCE(SUM(CASE WHEN nature = 'Credit' THEN amount ELSE 0 END), 0) AS Total_Credit,
            COALESCE(SUM(CASE WHEN nature = 'Debit' THEN amount ELSE 0 END), 0) AS Total_Debit,
            COALESCE(SUM(CASE WHEN nature = 'Credit' THEN amount ELSE 0 END), 0) - 
            COALESCE(SUM(CASE WHEN nature = 'Debit' THEN amount ELSE 0 END), 0) AS balance
        FROM 
            gl_transaction 
        WHERE 
            account = '$account' AND date < '$date'
    ");
    
    // Fetch the result
    $rs = mysqli_fetch_array($check_balance);
    $balance = $rs['balance'];
    return $balance;

}

function getProfitLoss($con, $date1,$date2) {

    $ret1 = mysqli_query($con, "SELECT 
                COALESCE(SUM(CASE WHEN maingroup = 'Revenue' THEN amount ELSE 0 END), 0) AS Total_Revenue,
                COALESCE(SUM(CASE WHEN maingroup = 'Expense' THEN amount ELSE 0 END), 0) AS Total_Expense,
                COALESCE(SUM(CASE WHEN maingroup = 'Revenue' THEN amount ELSE 0 END), 0) - 
                    COALESCE(SUM(CASE WHEN maingroup = 'Expense' THEN amount ELSE 0 END), 0) AS Retained_Earnings
            FROM 
                gl_transaction WHERE date < '$date1'");
                     $rss = mysqli_fetch_array($ret1);
                     $retained_earnings1 = $rss['Retained_Earnings'];
                     
    $ret = mysqli_query($con, "SELECT 
                COALESCE(SUM(CASE WHEN maingroup = 'Revenue' THEN amount ELSE 0 END), 0) AS Total_Revenue,
                COALESCE(SUM(CASE WHEN maingroup = 'Expense' THEN amount ELSE 0 END), 0) AS Total_Expense,
                COALESCE(SUM(CASE WHEN maingroup = 'Revenue' THEN amount ELSE 0 END), 0) - 
                    COALESCE(SUM(CASE WHEN maingroup = 'Expense' THEN amount ELSE 0 END), 0) AS Retained_Earnings
            FROM 
                gl_transaction WHERE date BETWEEN '$date1' AND '$date2'");
                     $rss = mysqli_fetch_array($ret);
                     $retained_earnings = $rss['Retained_Earnings'];
                     
                     return array($retained_earnings1,$retained_earnings);
  }
   list($profitprev,$profitnow) = getProfitLoss($con,$date1,$date2);
?>
<style>
        table {
            border-collapse: collapse;
            border: 1px solid black;
            width: 100%;
        }
        th, td {
            border: 1px solid black;
            padding: 8px;
            color: black;
        }
    </style>

<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=accounting" style="color: rgb(7, 133, 164)"></a>Accounting Menu</li>
                <li class="active">Changes in Equity</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>CHANGES IN EQUITY REPORT</b></h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()">
                            <span class="fa fa-arrow-left"></span> Go Back
                        </button>
                        <button class="btn btn-default" onclick="printTable()">
                            <span class="fa fa-print"></span> Print Report
                        </button>
                        <button class="btn btn-default" onclick="exportToExcel()">
                            <span class="fa fa-file-excel-o"></span> Export To Excel
                        </button>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                    <div id="printingArea">
                        <table id="myTable" border="1" style="width: 100%; text-align: center; border-collapse: collapse;">
                            <thead>
                            <tr>
                                <th colspan="6" style="text-align:center"><?php echo $_SESSION['Company']; ?></th>
                            </tr>
                            <tr>
                                <th colspan="6" style="text-align:center">BRANCH: <?php echo htmlspecialchars($branch); ?></th>
                            </tr>
                            <tr>
                                <th colspan="6" style="text-align:center">STATEMENT OF CHANGES IN EQUITY</th>
                            </tr>
                            <tr>
                                <th colspan="6" style="text-align:center">AS DATE OF <?php echo date('d-M-Y',strtotime($date2)); ?></th>
                            </tr>
                            </thead>
                            <tbody>
                                <tr style="font-weight: bold; background-color: #f2f2f2;">
                                    <td>Details</td>
                                    <td>Share Capital</td>
                                    <td>Share Premium</td>
                                    <td>Revaluation Reserve</td>
                                    <td>Retained Earnings</td>
                                    <td>Total Equity</td>
                                </tr>
                                 <?php
                                 $share_capital = getAmount($con, 2110, $date1);
                                 $share_premium = getAmount($con, 2125, $date1);
                                 $Revaluation_reserve = getAmount($con, 2115, $date1);
                                 $retain = getAmount($con, 2110, $date1) + $profitprev;
                                 $total1 = $share_capital+$share_premium+$Revaluation_reserve+$retain;
                                 $dividends = getAmount($con, 2215, $date1);
                                 $Revaluation_reserve2 = getAmount($con, 2115, $date2);
                                 $share_capital1 = getAmount($con, 2110, $date2);
                                 $share_premium1 = getAmount($con, 2125, $date2);
                                 //$retain1 = getAmount($con, 2110, $date2);
                                 $total2 = $share_capital1+$Revaluation_reserve2+$dividends+$profitnow+$share_premium1;
                                 ?>
                                <tr>
                                    <td style="text-align: left">Balance at Beginning of the Year</td>
                                    <td><?php echo number_format($share_capital,2);?></td>
                                    <td><?php echo number_format($share_premium,2);?></td>
                                    <td><?php echo number_format($Revaluation_reserve,2);?></td>
                                    <td><?php echo number_format($retain,2);?></td>
                                    <td><?php echo number_format($total1,2);?></td>
                                </tr>
                                <tr>
                                    <td style="text-align: left">Shares Issued</td>
                                    <td><?php echo number_format($share_capital1,2);?></td>
                                    <td>-</td>
                                    <td>-</td>
                                    <td>-</td>
                                    <td><?php echo number_format($share_capital1,2);?></td>
                                </tr>
                                <tr>
                                    <td style="text-align: left">Premium On Shares Issued</td>
                                    <td>-</td>
                                    <td><?php echo number_format($share_premium,2);?></td>
                                    <td>-</td>
                                    <td>-</td>
                                    <td><?php echo number_format($share_premium1,2);?></td>
                                </tr>
                                <tr>
                                    <td style="text-align: left">Profit for the Year</td>
                                    <td>-</td>
                                    <td>-</td>
                                    <td>-</td>
                                    <td><?php echo number_format($profitnow,2);?></td>
                                    <td><?php echo number_format($profitnow,2);?></td>
                                </tr>
                                <tr>
                                    <td style="text-align: left">Dividends Paid</td>
                                    <td>-</td>
                                    <td>-</td>
                                    <td>-</td>
                                    <td>(<?php echo number_format(-1*$dividends,2);?>)</td>
                                    <td>(<?php echo number_format(-1*$dividends,2);?>)</td>
                                </tr>
                                <tr>
                                    <td style="text-align: left">Revaluation Gains</td>
                                    <td>-</td> 
                                    <td>-</td>
                                    <td><?php echo number_format($Revaluation_reserve2,2);?></td>
                                    <td>-</td>
                                    <td><?php echo number_format($Revaluation_reserve2,2);?></td>
                                </tr>
                                <tr style="font-weight: bold; background-color: #f9f9f9;">
                                    <td style="text-align: left">Balance at End of the Year</td>
                                    <td><?php echo number_format($share_premium,2);?></td>
                                    <td><?php echo number_format($share_capital1+$share_capital,2);?></td>
                                    <td><?php echo number_format($Revaluation_reserve2+$Revaluation_reserve,2);?></td>
                                    <td><?php echo number_format($retain+$profitnow+$dividends,2);?></td>
                                    <td><?php echo number_format($total2,2);?></td>
                                </tr>
                            </tbody>
                        </table>

                    </div>
                </div>
                <div class="panel-footer">
                </div>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>

<script>
function printTable() {
    var printWindow = window.open('', '_blank');
    printWindow.document.open();
    printWindow.document.write('<html><head><title>Print Report</title></head><body>');
    printWindow.document.write('<style>table { border-collapse: collapse; width: 100%; } th, td { border: 1px solid black; padding: 8px; }</style>');

    // Get all tables in the printing area
    var tables = document.getElementById('printingArea').querySelectorAll('table');
    tables.forEach(function(table) {
        printWindow.document.write(table.outerHTML); // Append each table to the print window
        printWindow.document.write('<br>'); // Add a line break between tables
    });

    printWindow.document.close();
    printWindow.print();
}


function exportToExcel() {
    var table = document.getElementById('printingArea');
    var wb = XLSX.utils.table_to_book(table);
    var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });
    var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

    var link = document.createElement('a');
    link.href = window.URL.createObjectURL(blob);
    link.download = 'change_equity_report.xlsx';
    link.click();
}

function s2ab(s) {
    var buf = new ArrayBuffer(s.length);
    var view = new Uint8Array(buf);
    for (var i = 0; i < s.length; i++) {
        view[i] = s.charCodeAt(i) & 0xFF;
    }
    return buf;
}
</script>
</body>
</html>
