<?php
session_start();
include "../db/connection.php";
if (!isset($_SESSION['id'])) {
    header('location:../index.php');
    exit;
}
if (isset($_POST['submit_account_group'])) {
    $group = $_POST['group'];
    $statement = $_POST['statement'];
    $nature = $_POST['nature'];
    $nameeng = $_POST['nameeng'];
    $namekisw = $_POST['namekisw'];

    if ($nameeng == '' || $namekisw == '') {
        echo "<script>alert('Fill all empty blanks');</script>";
    } else {
        try {

            $pdo = new PDO($dsn, $username, $password);
            $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

            $stmt = $pdo->prepare("INSERT INTO account_group VALUES(NULL, ?, ?, ?, ? ,?)");
            
            $stmt = $pdo->prepare("INSERT INTO account_group 
                                (nameeng,namekisw,statement, nature, group 
                                VALUES (:nameeng,:namekisw,:statement, :nature, :group)");
            
             // Bind parameters to the prepared statement
            $stmt->bindParam(':nameeng', $nameeng);
            $stmt->bindParam(':namekisw', $namekisw);
            $stmt->bindParam(':statement', $statement);
            $stmt->bindParam(':nature', $nature);
            $stmt->bindParam(':group', $group);
            
            //$stmt->execute([$nameeng, $namekisw, $class, $group]);
            // Execute the prepared statement
            $stmt->execute();

            echo "<script>alert('Successfully added');</script>";
        } catch (PDOException $e) {
            echo "<script>alert('Something wrong');</script>";
        }
    }
}
?>

<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
              <li><a href="index.php?p=accounting" style="color: rgb(7, 133, 164)">Accounting And Reports</a></li>
              <li><a href="index.php?p=account_group_settings" style="color: rgb(7, 133, 164)">Chart of Accounts(groups)</a></li>
              <li class="active">New Group</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">CREATE NEW GROUP</h3>
                    <div class="pull-right">
                      <a href="index.php?p=account_group_settings"><button class="btn btn-success"> <span class="fa fa-plus-circle"></span> View Groups</button></a>
                     </div>
                </div>
                <div class="panel-body">
                    <form class="form-horizontal" method="post" action="">
                        <div class="panel-body tab-content">
                            <div class="tab-pane active" id="tab-first">
                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label">Main Group</label>
                                    <div class="col-md-6 col-xs-12">
                                        <select class="form-control select" name="group">
                                            <option value="Asset">Asset</option>
                                            <option value="Liabilities">Liabilities</option>
                                            <option value="Equity">Equity</option>
                                            <option value="Expense">Expense</option>
                                            <option value="Revenue">Revenue</option>
                                        </select>
                                    </div>
                                </div>
                                
                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label">Financial Statement</label>
                                    <div class="col-md-6 col-xs-12">
                                        <select class="form-control select" name="statement">
                                            <option>Balance sheet</option>
                                            <option>Income statement</option>
                                        </select>
                                    </div>
                                </div>

                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label" title="This are Financial Statement Line Items For Creating Financial Reports">Group Name (ENG)*</label>
                                    <div class="col-md-6 col-xs-12">
                                        <textarea class="form-control" name="nameeng"></textarea>
                                    </div>
                                </div>

                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label">Group Name (KISW)</label>
                                    <div class="col-md-6 col-xs-12">
                                        <textarea class="form-control" name="namekisw"></textarea>
                                    </div>
                                </div>
                                
                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label">Account Nature</label>
                                    <div class="col-md-6 col-xs-12">
                                        <select class="form-control select" name="nature">
                                            <option>Debit</option>
                                            <option>Credit</option>
                                        </select>
                                    </div>
                                </div>

                            </div>
                        </div>

                </div>
                <div class="panel-footer">
                    <button type="submit" name="submit_account_group" class="btn btn-warning pull-right">Submit <span class="fa fa-floppy-o fa-right"></span></button>
                </div>
                </form>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->

</div>
