<?php
error_reporting(E_ALL);
ini_set('display_errors', 1);


// Fetch accounts and fixed assets
try {
    // Fetch accounts ordered by account_name
    $queryAccount = $pdo->query("SELECT * FROM chart_master WHERE account_type = 17 ORDER BY account_name ASC");
    $accounts = $queryAccount->fetchAll(PDO::FETCH_ASSOC);
   
   //----fetch account for expense-----
    $expenseAccount = $pdo->query("SELECT * FROM chart_master  WHERE account_code = 64510 ORDER BY account_name ASC");
    $expensaccount = $expenseAccount->fetchAll(PDO::FETCH_ASSOC);
    
   //----fetch account for accumulated-----
    $accumAccount = $pdo->query("SELECT * FROM chart_master  WHERE account_name LIKE 'Accum%' ORDER BY account_name ASC");
    $accumulatedccount = $accumAccount->fetchAll(PDO::FETCH_ASSOC);
    
   //----fetch account for maintanance-----
    $mainAccount = $pdo->query("SELECT * FROM chart_master  WHERE account_name LIKE 'Capitalized%' ORDER BY account_name ASC");
    $maintananceccount = $mainAccount->fetchAll(PDO::FETCH_ASSOC);
    
   //----fetch account for asset account-----
    $assAccount = $pdo->query("SELECT * FROM chart_master  WHERE account_name NOT LIKE 'Capitalized%' AND account_name NOT LIKE 'Accum%' ORDER BY account_name ASC");
    $assetAccount = $assAccount->fetchAll(PDO::FETCH_ASSOC);
    
    // Fetch fixed assets
    $queryAsset = $pdo->query("SELECT * FROM fixedasset");
    $assets = $queryAsset->fetchAll(PDO::FETCH_ASSOC);
    
    
} catch (PDOException $e) {
    die("Error fetching data: " . $e->getMessage());
}

// Handle form submission
if (isset($_POST['submit'])) {
    $assetType = $_POST['assetType'] ?? null;
    $assetAccount = $_POST['assetAccount'] ?? null;
    $accumulatedDepreciation = $_POST['accumulatedDepreciation'] ?? null;
    $depreciationExpense = $_POST['depreciationExpense'] ?? null;
    $revaluation_gain = $_POST['revaluation_gain'] ?? null;
    $revaluation_loss = $_POST['revaluation_loss'] ?? null;
    $maintenance_cost = $_POST['maintenance_cost'] ?? null;
    $depreciationMethod = strtolower($_POST['depreciationMethod'] ?? '');
    $averagingMethod = $_POST['averagingMethod'] ?? null;
    $depreciationRate = $_POST['depreciationRate'] ?? null;
    $usefulLife = $_POST['usefulLife'] ?? null;
    $branch = $_SESSION['Branch'] ?? null;

    // Validate required fields
    if (!$assetType || !$assetAccount || !$accumulatedDepreciation || !$depreciationExpense || !$depreciationMethod || !$averagingMethod || !$depreciationRate || !$usefulLife) {
        echo "<p class='alert alert-danger'>Error: All required fields must be filled out.</p>";
    } else {
        // Insert data using a prepared statement
        $sql = "INSERT INTO fixedasset 
                (asset_type, asset_account, accumulated_depreciation_account, depreciation_expense_account, 
                 depreciation_method, averaging_method, depreciation_rate, useful_life, branch, 
                 revaluation_gain_account, revaluation_loss_account, maintenance_cost_account) 
                VALUES 
                (:assetType, :assetAccount, :accumulatedDepreciation, :depreciationExpense, 
                 :depreciationMethod, :averagingMethod, :depreciationRate, :usefulLife, :branch, 
                 :revaluation_gain, :revaluation_loss, :maintenance_cost)";

        try {
            $stmt = $pdo->prepare($sql);
            $stmt->execute([
                ':assetType' => $assetType,
                ':assetAccount' => $assetAccount,
                ':accumulatedDepreciation' => $accumulatedDepreciation,
                ':depreciationExpense' => $depreciationExpense,
                ':depreciationMethod' => $depreciationMethod,
                ':averagingMethod' => $averagingMethod,
                ':depreciationRate' => $depreciationRate,
                ':usefulLife' => $usefulLife,
                ':branch' => $branch,
                ':revaluation_gain' => $revaluation_gain,
                ':revaluation_loss' => $revaluation_loss,
                ':maintenance_cost' => $maintenance_cost,
            ]);

            echo "<script src='https://cdn.jsdelivr.net/npm/sweetalert2@11'></script>";
            echo "<script>
                Swal.fire({
                    icon: 'success',
                    title: 'Success',
                    text: 'Asset Type Created successfully.',
                    confirmButtonText: 'OK'
                }).then(() => {
                    setTimeout(() => {
                        window.location='index.php?p=asset_settings';
                    }, 1000); 
                });
            </script>";
        } catch (PDOException $e) {
            echo "<p class='alert alert-danger'>Error: " . $e->getMessage() . "</p>";
        }
    }
}
?>

<div class="col-md-9">
     <div class="page-content-wrap">
        <div class="row">
            <div class="col-md-12">
                <ul class="breadcrumb" style="height: 40px;padding-top: 10px;">                  
                    <li><a href="index.php?p=fixed_asset_menu" style="color: rgb(7, 133, 164)">Fixed Asset Menu</a></li>
                    <li><a href="index.php?p=asset_settings" style="color: rgb(7, 133, 164)">Setting List</a></li>
                    <li class="active">Add New Asset Type</li>
                </ul>
                <form class="form-horizontal" method="post" action="" enctype="multipart/form-data">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title" style="color: rgb(174, 169, 169);"><strong>Add New Asset Type</strong></h3>
                        <button class="btn btn-default btn btn-warning pull-right" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                    </div>
                    <div class="panel-body">          
						<div class="modal-body">
							<div class="form-group">
								<div class="row">
									<div class="col-sm-4">
										<label for="emp_code">Asset Type:</label>
										<input type="text" class="form-control" id="assetType" name="assetType" required/>
									</div>
									<div class="col-sm-4">
										<label for="assetAccount">Asset Account:</label>
        									<select class="form-control select" id="assetAccount" data-live-search="true" name="assetAccount" required>
                                                          <?php
        						                      foreach($assetAccount as $row):
        						                           ?>
        							                   <option value="<?php echo $row['account_code'];?>"><?php echo $row['account_name'];?> - <?php echo $row['account_code'];?></option>
        							                    <?php
        							                     endforeach;
        							                     ?>
                                           </select>
									</div>
									<div class="col-sm-4">
										<label for="accumulatedDepreciation">Accumulated Depreciation Account:</label>
                    			          <select class="form-control select" id="accumulatedDepreciation" name="accumulatedDepreciation" data-live-search="true">
                    				          <?php
                    						     foreach($accumulatedccount as $row):
                    						    ?>
                    							<option value="<?php echo $row['account_code'];?>"><?php echo $row['account_name'];?> - <?php echo $row['account_code'];?></option>
                    							<?php
                    							endforeach;
                    							?>
                    			           </select>
									</div>
								</div>
							</div>
							<div class="form-group">
								<div class="row">
									<div class="col-sm-4">
									<label for="depreciationExpense">Depreciation Expense Account:
            						</label>
            						<select class="form-control select" id="depreciationExpense" name="depreciationExpense" data-live-search="true">
            						    <?php
            						     foreach($expensaccount as $row):
            						    ?>
            							<option value="<?php echo $row['account_code'];?>"><?php echo $row['account_name'];?> - <?php echo $row['account_code'];?></option>
            							<?php
            							endforeach;
            							?>
            						</select>
									</div>
									<div class="col-sm-4">
										<label for="depreciationExpense">Revaluation Gain Account:
                						</label>
                						<select class="form-control select" id="revaluation_gain" name="revaluation_gain" data-live-search="true">
                						    <?php
                						     foreach($accounts as $row):
                						    ?>
                							<option value="<?php echo $row['account_code'];?>"><?php echo $row['account_name'];?> - <?php echo $row['account_code'];?></option>
                							<?php
                							endforeach;
                							?>
                						</select>
									</div>
									<div class="col-sm-4">
										<label for="depreciationExpense">Revaluation Loss Account:
                						</label>
                						<select class="form-control select" id="revaluation_loss" name="revaluation_loss" data-live-search="true">
                						    <?php
                						     foreach($accounts as $row):
                						    ?>
                							<option value="<?php echo $row['account_code'];?>"><?php echo $row['account_name'];?> - <?php echo $row['account_code'];?></option>
                							<?php
                							endforeach;
                							?>
                						</select>
									</div>
								</div>
							</div>
							<div class="form-group">
								<div class="row">
									<div class="col-sm-4">
										<label for="depreciationExpense">Maintenance Cost Account:
                						</label>
                						<select class="form-control select" id="maintenance_cost" name="maintenance_cost" data-live-search="true">
                						    <?php
                						     foreach($maintananceccount as $row):
                						    ?>
                							<option value="<?php echo $row['account_code'];?>"><?php echo $row['account_name'];?> - <?php echo $row['account_code'];?></option>
                							<?php
                							endforeach;
                							?>
                						</select>
									</div>
									<div class="col-sm-4">
										<label for="depreciationMethod">Depreciation Method:</label>
                						<select class="form-control" id="depreciationMethod" name="depreciationMethod">
                							<option value="noDepreciation">No Depreciation</option>
                							<option value="straightLine">Straight Line</option>
                							<!--<option value="reducingBalance">Reducing (Declining) Balance</option>
                							<option value="unitsProduction">Units of Production</option>
                							<option value="sumOfYearDigit">Sum-of-the-Years'-Digits</option>
                							<option value="doubleDeclining">Double Declining Balance</option>-->
                						</select>
									</div>
									<div class="col-sm-4">
										<label for="averagingMethod">Averaging Method:</label>
                						<select class="form-control" id="averagingMethod" name="averagingMethod">
                							<!--<option value="daily">Daily</option>
                							<option value="monthly">Monthly</option>-->
                							<option value="annually">Annually</option>
                						</select>
									</div>
								</div>
							</div>
							<div class="form-group">
								<div class="row">
									<div class="col-sm-4">
										<label for="depreciationRate">Depreciation Rate (%):</label>
						                <input type="number" class="form-control" id="depreciationRate" name="depreciationRate" oninput="calculateUsefulLife()">
									</div>
									<div class="col-sm-4">
										<label for="usefulLife">Useful Life (Years):</label>
						                <input type="number" class="form-control" id="usefulLife" name="usefulLife" readonly>
									</div>
								</div>
							</div>
							
                        </div>
							</div>
					<div class="panel-footer">
					   <button  type="submit" name="submit" class="btn btn-warning pull-right">
					       <span class = "fa fa-plus-circle"></span>Submit</button>
					</div>		
				</div>
						
					</form>
                <!-- END PAGE CONTENT WRAPPER -->        
			   </div>
			  </div>
	</div>
        
</div>            
    <!-- END PAGE CONTENT -->
</div>
<script>
// Function to calculate the useful life based on the depreciation rate
function calculateUsefulLife() {
    var depreciationRate = parseFloat(document.getElementById("depreciationRate").value);
    if (depreciationRate > 0) {
        var usefulLife = 100 / depreciationRate;
        document.getElementById("usefulLife").value = usefulLife.toFixed(2);
    } else {
        document.getElementById("usefulLife").value = "";
    }
}
</script>

    
  

