<?php
session_start();
include '../../db/db.php';

if (isset($_POST['submit'])) {
    // Retrieve data from the form
    $assetid = mysqli_real_escape_string($con, $_POST['assetid']);
    $maintenanceDate = mysqli_real_escape_string($con, $_POST['maintenanceDate']);
    $paidFrom = mysqli_real_escape_string($con, $_POST['paidFrom']);
    $maintenanceType = mysqli_real_escape_string($con, $_POST['maintenanceType']);
    $expenseAccount = mysqli_real_escape_string($con, $_POST['expenseAccount']);
    $amount = mysqli_real_escape_string($con, $_POST['maintenanceCost']);
    $nextMaintenanceDate = mysqli_real_escape_string($con, $_POST['nextMaintenanceDate']);
    $maintenanceDescription = mysqli_real_escape_string($con, $_POST['maintenanceDescription']);

    $asset_query = mysqli_query($con, "SELECT * FROM assetitems AS ai INNER JOIN fixedasset AS fa ON ai.fixedassetid = fa.id AND ai.id=$assetid");
    $asset_rows = mysqli_fetch_assoc($asset_query);

    $assetAcc = $asset_rows['asset_account'];
    $maintenance_cost_account = $asset_rows['maintenance_cost_account'];

    // Insert data into the database
    $query = "INSERT INTO asset_maintenance (date, Paid_from, Maintenance_Type, Expense_Account, Maintenance_Cost, Next_Maintenance_Date, description, asset_id) 
              VALUES ('$maintenanceDate', '$paidFrom', '$maintenanceType', '$expenseAccount', '$amount', '$nextMaintenanceDate', '$maintenanceDescription','$assetid')";

    if (mysqli_query($con, $query)) {
        $transId = mysqli_insert_id($con);

        if ($maintenanceType == 'Revenue Expenditure') {
            $debit = mysqli_query($con, "SELECT * FROM chart_master WHERE account_code = '$maintenance_cost_account'");
            $rows = mysqli_fetch_array($debit);
            $class_debit = $rows['class'];
            $fsli_debit = $rows['account_type'];

            $credit = mysqli_query($con, "SELECT * FROM chart_master WHERE account_code = '$paidFrom'");
            $rowss = mysqli_fetch_array($credit);
            $class_credit = $rowss['class'];
            $fsli_credit = $rowss['account_type'];

            // Debit Expense Account
            mysqli_query($con, "INSERT INTO gl_transaction VALUES('', '$maintenance_cost_account', '$fsli_debit', '$class_debit', '$amount', 'Debit', '$transId', '".$_SESSION['id']."', '$maintenanceDescription', '".date('Y')."', '$maintenanceDate', '".$_SESSION['Branch']."', 'Fixed Asset Maintenance')");
            // Credit Paid From Account
            mysqli_query($con, "INSERT INTO gl_transaction VALUES('', '$paidFrom', '$fsli_credit', '$class_credit', '$amount', 'Credit', '$transId', '".$_SESSION['id']."', '$maintenanceDescription', '".date('Y')."', '$maintenanceDate', '".$_SESSION['Branch']."', 'Fixed Asset Maintenance')");
        } else {
            $debit = mysqli_query($con, "SELECT * FROM chart_master WHERE account_code = '$assetAcc'");
            $rows = mysqli_fetch_array($debit);
            $class_debit = $rows['class'];
            $fsli_debit = $rows['account_type'];

            $credit = mysqli_query($con, "SELECT * FROM chart_master WHERE account_code = '$paidFrom'");
            $rowss = mysqli_fetch_array($credit);
            $class_credit = $rowss['class'];
            $fsli_credit = $rowss['account_type'];

            // Debit Asset Account
            mysqli_query($con, "INSERT INTO gl_transaction VALUES('', '$assetAcc', '$fsli_debit', '$class_debit', '$amount', 'Debit', '$transId', '".$_SESSION['id']."', '$maintenanceDescription', '".date('Y')."', '$maintenanceDate', '".$_SESSION['Branch']."', 'Fixed Asset Maintenance')");
            // Credit Paid From Account
            mysqli_query($con, "INSERT INTO gl_transaction VALUES('', '$paidFrom', '$fsli_credit', '$class_credit', '$amount', 'Credit', '$transId', '".$_SESSION['id']."', '$maintenanceDescription', '".date('Y')."', '$maintenanceDate', '".$_SESSION['Branch']."', 'Fixed Asset Maintenance')");

            mysqli_query($con, "UPDATE assetitems SET acquisition_cost = acquisition_cost + $amount WHERE id = $assetid");
        }

        // SweetAlert Success Message
        echo "<script>
            Swal.fire({
                title: 'Success!',
                text: 'Maintenance Successfully Created',
                icon: 'success'
            }).then(() => {
                window.location.href = 'index.php?p=maintenance_list'; // Redirect to a relevant page
            });
        </script>";
    } else {
        // SweetAlert Error Message
        $error_message = mysqli_error($con);
        echo "<script>
            Swal.fire({
                title: 'Error!',
                text: 'Something went wrong: $error_message. Please contact the system administrator.',
                icon: 'error'
            });
        </script>";
    }

    // Close database connection
    mysqli_close($con);
}
?>

<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=accounting" style="color: rgb(7, 133, 164)">Accounting</a></li>
                <li><a href="fixed_asset_tab.php" style="color: rgb(7, 133, 164)">Fixed Asset</a></li>
                <li class="active">Asset Items Maintenance</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>Asset Items Maintenance</b></h3>
                </div>
                <div class="panel-body" style="background: #fff">
                 
				    <form action="" method="post" id="myFormData" onsubmit="submitFormMaintenance(event)">
						<div class="row">
							<!-- First column -->
							<div class="col-md-6">
							    <div class="form-group">
									<label for="paidFrom">Asset Name:</label>
									<select class="form-control select" id="assetid" name="assetid" data-live-search="true">
										<?php
                                          $asset_query = mysqli_query($con,"SELECT * FROM assetitems WHERE status = 0");
                                            while($rows = mysqli_fetch_assoc($asset_query)){
                                         ?>
                                        <option value = "<?php echo $rows['id'];?>"><?php echo $rows['item_number'];?> - <?php echo $rows['item_name'];?></option>
                                        <?php
                                          }
                                        ?>
							       </select>
							    </div>
								<div class="form-group">
									<label for="maintenanceDate">Maintenance Date:</label>
									<input type="text" class="form-control datepicker" id="maintenanceDate" name="maintenanceDate" value="<?php echo date('Y-m-d');?>">
								</div>
								<div class="form-group">
									<label for="maintenanceType">Maintenance Type:</label>
									<select class="form-control select" id="maintenanceType" name="maintenanceType">
										<option value="Capital Expenditure">Capital Expenditure</option>
										<option value="Revenue Expenditure">Revenue Expenditure</option>
									</select>
								</div>
								<div class="form-group">
									<label for="maintenanceCost">Maintenance Cost:</label>
									<input type="text" class="form-control" id="maintenanceCost" name="maintenanceCost">
								</div>
							</div>
							<!-- Second column -->
							<div class="col-md-6">
								<div class="form-group">
									<label for="paidFrom">Paid from:</label>
									<select class="form-control select" id="paidFrom" name="paidFrom" data-live-search="true">
										<?php
                                          $cl = mysqli_query($con,"SELECT * FROM chart_master WHERE account_type_name = 'Cash and Bank' ORDER BY account_code ASC");
                                            while($class = mysqli_fetch_assoc($cl)){
                                         ?>
                                        <option value = "<?php echo $class['account_code'];?>"><?php echo $class['account_code'];?> - <?php echo $class['account_name'];?></option>
                                        <?php
                                          }
                                        ?>
									</select>
								</div>
								<!--<div class="form-group">
									<label for="paidFrom">Expense Account:</label>
									<select class="form-control select" id="expenseAccount" name="expenseAccount" data-live-search="true">
									   <?php
                                          $cl_q = mysqli_query($con,"SELECT * FROM chart_master WHERE account_type=31 ORDER BY account_name ASC");
                                            while($class = mysqli_fetch_assoc($cl_q)){
                                         ?>
                                        <option value = "<?php echo $class['account_code'];?>"><?php echo $class['account_code'];?> - <?php echo $class['account_name'];?></option>
                                        <?php
                                          }
                                        ?>
									</select>
								</div>-->
								<div class="form-group">
									<label for="nextMaintenanceDate">Next Maintenance Date:</label>
									<input type="text" class="form-control datepicker" id="nextMaintenanceDate" name="nextMaintenanceDate" value="<?php echo date('Y-m-d');?>">
								</div>
							    <div class="form-group">
									<label for="maintenanceDescription">Maintenance descriptions:</label>
									<textarea class="form-control" id="maintenanceDescription" name="maintenanceDescription" rows="3" required></textarea>
								</div>
							</div>    
						</div>
						<!-- Add more fields as needed -->
                   </div>
                 <div class="panel-footer">
                <button class="btn btn-warning pull-right" type="submit" name="submit">
                    <span class="fa fa-plus-circle"></span> Create
                </button>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>
