<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
    <div class="col-md-12">
        <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
           <li><a href="index.php?p=fixed_asset_menu" style="color: rgb(7, 133, 164)">Fixed Asset Menu</a></li>
           <li class="active">Depreciation</li>
        </ul>
       <div class="panel panel-default">
        <div class="panel-heading">
            <h3 class="panel-title"><b>DEPRECIATION</b></h3>
        </div>
        <div class="panel-body" style="background: #fff">
          <div class="table-responsive">
            <table id="assetDepreciationTable" class="table datatable">
                <thead>
                    <tr>
                        <th>Asset Type</th>
                        <th>Asset No#</th>
                        <th>Asset Name</th>
                        <th>Accumulated Depreciation A/C</th>
                        <th>Depreciation Expense A/C</th>
                        <th>Depreciation Amount</th>
                    </tr>
                </thead>
                <tbody>
                <?php
                try {
                    // Prepare the query
                    $stmt = $pdo->query("
                        SELECT 
                            ad.AssetID, 
                            fd.asset_type, 
                            ai.item_number, 
                            ai.item_name,
                            SUM(ad.Amount) AS TotalAmount,
                            cm1.account_name AS accumulated_depreciation_account_name,
                            cm2.account_name AS depreciation_expense_account_name
                        FROM AccumulativeDepreciation AS ad
                        INNER JOIN assetitems AS ai ON ad.AssetID = ai.id
                        INNER JOIN fixedasset AS fd ON fd.id = ai.fixedassetid
                        INNER JOIN chart_master AS cm1 ON fd.accumulated_depreciation_account = cm1.account_code
                        INNER JOIN chart_master AS cm2 ON fd.depreciation_expense_account = cm2.account_code
                        GROUP BY ad.AssetID
                    ");

                    // Fetch all rows
                    $results = $stmt->fetchAll(PDO::FETCH_ASSOC);
                } catch (PDOException $e) {
                    $results = [];
                    echo "<tr><td colspan='6'>Error: " . htmlspecialchars($e->getMessage()) . "</td></tr>";
                }
                ?>

                <?php foreach ($results as $row): ?>
                    <tr>
                        <td><?= htmlspecialchars($row['asset_type']) ?></td>
                        <td><?= htmlspecialchars($row['item_number']) ?></td>
                        <td><?= htmlspecialchars($row['item_name']) ?></td>
                        <td><?= htmlspecialchars($row['accumulated_depreciation_account_name']) ?></td>
                        <td><?= htmlspecialchars($row['depreciation_expense_account_name']) ?></td>
                        <td><?= number_format($row['TotalAmount']) ?></td>
                    </tr>
                <?php endforeach; ?>
                </tbody>
            </table>
           </div> 
        </div>
    </div>
  </div>
</div>
