<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
    <div class="col-md-12">
        <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
           <li><a href="index.php?p=fixed_asset_menu" style="color: rgb(7, 133, 164)">Fixed Asset Menu</a></li>
           <li class="active">Valuation</li>
        </ul>
       <div class="panel panel-default">
        <div class="panel-heading">
            <h3 class="panel-title"><b>ASSET VALUATION</b></h3>
        </div>
        <div class="panel-body" style="background: #fff">
          <div class="table-responsive">
            	<table id="assetRevaluationTable" class="table datatable">
					<thead>
						<tr>
							<th>Asset Name</th>
							<th>Asset No.</th>
							<th>Asset Type</th>
							<th>Purchase Date</th>
							<th>Purchase Cost</th>
							<th>Revaluation Date</th>
							<th>Previous Value</th>
							<th>Revalued Value</th>
							<th>Change in Value</th>
						</tr>
					</thead>
					<tbody>
					    <?php
					    // Establish a PDO connection
					    try {
					       
					        // Prepare the query
					        $stmt = $pdo->prepare("SELECT * 
					        FROM assetitems AS ai 
					        INNER JOIN fixedasset AS fa
								ON ai.fixedassetid=fa.id 
							INNER JOIN revalue AS ra 
							     ON ai.id=ra.Asset_Id
					        ");
					        $stmt->execute();

					        // Fetch all rows
					        $results = $stmt->fetchAll(PDO::FETCH_ASSOC);
					    ?>
					    <?php foreach ($results as $rws): 
					        $book_value = $rws['AssetCost'] - $rws['DepreciationAmt'];
					        $gain_lose = $rws['Revaluation_Amount'] > $book_value
					            ? number_format($rws['Revaluation_Amount'] - $book_value, 2)
					            : '(' . number_format($book_value - $rws['Revaluation_Amount'], 2) . ')';
					    ?>
						<tr>
							<td><?= htmlspecialchars($rws['item_name']) ?></td>
							<td><?= htmlspecialchars($rws['item_number']) ?></td>
							<td><?= htmlspecialchars($rws['asset_type']) ?></td>
							<td><?= date('d-m-Y', strtotime($rws['purchased_date'])) ?></td>
							<td><?= number_format($rws['AssetCost'], 2) ?></td>
							<td><?= date('d-m-Y', strtotime($rws['Date_Revalued'])) ?></td>
							<td><?= number_format($book_value, 2) ?></td>
							<td><?= number_format($rws['Revaluation_Amount'], 2) ?></td>
							<td><?= $gain_lose ?></td>
						</tr>
					    <?php endforeach; ?>
					    <?php
					    } catch (PDOException $e) {
					        echo "<tr><td colspan='9'>Database error: " . htmlspecialchars($e->getMessage()) . "</td></tr>";
					    }
					    ?>
					</tbody>
				</table>
           </div> 
        </div>
    </div>
  </div>
</div>
