<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=accounting" style="color: rgb(7, 133, 164)">Accounting Menu</a></li>
                <li class="active">Journal</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">JOURNAL</h3>
                    <div class="pull-right">
                        <a href="index.php?p=journal_entries_add"><button class="btn btn-warning">
                            <span class="fa fa-plus-circle"></span> Create New
                        </button></a>
                    </div>
                </div>
                <div class="panel-body">
                    <div class="table-responsive">
                        <?php
                        try {
                            $branch = $_SESSION['Branch'];
                            $stmt = $pdo->prepare("SELECT * FROM journal WHERE Branch = :branch ORDER BY Id ASC");
                                $stmt->execute([':branch' => $branch]); // Bind the branch parameter
                                $transaction_data = $stmt->fetchAll(PDO::FETCH_ASSOC);
                        ?>
                            <table class="table datatable table-striped table-hover">
                                <thead>
                                    <tr>
                                        <th>#</th>
                                        <th>Date</th>
                                        <th>Narration</th>
                                        <th>Debit</th>
                                        <th>Credit</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <?php
                                    $a = 1;
                                    foreach ($transaction_data as $data) {
                                    ?>
                                        <tr>
                                            <td><?php echo $a; ?></td>
                                            <td><?php echo $data['Date']; ?></td>
                                            <td><?php echo $data['Note']; ?></td>
                                            <td><?php echo number_format($data['Debit'], 2); ?></td>
                                            <td><?php echo number_format($data['Credit'], 2); ?></td>
                                            <td class="journal-actions">
                                                <a href="index.php?p=journal_edit&EditId=<?php echo encrypt($data['Id'], $encryption_key, $encryption_method, $iv); ?>" class="edit-icon">
                                                    <span class="fa fa-edit fa-lg"></span>
                                                </a>
                                               <a href="index.php?EditId=<?php echo encrypt($data['Id'], $encryption_key, $encryption_method, $iv); ?>&p=journal_delete" onclick="return confirm('Are you sure you want to delete this record?')" class="delete-icon">
                                                    <span class="glyphicon glyphicon-remove" style="color:red; font-size: 14px;"></span>
                                                </a>
                                                <a href="index.php?p=journal_view&Id=<?php echo encrypt($data['Id'], $encryption_key, $encryption_method, $iv); ?>" class="view-icon" onclick="viewJournalEntry(this)">
                                                    <span class="glyphicon glyphicon-eye-open" style="color:green;font-size: 14px"></span>
                                                </a>
                                            </td>
                                        </tr>
                                    <?php
                                        $a++;
                                    }
                                    ?>
                                </tbody>
                            </table>
                        <?php
                        } catch (PDOException $e) {
                            echo "Error: " . $e->getMessage();
                        }
                        ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
