<?php
if (isset($_GET['Id'])) {
     $idd = $_GET['Id'];
     $id = decrypt($idd, $encryption_key, $encryption_method);
}
try {
   
    // Create a new PDO instance
 $pdo = new PDO($dsn, $username, $password);
 $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
     
  // Query to fetch data from journal table
  $journal_stmt = $pdo->prepare("SELECT * FROM journal WHERE Id = :id");
  $journal_stmt->bindParam(':id',$id);
  $journal_stmt->execute();
    // Fetch all results
  $journals= $journal_stmt->fetch(PDO::FETCH_ASSOC);
  
  
   
   // query to fech data from business info
   $business_stmt = $pdo->query("SELECT * FROM BusinessInfo");
   $business = $business_stmt->fetch(PDO::FETCH_ASSOC);
   
   //define cat and transcId 
   $transid = $id;
   // Define cat as an array with the values 'Journal' and 'Tax Journal'
$cat = ['Journal', 'Tax Journal'];

// Query to select from gl_transaction using IN clause for multiple values in $cat
$gl_stmt = $pdo->prepare("
    SELECT 
        gl.account, gl.nature, gl.amount, cm.account_name,
        CASE WHEN gl.nature = 'Debit' THEN gl.amount ELSE '0' END AS Debit_Amount,
        CASE WHEN gl.nature = 'Credit' THEN gl.amount ELSE '0' END AS Credit_Amount
    FROM gl_transaction AS gl 
    INNER JOIN chart_master AS cm ON gl.account = cm.account_code
    WHERE gl.transid = :transid AND gl.cat IN (:cat1, :cat2)
");

// Bind the transaction ID
$gl_stmt->bindParam(':transid', $transid);
// Bind the category values
$gl_stmt->bindParam(':cat1', $cat[0]);
$gl_stmt->bindParam(':cat2', $cat[1]);

$gl_stmt->execute();
$gls = $gl_stmt->fetchAll(PDO::FETCH_ASSOC);

   
} catch (PDOException $e) {
    // Handle PDO exceptions
    echo "Connection failed: " . $e->getMessage();
}

?>

<style>
        .company-details {
            float: right;
            text-align: right;
        }
        .company-details img {
            max-width: 150px;
            margin-bottom: 10px;
        }
    </style>
    
<div class="col-md-9">
   <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
      <li><a href="index.php?p=accounting" style="color: rgb(7, 133, 164)">Accounting And Reports</a></li>
      <li><a href="index.php?p=journal" style="color: rgb(7, 133, 164)">Journal List</a></li>
      <li class="active">Journal</li>
    </ul>
<div class="panel panel-default">
    <div class="panel-heading">
        <h3 class="panel-title"><b>Journal</b></h3>
        <div class="pull-right">
            
            
            <a href="../pdf/reports/journal_print.php?id=<?php echo $id; ?>" target="_blank">
                <button class="btn btn-default" onclick="exportToPDF()">
                    <span class="fa fa-file-o"></span> Print
                </button>
            </a>

        </div>
    </div>
    <div class="panel-body" style="background: #fff">
        <div class="table-responsive">
            <table class="table" id="printabletable">
                <thead>    
                    <tr>
                        <td colspan="3" class="center-left-align" style="background-color:#2d2860; height:30px;">
                            <h4 style="color:#F3A02A;"><b>JOURNAL ENTRY STATEMENT</b></h4>
                        </td>
                    </tr>
                    <tr>
                        <td colspan="3">
                            <div style="overflow: hidden;">
                                <div style="float: left;">
                                    <p style="font-size:16px; padding-top:30px; color:black; text-align:left;">
                                        Reference Number:
                                        <span style="color:gray; padding-left:30px;"> JE<?php echo $id?></span> <br/>
                                        Journal entry date:
                                        
                                        <span style="color:gray; padding-left:30px;"><?php echo $journals['Date'];?></span>
                                    </p>
                                </div>
                                <div class="company-details">
                                    <img src="../<?php echo $business['business_logo'] ?>" alt="Company Logo">
                                    <p style="color:black;">
                                        <?php echo $business['business_name'] ?><br>
                                        <?php echo $business['physical_location'] ?><br>
                                        Address Line 2<br>
                                        Phone: <?php echo $business['telephone_number'] ?> <br>
                                        Email: <?php echo $business['email'] ?>
                                    </p>
                                </div>
                            </div>
                        </td>
                    </tr>
                </thead>
                
                <tbody>
                    
                    <tr>
                        <td align="left" colspan=3><h4 style="color:black;"><b>Journal Description:</b> <?php echo $journals['Note'];?></h4></td>
                    </tr>
                    <tr style="background-color:#2d2860; height:30px;">
                        <td align="left"><h4 style="color:#F3A02A;font-weight:bold;">Account Name</h4></td>
                        <td align="left"><h4 style="color:#F3A02A;font-weight:bold;">Debit</h4></td>
                        <td align="left"><h4 style="color:#F3A02A;font-weight:bold;">Credit</h4></td>
                    </tr>
                    
                       <?php 
                       $debitTotal=0;
                       $creditTotal=0;
                       foreach ($gls as $gl): 
                           $debitTotal+=$gl['Debit_Amount'];
                           $creditTotal+=$gl['Credit_Amount'];
                       ?>
                            <tr>
                                <td align="left"><p style="color:black; font-size:14px"><?php echo $gl['account_name']; ?></p></td>
                                <td><p style="color:black; font-size:14px"><?php echo number_format($gl['Debit_Amount'],2); ?></p></td>
                                <td><p style="color:black; font-size:14px"><?php echo number_format($gl['Credit_Amount'],2); ?></p></td>
                            </tr>
                        <?php endforeach; ?>
					<tr>
                        <td align="left"><p style="color:black; font-size:14px;font-weight:bold">Total</p></td>
                        <td><p style="color:black; font-size:14px;font-weight:bold"><?php echo number_format($debitTotal,2); ?></p></td>
                        <td><p style="color:black; font-size:14px;font-weight:bold"><?php echo number_format($creditTotal,2); ?></p></td>
                    </tr>
                </tbody> 
            </table>
        </div> 
    </div>
</div>
                        </div>
                        <!-- END TIMELINE -->