<?php
session_start();
include "../db/connection.php";

if (isset($_POST['submit_jornal'])) {
    $debit_account = $_POST['debit'];
    $credit_account = $_POST['credit'];
    $amount = $_POST['amount'];
    $notes = $_POST['notes'];
    $date = $_POST['date'];
    $user = $_SESSION['id'];
    $fyear = date('Y');

    if ($debit_account == '' || $credit_account == '' || $amount == '' || $notes == '' || $date == '') {
        echo "<script>alert('Fill all empty blanks --- Hakikisha umejaza sehemu zote zenye alama ya nyota');</script>";
    } else {
        try {
            $pdo = new PDO($dsn, $username, $password);
            $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

            // Start a transaction
            $pdo->beginTransaction();
            
             // Fetch debit account details
            $stmtDebitAccount = $pdo->prepare("SELECT * FROM chart_master WHERE account_code = ?");
            $stmtDebitAccount->execute([$debit_account]);
            $debit_account_details = $stmtDebitAccount->fetch(PDO::FETCH_ASSOC);
            $fsli = $debit_account_details['account_type'];
            $group = $debit_account_details['class'];
            // Fetch credit account details
            $stmtCreditAccount = $pdo->prepare("SELECT * FROM chart_master WHERE account_code = ?");
            $stmtCreditAccount->execute([$credit_account]);
            $credit_account_details = $stmtCreditAccount->fetch(PDO::FETCH_ASSOC);
            $fsli2 = $credit_account_details['account_type'];
            $group2 = $credit_account_details['class'];

            // Prepare the SQL statements for debit and credit entries
            $stmtDebit = $pdo->prepare("INSERT INTO gl_transaction (account, fsli, maingroup, amount, nature, transid, user, notes, fyear, date, branchno, cat) VALUES (?, ?, ?, ?, 'debit', 0, ?, ?, ?, ?, ?, ?)");
            $stmtCredit = $pdo->prepare("INSERT INTO gl_transaction (account, fsli, maingroup, amount, nature, transid, user, notes, fyear, date, branchno, cat) VALUES (?, ?, ?, ?, 'credit', 0, ?, ?, ?, ?, ?, ?)");


            // Bind parameters for debit entry
        $stmtDebit->bindParam(1, $debit_account);
        $stmtDebit->bindParam(2, $fsli);
        $stmtDebit->bindParam(3, $group);
        $stmtDebit->bindParam(4, $amount);
        $stmtDebit->bindParam(5, $user);
        $stmtDebit->bindParam(6, $notes);
        $stmtDebit->bindParam(7, $fyear);
        $stmtDebit->bindParam(8, $date);
        $stmtDebit->bindParam(9, $_SESSION['Branch']);
        $stmtDebit->bindParam(10, 5);

        // Bind parameters for credit entry
        $stmtCredit->bindParam(1, $credit_account);
        $stmtCredit->bindParam(2, $fsli2);
        $stmtCredit->bindParam(3, $group2);
        $stmtCredit->bindParam(4, $amount);
        $stmtCredit->bindParam(5, $user);
        $stmtCredit->bindParam(6, $notes);
        $stmtCredit->bindParam(7, $fyear);
        $stmtCredit->bindParam(8, $date);
        $stmtDebit->bindParam(9, $_SESSION['Branch']);
        $stmtDebit->bindParam(10, 5);

            // Execute the debit and credit queries
            $stmtDebit->execute();
            $stmtCredit->execute();

            // Commit the transaction
            $pdo->commit();

            echo "<script>alert('Double-entry transaction recorded successfully');</script>";
        } catch (PDOException $e) {
        // Rollback the transaction if an error occurs
        $pdo->rollBack();
        echo $e->getMessage();
    }
    }
}
?>


<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">PAYMENT JOURNAL</h3>
                </div>
                <div class="panel-body">
                    <form class="form-horizontal" method="post" action="">
                        <div class="panel-body tab-content">
                            <div class="tab-pane active" id="tab-first">
                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label">Debit Account *</label>
                                    <div class="col-md-6 col-xs-12">
                                         <select class="form-control select" name="debit" data-live-search="true">
                                            <option value="">Choose Account</option>
                                            <?php
                                            $query_group = mysqli_query($con, "SELECT * FROM chart_master");
                                            while ($rows = mysqli_fetch_assoc($query_group)) {
                                            ?>
                                                <option value="<?php echo $rows['account_code']; ?>"><?php echo $rows['account_name']; ?> - <?php echo $rows['account_code']; ?></option>
                                            <?php
                                            }
                                            ?>
                                        </select>
                                    </div>
                                </div>
                                
                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label">Credit Account *</label>
                                    <div class="col-md-6 col-xs-12">
                                         <select class="form-control select" name="credit" data-live-search="true">
                                            <option value="">Choose Account</option>
                                            <?php
                                            $query_group = mysqli_query($con, "SELECT * FROM chart_master");
                                            while ($rows = mysqli_fetch_assoc($query_group)) {
                                            ?>
                                                <option value="<?php echo $rows['account_code']; ?>"><?php echo $rows['account_name']; ?></option>
                                            <?php
                                            }
                                            ?>
                                        </select>
                                    </div>
                                </div>
                                
                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label">Amount *</label>
                                    <div class="col-md-6 col-xs-12">
                                        <input class="form-control" name="amount" value="<?php echo $_GET['amt'];?>"/>
                                    </div>
                                </div>
                                
                                <div class="form-group">
                                        <label class="col-md-3 col-xs-12 control-label">Date *</label>
                                        <div class="col-md-6 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-calendar"></span></span>
                                                <input type="text" name = "date" class="form-control datepicker" value="<?php echo date('Y-m-d');?>">                                            
                                            </div>                                            
                                        </div>
                                    </div> 

                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label" title="This are Financial Statement Line Items For Creating Financial Reports">Notes*</label>
                                    <div class="col-md-6 col-xs-12">
                                        <textarea class="form-control" name="notes"></textarea>
                                    </div>
                                </div>

                            </div>
                        </div>

                </div>
                <div class="panel-footer">
                    <button type="submit" name="submit_jornal" class="btn btn-warning pull-right">Submit <span class="fa fa-floppy-o fa-right"></span></button>
                </div>
                </form>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->

</div>