<?php
require_once '../db/db.php';
if(isset($_POST['show_report'])){
    $date1 = mysqli_real_escape_string($con,$_POST['date1']);
    $date2 = mysqli_real_escape_string($con,$_POST['date2']);
    $user = mysqli_real_escape_string($con,$_POST['user']);
    $bank = mysqli_real_escape_string($con,$_POST['bank']);
    $branch = $_SESSION['Branch'];
    
    if($bank == 'All'){
    if($user == 'All'){
        $sql = "SELECT gl.date, gl.id, gl.notes, gl.user, gl.amount, gl.nature, ba.account_code
            FROM gl_transaction AS gl
            INNER JOIN bank_accounts AS ba ON gl.account = ba.account_code
            WHERE gl.date BETWEEN ? AND ? AND gl.branchno = ? 
            ORDER BY gl.date ASC";
        $stmt = $con->prepare($sql);
        $stmt->bind_param("iss", $date1, $date2, $branch);
        $stmt->execute();
        $result = $stmt->get_result();
    } else {
        $sql = "SELECT gl.date,gl.id, gl.notes, gl.user, gl.amount, gl.nature, ba.account_code
            FROM gl_transaction AS gl
            INNER JOIN bank_accounts AS ba ON gl.account = ba.account_code
            WHERE gl.user = ? AND gl.date BETWEEN ? AND ? 
            ORDER BY gl.date ASC";  
        $stmt = $con->prepare($sql);
        $stmt->bind_param("iss", $user, $date1, $date2);
        $stmt->execute();
        $result = $stmt->get_result();
    }
    }else{
          if($user == 'All'){
        $sql = "SELECT gl.date,gl.id, gl.notes, gl.user, gl.amount, gl.nature, ba.account_code
            FROM gl_transaction AS gl
            INNER JOIN bank_accounts AS ba ON gl.account = ba.account_code
            WHERE gl.date BETWEEN ? AND ? AND gl.branchno = ? AND gl.account = ?
            ORDER BY gl.date ASC";
        $stmt = $con->prepare($sql);
        $stmt->bind_param("issi", $date1, $date2, $branch,$bank);
        $stmt->execute();
        $result = $stmt->get_result();
    } else {
        $sql = "SELECT gl.date, gl.id, gl.notes, gl.user, gl.amount, gl.nature, ba.account_code
            FROM gl_transaction AS gl
            INNER JOIN bank_accounts AS ba ON gl.account = ba.account_code
            WHERE gl.user = ? AND gl.date BETWEEN ? AND ? AND gl.account = ?
            ORDER BY gl.date ASC";  
        $stmt = $con->prepare($sql);
        $stmt->bind_param("issi", $user, $date1, $date2,$bank);
        $stmt->execute();
        $result = $stmt->get_result();
    }  
    }
}
?>
<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=accounting" style="color: rgb(7, 133, 164)">Accounting Menu</a></li>
                <li class="active">Transactions</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>TRANSACTIONS</b></h3>
                </div>
                <div class="panel-body" style="background: #fff">
                    <?php if(isset($err)){ echo $err;}?>
                    <form action="" method="post">
                        <div class="row">
                            <div class="col-md-4">  
                                <div class="form-group">                       
                                    <label class="col-md-12 col-xs-12 control-label">Users *</label>
                                    <div class="col-md-12 col-xs-12">
                                        <select class="form-control select" name="user" data-live-search="true">
                                            <?php
                                            $user = mysqli_query($con,"SELECT * FROM inv_users");
                                            while($rs=mysqli_fetch_array($user)){
                                            ?>
                                            <option value="<?php echo $rs['id'];?>"><?php echo $rs['Name'];?></option>
                                            <?php
                                            }
                                            ?>
                                        </select>
                                    </div>                      
                                </div>                     
                            </div> 
                            <div class="col-md-4">  
                                <div class="form-group">                
                                    <label class="col-md-12 col-xs-12 control-label">From</label>
                                    <div class="col-md-12 col-xs-12">
                                        <input type="text" name="date1" class="form-control datepicker" value="<?php echo date('Y-m-d');?>"> 
                                    </div>
                                </div>                     
                            </div>
                            <div class="col-md-4">  
                                <div class="form-group">                
                                    <label class="col-md-12 col-xs-12 control-label">To</label>
                                    <div class="col-md-12 col-xs-12">
                                        <input type="text" name="date2" class="form-control datepicker" value="<?php echo date('Y-m-d');?>"> 
                                    </div>
                                </div>                     
                            </div>
                        </div><br/>
                        <div class="row">
                            <div class="col-md-4">
                            <?php
                
                                $cl = mysqli_query($con,"SELECT * FROM bank_accounts WHERE branch = '".$_SESSION['Branch']."'");
                             ?>  
                                <div class="form-group">
                                    <label class="col-md-12 col-xs-12 control-label">Bank Account *</label>
                                                <div class="col-md-12 col-xs-12">
                                                    <select class="form-control select" name= "bank" data-live-search="true">
                                                        <option value = "All">All</option>
                                                  <?php
                                                    while($class = mysqli_fetch_assoc($cl)){
                                                  ?>
                                                        <option value = "<?php echo $class['account_code'];?>"><?php echo $class['bank_account_name'];?></option>
                                                     <?php
                                                       }
                                                      ?>
                                        </select>
                                    </div>          
                                </div>  
                            </div>
                            <div class="col-md-4">  
                            </div>
                            <div class="col-md-4">  
                                <button class="btn btn-info pull-right" type="submit" name="show_report"><span class="fa fa-arrow-right"></span> Create</button>                  
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel-heading">
                <h3 class="panel-title" style="color:#000"></h3>
                  <div class="pull-right">
                        <button class="btn btn-default" onclick="printContent()">
                            <span class="fa fa-print"></span> Print Report
                        </button>
                        <button class="btn btn-default" onclick="exportToExcel()">
                            <span class="fa fa-print"></span> Export To Excel
                        </button>
                    </div>
            </div>
            <div class="panel-body" style="background: #fff" id="printingArea">
                <table class="table table-bordered" id="myTable" style="color:black;font-size:13px;width:100%">
                 <tr>
                    <th colspan="7" style="text-align:center">
                        COMPANY: <?php echo $_SESSION['Company']?>
                    </th>
                 </tr>
                 <tr>
                    <th colspan="7" style="text-align:center">
                        BRANCH: <?php echo $_SESSION['Branch']?>
                    </th>
                 </tr>
                 <tr>
                    <th colspan="7" style="text-align:center">
                        REPORT FROM <span style="color:#999"><?php if(isset($date1)){ echo $date1;}else{ echo "- - -";}?></span> 
                        TO <span style="color:#999"><?php if(isset($date2)){ echo $date2;}else{ echo "- - -";}?></span>
                    </th>
             </tr>
            <tr style="font-weight:bold">
                <td>#</td>
                <td>Date</td>
                <td>Descriptions</td>
                <td>CreatedBy</td>
                <td>Bank Account</td>
                <td>Nature</td>
                <td>Amount</td>
            </tr> 
            <?php 
            $a = 1;
            $sum = 0;
            foreach($result as $rows){
                $account = mysqli_query($con,"SELECT * FROM chart_master WHERE account_code = '".$rows['account_code']."'"); 
                $rs = mysqli_fetch_array($account);
                
                $users = mysqli_query($con,"SELECT * FROM inv_users WHERE id = '".$rows['user']."'"); 
                $r = mysqli_fetch_array($users);
                ?>
                <tr>
                    <td><?php echo $a;?></td>
                    <td><?php echo $rows['date'];?></td>
                    <td><?php echo $rows['notes'];?></td>
                    <td><?php echo $r['Name'];?></td>
                    <td><?php echo $rs['account_name'];?></td>
                    <td><?php echo $rows['nature'];?></td>
                    <td><a href="index.php?p=transaction_user_view&id=<?php echo urlencode($rows['id']); ?>&user=<?php echo urlencode($rows['user']); ?>&nat=<?php echo urlencode($rows['nature']); ?>&date1=<?php echo urlencode($date1); ?>&date2=<?php echo urlencode($date2); ?>">
    <?php echo ($rows['nature'] == 'Debit') ? number_format($rows['amount'],2) : '('.number_format($rows['amount'],2).')';?>
</a></td>

                </tr>    
                <?php
                $sum += ($rows['nature'] == 'Debit') ? $rows['amount'] : -$rows['amount'];
                $a++;
            }
            ?>
            <tr>
                <td colspan="6" align="left"><b>TOTAL</b></td>
                <td><b><?php echo number_format($sum,2);?></b></td>
            </tr>
        </table>

            </div>
        </div>
    </div>
    <!-- END TIMELINE -->                            
</div>
<script>
    function printContent() {
        var content = document.getElementById('printingArea').innerHTML;
        var printWindow = window.open('', '_blank');
        printWindow.document.write('<html><head><title>Print</title>');
        printWindow.document.write('<style>table { border-collapse: collapse; border: 1px solid black; width: 100%; } th, td { border: 1px solid black; padding: 8px; text-align: center; height: 20px; color: black; } a { color: black; text-decoration: none; } </style>');
        printWindow.document.write('</head><body>');
        printWindow.document.write(content);
        printWindow.document.write('</body></html>');
        printWindow.document.close();
        printWindow.print();
    }

    function exportToExcel() {
        // Get the HTML table element
        var table = document.getElementById('printingArea'); // Replace 'tableId' with the ID of your table

        // Convert the HTML table to a worksheet
        var wb = XLSX.utils.table_to_book(table);

        // Generate a binary string from the XLSX workbook
        var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });

        // Create a Blob object representing the data as an Excel file
        var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

        // Create a temporary anchor element and trigger a download
        var link = document.createElement('a');
        link.href = window.URL.createObjectURL(blob);
        link.download = 'user_transactions.xlsx'; // Change 'filename' to your desired filename
        link.click();
    }

    // Utility function to convert a string to an ArrayBuffer
    function s2ab(s) {
        var buf = new ArrayBuffer(s.length);
        var view = new Uint8Array(buf);
        for (var i = 0; i < s.length; i++) {
            view[i] = s.charCodeAt(i) & 0xFF;
        }
        return buf;
    }
</script>
