<?php
// Get parameters from URL
$id = isset($_GET['id']) ? mysqli_real_escape_string($con, $_GET['id']) : '';
$user = isset($_GET['user']) ? mysqli_real_escape_string($con, $_GET['user']) : '';
$nature = isset($_GET['nat']) ? mysqli_real_escape_string($con, $_GET['nat']) : '';
$date1 = isset($_GET['date1']) ? mysqli_real_escape_string($con, $_GET['date1']) : '';
$date2 = isset($_GET['date2']) ? mysqli_real_escape_string($con, $_GET['date2']) : '';

// Fetch user transaction details based on passed parameters
$sql = "SELECT * FROM gl_transaction WHERE id = ? AND user = ? AND nature = ? AND date BETWEEN ? AND ?";
$stmt = $con->prepare($sql);
$stmt->bind_param("issss",$id, $user,$nature, $date1, $date2);
$stmt->execute();
$result = $stmt->get_result();
?>
<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">User Transactions</h3>
                </div>
                <div class="panel-body" style="background: #fff">
                    <table class="table table-striped table-bordered" width="100%">
                        <tr>
                            <td style="width:10%">Date</td>
                            <td style="width:50%">Description</td>
                            <td style="width:20%" align="right">Amount</td>
                        </tr>
                        <?php
                        while($row = $result->fetch_assoc()):
                        ?>
                        <tr>
                            <td><?php echo $row['date']; ?></td>
                            <td><?php echo $row['notes']; ?></td>
                            <td align="right"><?php echo number_format($row['amount'],2); ?></td>
                        </tr>
                        <?php endwhile; ?>
                    </table>   
                </div>
            </div>
        </div>
        <!-- END TIMELINE -->
    </div>
</div>
