<?php
session_start();
include "../db/connection.php";
if (!isset($_SESSION['id'])) {
    header('location:../index.php');
    exit;
}
 
 if (isset($_POST['submit_trial_balance'])) {
    $date1 = mysqli_real_escape_string($con, $_POST['date1']);
    $date2 = mysqli_real_escape_string($con, $_POST['date2']);
    $branch = mysqli_real_escape_string($con, $_POST['branch']);
    $title = mysqli_real_escape_string($con, $_POST['title']);
    $notes = mysqli_real_escape_string($con, $_POST['notes']);
    $method = mysqli_real_escape_string($con, $_POST['method']);
    $style = mysqli_real_escape_string($con, $_POST['style']);

    $url = "";
    if ($method == "Accrual Basis" && $style == "1") {
        $url = "index.php?p=trial_balance_report_two&date1=$date1&date2=$date2&branch=$branch&method=$method&title=$title&notes=$notes";
    } elseif ($method == "Cash Basis" && $style == "1") {
        $url = "index.php?p=trial_balance_report_two&date1=$date1&date2=$date2&branch=$branch&method=$method&title=$title&notes=$notes";
    } elseif ($method == "Accrual Basis" && $style == "2") {
        $url = "index.php?p=trial_balance_report_one&date1=$date1&date2=$date2&branch=$branch&method=$method&title=$title&notes=$notes";
    } elseif ($method == "Cash Basis" && $style == "2") {
        $url = "index.php?p=trial_balance_report_one&date1=$date1&date2=$date2&branch=$branch&method=$method&title=$title&notes=$notes";
    }

    if (!empty($url)) {
        echo "<script>window.location.href = '$url';</script>";
        exit;
    }
}


?>


<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=accounting" style="color: rgb(7, 133, 164)">Accounting Menu</a></li>
                <li class="active">Trial Balance</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title" style="font-weight:bold">TRIAL BALANCE REPORT</h3>
                    <div class="pull-right">
                     </div>
                </div>
                <div class="panel-body">
                    <form class="form-horizontal" method="post" action="">
                        <div class="panel-body tab-content">
                            <div class="tab-pane active" id="tab-first">
                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label">Accounting Method</label>
                                    <div class="col-md-6 col-xs-12">
                                         <select class="form-control select" name="method" data-live-search="true">
                                            <option value="Accrual Basis">Accrual Basis</option>
                                            <option value="Cash Basis">Cash Basis</option>
                                        </select>
                                    </div>
                                </div>
                                
                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label">Reporting Style</label>
                                    <div class="col-md-6 col-xs-12">
                                         <select class="form-control select" name="style" data-live-search="true">
                                            <option value="1">Single Column</option>
                                            <option value="2">Double Column</option>
                                        </select>
                                    </div>
                                </div>
                                
                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label">Title</label>
                                    <div class="col-md-6 col-xs-12">
                                        <input class="form-control" name="title" value="Trial Balance"/>
                                    </div>
                                </div>
                                
                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label" title="This are Financial Statement Line Items For Creating Financial Reports">Description</label>
                                    <div class="col-md-6 col-xs-12">
                                        <textarea class="form-control" name="notes"></textarea>
                                    </div>
                                </div>
                                
                                <div class="form-group">
                                        <label class="col-md-3 col-xs-12 control-label">From </label>
                                        <div class="col-md-6 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-calendar"></span></span>
                                                <input type="text" name = "date1" class="form-control datepicker" value="<?php echo date('Y-m-d');?>">                                            
                                            </div>                                            
                                        </div>
                                    </div>
                                <div class="form-group">
                                        <label class="col-md-3 col-xs-12 control-label">To</label>
                                        <div class="col-md-6 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-calendar"></span></span>
                                                <input type="text" name = "date2" class="form-control datepicker" value="<?php echo date('Y-m-d');?>">                                            
                                            </div>                                            
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <label class="col-md-3 col-xs-12 control-label">Branch</label>
                                        <div class="col-md-6 col-xs-12">        
                                            <select class="form-control select" name = "branch" onchange="showDis(this.value)">
                                                <option value="All Branches">All Branches</option>
                                              <?php
                                               $region = mysqli_query($con,"SELECT * FROM branch ORDER BY name");
                                               while($reg = mysqli_fetch_array($region)){
                                              ?>
                                                <option value="<?php echo $reg['name'];?>"><?php echo $reg['name'];?></option>
                                              <?php
                                               }
                                              ?>  
                                            </select>
                                        </div>
                                    </div>
                            </div>
                        </div>

                </div>
                <div class="panel-footer">
                    <button type="submit" name="submit_trial_balance" class="btn btn-default pull-right">Create</button>
                </div>
                </form>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->

</div>