<?php
include "../db/connection.php";
 $pdo = new PDO($dsn, $username, $password);
 $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
?>
<?php
// Assuming you've established a PDO connection ($pdo) to your database

// Retrieve data from the 'gl_transaction' table
$query = "SELECT * FROM gl_transaction";
$statement = $pdo->prepare($query);
$statement->execute();
$transactions = $statement->fetchAll(PDO::FETCH_ASSOC);

// Initialize an array to hold main group totals
$mainGroups = [];

// Organize data into main groups and calculate their total amount
foreach ($transactions as $transaction) {
    $amount = (float)$transaction['amount'];
    $maingroup = $transaction['maingroup'];

    if (!isset($mainGroups[$maingroup])) {
        $mainGroups[$maingroup] = 0;
    }

    // Accumulate amounts regardless of debit or credit
    if ($transaction['nature'] === 'debit') {
        $mainGroups[$maingroup] += $amount;
    } else {
        $mainGroups[$maingroup] -= $amount;
    }
}

// Display the total amounts for each main group
echo '<table border="1">
        <tr>
            <th>Main Group</th>
            <th>Total Amount</th>
        </tr>';

foreach ($mainGroups as $maingroup => $totalAmount) {
    echo '<tr>
            <td>' . $maingroup . '</td>
            <td>' . number_format($totalAmount, 2) . '</td>
        </tr>';
}

echo '</table>';
?>


