<?php
include "../db/connection.php";
if (!isset($_SESSION['id'])) {
    header('location:../index.php');
    exit;
}
$date3 = date('d/m/Y', strtotime($_GET['date1']));
$date4 = date('d/m/Y', strtotime($_GET['date2']));
$date1 = $_GET['date1'];
$date2 = $_GET['date2'];
$branch = $_GET['branch'];
?>
<div class="col-md-9">
    <!-- START TRIAL BALANCE -->
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">TRIAL BALANCE DOUBLE COLUMNs</h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                        <button class="btn btn-default" onclick="printContent()">
                            <span class="fa fa-print"></span> Print Report
                        </button>
                        <button class="btn btn-default" onclick="exportToExcel()">
                            <span class="fa fa-print"></span> Export To Excel
                        </button>
                    </div>
                </div>
                <div class="panel-body" id= "printingArea">
                    <center>
                        <h2 style="color:black"><?php echo $_GET['notes'];?></h2>
                        <h1 style="color:black"><?php echo $_GET['title'];?></h1>
                        <h2 style="color:black"><?php echo $_GET['method'];?></h2>
                        <h3 style="color:black"><?php echo $date3;?> - <?php echo $date4;?></h3>
                        </center>
                    <div class="table-responsive">
                        <?php
                        try {
                            $pdo = new PDO($dsn, $username, $password);
                            $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

                            // Fetch debit and credit totals joined on account code
                            if($branch=1){
                            $stmt = $pdo->prepare("SELECT cm.account_name, cm.account_code,
                                  SUM(CASE WHEN gt.nature = 'debit' THEN gt.amount ELSE NULL END) AS total_debit,
                                  SUM(CASE WHEN gt.nature = 'credit' THEN gt.amount ELSE NULL END) AS total_credit
                                  FROM chart_master cm
                                  INNER JOIN gl_transaction gt ON cm.account_code = gt.account
                                   WHERE gt.date BETWEEN :date1 AND :date2
                                  GROUP BY cm.account_name, cm.account_code");

                            }else{
                                $stmt = $pdo->prepare("SELECT cm.account_name, cm.account_code,
                                  SUM(CASE WHEN gt.nature = 'debit' THEN gt.amount ELSE NULL END) AS total_debit,
                                  SUM(CASE WHEN gt.nature = 'credit' THEN gt.amount ELSE NULL END) AS total_credit
                                  FROM chart_master cm
                                  INNER JOIN gl_transaction gt ON cm.account_code = gt.account
                                  WHERE gt.date BETWEEN :date1 AND :date2 AND gt.branchno = :branch
                                  GROUP BY cm.account_name, cm.account_code");
                                  $stmt->bindParam(':branch', $branch);
                            }
                            $stmt->bindParam(':date1', $date1);
                            $stmt->bindParam(':date2', $date2);
                            $stmt->execute();
                            $trial_balance_data = $stmt->fetchAll(PDO::FETCH_ASSOC);

                            $totalDebitSum = 0;
                            $totalCreditSum = 0;

                            echo "<table class='table table-striped table-hover'>
                                    <thead>
                                        <tr>
                                            <th>ACCOUNT NAME</th>
                                            <th>ACCOUNT CODE</th>
                                            <th>DEBIT</th>
                                            <th>CREDIT</th>
                                        </tr>
                                    </thead>
                                    <tbody>";

                            foreach ($trial_balance_data as $data) {
                                $accountName = $data['account_name'];
                                $accountCode = $data['account_code'];
                                $debitAmount = $data['total_debit'];
                                $creditAmount = $data['total_credit'];

                                // Calculate balance for each account
                                $balance = $debitAmount - $creditAmount;

                                // Determine whether to display in debit or credit side based on balance
                                if ($balance > 0) {
                                    $debitAmount = $balance;
                                    $creditAmount = 0;
                                    $totalDebitSum += $debitAmount;
                                } else {
                                    $creditAmount = abs($balance);
                                    $debitAmount = 0;
                                    $totalCreditSum += $creditAmount;
                                }

                                echo "<tr>
                                        <td>{$accountName}</td>
                                        <td>{$accountCode}</td>
                                        <td><a href=''>".number_format($debitAmount,2)."</a></td>
                                        <td><a href=''>".number_format($creditAmount,2)."</a></td>
                                      </tr>";
                            }
                              echo "<tr>
                                        <td colspan='2'><b>TOTAL</b></td>
                                        <td><b>" . number_format($totalDebitSum, 2) . "</b></td>
                                        <td><b>".number_format($totalCreditSum,2)."</b></td>
                                      </tr>";

                            echo "
                            </tbody></table>";
                        } catch (PDOException $e) {
                            echo "Error: " . $e->getMessage();
                        }
                        ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- END TRIAL BALANCE -->
</div>
<script>
    function printContent() {
    var content = document.getElementById('printingArea').innerHTML;
    var printWindow = window.open('', '_blank');
    printWindow.document.write('<html><head><title>Print</title>');
    printWindow.document.write(`
        <style>
            table { border-collapse: collapse; border: 1px solid black; width: 100%; }
            th, td { border: 1px solid black; padding: 8px; text-align: left; height: 20px; color: black; }
            th:nth-child(2), td:nth-child(2),
            th:nth-child(3), td:nth-child(3) { text-align: right; }
             th:nth-child(4), td:nth-child(4) { text-align: right; }/* Centers Amount and Heading columns */
            a { color: black; text-decoration: none; }
        </style>
    `);
    printWindow.document.write('</head><body>');
    printWindow.document.write(content);
    printWindow.document.write('</body></html>');
    printWindow.document.close();
    printWindow.print();
}


    function exportToExcel() {
        // Get the HTML table element
        var table = document.getElementById('printingArea'); // Replace 'tableId' with the ID of your table

        // Convert the HTML table to a worksheet
        var wb = XLSX.utils.table_to_book(table);

        // Generate a binary string from the XLSX workbook
        var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });

        // Create a Blob object representing the data as an Excel file
        var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

        // Create a temporary anchor element and trigger a download
        var link = document.createElement('a');
        link.href = window.URL.createObjectURL(blob);
        link.download = 'trial_balance_report_one.xlsx'; // Change 'filename' to your desired filename
        link.click();
    }

    // Utility function to convert a string to an ArrayBuffer
    function s2ab(s) {
        var buf = new ArrayBuffer(s.length);
        var view = new Uint8Array(buf);
        for (var i = 0; i < s.length; i++) {
            view[i] = s.charCodeAt(i) & 0xFF;
        }
        return buf;
    }
</script>