<?php
if (!isset($_SESSION['id'])) {
    header('location:../index.php');
    exit;
}
include "../db/connection.php";
$date3 = date('d/m/Y', strtotime($_GET['date1']));
$date4 = date('d/m/Y', strtotime($_GET['date2']));
$date1 = $_GET['date1'];
$date2 = $_GET['date2'];
$branch = $_GET['branch'];
?>

<style>
    /* CSS to style the table */
    table {
        border-collapse: collapse;
        border: 1px solid black; /* Set border color and thickness */
        width: 100%; /* Set table width to 100% of its container */
    }

    th{
        border: 1px solid black; /* Set border for table cells */
        padding: 8px; /* Add padding for better readability */
        text-align: center; /* Center-align text within cells */
        height: 20px;
        color: black;
    }
    td{
       border: 1px solid black; /* Set border for table cells */
        padding: 8px; /* Add padding for better readability */
        text-align: left; /* Center-align text within cells */
        height: 20px;
        color: black; 
    }

    @media print {
        a {
            color: black;
            text-decoration: none;
        }
        table {
            border-collapse: collapse;
            border: 1px solid black;
        }
        th, td {
            border: 1px solid black;
        }
    }
    table {
        border-collapse: collapse;
        border: 1px solid black;
        width: 100%;
    }

    th, td {
        border: 1px solid black;
        padding: 8px;
        height: 20px;
        color: black;
    }

    th {
        text-align: center; /* Center align headers */
    }

    td {
        text-align: left; /* Default alignment for text */
    }

    /* Specific column styling */
    td.account-code {
        text-align: center; /* Center align account codes */
    }

    td.balance {
        text-align: right; /* Right align balances */
    }

    @media print {
        a {
            color: black;
            text-decoration: none;
        }
        table {
            border-collapse: collapse;
            border: 1px solid black;
        }
        th, td {
            border: 1px solid black;
        }
    }
</style>
<div class="col-md-9">
    <!-- START TRIAL BALANCE -->
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">Trial Balance Single Column</h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                        <button class="btn btn-default" onclick="printContent()">
                            <span class="fa fa-print"></span> Print Report
                        </button>
                        <button class="btn btn-default" onclick="exportToExcel()">
                            <span class="fa fa-print"></span> Export To Excel
                        </button>
                    </div>
                </div>
                <div class="panel-body" id="printingArea">
                    <center id="myTable">
                        <h2 style="color:black"><?php echo $_GET['notes'];?></h2>
                        <h1 style="color:black"><?php echo $_GET['title'];?></h1>
                        <h2 style="color:black"><?php echo $_GET['method'];?></h2>
                        <h2 style="color:black"><?php echo $_GET['branch'];?></h2>
                        <h3 style="color:black"><?php echo $date3;?> - <?php echo $date4;?></h3>
                        </center>
                    <div class="table-responsive">
                        <?php
                        try {
                            $pdo = new PDO($dsn, $username, $password);
                            $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

                            // Fetch debit and credit totals joined on account
                            if($branch=1){
                            $stmt = $pdo->prepare("SELECT cm.account_name, cm.account_code, SUM(CASE WHEN gt.nature = 'debit' THEN gt.amount ELSE -gt.amount END) AS balance
                                FROM chart_master cm
                                INNER JOIN gl_transaction gt ON cm.account_code = gt.account
                                WHERE gt.date BETWEEN :date1 AND :date2
                                GROUP BY cm.account_name, cm.account_code");
                            }else{
                              $stmt = $pdo->prepare("SELECT cm.account_name, cm.account_code, SUM(CASE WHEN gt.nature = 'debit' THEN gt.amount ELSE -gt.amount END) AS balance
                                    FROM chart_master cm
                                    INNER JOIN gl_transaction gt ON cm.account_code = gt.account
                                    WHERE gt.date BETWEEN :date1 AND :date2 AND gt.branchno = :branch
                                    GROUP BY cm.account_name, cm.account_code");
                                $stmt->bindParam(':branch', $branch); 
                            }

                            $stmt->bindParam(':date1', $date1);
                            $stmt->bindParam(':date2', $date2);
                            $stmt->execute();

                            $trial_balance_data = $stmt->fetchAll(PDO::FETCH_ASSOC);

                            $totalBalance = 0;

                            echo "<table class='table table-striped table-hover'>
        <thead>
            <tr>
                <th>ACCOUNT NAME</th>
                <th>ACCOUNT CODE</th>
                <th style='text-align: right;'>BALANCE</th>
            </tr>
        </thead>
        <tbody>";

foreach ($trial_balance_data as $data) {
    $accountName = $data['account_name'];
    $accountCode = $data['account_code'];
    $balance = $data['balance'];

    // Format negative values with brackets
    $formattedBalance = ($balance < 0) ? "(".number_format(abs($balance), 2).")" : number_format($balance, 2);

    echo "<tr>
            <td>{$accountName}</td>
            <td class='account-code'>{$accountCode}</td>
            <td class='balance'><a href=''>{$formattedBalance}</a></td>
          </tr>";

    // Accumulate total balance
    $totalBalance += $balance;
}

echo "</tbody></table>";

// Display total balance
$formattedTotalBalance = ($totalBalance < 0) ? "(".abs($totalBalance).")" : $totalBalance;
echo "<table class='table'>
        <tbody>
            <tr class='total-balance'>
                <td><b>Total Balance</b></td>
                <td>{$formattedTotalBalance}</td>
            </tr>
        </tbody>
    </table>";

                        } catch (PDOException $e) {
                            echo "Error: " . $e->getMessage();
                        }
                        ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- END TRIAL BALANCE -->
</div>


<script src="https://cdn.jsdelivr.net/npm/chart.js"></script>
<script>
    function printContent() {
    var content = document.getElementById('printingArea').innerHTML;
    var printWindow = window.open('', '_blank');
    printWindow.document.write('<html><head><title>Print</title>');
    printWindow.document.write('<style>');
    printWindow.document.write('table { border-collapse: collapse; border: 1px solid black; width: 100%; }');
    printWindow.document.write('th, td { border: 1px solid black; padding: 8px; height: 20px; color: black; }');
    printWindow.document.write('th { text-align: center; }'); // Center-align headers
    printWindow.document.write('td:nth-child(2) { text-align: center; }'); // Center-align account codes
    printWindow.document.write('td:nth-child(3) { text-align: right; }'); // Right-align balance
    printWindow.document.write('tr.total-balance td { text-align: right; font-weight: bold; }'); // Right-align total balance row
    printWindow.document.write('tr.total-balance td:first-child { text-align: left; }'); // Left-align first cell in total balance row
    printWindow.document.write('a { color: black; text-decoration: none; }');
    printWindow.document.write('</style>');
    printWindow.document.write('</head><body>');
    printWindow.document.write(content);
    printWindow.document.write('</body></html>');
    printWindow.document.close();
    printWindow.print();
}


    function exportToExcel() {
        // Get the HTML table element
        var table = document.getElementById('printingArea'); // Replace 'tableId' with the ID of your table

        // Convert the HTML table to a worksheet
        var wb = XLSX.utils.table_to_book(table);

        // Generate a binary string from the XLSX workbook
        var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });

        // Create a Blob object representing the data as an Excel file
        var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

        // Create a temporary anchor element and trigger a download
        var link = document.createElement('a');
        link.href = window.URL.createObjectURL(blob);
        link.download = 'trial_balance_report_two.xlsx'; // Change 'filename' to your desired filename
        link.click();
    }

    // Utility function to convert a string to an ArrayBuffer
    function s2ab(s) {
        var buf = new ArrayBuffer(s.length);
        var view = new Uint8Array(buf);
        for (var i = 0; i < s.length; i++) {
            view[i] = s.charCodeAt(i) & 0xFF;
        }
        return buf;
    }
</script>
