<?php
if (isset($_POST['finish'])) {
    $branchno = $_POST['branchno'];
    $name = $_POST['name'];
    $mkoa = $_POST['mkoa'];

    if ($name == '' || $mkoa == '' || $branchno == '') {
        $err = "<p class='alert alert-danger'>Please fill in all fields!</p>";
    } else {
        // Establish a PDO connection (replace with your own connection details)
        
        try {
            $pdo = new PDO($dsn, $username, $password);
            $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

            $stmt = $pdo->prepare("SELECT * FROM branch WHERE branchno = :branchno");
            $stmt->bindParam(':branchno', $branchno);
            $stmt->execute();
            $num = $stmt->rowCount();

            if ($num == 0) {
                $stmt = $pdo->prepare("INSERT INTO branch VALUES(NULL, :name, :mkoa, :branchno)");
                $stmt->bindParam(':name', $name);
                $stmt->bindParam(':mkoa', $mkoa);
                $stmt->bindParam(':branchno', $branchno);
                $success = $stmt->execute();

                if ($success) {
                    $err = "<p class='alert alert-success'>Data successfully recorded!</p>";
                } else {
                    $err = "<p class='alert alert-danger'>Something went wrong! Contact system administrator.</p>";
                }
            } else {
                $err = "<p class='alert alert-danger'>This branch already exists in our database. Please use a different branch number.</p>";
            }
        } catch (PDOException $e) {
            $err = "<p class='alert alert-danger'>Database Error: " . $e->getMessage() . "</p>";
        }
    }
}
?>
                            <div class="col-md-9">

                            <!-- START TIMELINE -->
                            <div class="row">
                            <div class="col-md-12">
                               <div class="panel panel-default">
                                <div class="panel-heading">
                                    <h3 class="panel-title"><b>CREATE NEW BRANCH</b></h3>
                                </div>
                                <div class="panel-body" style="background: #fff">
                                    <?php if(isset($err)){ echo $err;}?>
                                    <form class="form-horizontal" method = "post" action = "">
                                     <div class="form-group">
                                            <label class="col-md-3 control-label">Branch Number *</label>
                                            <div class="col-md-6 col-xs-12">
                                              <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-pencil"></span></span>
                                                <input type="text" name = "branchno" class="form-control" placeholder="Branch Number" />
                                            </div>
                                            </div>
                                     </div>    

                                     <div class="form-group">
                                            <label class="col-md-3 control-label">Branch Name *</label>
                                            <div class="col-md-6 col-xs-12">
                                              <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-pencil"></span></span>
                                                <input type="text" name = "name" class="form-control" placeholder="Branch Name" />
                                            </div>
                                            </div>
                                     </div>

                                     <div class="form-group">
                                            <label class="col-md-3 control-label">Region *</label>
                                            <div class="col-md-6 col-xs-12">
                                              <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-pencil"></span></span>
                                                <input type="text" name = "mkoa" class="form-control" placeholder="Region" />
                                            </div>
                                            </div>
                                     </div>
                                </div>
                                <div class="panel-footer">                                    
                                    <button class="btn btn-warning pull-right" type = "submit" name = "finish"><span class="fa fa-plus-circle"></span> Create</button>
                                </div>
                            </form>
                            </div>
                          </div>
                        </div>
                            <!-- END TIMELINE -->                            
                        </div>