<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

if(isset($_POST['submitbankstatement1'])){
   $account = mysqli_real_escape_string($con,$_POST['account']);
   $date1 = mysqli_real_escape_string($con,$_POST['date1']);
   $date2 = mysqli_real_escape_string($con,$_POST['date2']);
   $balance = mysqli_real_escape_string($con,$_POST['balance']);
   
 $bank_account = mysqli_query($con, "SELECT * FROM chart_master WHERE account_code = '$account'");

if (!$bank_account) {
    die("Error: " . mysqli_error($con));
}

$rows = mysqli_fetch_array($bank_account);

if (!$rows) {
    echo "No matching record found for account number: $account_number";
} else {
    $acc_name = $rows['account_name'];
    //echo "Account Name: $acc_name";
}

// Query to calculate the opening balance
$sql_opening_balance = "SELECT COALESCE(SUM(CASE WHEN nature = 'Debit' THEN amount 
                                    WHEN nature = 'Credit' THEN -amount END), 0) AS opening_balance
                        FROM gl_transaction 
                        WHERE account = :account AND date < :date";

// Prepare the statement
$stmt_opening_balance = $pdo->prepare($sql_opening_balance);

// Bind parameters
$stmt_opening_balance->bindParam(':account', $account, PDO::PARAM_INT);
$stmt_opening_balance->bindParam(':date', $date1, PDO::PARAM_STR);

// Execute the statement
$stmt_opening_balance->execute();

// Fetch the result
$opening_balance = $stmt_opening_balance->fetchColumn(); // Fetch a single column value

// Query to fetch transactions within the date range
$sql = "SELECT date, notes, id, nature, 
        CASE WHEN nature = 'Credit' THEN amount ELSE 0 END AS credit_amount,
        CASE WHEN nature = 'Debit' THEN amount ELSE 0 END AS debit_amount
        FROM gl_transaction 
        WHERE account = :account AND date BETWEEN :start_date AND :end_date 
        ORDER BY date ASC";

// Prepare the statement
$stmt = $pdo->prepare($sql);

// Bind parameters
$stmt->bindParam(':account', $account, PDO::PARAM_INT);
$stmt->bindParam(':start_date', $date1, PDO::PARAM_STR);
$stmt->bindParam(':end_date', $date2, PDO::PARAM_STR);

// Execute the statement
$stmt->execute();

// Fetch all results
$result = $stmt->fetchAll(PDO::FETCH_ASSOC);


 //insert bank reconciliation query
 
$currentdate = date('Y-m-d');
$total_payment = 0;
$total_receipt = 0;
$difference = 0;
$system_balance = 0;
$statement_file = '';


// Define the SQL query with placeholders
$sttbank = "INSERT INTO bank_reconciliation 
(account, statement_date, beginning_balance, statement_ending_balance, 
system_balance, difference, total_receipt, total_payment, statement_file, 
start_date, end_date) 
VALUES (:account, :statement_date, :beginning_balance, :statement_ending_balance, 
:system_balance, :difference, :total_receipt, :total_payment, :statement_file, 
:start_date, :end_date)";

// Prepare the SQL statement
$bank = $pdo->prepare($sttbank);

// Bind the parameters with the actual values
$bank->bindParam(':account', $account, PDO::PARAM_INT);
$bank->bindParam(':statement_date', $currentdate, PDO::PARAM_STR);
$bank->bindParam(':beginning_balance',$opening_balance, PDO::PARAM_INT);
$bank->bindParam(':statement_ending_balance', $balance, PDO::PARAM_INT);
$bank->bindParam(':system_balance', $system_balance, PDO::PARAM_INT);
$bank->bindParam(':difference', $difference, PDO::PARAM_INT);
$bank->bindParam(':total_receipt', $total_receipt, PDO::PARAM_INT);
$bank->bindParam(':total_payment', $total_payment, PDO::PARAM_INT);
$bank->bindParam(':statement_file', $statement_file, PDO::PARAM_STR);
$bank->bindParam(':start_date', $date1, PDO::PARAM_STR);
$bank->bindParam(':end_date', $date2, PDO::PARAM_STR);

// Execute the statement
$bank->execute();

  $bankRec = $pdo->lastInsertId();
 
  $satus = 0;
  $sumreceipt = 0;
  $sumpayment = 0;
 foreach($result as $row){
     $ref = $row['id'];
     $date = $row['date'];
     $notes = $row['notes'];
     $debit_amount = $row['debit_amount'];
     $credit_amount = $row['credit_amount'];
     $sumreceipt+= $row['debit_amount'];
     $sumpayment+= $row['credit_amount'];
     
     $itemstmt = $pdo->prepare("INSERT INTO bank_reconciliation_draft (reco_id,reference,date,note,payment,receipt,status)
                    VALUES(:reco_id,:reference,:date,:note,:payment,:receipt,:status)");
    $itemstmt->bindParam(':reco_id',$bankRec);
    $itemstmt->bindParam(':reference',$ref);
    $itemstmt->bindParam(':date',$date);
    $itemstmt->bindParam(':note',$notes);
    $itemstmt->bindParam(':payment',$credit_amount);
    $itemstmt->bindParam(':receipt',$debit_amount);
    $itemstmt->bindParam(':status',$satus);
    
    $itemstmt->execute();
 }

//update bank reconciliation amounts
$stmbalance = $sumreceipt - $sumpayment;
$difference = $opening_balance - $stmbalance;

$amt = $pdo->prepare("UPDATE bank_reconciliation SET system_balance = :system_balance, difference=:difference, total_receipt=:total_receipt,total_payment=:total_payment WHERE bank_reco_id = $bankRec");
 $amt->bindParam(':system_balance',$stmbalance);
 $amt->bindParam(':difference',$difference);
 $amt->bindParam(':total_receipt',$sumreceipt);
 $amt->bindParam(':total_payment',$sumpayment);
 
 $amt->execute();
 
    // Constructing the URL with form attributes
   $redirectURL = 'reconciliation_form.php?account=' . urlencode($account) . '&date1=' . urlencode($date1) . '&date2=' . urlencode($date2);
    // Constructing the URL with form attributes
    echo "<script>window.location='$redirectURL';</script>"; 
}
?>
<div class="col-md-9">

<!-- START TIMELINE -->
<div class="row">
<div class="col-md-12">
<ul class="breadcrumb" style="height: 40px;padding-top: 10px;"> 
         <li><a href="index.php?p=accounting" style="color: rgb(7, 133, 164)">Accounting Menu</a></li>
         <li><a href="index.php?p=bank_reconciliation_list" style="color: rgb(7, 133, 164)">Bank Reconciliation</a></li>
          <li class="active">New Bank Reconciliation</li>
     </ul>
   <div class="panel panel-default">
    <div class="panel-heading">
        <h3 class="panel-title"><b>BANK RECONCILIATION</b></h3>
        
    </div>
    <div class="panel-body">
        <form class="form-horizontal" method = "post" action = "" enctype="multipart/form-data">
                 <?php

                   $cl = mysqli_query($con,"SELECT * FROM bank_accounts WHERE branch = '".$_SESSION['Branch']."'");
                 ?>  
                 <div class="form-group">
                    <label class="col-md-3 col-xs-12 control-label">Bank Account *</label>
                    <div class="col-md-6 col-xs-12">
                        <select class="form-control select" name= "account" data-live-search="true">
                      <?php
                        while($class = mysqli_fetch_assoc($cl)){
                      ?>
                            <option value = "<?php echo $class['account_code'];?>"><?php echo $class['bank_account_name'];?></option>
                         <?php
                           }
                          ?>
                        </select>
                    </div>                                               
            </div>

                <div class="form-group">
                    <label class="col-md-3 col-xs-12 control-label">From *</label>
                    <div class="col-md-6 col-xs-12">                    
                        <input type="text" class="form-control datepicker" name = "date1" value="<?php echo date('Y-m');?>-01"/>    
                    </div>
                </div>
                <div class="form-group">
                    <label class="col-md-3 col-xs-12 control-label">To *</label>
                    <div class="col-md-6 col-xs-12">                    
                        <input type="text" class="form-control datepicker" name = "date2" value="<?php echo date('Y-m-d');?>"/>    
                    </div>
                </div>
                <div class="form-group">
                    <label class="col-md-3 col-xs-12 control-label">Ending bank balance *</label>
                    <div class="col-md-6 col-xs-12">                    
                        <input type="text" class="form-control" name = "balance" value="" required/>    
                    </div>
                </div>
                <!-- File Upload Section -->
                <div class="form-group">
                    <label class="col-md-3 col-xs-12 control-label">Upload Bank Statement *</label>
                    <div class="col-md-6 col-xs-12">                    
                        <input type="file" class="form-control" name="bank_statement" accept=".pdf,.jpg,.png,.jpeg"/>    
                    </div>
                </div>
            </div><div class="panel-footer">                                                                        
            <button type = "submit" name = "submitbankstatement1" class="btn btn-warning pull-right"><span class="fa fa-plus-circle"></span>Create </button>
    </div>
  </form> 
        </div>
    </div>
         
</div>
</div>



<!-- END TIMELINE -->                            

</div>