<?php
include '../db/connection.php';

// Set PDO error mode to exception
$pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    $currencyName = $_POST['currency_name'];
    $currencySymbol = $_POST['currency_symbol'];
    
    try {
        $stmt = $pdo->prepare("INSERT INTO currency (currency_name, symbol) VALUES (:currency_name, :currency_symbol)");
        $stmt->execute([
            'currency_name' => $currencyName,
            'currency_symbol' => $currencySymbol
        ]);
        
         echo "<script src='https://cdn.jsdelivr.net/npm/sweetalert2@11'></script>";
                echo "<script>
                Swal.fire({
                    title: 'Success!',
                    text: 'Currency Added successfully.',
                    icon: 'success',
                    timer: 2000, 
                    showConfirmButton: false
                });
            </script>";
    } catch (PDOException $e) {
        echo "Error: " . $e->getMessage();
    }
}

// Fetch countries for the dropdown
$stmtc = $pdo->query("SELECT id, name FROM countries");
$countries = $stmtc->fetchAll(PDO::FETCH_ASSOC);

// Fetch existing currencies for the table
$stmt = $pdo->query("SELECT * FROM currency");
$currencies = $stmt->fetchAll(PDO::FETCH_ASSOC);

$pdo = null;
?>

<!-- HTML Structure -->
<div class="col-md-9">
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=settingspage" style="color: rgb(7, 133, 164)">Settings</a></li>
                <li class="active">Currency</li>
            </ul>
            <div class="col-lg-4">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title"><b>ADD CURRENCY</b></h3>
                    </div>
                    <div class="panel-body" style="background: #fff">
                        <form class="form-horizontal" action="" method="post">
                            <div class="form-group">
                                <div class="col-md-12">
                                 <label >Select Country</label>

                                    <select class="form-control select" data-live-search="true" name="country" id="country" onchange="fetchCurrency()">
                                        <option value="">Search</option>
                                        <?php foreach ($countries as $country): ?>
                                            <option value="<?php echo $country['id']; ?>"><?php echo htmlspecialchars($country['name']); ?></option>
                                        <?php endforeach; ?>
                                    </select>
                                </div> 
                            </div>
                            <div class="form-group">
                                <div class="col-md-12">
                                    <label for="currency_name">Currency Name:</label>
                                    <input type="text" class="form-control" id="currency_name" name="currency_name" readonly>
                                </div> 
                            </div>
                            <div class="form-group">
                                <div class="col-md-12">
                                    <label for="currency_symbol">Currency Symbol:</label>
                                    <input type="text" id="currency_symbol" name="currency_symbol" readonly class="form-control">
                                </div> 
                            </div>
                            <div class="panel-footer">                                    
                                <button class="btn btn-warning pull-right" type="submit"><span class="fa fa-plus-circle"></span> Add</button>
                            </div>
                        </form>      
                    </div>
                </div>
            </div>
            <div class="col-lg-8">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title"><b>CURRENCY LIST</b></h3>
                    </div>
                    <div class="panel-body">
                        <div class="table-responsive">
                            <table class="table datatable table-striped">
                                <thead>
                                    <tr>
                                        <th>#</th>
                                        <th>Currency Name</th>
                                        <th>Currency Symbol</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <?php $count = 1; ?>
                                    <?php foreach ($currencies as $currency): ?>
                                        <tr>
                                            <td><?php echo $count++; ?></td>
                                            <td><?php echo htmlspecialchars($currency['currency_name']); ?></td>
                                            <td><?php echo htmlspecialchars($currency['symbol']); ?></td>
                                            <td>
                                                <!--<a href="index.php?p=currency_edit&id=<?php //echo $currency['id']; ?>"><span class="fa fa-edit"></span> Edit</a> | -->
                                                <a onclick="return confirm('Are you sure you want to delete this currency?');" href="index.php?p=currency_delete&id=<?php echo $currency['id']; ?>"><span class="fa fa-trash-o"></span> Delete</a>
                                            </td>
                                        </tr>
                                    <?php endforeach; ?>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<script>
function fetchCurrency() {
    var countryId = document.getElementById('country').value;
    if (countryId) {
        fetch('fetch_currency.php?country_id=' + countryId)
            .then(response => response.json())
            .then(data => {
                document.getElementById('currency_name').value = data.currency_name;
                document.getElementById('currency_symbol').value = data.currency;
            })
            .catch(error => console.error('Error fetching currency:', error));
    }
}
</script>
