<?php
// Assuming you have already established a connection to the database in $pdo
// Example:
// $pdo = new PDO('mysql:host=localhost;dbname=yourdbname', 'username', 'password');

try {
    $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    if ($_SERVER['REQUEST_METHOD'] === 'POST') {
        $currency_symbol = $_POST['currency_symbol'];
        $currency_name = $_POST['currency_name'];
        $currency_rate = $_POST['currency_rate'];

        $stmt = $pdo->prepare("INSERT INTO currency (country, symbol, exchange_rate) VALUES (:currency_name, :currency_symbol, :currency_rate)");

        $stmt->bindParam(':currency_name', $currency_name);
        $stmt->bindParam(':currency_symbol', $currency_symbol);
        $stmt->bindParam(':currency_rate', $currency_rate);

        $stmt->execute();
        echo "<script>
                alert('Currency Added successfully!');
                window.location.href='index.php?p=currency';
              </script>";
    }

} catch (PDOException $e) {
    echo "Error: " . $e->getMessage();
}

$pdo = null;
?>
<div class="col-md-9">
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=settingspage" style="color: rgb(7, 133, 164)">settings</a></li>
                <li><a href="index.php?p=currency" style="color: rgb(7, 133, 164)">Currency List</a></li>
                <li class="active">Create New</li>
            </ul>

            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>CREATE NEW CURRENCY</b></h3>
                </div>
                <div class="panel-body" style="background: #fff">
                    <form method="post" action="">
                        <table width="70%">
                            <tr>
                                <td><br>
                                    <div class="form-group">
                                        <label class="col-md-3 col-xs-9 control-label">Currency Name</label>
                                        <div class="col-md-6">
                                            <div class="input-group">
                                                <input type="text" class="form-control" placeholder="Currency name" name="currency_name" required />
                                                <span class="input-group-addon"></span>
                                            </div>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            <tr>
                                <td><br>
                                    <div class="form-group">
                                        <label class="col-md-3 col-xs-9 control-label">Currency Symbol</label>
                                        <div class="col-md-6">
                                            <div class="input-group">
                                                <input type="text" class="form-control" placeholder="Symbol" name="currency_symbol" required />
                                                <span class="input-group-addon"></span>
                                            </div>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            <tr>
                                <td><br>
                                    <div class="form-group">
                                        <label class="col-md-3 col-xs-9 control-label">Exchange Rate</label>
                                        <div class="col-md-6">
                                            <div class="input-group">
                                                <input type="text" class="form-control" placeholder="Exchange Rate" name="currency_rate"  />
                                                <span class="input-group-addon"></span>
                                            </div>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                        </table>
                </div>
                <div class="panel-footer">
                            <button class="btn btn-info pull-right" type="submit"><span class="fa fa-plus-circle"></span> Create</button>
                        </div>
                    </form>
            </div>
        </div>
    </div>
</div>
