<?php
include '../db/connect.php';

try {
    $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    if ($_SERVER['REQUEST_METHOD'] === 'POST') {
        $id = $_GET['id']; 
        $currency_rate = $_POST['currency_rate'];
        $date = $_POST['date'];

        if (!empty($id)) {
            // Update existing currency
            $stmt = $pdo->prepare("UPDATE currencyExchange SET exchange_rate = :currency_rate, date = :date WHERE id = :id");

            $stmt->bindParam(':id', $id);
            $stmt->bindParam(':currency_rate', $currency_rate);
            $stmt->bindParam(':date', $date);

            $stmt->execute();

            echo "<script src='https://cdn.jsdelivr.net/npm/sweetalert2@11'></script>";
            echo "<script>
                Swal.fire({
                    title: 'Success!',
                    text: 'Rate updated successfully.',
                    icon: 'success',
                    timer: 2000, 
                    showConfirmButton: false
                }).then(() => {
                    window.location.href = 'index.php?p=exchange_rate';
                });
            </script>";
        } else {
            echo "<script>
                    alert('Error: Invalid ID');
                  </script>";
        }
    }

} catch (PDOException $e) {
    echo "<script>
            alert('Error: " . $e->getMessage() . "');
          </script>";
}

$id = $_GET['id'] ?? null; // Use null coalescing operator for safety
$currency = null;

if ($id) {
    try {
        $stmt = $pdo->prepare("SELECT c.currency_name,ce.date,ce.exchange_rate FROM currencyExchange ce INNER JOIN currency c ON ce.currency = c.id  WHERE ce.id = :id");
        $stmt->bindParam(':id', $id);
        $stmt->execute();
        $currency = $stmt->fetch(PDO::FETCH_ASSOC);
    } catch (PDOException $e) {
        echo "<script>
                alert('Error: " . $e->getMessage() . "');
              </script>";
    }
}

$pdo = null;
?>

<div class="col-md-9">
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=settingspage" style="color: rgb(7, 133, 164)">settings</a></li>
                <li><a href="index.php?p=currency" style="color: rgb(7, 133, 164)">Currency List</a></li>
                <li class="active">Update Currency Rate</li>
            </ul>

            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>UPDATE CURRENCY RATE</b></h3>
                </div>
                <div class="panel-body" style="background: #fff">
                    <?php if ($currency): ?>
                    <form method="post" action="">
                        <input type="hidden" name="id" value="<?php echo $currency['id']; ?>">
                        <table width="70%">
                            <tr>
                                <td><br>
                                    <div class="form-group">
                                        <label class="col-md-3 col-xs-9 control-label">Date</label>
                                        <div class="col-md-6">
                                            <div class="input-group">
                                                <input type="text" class="form-control datepicker datepicker-from" value="<?php echo $currency['date']; ?>" name="date">          
                                                <span class="input-group-addon"></span>
                                            </div>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            <tr>
                                <td><br>
                                    <div class="form-group">
                                        <label class="col-md-3 col-xs-9 control-label">Currency Name</label>
                                        <div class="col-md-6">
                                            <div class="input-group">
                                                <input type="text" class="form-control" placeholder="currency name" name="country" value="<?php echo $currency['currency_name']; ?>" required />
                                                <span class="input-group-addon"></span>
                                            </div>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            <tr>
                                <td><br>
                                    <div class="form-group">
                                        <label class="col-md-3 col-xs-9 control-label">Exchange Rate</label>
                                        <div class="col-md-6">
                                            <div class="input-group">
                                                <input type="text" class="form-control" placeholder="Exchange Rate" name="currency_rate" value="<?php echo $currency['exchange_rate']; ?>" required />
                                                <span class="input-group-addon"></span>
                                            </div>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                        </table>
                </div>
                <div class="panel-footer">
                    <button class="btn btn-info pull-right" type="submit"><span class="fa fa-plus-circle"></span> Update</button>
                </div>
                    </form>
                    <?php else: ?>
                        <div class="alert alert-danger">
                            <strong>Error!</strong> Currency not found.
                        </div>
                    <?php endif; ?>
            </div>
        </div>
    </div>
</div>
