<?php
session_start();
include "../db/connection.php";
error_reporting(E_ALL);
ini_set('display_errors', 1);

if(isset($_GET['id'])) {
    $id = $_GET['id'];

    // Fetch transaction details based on the id
    $query = "SELECT * FROM transactions WHERE id = $id";
    $result = mysqli_query($con, $query);
    $row = mysqli_fetch_assoc($result);

    // Assign fetched values to variables
    $debit_account = $row['debit_account'];
    $credit_account = $row['credit_account'];
    $amount = $row['amount'];
    $date = $row['date'];
    $notes = $row['notes'];
}

if (isset($_POST['submit_jornal'])) {
    $debit_account = $_POST['debit'];
    $credit_account = $_POST['credit'];
    $amount = $_POST['amount'];
    $notes = $_POST['notes'];
    $date = $_POST['date'];
    $user = $_SESSION['id'];
    $fyear = date('Y');
    $cat = 'Bank Transfer';

    if ($debit_account == '' || $credit_account == '' || $amount == '' || $notes == '' || $date == '') {
        echo "<script>alert('Fill all empty blanks --- Hakikisha umejaza sehemu zote zenye alama ya nyota');</script>";
    } else {
        try {

            // Start a transaction
            $pdo->beginTransaction();

            // Update the transactions table
            $stmtTransaction = $pdo->prepare("UPDATE transactions SET debit_account = ?, credit_account = ?, amount = ?, date = ?, notes = ?, user = ? WHERE id = ?");
            $success = $stmtTransaction->execute([$debit_account, $credit_account, $amount, $date, $notes, $user, $id]);

            if($success) {
                // Delete previous gl_transaction records
                $stmtDelete = $pdo->prepare("DELETE FROM gl_transaction WHERE transid = ? AND cat = 'Bank Transfer'");
                $stmtDelete->execute([$id]);

                // Fetch debit account details
                $stmtDebitAccount = $pdo->prepare("SELECT * FROM chart_master WHERE account_code = ?");
                $stmtDebitAccount->execute([$debit_account]);
                $debit_account_details = $stmtDebitAccount->fetch(PDO::FETCH_ASSOC);
                $fsli = $debit_account_details['account_type'];
                $group = $debit_account_details['class'];

                // Fetch credit account details
                $stmtCreditAccount = $pdo->prepare("SELECT * FROM chart_master WHERE account_code = ?");
                $stmtCreditAccount->execute([$credit_account]);
                $credit_account_details = $stmtCreditAccount->fetch(PDO::FETCH_ASSOC);
                $fsli2 = $credit_account_details['account_type'];
                $group2 = $credit_account_details['class'];

                // Prepare the SQL statements for debit and credit entries
                $stmtDebit = $pdo->prepare("INSERT INTO gl_transaction (account, fsli, maingroup, amount, nature, transid, user, notes, fyear, date, branchno, cat) VALUES (:account, :fsli, :maingroup, :amount, 'debit', :transid, :user, :notes, :fyear, :date, :branchno, :cat)");
                $stmtCredit = $pdo->prepare("INSERT INTO gl_transaction (account, fsli, maingroup, amount, nature, transid, user, notes, fyear, date, branchno, cat) VALUES (:account, :fsli2, :maingroup2, :amount, 'credit', :transid, :user, :notes, :fyear, :date, :branchno, :cat)");

                // Bind parameters for debit entry
                $stmtDebit->bindParam(':account', $debit_account);
                $stmtDebit->bindParam(':fsli', $fsli);
                $stmtDebit->bindParam(':maingroup', $group);
                $stmtDebit->bindParam(':amount', $amount);
                $stmtDebit->bindParam(':transid', $id);
                $stmtDebit->bindParam(':user', $user);
                $stmtDebit->bindParam(':notes', $notes);
                $stmtDebit->bindParam(':fyear', $fyear);
                $stmtDebit->bindParam(':date', $date);
                $stmtDebit->bindParam(':branchno', $_SESSION['Branch']);
                $stmtDebit->bindParam(':cat', $cat);

                // Bind parameters for credit entry
                $stmtCredit->bindParam(':account', $credit_account);
                $stmtCredit->bindParam(':fsli2', $fsli2);
                $stmtCredit->bindParam(':maingroup2', $group2);
                $stmtCredit->bindParam(':amount', $amount);
                $stmtCredit->bindParam(':transid', $id);
                $stmtCredit->bindParam(':user', $user);
                $stmtCredit->bindParam(':notes', $notes);
                $stmtCredit->bindParam(':fyear', $fyear);
                $stmtCredit->bindParam(':date', $date);
                $stmtCredit->bindParam(':branchno', $_SESSION['Branch']);
                $stmtCredit->bindParam(':cat', $cat);

                // Execute the debit and credit queries
                $stmtDebit->execute();
                $stmtCredit->execute();
            }

            // Commit the transaction
            $pdo->commit();

            echo "<script>alert('Data recorded successfully');</script>";
        } catch (PDOException $e) {
            // Rollback the transaction if an error occurs
            $pdo->rollBack();
            echo "<script>alert('Transaction failed: " . $e->getMessage() . "');</script>";
        }
    }
}
?>

<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=accounting" style="color: rgb(7, 133, 164)">Accounting Menu</a></li>
                <li class="active">Inter Account Transfer</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">INTER ACCOUNT TRANSFER</h3>
                </div>
                <div class="panel-body">
                    <form class="form-horizontal" method="post" action="">
        <div class="panel-body tab-content">
            <div class="tab-pane active" id="tab-first">
                <div class="form-group">
                    <label class="col-md-3 col-xs-12 control-label">To (Debit A/C) *</label>
                    <div class="col-md-6 col-xs-12">
                        <select class="form-control select" name="debit" data-live-search="true">
                            <option value="">Choose Account</option>
                            <?php
                            $query_group = mysqli_query($con, "SELECT * FROM bank_accounts");
                            while ($rows = mysqli_fetch_assoc($query_group)) {
                                $selected = ($rows['account_code'] == $debit_account) ? 'selected' : '';
                                ?>
                                <option value="<?php echo $rows['account_code']; ?>" <?php echo $selected; ?>>
                                    <?php echo $rows['bank_account_name']; ?> - <?php echo $rows['account_code']; ?>
                                </option>
                            <?php } ?>
                        </select>
                    </div>
                </div>

                <div class="form-group">
                    <label class="col-md-3 col-xs-12 control-label">From (Credit A/C) *</label>
                    <div class="col-md-6 col-xs-12">
                        <select class="form-control select" name="credit" data-live-search="true">
                            <option value="">Choose Account</option>
                            <?php
                            $query_group = mysqli_query($con, "SELECT * FROM bank_accounts");
                            while ($rows = mysqli_fetch_assoc($query_group)) {
                                $selected = ($rows['account_code'] == $credit_account) ? 'selected' : '';
                                ?>
                                <option value="<?php echo $rows['account_code']; ?>" <?php echo $selected; ?>>
                                    <?php echo $rows['bank_account_name']; ?> - <?php echo $rows['account_code']; ?>
                                </option>
                            <?php } ?>
                        </select>
                    </div>
                </div>

                <div class="form-group">
                    <label class="col-md-3 col-xs-12 control-label">Amount *</label>
                    <div class="col-md-6 col-xs-12">
                        <input class="form-control" name="amount" value="<?php echo $amount; ?>" />
                    </div>
                </div>

                <div class="form-group">
                    <label class="col-md-3 col-xs-12 control-label">Date *</label>
                    <div class="col-md-6 col-xs-12">
                        <div class="input-group">
                            <span class="input-group-addon"><span class="fa fa-calendar"></span></span>
                            <input type="text" name="date" class="form-control datepicker" value="<?php echo $date; ?>" />
                        </div>
                    </div>
                </div>

                <div class="form-group">
                    <label class="col-md-3 col-xs-12 control-label">Notes *</label>
                    <div class="col-md-6 col-xs-12">
                        <textarea class="form-control" name="notes"><?php echo $notes; ?></textarea>
                    </div>
                </div>

            </div>
        </div>
        <div class="panel-footer">
            <button type="submit" name="submit_jornal" class="btn btn-warning pull-right">
                Submit <span class="fa fa-floppy-o fa-right"></span>
            </button>
        </div>
    </form>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>
