 <?php
require_once '../db/connection.php';
  $pdo = new PDO($dsn, $username, $password);
  $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION); 
if(isset($_GET['id'])) {
    $id = $_GET['id'];
    // Fetch the existing data from the database to populate the form for editing
    $stmt = $pdo->prepare("SELECT * FROM ngm_customer WHERE id = ?");
    $stmt->execute([$id]);
    $row = $stmt->fetch(PDO::FETCH_ASSOC);
    if(!$row) {
        // Handle if no record is found for the provided ID
        echo "Record not found!";
        exit;
    }
    // Extract fetched data to populate the form fields for editing
    $fname = $row['fname'];
    $lname = $row['lname'];
    $name = $row['name'];
    $member_code = $row['customerNo'];
    $sex = $row['sex'];
    $age = $row['age'];
    $phone1 = $row['phone1'];
    $phone2 = $row['phone2'];
    $region = $row['region'];
    $district = $row['district'];
    $ward = $row['ward'];
    $area = $row['area'];
    $kazi = $row['kazi'];
    $kaziAddress = $row['kaziAddress'];
    $idtype = $row['idType'];
    $idnumber = $row['idNumber'];
    $relation = $row['relation'];
}
// Update record in the database on form submission
if(isset($_POST['submit'])) {
    $id = $_GET['id'];
    
    // Retrieve form data
    $name = strtoupper($_POST['name']);
    $member_code = strtoupper($_POST['member_code']);
    $sex = $_POST['sex'];
    $age = $_POST['age'];
    $relation = $_POST['relation'];
    $area = strtoupper($_POST['area']);
    $ward = strtoupper($_POST['ward']);
    $kazi = $_POST['kazi'];
    $baddress = $_POST['baddress'];
    $region = strtoupper($_POST['region']);
    $district = strtoupper($_POST['district']);
    $phone1 = $_POST['phone1'];
    $phone2 = $_POST['phone2'];
    $idtype = $_POST['idtype'];
    $idno = $_POST['idname'];
    $fname = '';
    $lname = '';
   // $name = $fname." ".$mname." ".$lname;
    
    if(strlen($phone1)<>12){
        $err = "<p class = 'alert alert-danger'>Invalid phone number !!! Tafadhali hakikisha umejaza namba ya simu kwa usahihi</p>";  
    }else{

    // Update the record in the database
    $stmt = $pdo->prepare("UPDATE ngm_customer SET fname = ?, lname = ?, sex = ?, age = ?, relation = ?, area = ?, ward = ?, district = ?, region = ?, kazi = ?, kaziAddress = ?, phone1 = ?, phone2 = ?, idType = ?, idNumber = ?,name = ?, customerNo = ? WHERE id = ?");
    $stmt->execute([$fname, $lname, $sex, $age, $relation, $area, $ward, $district, $region, $kazi, $baddress, $phone1, $phone2, $idtype, $idno, $name,$member_code, $id]);

    if($stmt->rowCount() > 0) {
        // Handle successful update
       // echo "<p class='alert alert-success'>Record updated successfully!</p>";
        echo "<script>
              window.location='index.php?p=customers';
        </script>";
        
    } else {
        // Handle update failure
        echo "<p class='alert alert-danger'>Failed to update the record!</p>";
    }
}
}
?>
                            <div class="col-md-9">

                            <!-- START TIMELINE -->
                            <div class="row">
                            <div class="col-md-12">

                               <div class="panel panel-default">
                                <div class="panel-heading">
                                    <h3 class="panel-title"><b>EDIT MEMBER INFO</b></h3>
                                </div>
                                <div class="panel-body" style="background: #fff">
                                    <?php if(isset($err)){ echo $err;}?>
                                    <form action = "" method="post">
                                    <h4><span class="fa fa-user"></span> Name (Mandatory)</h4><hr/>
                                    <div class="row"> 
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                          <label class="col-md-6 col-xs-12 control-label">Name</label>
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-pencil"></span></span>
                                                <input type="text" name = "name" class="form-control" value="<?php echo $name;?>" />
                                            </div>                                            
                                        </div>
                                    </div>                     
                                                                    
                                     </div>
                                     
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                          <label class="col-md-6 col-xs-12 control-label">Member Code</label>
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-pencil"></span></span>
                                                <input type="text" name = "member_code" class="form-control" value="<?php echo $member_code;?>" />
                                            </div>                                            
                                        </div>
                                    </div>                     
                                                                    
                                     </div>
                                   </div><br/><br/>
                                   <h4><span class="fa fa-user"></span> Gender & Age (Mandatory)</h4><hr/>
                                    <div class="row"> 
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                        <label class="col-md-6 col-xs-12 control-label">Gender</label>
                                        <div class="col-md-12 col-xs-12">                                               
                                            <select class="form-control select" name = "sex" >
                                            <option value="M" <?php if($sex === 'M') echo 'selected'; ?>>Male</option>
                                            <option value="F" <?php if($sex === 'F') echo 'selected'; ?>>Female</option>
                                            </select>
                                        </div>
                                    </div>                    
                                                                    
                                     </div>
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                        <label class="col-md-6 col-xs-12 control-label">Age</label>
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-pencil"></span></span>
                                                <input type="text" name = "age" class="form-control" value="<?php echo $age;?>" />
                                            </div>                                            
                                        </div>
                                    </div>                     
                                                                    
                                     </div>
                                   </div><br/><br/>
                                   <h4><span class="fa fa-phone"></span> Communication (Mandatory)</h4><hr/>
                                    <div class="row"> 
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                          <label class="col-md-6 col-xs-12 control-label">Phone</label>
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-pencil"></span></span>
                                                <input type="text" name = "phone1" class="form-control" value="<?php echo $phone1;?>" />
                                            </div>                                            
                                        </div>
                                    </div>                     
                                                                    
                                     </div>
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                          <label class="col-md-6 col-xs-12 control-label">Alt Phone</label>
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-pencil"></span></span>
                                                <input type="text" name = "phone2" class="form-control" value="<?php echo $phone2;?>" />
                                            </div>                                            
                                        </div>
                                    </div>                     
                                                                    
                                     </div>
                                   </div>

                                    <br/><br/>
                                    <h4><span class="fa fa-arrow-right"></span> Physical Address (Optional)</h4><hr/>
                                    <div class="row"> 
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                          <label class="col-md-6 col-xs-12 control-label">Region</label>
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-pencil"></span></span>
                                                <input type="text" name = "region" class="form-control" value="<?php echo $region;?>" />
                                            </div>                                            
                                        </div>
                                    </div>                    
                                                                    
                                     </div>
                                     <div class="col-md-4">
                                     <div class="form-group">
                                         <label class="col-md-6 col-xs-12 control-label">District</label>
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-pencil"></span></span>
                                                <input type="text" name = "district" class="form-control" value="<?php echo $district;?>" />
                                            </div>                                            
                                        </div>
                                    </div>                                
                                     </div>

                                   </div><br><br/>
                                    <div class="row"> 
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                          <label class="col-md-6 col-xs-12 control-label">Ward</label>
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-pencil"></span></span>
                                                <input type="text" name = "ward" class="form-control" value="<?php echo $ward;?>" />
                                            </div>                                            
                                        </div>
                                    </div>                     
                                                                    
                                     </div>
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                          <label class="col-md-6 col-xs-12 control-label">Street</label>
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-pencil"></span></span>
                                                <input type="text" name = "area" class="form-control" value="<?php echo $area;?>" />
                                            </div>                                            
                                        </div>
                                    </div>                     
                                                                    
                                     </div>
                                   </div><br/><br/>

                                    <h4><span class="fa fa-wrench"></span> Occupation (Optional)</h4><hr/>
                                    <div class="row"> 
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                          <label class="col-md-6 col-xs-12 control-label">Work/Business</label>
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-pencil"></span></span>
                                                <input type="text" name = "kazi" class="form-control" value="<?php echo $kazi;?>" />
                                            </div>                                            
                                        </div>
                                    </div>                      
                                                                    
                                     </div>
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                          <label class="col-md-6 col-xs-12 control-label">Work/Business Location</label>
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-pencil"></span></span>
                                                <input type="text" name = "baddress" class="form-control" value="<?php echo $kaziAddress;?>" />
                                            </div>                                            
                                        </div>
                                    </div>                     
                                                                    
                                     </div>

                                   </div>

                                    <br/><br/>

                                    <h4><span class="fa fa-envelope"></span> Identification & Relationship (Optional)</h4><hr/>
                                    <div class="row"> 
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                        <div class="col-md-12 col-xs-12">       
                                            <select class="form-control select" name = "relation">
                                                <option value="">Relation</option>
                                                <option>Board Member</option>
                                                <option>Insider</option>
                                                <option>None</option>
                                            </select>
                                        </div>
                                    </div>                     
                                                                    
                                     </div>
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-pencil"></span></span>
                                                <input type="text" name = "idname" class="form-control" value="<?php echo $idno;?>" />
                                            </div>                                            
                                        </div>
                                    </div>                     
                                                                    
                                     </div>

                                   </div><br/><br/>
                                   
                                   <div class="row"> 
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                        <div class="col-md-12 col-xs-12">       
                                            <select class="form-control select" name = "idtype">
                                                <option><?php echo $idtype;?></option>
                                                <option>Worker</option>
                                                <option>National</option>
                                                <option>Voter</option>
                                                <option>Driver Licence</option>
                                                <option>Passport</option>
                                                <option>PSPF</option>
                                                <option>PPF</option>
                                            </select>
                                        </div>
                                    </div> 
                                     </div>
 
                                   </div><br/><br/>

                                </div>
                                <div class="panel-footer">                                    
                                    <button class="btn btn-info pull-right" type = "submit" name = "submit"><span class="fa fa-arrow-right"></span> Update</button>
                                </div>
                            </form>
                            </div>
                          </div>
                        </div>


                            <!-- END TIMELINE -->                            
                            
                        </div>