<?php
// Database connection parameters
include '../db/db.php';

// Check if the form is submitted
if (isset($_POST['submit'])) {
    // Retrieve form data
    $id = $_POST['id'];
    $date = mysqli_real_escape_string($con, $_POST['date']);
    $reference = mysqli_real_escape_string($con, $_POST['reference']);
    if ($reference == '') {
        $reference = $refs;
    } else {
        $reference = 'RV' . '-' . $_POST['reference'];
    }
    $bank = mysqli_real_escape_string($con, $_POST['bank']);
    $payee = mysqli_real_escape_string($con, $_POST['payee']);
    $note = mysqli_real_escape_string($con, $_POST['note']);
    $user = $_SESSION['id'];
    $attachment = '';
    $payeetype = mysqli_real_escape_string($con, $_POST['payeetype']);
    $branch = $_SESSION['Branch'];

    if ($payeetype == 'other') {
        $payee = mysqli_real_escape_string($con, $_POST['other']);
    } else if ($payeetype == 'customer') {
        $payee = mysqli_real_escape_string($con, $_POST['customer']);
    } else {
        $payee = mysqli_real_escape_string($con, $_POST['supplier']);
    }

    // Update main payment data
    $q = mysqli_query($con, "UPDATE transactions_details SET date='$date', reference='$reference', payer='$bank', payee='$payee', note='$note', user='$user', branch='$branch', method='receipt' WHERE id='$id'");

    if ($q) {
        // Delete old transaction items
        mysqli_query($con, "DELETE FROM transactions_details_items WHERE transid='$id'");

        // Insert new account lines
        $sum = 0;
        foreach ($_POST['account'] as $index => $account) {
            $amount = $_POST['amount'][$index];

            $sum = $sum + $amount;

            // Insert account line data
            $stmt = mysqli_query($con, "INSERT INTO transactions_details_items VALUES ('','$id', '$account', '$amount')");
            if ($stmt) {
                $debit = mysqli_query($con, "SELECT * FROM chart_master WHERE account_code = '$bank'");
                $rows = mysqli_fetch_array($debit);
                $class_debit = $rows['class'];
                $fsli_debit = $rows['account_type'];

                $credit = mysqli_query($con, "SELECT * FROM chart_master WHERE account_code = '$account'");
                $rowss = mysqli_fetch_array($credit);
                $class_credit = $rowss['class'];
                $fsli_credit = $rowss['account_type'];

                mysqli_query($con, "INSERT INTO gl_transaction VALUES('', '$bank', '$fsli_debit', '$class_debit', '$amount', 'Debit', '$id', '".$_SESSION['id']."', '$note', '$year', '$date', '".$_SESSION['Branch']."', 'Receipt')");
                mysqli_query($con, "INSERT INTO gl_transaction VALUES('', '$account', '$fsli_credit', '$class_credit', '$amount', 'Credit', '$id', '".$_SESSION['id']."', '$note', '$year', '$date', '".$_SESSION['Branch']."', 'Receipt')");
            }
        }
        mysqli_query($con, "UPDATE transactions_details SET total='$sum' WHERE id='$id'");
        echo "<script>
        alert('Receipt Updated Successfully!');
        window.location = 'index.php?p=receipt';
        </script>";
    }
} else {
    // Fetch existing transaction details if id is set
    if (isset($_GET['id'])) {
        $id = $_GET['id'];
        $query = mysqli_query($con, "SELECT * FROM transactions_details WHERE id='$id'");
        $transaction = mysqli_fetch_assoc($query);

        // Fetch existing transaction items
        $itemsQuery = mysqli_query($con, "SELECT * FROM transactions_details_items WHERE transid='$id'");
        $items = [];
        while ($row = mysqli_fetch_assoc($itemsQuery)) {
            $items[] = $row;
        }
    }
}
?>

<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=accounting" style="color: rgb(7, 133, 164)">Accounting Menu</a></li>
                <li><a href="index.php?p=receipt" style="color: rgb(7, 133, 164)">Receipts List</a></li>
                <li class="active">Receipt Voucher</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>RECEIPT VOUCHER</b></h3>
                </div>
                <div class="panel-body">
                    <form class="form-horizontal" method="post" action="" enctype="multipart/form-data">
                        <input type="hidden" name="id" value="<?php echo $id; ?>">
                        <h4 style="font-weight: bold;color: rgb(193, 190, 190);">Update Receipt</h4>
                        <table class="table" style="width: 70%;">
                            <tbody>
                                <tr>
                                    <th style="width:35%">
                                        <div class="form-group">
                                            <label class="col-md-12 col-xs-12">Date *</label>
                                            <div class="col-md-12 col-xs-12">
                                                <input type="text" class="form-control datepicker" name="date" value="<?php echo $transaction['date']; ?>" />
                                            </div>
                                        </div>
                                    </th>
                                    <th style="width:35%">
                                        <div class="form-group">
                                            <label class="col-md-12 col-xs-12">Reference</label>
                                            <div class="col-md-12 col-xs-12">
                                                <div class="input-group">
                                                    <span class="input-group-addon"><input type="checkbox" id="referenceCheckbox"></span>
                                                    <input type="text" class="form-control" id="referenceInput" placeholder="Optional" name="reference" value="<?php echo $transaction['reference']; ?>">
                                                </div>
                                            </div>
                                        </div>
                                    </th>
                                </tr>
                                <tr>
                                    <th colspan="2" style="width:70%">Received In</th>
                                </tr>
                                <tr>
                                    <td colspan="2" style="width:70%">
                                        <div class="form-group">
                                            <div class="col-md-12 col-xs-12">
                                                <div class="input-group">
                                                    <span class="input-group-addon">Bank Account</span>
                                                    <select class="form-control select" name="bank" data-live-search="true">
                                                        <?php
                                                        $cl = mysqli_query($con, "SELECT * FROM bank_accounts WHERE branch = '".$_SESSION['Branch']."'");
                                                        while ($class = mysqli_fetch_assoc($cl)) {
                                                        ?>
                                                            <option value="<?php echo $class['account_code']; ?>" <?php echo ($transaction['payer'] == $class['account_code']) ? 'selected' : ''; ?>>
                                                                <?php echo $class['bank_account_name']; ?>
                                                            </option>
                                                        <?php
                                                        }
                                                        ?>
                                                    </select>
                                                </div>
                                            </div>
                                        </div>
                                    </td>
                                </tr>
                                <tr>
                                    <th colspan="2" style="width:70%; text-align:center">Payee</th>
                                </tr>
                                <tr>
                                    <td style="width:35%">
                                        <div class="form-group">
                                            <div class="col-md-12 col-xs-12">
                                                <select class="form-control select" name="payeetype" id="payeeType" data-live-search="true">
                                                    <option value="other" <?php echo ($transaction['payeetype'] == 'other') ? 'selected' : ''; ?>>Other</option>
                                                    <option value="customer" <?php echo ($transaction['payeetype'] == 'customer') ? 'selected' : ''; ?>>Customer</option>
                                                    <option value="supplier" <?php echo ($transaction['payeetype'] == 'supplier') ? 'selected' : ''; ?>>Supplier</option>
                                                </select>
                                            </div>
                                        </div>
                                    </td>
                                    <td style="width:35%">
                                        <div class="form-group">
                                            <div class="col-md-12 col-xs-12" id="payeeInputWrapper" <?php echo ($transaction['payeetype'] == 'other') ? '' : 'style="display:none;"'; ?>>
                                                <input type="text" name="other" id="payeeInput" class="form-control" value="<?php echo ($transaction['payeetype'] == 'other') ? $transaction['payee'] : ''; ?>" />
                                            </div>
                                            <div class="col-md-12 col-xs-12" id="payeeSelect" <?php echo ($transaction['payeetype'] == 'customer') ? '' : 'style="display:none;"'; ?>>
                                                <?php
                                                $cust = mysqli_query($con, "SELECT * FROM ngm_customer WHERE branch = '".$_SESSION['Branch']."' AND category ='customer' ORDER BY name ASC");
                                                ?>
                                                <select class="form-control select" name="customer" data-live-search="true">
                                                    <option value="">---Select Customer---</option>
                                                    <?php
                                                    while ($rs = mysqli_fetch_array($cust)) {
                                                    ?>
                                                        <option value="<?php echo $rs['id']; ?>" <?php echo ($transaction['payee'] == $rs['id']) ? 'selected' : ''; ?>>
                                                            <?php echo $rs['name']; ?>
                                                        </option>
                                                    <?php
                                                    }
                                                    ?>
                                                </select>
                                            </div>
                                            <div class="col-md-12 col-xs-12" id="payeeSelectSupplier" <?php echo ($transaction['payeetype'] == 'supplier') ? '' : 'style="display:none;"'; ?>>
                                                <?php
                                                $sup = mysqli_query($con, "SELECT * FROM ngm_customer WHERE branch = '".$_SESSION['Branch']."' AND category ='supplier' ORDER BY name ASC");
                                                ?>
                                                <select class="form-control select" name="supplier" data-live-search="true">
                                                    <option value="">---Select Supplier---</option>
                                                    <?php
                                                    while ($suprs = mysqli_fetch_array($sup)) {
                                                    ?>
                                                        <option value="<?php echo $suprs['id']; ?>" <?php echo ($transaction['payee'] == $suprs['id']) ? 'selected' : ''; ?>>
                                                            <?php echo $suprs['name']; ?>
                                                        </option>
                                                    <?php
                                                    }
                                                    ?>
                                                </select>
                                            </div>
                                        </div>
                                    </td>
                                </tr>
                                <tr>
                                    <th colspan="2" style="width:70%">Transaction Description</th>
                                </tr>
                                <tr>
                                    <td colspan="2" style="width:70%">
                                        <div class="form-group">
                                            <div class="col-md-12 col-xs-12">
                                                <textarea class="form-control" name="note" required><?php echo $transaction['note']; ?></textarea>
                                            </div>
                                        </div>
                                    </td>
                                </tr>
                                <tr>
                                    <th style="width:35%">Account</th>
                                    <th style="width:35%">Amount</th>
                                </tr>
                                <?php foreach ($items as $item): ?>
                                    <tr>
                                        <td style="width:35%">
                                            <div class="form-group">
                                                <div class="col-md-12 col-xs-12">
                                                    <select class="form-control select" name="account[]" data-live-search="true">
                                                        <?php
                                                        $cl = mysqli_query($con, "SELECT * FROM chart_master ORDER BY account_name ASC");
                                                        while ($class = mysqli_fetch_assoc($cl)) {
                                                        ?>
                                                            <option value="<?php echo $class['account_code']; ?>" <?php echo ($item['account_code'] == $class['account_code']) ? 'selected' : ''; ?>>
                                                                <?php echo $class['account_code']; ?> - <?php echo $class['account_name']; ?>
                                                            </option>
                                                        <?php
                                                        }
                                                        ?>
                                                    </select>
                                                </div>
                                            </div>
                                        </td>
                                        <td style="width:35%">
                                            <div class="form-group">
                                                <div class="col-md-12 col-xs-12">
                                                    <input type="text" oninput="updateTotalAmount()" name="amount[]" class="form-control amount-input" style="width:100%" value="<?php echo $item['amount']; ?>" />
                                                </div>
                                            </div>
                                        </td>
                                    </tr>
                                <?php endforeach; ?>
                                <tr>
                                    <td>
                                        <span><button type="button" class="btn btn-primary" onclick="addAccountLine()" style="background-color: green;color: white;">Add Line</button></span>
                                    </td>
                                    <td align="right"><button class="btn btn-default" style="color:red;font-size:16px">Total Amount: <span id="totalAmount">0.00</span></button></td>
                                </tr>
                            </tbody>
                        </table>
                </div>
                <div class="panel-footer">
                    <button type="submit" name="submit" class="btn btn-info pull-right"><span class="fa fa-plus-circle"></span> Update </button>
                </div>
                </form>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>
<script>
    let voucherCounter = 1; // Initialize the voucher counter

    // Set default date to today
    document.getElementById('datePicker').valueAsDate = new Date();

    // Function to add a new account line
    function addAccountLine() {
        const tableBody = document.querySelector('.table tbody');

        const newRow = document.createElement('tr');
        newRow.innerHTML = `
            <td style="width:50%">
                <div class="form-group">
                    <div class="col-md-12 col-xs-12">
                        <select class="form-control select" name="account[]" data-live-search="true">
                            <?php
                            $cl = mysqli_query($con, "SELECT * FROM chart_master ORDER BY account_name ASC");
                            while ($class = mysqli_fetch_assoc($cl)) {
                            ?>
                                <option value="<?php echo $class['account_code']; ?>"><?php echo $class['account_code']; ?> - <?php echo $class['account_name']; ?></option>
                            <?php
                            }
                            ?>
                        </select>
                    </div>
                </div>
            </td>
            <td style="width:50%">
                <div class="form-group">
                    <div class="col-md-12 col-xs-12">
                        <input type="text" name="amount[]" class="form-control amount-input" oninput="updateTotalAmount()" />
                    </div>
                </div>
            </td>
            <td style="background-color:#ffffff">
                <button class="btn btn-danger" onclick="removeAccountLine(this)"><i class="fa fa-trash-o"></i></button>
            </td>
        `;
        // Initialize Bootstrap Selectpicker for the new row
        $(newRow.querySelector('.select')).selectpicker();

        // Insert new row just above the "Add Line" and "Create" buttons
        tableBody.insertBefore(newRow, tableBody.lastElementChild);

        // Update the sum of amounts
        updateTotalAmount();
    }

    // Function to remove an account line
    function removeAccountLine(button) {
        const row = button.closest('tr');
        row.remove();

        // Update the sum of amounts after removing the line
        updateTotalAmount();
    }

    // Function to update the total amount
    function updateTotalAmount() {
        const amounts = document.querySelectorAll('.amount-input');
        let total = 0;

        amounts.forEach(input => {
            total += parseFloat(input.value) || 0;
        });
        const formattedTotal = total.toLocaleString();
        // Display the total amount in an element with id "totalAmount"
        document.getElementById('totalAmount').innerText = formattedTotal;
    }

    // Handle payee type change
    document.getElementById('payeeType').addEventListener('change', function() {
        const payeeType = this.value;
        document.getElementById('payeeInputWrapper').style.display = (payeeType === 'other') ? '' : 'none';
        document.getElementById('payeeSelect').style.display = (payeeType === 'customer') ? '' : 'none';
        document.getElementById('payeeSelectSupplier').style.display = (payeeType === 'supplier') ? '' : 'none';
    });

    // Initialize the select elements with Bootstrap Selectpicker
    $(document).ready(function() {
        $('.select').selectpicker();
        updateTotalAmount(); // Calculate total amount on page load
    });
</script>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
