<?php
include '../db/connection.php';

// Set PDO error mode to exception
$pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    $currency = $_POST['currency'];
    $exchange_rate = $_POST['rate'];
    $date = $_POST['date'];
    
    try {
        $stmt = $pdo->prepare("INSERT INTO  currencyExchange  (exchange_rate,currency,date) VALUES (:exchange_rate,:currency,:date)");
        $stmt->bindValue(':exchange_rate',$exchange_rate);
        $stmt->bindValue(':currency',$currency);
        $stmt->bindValue(':date',$date);
        $stmt->execute();
        
         echo "<script src='https://cdn.jsdelivr.net/npm/sweetalert2@11'></script>";
                echo "<script>
                Swal.fire({
                    title: 'Success!',
                    text: 'Rate Added successfully.',
                    icon: 'success',
                    timer: 2000, 
                    showConfirmButton: false
                });
            </script>";
    } catch (PDOException $e) {
        echo "Error: " . $e->getMessage();
    }
}

// Fetch countries for the dropdown
$stmtc = $pdo->query("SELECT id, name FROM countries");
$countries = $stmtc->fetchAll(PDO::FETCH_ASSOC);

// Fetch existing currencies for the table
$stmt = $pdo->query("SELECT * FROM currency");
$currencies = $stmt->fetchAll(PDO::FETCH_ASSOC);

// Fetch existing currenciesExchange for the table
$stmtt = $pdo->query("SELECT 
c.currency_name,
ce.exchange_rate,
ce.id as exchange_id

FROM currencyExchange ce INNER JOIN currency c ON ce.currency = c.id ");
$currenciesexchange = $stmtt->fetchAll(PDO::FETCH_ASSOC);

$pdo = null;
?>

<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=settingspage" style="color: rgb(7, 133, 164)">Settings</a></li>
                <li class="active">Exchange Rate</li>
                    </ul>
            <div class="col-lg-4">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>ADD EXCHANGE RATE</b></h3>
                </div>
                <div class="panel-body" style="background: #fff">
                    <form class="form-horizontal" action="" method="post">
                        <div class="form-group">
                             <label class="col-md-3 control-label col-label">Date</label>
                                    <div class="col-md-12">
                                        <div class="input-group">
                                            <span class="input-group-addon"><span class="fa fa-calendar"></span></span>
                                            <input type="text" class="form-control datepicker datepicker-from" value="<?php echo date('Y-m-d');?>" name="date">          
                                        </div>
                                    </div>
                            </div>
                            <div class="form-group">
                               <label class="col-md-6 control-label col-label">Select Currency</label>
                                    <div class="col-md-12">
                                        <select class="form-control select" data-live-search="true" name="currency" id="country" onchange="fetchCurrency()">
                                        <option value="">Search</option>
                                        <?php foreach ($currencies as $currency): ?>
                                            <option value="<?php echo $currency['id']; ?>"><?php echo htmlspecialchars($currency['currency_name']); ?></option>
                                        <?php endforeach; ?>
                                    </select>
                                   </div> 
                                </div>
                                <div class="form-group">
                                        <label class="col-md-6  control-label">Exchange Rate</label>
                                        <div class="col-md-12">
                                            <div class="input-group">
                                                <span class="input-group-addon"><span class="fa fa-pencil"></span></span>
                                                <input type="text" class="form-control" placeholder="Rate" name="rate"  />
                                            </div>
                                        </div>
                                    </div>
                        </div>
                <div class="panel-footer">                                    
                  <button class="btn btn-warning pull-right" type="submit" name="general_ledger"><span class="fa fa-plus-circle"></span> Add</button>
            </form>      
            </div>
        </div>
    </div>
    <div class="col-lg-8">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>EXCHANGE RATE LIST</b></h3>
                </div>
                <div class="panel-body">
                    
                    <div class="table-responsive">
                        <table class="table datatable table-striped">
                            <thead>
                                <tr>
                                    <th>#</th>
                                    <th>Currency Name</th>
                                    <th>Rate</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php 
                                 $count=0;
                                ?>
                              <?php foreach ($currenciesexchange as $index=> $currenc): ?>
                                <tr>
                                    <td><?php echo $index + 1?></td>
                                    <td><?php echo htmlspecialchars($currenc['currency_name']); ?></td>
                                    <td><?php echo htmlspecialchars($currenc['exchange_rate']); ?></td>
                                    <td>
                                        <a href="index.php?p=currency_exchange_edit&id=<?php echo $currenc['exchange_id']; ?>"><span class="fa fa-edit"></span> Edit</a> 
                                        <!--<a onclick="return confirm('Are you Sure you want to Delete Currency');" href="index.php?p=currency_delete&id=<?php// echo $currency['id'];?>"><span class="fa fa-trash-o"></span> Delete</a>-->
                                    </td>
                                </tr>
                           <?php endforeach; ?>
                           
                            </tbody>
                        </table>
                    </div>
                    
                </div>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>