<?php
session_start();
include '../db/connect.php'; 
include '../db/db.php'; 
include '../db/connection.php'; 

// Enable error reporting
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

// Check if productId is provided
if (isset($_GET['productId'])) {
    $productId = filter_var($_GET['productId'], FILTER_SANITIZE_NUMBER_INT);
    $branch = $_SESSION['Branch'];

    try {
        // Check if $pdo is set and is a PDO instance
        if (!isset($pdo) || !$pdo instanceof PDO) {
            throw new Exception('Database connection not initialized.');
        }

        $query_opening_stock = mysqli_query($con, "SELECT SUM(ist.quantity) as quantity 
            FROM item_opening io 
            INNER JOIN item_stock_table ist ON io.id = ist.open_id 
            WHERE ist.itemid = '$productId' AND ist.date BETWEEN '$date1' AND '$date2'");
        $rows_opening_stock = mysqli_fetch_assoc($query_opening_stock);
        $openQuantity = $rows_opening_stock['quantity'];
        
        $query_writeoff_stock = mysqli_query($con, "SELECT SUM(woi.quantity) as quantity 
            FROM writeoff wo 
            INNER JOIN writeoff_items woi ON wo.id = woi.writeoff_id 
            WHERE woi.itemid = '$productId' AND wo.date BETWEEN '$date1' AND '$date2'");
        $rows_writeoff_stock = mysqli_fetch_assoc($query_writeoff_stock);
        $writeoffQuantity = $rows_writeoff_stock['quantity'];
        
        // Purchases Quantity
        $query_cash_purchase = mysqli_query($con, "SELECT SUM(pi.quantity) as quantity 
            FROM purchases p 
            INNER JOIN purchase_items pi ON p.purchase_id = pi.purchase_no 
            WHERE pi.product_id = '$productId' AND pi.date BETWEEN '$date1' AND '$date2'");
        $rows_cash_purchase = mysqli_fetch_assoc($query_cash_purchase);
        $cashPurchaseQuantity = $rows_cash_purchase['quantity'];
        
        $query_invoice_purchase = mysqli_query($con, "SELECT SUM(pi.quantity) as quantity 
            FROM purchase_invoice p 
            INNER JOIN purchase_invoice_items pi ON p.purchase_id = pi.purchase_no 
            WHERE pi.product_id = '$productId' AND pi.date BETWEEN '$date1' AND '$date2'");
        $rows_invoice_purchase = mysqli_fetch_assoc($query_invoice_purchase);
        $invoicePurchaseQuantity = $rows_invoice_purchase['quantity'];
        
        $purchases_quantity = $cashPurchaseQuantity + $invoicePurchaseQuantity;

        $sales_query_invoice = mysqli_query($con, "SELECT SUM(it.quantity) AS quantity 
            FROM invoices AS i 
            INNER JOIN invoice_items AS it ON i.invoice_id = it.invoice_no 
            WHERE i.invoice_date BETWEEN '$date1' AND '$date2' 
            AND it.product_id = '$productId'");
        $row_invoice_sales = mysqli_fetch_assoc($sales_query_invoice);
        $invoice_sales_quantity = $row_invoice_sales['quantity'];
        
        $sales_query_cash = mysqli_query($con, "SELECT SUM(it.quantity) AS quantity 
            FROM sales_cash AS i 
            INNER JOIN sales_cash_items AS it ON i.sales_cash_id = it.cash_no 
            WHERE i.invoice_date BETWEEN '$date1' AND '$date2' 
            AND it.product_id = '$productId'");
        $row_cash_sales = mysqli_fetch_assoc($sales_query_cash);
        $cash_sales_quantity = $row_cash_sales['quantity'];
        
        $sales_quantity = $invoice_sales_quantity + $cash_sales_quantity;

        $closing_balance = ($openQuantity + $purchases_quantity) - ($writeoffQuantity + $sales_quantity);
        
        // Return the result
        echo $closing_balance;
    } catch (PDOException $e) {
        // Handle errors
        echo 'Error: ' . htmlspecialchars($e->getMessage());
    } catch (Exception $e) {
        // Handle errors
        echo 'Error: ' . htmlspecialchars($e->getMessage());
    }
} else {
    echo 'Product ID is required.';
}
