<?php
session_start();
require_once '../db/db.php';  // Make sure this path is correct and that $con is properly defined in this file.
//require_once '../fixedasset/add_fixedasset_model.php';

$queryAccount = mysqli_query($con, "SELECT * FROM chart_master ORDER BY account_name ASC");
$account = [];
foreach ($queryAccount as $rowAccount) {
    $account[] = $rowAccount;
}

$err = "";  // Initialize error message variable
if (isset($_POST['submit'])) {
    // Escape all inputs to protect against SQL injection
    $assetType = mysqli_real_escape_string($con, $_POST['assetType']);
    $assetAccount = mysqli_real_escape_string($con, $_POST['assetAccount']);
    $accumulatedDepreciation = mysqli_real_escape_string($con, $_POST['accumulatedDepreciation']);
    $depreciationExpense = mysqli_real_escape_string($con, $_POST['depreciationExpense']);
    $depreciationMethod = strtolower(mysqli_real_escape_string($con, $_POST['depreciationMethod']));
    $averagingMethod = mysqli_real_escape_string($con, $_POST['averagingMethod']);
    $depreciationRate = mysqli_real_escape_string($con, $_POST['depreciationRate']);
    $usefulLife = mysqli_real_escape_string($con, $_POST['usefulLife']);
    $branch = $_SESSION['Branch'];

    // Assuming you have a field in your form to identify the record to update, like 'editAssetId'
    $editAssetId = mysqli_real_escape_string($con, $_POST['editAssetId']);

    // SQL query to update data
    $updateQuery = mysqli_query($con, "UPDATE fixedasset SET 
                        asset_type = '$assetType', 
                        asset_account = '$assetAccount', 
                        accumulated_depreciation_account = '$accumulatedDepreciation', 
                        depreciation_expense_account = '$depreciationExpense', 
                        depreciation_method = '$depreciationMethod', 
                        averaging_method = '$averagingMethod', 
                        depreciation_rate = '$depreciationRate', 
                        useful_life = '$usefulLife' 
                    WHERE id = '$editAssetId'");

    if ($updateQuery) {
        $err = '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                    <strong>Well done!</strong> Your data has been successfully updated.
                </div>';
    } else {
        $error_message = mysqli_error($con);  // Get the error message from MySQL
        $err = "<p class='alert alert-danger'>Error updating data: $error_message. Please contact the system administrator.</p>";
    }
}

// Display the error or success message if $err is not empty.
if (!empty($err)) {
    echo $err;
}
?>

<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-9">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>Edit Asset Type</b></h3>
                </div>
                <div class="panel-body" style="background: #fff">
                    <form class="form-horizontal" action="" method="post">
                        <!-- Hidden input field for editAssetId -->
                        <input type="hidden" name="editAssetId" value="<?php echo isset($editAssetId) ? $editAssetId : ''; ?>">

                        <div class="col-md-6">
                            <!-- First Column -->
                            <div class="form-group">
                                <label for="editAssetType">Asset Type:</label>
                                <input type="text" class="form-control" id="editAssetType" name="editAssetType" value="<?php echo isset($editAssetType) ? $editAssetType : ''; ?>" required>
                            </div>
                            <div class="form-group">
                                <label for="assetAccount">Asset Account:</label>
                                <select class="form-control select" id="assetAccount" data-live-search="true" name="assetAccount" required>
                                    <?php foreach($account as $row): ?>
                                        <option value="<?php echo $row['account_code']; ?>" <?php echo isset($editAssetAccount) && $editAssetAccount == $row['account_code'] ? 'selected' : ''; ?>>
                                            <?php echo $row['account_name']; ?> - <?php echo $row['account_code']; ?>
                                        </option>
                                    <?php endforeach; ?>
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="accumulatedDepreciation">Accumulated Depreciation Account:</label>
                                <select class="form-control select" id="accumulatedDepreciation" name="accumulatedDepreciation">
                                    <?php foreach($account as $row): ?>
                                        <option value="<?php echo $row['account_code']; ?>" <?php echo isset($editAccumulatedDepreciation) && $editAccumulatedDepreciation == $row['account_code'] ? 'selected' : ''; ?>>
                                            <?php echo $row['account_name']; ?> - <?php echo $row['account_code']; ?>
                                        </option>
                                    <?php endforeach; ?>
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="depreciationExpense">Depreciation Expense Account:</label>
                                <select class="form-control select" id="depreciationExpense" name="depreciationExpense" data-live-search="true">
                                    <?php foreach($account as $row): ?>
                                        <option value="<?php echo $row['account_code']; ?>" <?php echo isset($editDepreciationExpense) && $editDepreciationExpense == $row['account_code'] ? 'selected' : ''; ?>>
                                            <?php echo $row['account_name']; ?> - <?php echo $row['account_code']; ?>
                                        </option>
                                    <?php endforeach; ?>
                                </select>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <!-- Second Column -->
                            <div class="form-group">
                                <label for="editDepreciationMethod">Depreciation Method:</label>
                                <select class="form-control" id="editDepreciationMethod" name="editDepreciationMethod">
                                    <option value="noDepreciation" <?php echo isset($editDepreciationMethod) && $editDepreciationMethod == 'noDepreciation' ? 'selected' : ''; ?>>No Depreciation</option>
                                    <option value="straightLine" <?php echo isset($editDepreciationMethod) && $editDepreciationMethod == 'straightLine' ? 'selected' : ''; ?>>Straight Line</option>
                                    <!-- Add other options -->
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="editAveragingMethod">Averaging Method:</label>
                                <select class="form-control" id="editAveragingMethod" name="editAveragingMethod">
                                    <option value="daily" <?php echo isset($editAveragingMethod) && $editAveragingMethod == 'daily' ? 'selected' : ''; ?>>Daily</option>
                                    <option value="monthly" <?php echo isset($editAveragingMethod) && $editAveragingMethod == 'monthly' ? 'selected' : ''; ?>>Monthly</option>
                                    <!-- Add other options -->
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="editDepreciationRate">Depreciation Rate (%):</label>
                                <input type="number" class="form-control" id="editDepreciationRate" name="editDepreciationRate" value="<?php echo isset($editDepreciationRate) ? $editDepreciationRate : ''; ?>" oninput="calculateUsefulLife()">
                            </div>
                            <div class="form-group">
                                <label for="editUsefulLife">Useful Life (Years):</label>
                                <input type="number" class="form-control" id="editUsefulLife" name="editUsefulLife" value="<?php echo isset($editUsefulLife) ? $editUsefulLife : ''; ?>" readonly>
                            </div>
                        </div>
                        <div class="panel-footer">
                            <!-- Save Button -->
                            <button type="submit" class="btn btn-primary" style="margin-top:10px;">Save</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>
