<?php
// Include your database connection file
require_once '../db/db.php';

// Check if the form is submitted
if(isset($_POST['submit'])) {
    // Escape user inputs to prevent SQL injection
    $bg_color = mysqli_real_escape_string($con, $_POST['bg_color']);
    $font_color = mysqli_real_escape_string($con, $_POST['font_color']);
    
    // Check if a record with ID 1 already exists
    $checkQuery = "SELECT * FROM ColorSettings WHERE id = 1";
    $checkResult = mysqli_query($con, $checkQuery);
    if(mysqli_num_rows($checkResult) > 0) {
        // Update the existing record
        $updateQuery = "UPDATE ColorSettings SET bg_color = '$bg_color', font_color = '$font_color' WHERE id = 1";
        $result = mysqli_query($con, $updateQuery);
    } else {
        // Insert new record
        $insertQuery = "INSERT INTO ColorSettings (id, bg_color, font_color) VALUES (1, '$bg_color', '$font_color')";
        $result = mysqli_query($con, $insertQuery);
    }
    
    // Check if the insertion/update was successful
    if($result) {
        // Display success message or redirect to another page
        $err = '<div class="alert alert-success" role="alert">
        <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                        <strong>Success!</strong> Color settings saved successfully.
                      </div>';
    } else {
        // Display error message
        $err = '<div class="alert alert-danger" role="alert">
        <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                        <strong>Error!</strong> Failed to save color settings. Please try again.
                     </div>';
    }
}
?>


                        <div class="row">
                            <div class="col-md-6">
                               <div class="panel panel-default">
                                <div class="panel-heading">
                                    <h3 class="panel-title"><b>Set Form Color</b></h3>
                                    <!--<div class="pull-right">
                                        <a href=""><button class="btn btn-default" onclick="printTable()"> <span class="fa fa-print"></span> Print</button></a>
                                    </div>-->
                                    
                                </div>
                                
                                <div class="panel-body" style="background: #fff">
                                    <div class="table-responsive">
                                        <table class="table" id="printabletable" width="100%">
                                            <thead>
                                            <tr class="formPanel" bgcolor="#2D2860">
                                                <td><h4 class="formPanel1" style="color:#F3A02A;padding-top:7px;font-weight:bold;">Set Form Color</h4></td>
                                                <td></td>
                                                <td></td>
                                                <td></td>
                                                <td></td>
                                                <td></td>
                                                <td></td>
                                            </tr>
                                            <tr colspan="2" color="#ffffff">
                                                <td align="left">
                                                    <p style="font-size:12px;font-weight:bold;padding-top:30px;color:black">
                                                        Reconciliation Date: <br/>
                                                        <span style="color:gray;padding-left:30px;">20/03/2024</span> <br/>
                                                        Reference Number: <br/>
                                                        <span style="color:gray;padding-left:30px;">RECON001</span> <br/>
                                                        Account Reconciled<br/>
                                                        <span style="color:gray;padding-left:30px;">CRDB BANK A/C</span>
                                                    </p>
                                                </td>
                                                <td></td>
                                                <td></td>
                                                <td></td>
                                                <?php
                                                $selectQuery = "SELECT * FROM BusinessInfo";
                                                $result = mysqli_query($con,$selectQuery);
                                                $row = mysqli_fetch_assoc($result);
                                                $logo = $row['business_logo'];
                                                 echo '<td colspan="3" align="right"><img src="'.$logo.'" width="150" height="150"></td>';
                                                ?>
                                                
                                            </tr>
                                
                                            </thead>
                                            <tbody style="border: 1px solid black;">
                                           
                                            <tr class="formPanel" bgcolor="#2D2860" >
                                                <th class="formPanel1">#</th>
                                                <th class="formPanel1">Description</th>
                                                <th class="formPanel1">Unit Price</th>
                                                <th class="formPanel1">Quantity</th>
                                                <th class="formPanel1">UOM</th>
                                                <th class="formPanel1">Total(TZS)</th>
                                                <th class="formPanel1">Amount</th>
                                            </tr>
                                            <tr bgcolor="white">
                                                <td ></td>
                                                <td ></td>
                                                <td></td>
                                                <td></td>
                                                <td></td>
                                                <td></td>
                                                <td ></td>
                                            </tr>
                                            <tr bgcolor="white">
                                                <td ></td>
                                                <td ></td>
                                                <td></td>
                                                <td></td>
                                                <td></td>
                                                <td></td>
                                                <td ></td>
                                            </tr>
                                            <tr>
                                                <td ></td>
                                                <td ></td>
                                                <td></td>
                                                <td></td>
                                                <td></td>
                                                <td></td>
                                                <td ></td>
                                            </tr>
                                            <tr>
                                                <td align="right" style="font-weight:bold" colspan="6" >Sub-total</td>
                                                <td >-</td>
                                                
                                            </tr>
                                            <tr>
                                                <td align="right" style="font-weight:bold"  colspan="6" >VAT</td>
                                                <td >-</td>
                                                
                                            </tr>
                                            <tr>
                                                <td align="right" style="font-weight:bold"  colspan="6" >Total</td>
                                                <td >-</td>
                                                
                                            </tr>
                                            <br/><br/>
                                            <!-- Modify your HTML table to include ids for relevant elements -->
                                            
                                
                                            <table class="success" width="100%" style="margin-left:5px;font-size:12px;">
                                                <thead>
                                                <tr>
                                                    <th>Prepared by:</th>
                                                    <th>Reviewed by:</th>
                                                    <th>Approved by:</th>
                                                </tr>
                                                </thead>
                                                <tbody>
                                                <tr>
                                                    <td>Name:.......................................................</td>
                                                    <td>Name:.......................................................</td>
                                                    <td>Name:.......................................................</td>
                                                </tr>
                                                <tr>
                                                    <td>Designation:............................................</td>
                                                    <td>Designation:............................................</td>
                                                    <td>Designation:............................................</td>
                                                </tr>
                                                <tr>
                                                    <td>Signature:................................................</td>
                                                    <td>Signature:................................................</td>
                                                    <td>Signature:................................................</td>
                                                </tr>
                                                <tr>
                                                    <td>Date:.........................................................</td>
                                                    <td>Date:.........................................................</td>
                                                    <td>Date:.........................................................</td>
                                
                                                </tr>
                                                <!-- Add more rows as needed -->
                                                </tbody>
                                            </table>
                                            </tbody>
                                
                                        </table>
                                    </div>
                                </div>
                            </div>
                        </div>
                                
                                <div class="col-md-3">
                                     <?php if(isset($err)) { echo $err; } ?>
                                    <div class="panel panel-default">
                                        <div class="panel-heading">
                                            <h3 class="panel-title"><b>Change color here</b></h3>
                                        </div>
                                        <div class="panel-body" style="background: #fff">
                                            <div class="table-responsive">
                                                <div class="form-container">
                                                    <form id="colorForm" method="post" action="">
                                                        <label for="colorPicker" style="font-weight: bold;">Background-Color:</label><br/>
                                                        <input type="color" id="colorPicker" name="bg_color"><span style="padding-left:30px;"></span>
                                                        <button type="button" id="applyColorButton">Apply Color</button><br/><br/><br/>
                                                    
                                                        <label for="colorPicker1" style="font-weight: bold;">Font-Color:</label><br/>
                                                        <input type="color" id="colorPicker1" name="font_color"><span style="padding-left:30px;"></span>
                                                        <button type="button" id="applyColorButton1">Apply Color</button>
                                                        <br><br/>
                                                        <div class="panel-footer">                                    
                                                        <button class="btn btn-warning pull-right" type="submit" name="submit"><span class="fa fa-plus-circle"></span> Create</button>
                                                    </div>
                                                    </form>
                                                </div>
                                            </div>
                                        </div>
                                        
                                    </div>
                                
                                    <!-- END TIMELINE -->
                                
                                </div>
                                
                                <!-- END PAGE CONTENT WRAPPER -->
                                </div>
                                
                                 <script>
                                    // JavaScript code to change background color on button click
                                    document.getElementById('applyColorButton').addEventListener('click', function() {
                                        var color = document.getElementById('colorPicker').value;
                                        var formPanels = document.getElementsByClassName('formPanel');
                                        for (var i = 0; i < formPanels.length; i++) {
                                            formPanels[i].style.backgroundColor = color;
                                        }
                                    });
                                </script>
                                <script>
                                    // JavaScript code to change text color on button click
                                    document.getElementById('applyColorButton1').addEventListener('click', function() {
                                        var color = document.getElementById('colorPicker1').value;
                                        var formPanels = document.getElementsByClassName('formPanel1');
                                        for (var i = 0; i < formPanels.length; i++) {
                                            formPanels[i].style.color = color;
                                        }
                                    });
                                </script>