<?php
$date1 = $_GET['date1'];
$date2 = $_GET['date2'];
$branch = $_GET['branch'];
$date3 = date('d-m-Y', strtotime($_GET['date1']));
$date4 = date('d-m-Y', strtotime($_GET['date2']));

if ($date1 !== $date2) {
    $note = "FOR THE PERIOD FROM {$date3} TO {$date4}";
} else {
    $note = "FOR THE DATE: {$date3}";
}

// If 'All' is selected, include all branches; otherwise, filter by the selected branch
$branchCondition = $branch !== 'All' ? "WHERE Branch = '$branch'" : '';
$queryBranches = "SELECT DISTINCT Branch FROM product $branchCondition";
$branches = mysqli_query($con, $queryBranches);

$branch_columns = [];
while ($row = mysqli_fetch_assoc($branches)) {
    $branch_columns[] = $row['Branch'];
}

$grand_totals = array_fill_keys($branch_columns, 0);
$grand_total_closing = 0;

// Associative array to store items grouped by name
$item_totals = [];

// Adjust the $itemsQuery to remove the branch condition if $branch is "All"
$itemsQuery = "SELECT DISTINCT Name, ProductId FROM product WHERE Category = 'Product'" . ($branch !== 'All' ? " AND Branch = '$branch'" : "");
$items = mysqli_query($con, $itemsQuery);

while ($rows = mysqli_fetch_assoc($items)) {
    $item_name = $rows['Name'];
    $product_id = $rows['ProductId'];

    // Initialize an array for each branch total per item
    if (!isset($item_totals[$item_name])) {
        $item_totals[$item_name] = array_fill_keys($branch_columns, 0);
    }

    // Calculate totals for each branch
    foreach ($branch_columns as $branch) {
        // Opening stock and balance calculations, ensuring zero if not available in branch
        $query_opening_stock = mysqli_query($con, "SELECT SUM(ist.quantity) as quantity FROM item_opening io 
            INNER JOIN item_stock_table ist ON io.id = ist.open_id 
            WHERE ist.itemid = '$product_id' AND io.date <= '$date2' AND io.branch = '$branch'");
        $rows_opening_stock = mysqli_fetch_assoc($query_opening_stock);
        $openQuantity = $rows_opening_stock['quantity'] ?? 0;

        $query_writeoff_stock_open = mysqli_query($con, "SELECT SUM(woi.quantity) as quantity FROM writeoff wo 
            INNER JOIN writeoff_items woi ON wo.id = woi.writeoff_id 
            WHERE woi.itemid = '$product_id' AND wo.date <= '$date2' AND wo.branch = '$branch'");
        $writeoffQuantity_open = mysqli_fetch_assoc($query_writeoff_stock_open)['quantity'] ?? 0;

        $query_cash_purchase_open = mysqli_query($con, "SELECT SUM(pi.quantity) as quantity FROM purchases p 
            INNER JOIN purchase_items pi ON p.purchase_id = pi.purchase_no 
            WHERE pi.product_id = '$product_id' AND p.purchase_date <= '$date2' AND p.branchno = '$branch'");
        $cashPurchaseQuantity_open = mysqli_fetch_assoc($query_cash_purchase_open)['quantity'] ?? 0;

        $query_invoice_purchase_open = mysqli_query($con, "SELECT SUM(pi.quantity) as quantity FROM purchase_invoice p 
            INNER JOIN purchase_invoice_items pi ON p.purchase_id = pi.purchase_no 
            WHERE pi.product_id = '$product_id' AND p.purchase_date <= '$date2' AND p.branchno = '$branch'");
        $invoicePurchaseQuantity_open = mysqli_fetch_assoc($query_invoice_purchase_open)['quantity'] ?? 0;

        $purchases_quantity_open = $cashPurchaseQuantity_open + $invoicePurchaseQuantity_open;

        $sales_query_invoice_open = mysqli_query($con, "SELECT SUM(it.quantity) AS quantity FROM invoices AS i 
            INNER JOIN invoice_items AS it ON i.invoice_id = it.invoice_no 
            WHERE i.invoice_date <= '$date2' AND it.product_id='$product_id' AND i.branchno = '$branch'");
        $invoice_sales_quantity_open = mysqli_fetch_assoc($sales_query_invoice_open)['quantity'] ?? 0;

        $sales_query_cash_open = mysqli_query($con, "SELECT SUM(it.quantity) AS quantity FROM sales_cash AS i 
            INNER JOIN sales_cash_items AS it ON i.sales_cash_id = it.cash_no 
            WHERE i.invoice_date <= '$date2' AND it.product_id='$product_id' AND i.branchno = '$branch'");
        $cash_sales_quantity_open = mysqli_fetch_assoc($sales_query_cash_open)['quantity'] ?? 0;

        $sales_quantity_open = $invoice_sales_quantity_open + $cash_sales_quantity_open;

        // Calculate total opening balance and closing balance
        $total_open = ($openQuantity + $purchases_quantity_open) - ($sales_quantity_open + $writeoffQuantity_open);
        $item_totals[$item_name][$branch] += $total_open;  // Sum for each branch
        $grand_totals[$branch] += $total_open;
    }
}
?>
<style>
    table {
        border-collapse: collapse;
        border: 1px solid black;
        width: 100%;
    }
    th, td {
        border: 1px solid black;
        padding: 8px;
        text-align: center;
        color: black;
    }
</style>
<div class="col-md-9">
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=item_menu" style="color: rgb(7, 133, 164)">Items and Inventory Menu</a></li>
                <li class="active">Inventory Quantity Summary Report</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>Inventory Quantity Summary Report</b></h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()"><span class="fa fa-arrow-left"></span> Go Back</button>
                        <button class="btn btn-default" onclick="printTable()"><span class="fa fa-print"></span> Print Report</button>
                        <button class="btn btn-default" onclick="exportToExcel()"><span class="fa fa-file-excel-o"></span> Export To Excel</button>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                    <div id="printingArea">
                        <table id="myTable">
                            <tr>
                                <th colspan="<?php echo count($branch_columns) + 2; ?>">Company: <?php echo $_SESSION['Company']; ?></th>
                            </tr>
                            <tr>
                                <th colspan="<?php echo count($branch_columns) + 2; ?>">Branch: <?php echo $_GET['branch']; ?></th>
                            </tr>
                            <tr>
                                <th colspan="<?php echo count($branch_columns) + 2; ?>"><?php echo htmlspecialchars($_GET['description']); ?></th>
                            </tr>
                            <tr>
                                <th colspan="<?php echo count($branch_columns) + 2; ?>"><?php echo $note; ?></th>
                            </tr>
                            <tr style="font-weight: bold">
                                <td style="text-align: left;">Item</td>
                                <?php foreach ($branch_columns as $branch): ?>
                                    <td><?php echo htmlspecialchars($branch); ?></td>
                                <?php endforeach; ?>
                                <td>Total Closing Balance</td>
                            </tr>
                            <?php foreach ($item_totals as $item_name => $branch_balances): ?>
                                <tr>
                                    <td style="text-align: left;"><?php echo htmlspecialchars($item_name); ?></td>
                                    <?php $total_closing_balance = 0; ?>
                                    <?php foreach ($branch_columns as $branch): ?>
                                        <?php $closing_balance = $branch_balances[$branch] ?? 0; ?>
                                        <td><?php echo $closing_balance; ?></td>
                                        <?php $total_closing_balance += $closing_balance; ?>
                                    <?php endforeach; ?>
                                    <td><?php echo $total_closing_balance; ?></td>
                                </tr>
                                <?php $grand_total_closing += $total_closing_balance; ?>
                            <?php endforeach; ?>
                            <tr style="font-weight: bold; background-color: #f2f2f2;">
                                <td>GRAND TOTAL</td>
                                <?php foreach ($branch_columns as $branch): ?>
                                    <td><?php echo $grand_totals[$branch]; ?></td>
                                <?php endforeach; ?>
                                <td><?php echo $grand_total_closing; ?></td>
                            </tr>
                        </table>
                    </div>
                    <script>
                        function printTable() {
                            var cells = document.querySelectorAll('td, th');
                            cells.forEach(function(cell) {
                                cell.style.border = '1px solid black';
                            });
                            window.print();
                            cells.forEach(function(cell) {
                                cell.style.border = '';
                            });
                        }
                        function exportToExcel() {
                            var table = document.getElementById('myTable');
                            var tableHtml = table.outerHTML.replace(/ /g, '%20');
                            var link = document.createElement('a');
                            link.href = 'data:application/vnd.ms-excel,' + tableHtml;
                            link.download = 'Inventory_Quantity_Summary_Report.xls';
                            link.click();
                        }
                    </script>
                </div>
            </div>
        </div>
    </div>
</div>
