<?php
if(isset($_POST['submit'])){
    $name = trim($_POST['name']);
    $category = trim($_POST['category']);
    $unit = strtolower(trim($_POST['unit']));
    $cost = trim($_POST['cost']);
    $price = trim($_POST['price']);
    $stock = trim($_POST['stock']);
    $branch = $_SESSION['Branch'];
    $level = '';
    $sales = '';
    $cogs = '';
    $inventory = '';
    $date = date('Y-m-d');
    $total = 0;

    if($name == '' || $category == '' || $unit == ''){
        $err = "<p class='alert alert-danger'>Fill all fields please!!! Tafadhali hakikisha umejaza taarifa zote zenye alama * kabla ya kutuma taarifa</p>";
    } else {
        try {
            $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
            
            $stmt = $pdo->prepare("SELECT * FROM product WHERE Name = :name");
            $stmt->execute([':name' => $name]);
            $num = $stmt->rowCount();

            if($num == 0){
                $stmt = $pdo->prepare("INSERT INTO product (Name, Product_Price, Product_Cost, Quantity, Level, Branch, Category, Unit) 
                    VALUES (:name, :price, :cost, :stock, :level, :branch, :category, :unit)");
                $stmt->execute([
                    ':name' => $name,
                    ':price' => $price,
                    ':cost' => $cost,
                    ':stock' => $stock,
                    ':level' => $level,
                    ':branch' => $branch,
                    ':category' => $category,
                    ':unit' => $unit
                ]);

                $id = $pdo->lastInsertId();
                $err = "<p class='alert alert-success'>Data successfully recorded </p>";

            } else {
                $err = "<p class='alert alert-danger'>This item exists in our database.</p>";
            }
        } catch (PDOException $e) {
            $err = "<p class='alert alert-danger'>Something wrong !!! Contact system administrator...Wasiliana na mafundi wa mfumo kuna tatizo katika database</p>";
            error_log($e->getMessage());
        }
    }
}
?>
<div class="col-md-9">  
                  <div class="row">
                           <div class="col-md-12">
                               <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                                <li><a href="index.php?p=item_menu" style="color: rgb(7, 133, 164)">Items and Inventory Menu</a></li>
                                <li><a href="index.php?p=item_product" style="color: rgb(7, 133, 164)">Products List</a></li>
                                <li><a href="index.php?p=item_service" style="color: rgb(7, 133, 164)">Services List</a></li>
                                <li class="active">Create New</li>
                                    </ul>

                            <div class="panel panel-default">
                                <div class="panel-heading">
                                    <h3 class="panel-title"><b>CREATE SERVICE OR PRODUCT</b></h3>
                                </div>
                                <div class="panel-body" style="background: #fff">
                                    <?php if(isset($err)) { echo $err; } ?>
                                   <form method="post" action="">
                                    <table width="70%">
                                        <tr>
                                            <td>
                                                <div class="form-group">
                                                    <label class="col-md-3 control-label">Select category</label>
                                                    <div class="col-md-6">                                             
                                                        <select class="form-control select" data-style="btn-info" id="selectedCat" onchange="changeCategory()" name="category">
                                                            <option value="">Select Category</option>
                                                            <option value="Product">Product</option>
                                                            <option value="Service">Service</option>
                                                        </select>
                                                    </div>
                                                </div>  
                                            </td>
                                        </tr>
                                        <tr>
                                            <td><br>
                                                <div class="form-group">
                                                    <label class="col-md-3 col-xs-12 control-label">Name</label>
                                                    <div class="col-md-6 name-field"> <!-- Add class "name-field" here -->
                                                        <textarea class="form-control" name="name"></textarea>
                                                    </div>
                                                </div>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td><br>
                                                <div class="form-group">
                                                    <label class="col-md-3 control-label">Select Unit</label>
                                                    <div class="col-md-6">
                            
                                                        <select class="form-control select" data-style="btn-info" name="unit">
                                                            <?php
                                                              $unit = mysqli_query($con,"SELECT * FROM unit_measure");
                                                              foreach($unit as $rw){
                                                            ?>
                                                            <option value="<?php echo $rw['name'];?>"><?php echo $rw['name'];?></option>
                                                            <?php
                                                            }
                                                            ?>
                                                        </select>
                                
                                                    </div>
                                                </div>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td><br>
                                                <div class="form-group">
                                                    <label class="col-md-3 col-xs-12 control-label">Buying Price</label>
                                                    <div class="col-md-6"> <!-- Add class "buying-price-field" here -->
                                                        <div class="input-group">
                                                            <input type="number" class="form-control" placeholder="0" id="buyingPriceInput" name="cost"/>
                                                            <span class="input-group-addon">TZS</span>
                                                        </div>
                                                    </div>
                                                </div>
                                            </td>
                                        </tr>
                                        <tr>
                                            <td><br>
                                                <div class="form-group">
                                                    <label class="col-md-3 col-xs-9 control-label">Selling Price</label>
                                                    <div class="col-md-6"> <!-- Add class "selling-price-field" here -->
                                                        <div class="input-group">
                                                            <input type="number" class="form-control" placeholder="0" style="" name="price"/>
                                                            <span class="input-group-addon">TZS</span>
                                                        </div>
                                                    </div>
                                                </div>
                                            </td>
                                        </tr>
                                    </table>
                                    
                                </div>
								<div class="panel-footer">                                    
                                    <button class="btn btn-info pull-right" type = "submit" name = "submit"><span class="fa fa-plus-circle"></span> Create</button>
                                    </form>
                                </div>
                        </div>
                   </div>
            </div>
</div>
<script>
    function changeCategory(){
    var selectedCategory = document.getElementById('selectedCat').value;
        console.log("Category changed");
        console.log("Selected category: " + selectedCategory);
        // Show/hide fields based on the selected category
        if (selectedCategory === 'Product') {
            document.getElementById('buyingPriceInput').disabled = false;
            document.getElementById('openingStockInput').disabled = false;
        } else if (selectedCategory === 'Service') {
            document.getElementById('buyingPriceInput').disabled = true;
            document.getElementById('openingStockInput').disabled = true;
        }
    }
    function createProductOrService() {
        // You can add your form submission logic here
        // This function will be called when the Create button is clicked
    }
</script>