<?php
require_once '../db/db.php';

try {
    $stmt = $pdo->prepare("SELECT * FROM product WHERE ProductId = :id");
    $stmt->execute([':id' => $_GET['id']]);
    $rows = $stmt->fetch(PDO::FETCH_ASSOC);
    
    if (isset($_POST['submit'])) {
        $name = $_POST['name'];
        $unit = strtolower($_POST['unit']);
        $price = $_POST['price'];
        $branch = $_SESSION['Branch'];

        if ($name == '' ) {
            $err = "<p class='alert alert-danger'>Fill all fields please!!! Tafadhali hakikisha umejaza taarifa zote zenye alama * kabla ya kutuma taarifa</p>";
        } else {
            $updateQuery = $pdo->prepare("UPDATE product SET Name = :name,  Product_Price = :price, Unit = :unit WHERE ProductId = :id");
            $updateQuery->execute([
                ':name' => $name,
                ':price' => $price,
                ':unit' => $unit,
                ':id' => $_GET['id']
            ]);

            if ($updateQuery) {
                $stmt = $pdo->prepare("SELECT * FROM product WHERE ProductId = :id");
                $stmt->execute([':id' => $_GET['id']]);
                $rows = $stmt->fetch(PDO::FETCH_ASSOC);
                $err = "<p class='alert alert-success'>Data Successfully Updated </p>";
            } else {
                $err = "<p class='alert alert-danger'>Something wrong !!! Contact system administrator...Wasiliana na mafundi wa mfumo kuna tatizo katika database</p>";
            }
        }
    }
} catch (PDOException $e) {
    echo "Error: " . $e->getMessage();
}
?>

<div class="col-md-9">  
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=item_menu" style="color: rgb(7, 133, 164)">Items and Inventory Menu</a></li>
                <li><a href="index.php?p=item_product" style="color: rgb(7, 133, 164)">Products List</a></li>
                <li><a href="index.php?p=item_service" style="color: rgb(7, 133, 164)">Services List</a></li>
                <li class="active">Items Edit</li>
                    </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>EDIT SERVICE OR PRODUCT</b></h3>
                    <div class="pull-right">
                        <a href="index.php?p=item_product"><button class="btn btn-info"> <span class="fa fa-eye"></span> View Product</button></a>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                    <?php if (isset($err)) { echo $err; } ?>
                    <form method="post" action="">
                        <table width="70%">
                            <tr>
                                <td>
                                    <div class="form-group">
                                        <label class="col-md-3 control-label">Select category</label>
                                        <div class="col-md-6">                                             
                                            <select class="form-control select" data-style="btn-info" id="selectedCat" onchange="changeCategory()" name="category" disabled>
                                                <option value="<?php echo $rows['Category']; ?>"><?php echo $rows['Category']; ?></option>
                                                <option value="Product">Product</option>
                                                <option value="Service">Service</option>
                                            </select>
                                        </div>
                                    </div>  
                                </td>
                            </tr>
                            <tr>
                                <td><br>
                                    <div class="form-group">
                                        <label class="col-md-3 col-xs-12 control-label">Name</label>
                                        <div class="col-md-6 name-field">
                                            <textarea class="form-control" name="name"><?php echo $rows['Name']; ?></textarea>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <br/>
                                    <div class="form-group">
                                        <label class="col-md-3 control-label">Unit of Measurement</label>
                                        <div class="col-md-6">                                             
                                            <select class="form-control select" data-style="btn-info" name="unit">
                                                <option value="<?php echo $rows['Unit']; ?>"><?php echo $rows['Unit']; ?></option>
                                                <?php
                                                $unitStmt = $pdo->query("SELECT * FROM unit_measure");
                                                while ($rw = $unitStmt->fetch(PDO::FETCH_ASSOC)) {
                                                ?>
                                                <option value="<?php echo $rw['name']; ?>"><?php echo $rw['name']; ?></option>
                                                <?php
                                                }
                                                ?>
                                            </select>
                                        </div>
                                    </div>  
                                </td>
                            </tr>
                            <tr>
                                <td><br>
                                    <div class="form-group" >
                                        <label class="col-md-3 col-xs-12 control-label">Buying Price</label>
                                        <div class="col-md-6 buying-price-field">
                                            <div class="input-group" >
                                                <input disabled  type="text" class="form-control" placeholder="0" id="buyingPriceInput" name="cost" value="<?php echo $rows['Product_Cost']; ?>"/>
                                                <span class="input-group-addon">TZS</span>
                                            </div>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            <tr>
                                <td><br>
                                    <div class="form-group">
                                        <label class="col-md-3 col-xs-9 control-label">Selling Price</label>
                                        <div class="col-md-6 selling-price-field">
                                            <div class="input-group">
                                                <input type="text" class="form-control" placeholder="0" name="price" value="<?php echo $rows['Product_Price']; ?>"/>
                                                <span class="input-group-addon">TZS</span>
                                            </div>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            <!--<tr>-->
                            <!--    <td><br>-->
                            <!--        <div class="form-group">-->
                            <!--            <label class="col-md-3 col-xs-12 control-label">Opening Stock</label>-->
                            <!--            <div class="col-md-6 opening-stock-field">-->
                            <!--                <input type="text" class="form-control" value="<?php //echo $rows['Quantity']; ?>" placeholder="Enter Qty" id="openingStockInput" name="stock"/>-->
                            <!--            </div>-->
                            <!--        </div>-->
                            <!--    </td>-->
                            <!--</tr>-->
                        </table>
                </div>
                <div class="panel-footer">                                    
                    <button class="btn btn-info pull-right" type="submit" name="submit"><span class="fa fa-edit"></span> Update</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
<script>
var selectedCategory = document.getElementById('selectedCat').value;
function handleValueChange() {
   if (selectedCategory === 'Product') {
        document.getElementById('buyingPriceInput').disabled = true;
        document.getElementById('openingStockInput').disabled = true;
    } else if (selectedCategory === 'Service') {
        document.getElementById('buyingPriceInput').disabled = true;
        document.getElementById('openingStockInput').disabled = true;
    }
}
// Call the handler function initially
handleValueChange();
function changeCategory(){
    console.log("Category changed");
    console.log("Selected category: " + selectedCategory);
    // Show/hide fields based on the selected category
    if (selectedCategory === 'Product') {
        document.getElementById('buyingPriceInput').disabled = true;
        document.getElementById('openingStockInput').disabled = true;
    } else if (selectedCategory === 'Service') {
        document.getElementById('buyingPriceInput').disabled = true;
        document.getElementById('openingStockInput').disabled = true;
    }
}
</script>