<?php
// Start the session and include the database connection
session_start();
include '../db/db.php';

                           
            if ($_GET['status'] === 'deleted') {
                echo "<script>
                document.addEventListener('DOMContentLoaded', function() {
                    Swal.fire({
                        position: 'top',
                        icon: 'success',
                        title: ' Deleted Successfully',
                        showConfirmButton: false,
                        timer: 1500
                    }).then(function() {
                        location.reload(); 
                    }).then(function() {
                      window.location.href = 'index.php?p=item_stock_out'; 
                  });
                 });
                </script>";
            }


$branch = $_SESSION['Branch'];
$stmt = $pdo->prepare("SELECT 
                so.id, 
                so.date, 
                so.reference, 
                iu.Name,
                so.providedto
                        FROM stockout so
                        LEFT JOIN stockout_items si ON so.id = si.stockoutid
                        INNER JOIN product p ON si.itemid = p.ProductId
                        INNER JOIN inv_users iu ON so.issuedby = iu.id
                        WHERE so.branch = :branch 
                        GROUP BY so.id, so.date, so.reference
                        ORDER BY so.date DESC");

$stmt->bindParam(':branch', $branch);
$stmt->execute();

$stockouts = $stmt->fetchAll(PDO::FETCH_ASSOC);

// Check if stockouts data is available
if (count($stockouts) > 0) {
    foreach ($stockouts as &$stockout) {
        $created_by_id = (int)$stockout['issuedby'];

        $sql = "SELECT Name FROM inv_users WHERE id = :id";
        $userstmt = $pdo->prepare($sql);
        $userstmt->bindParam(':id', $created_by_id, PDO::PARAM_INT);
        $userstmt->execute();
        $user = $userstmt->fetch(PDO::FETCH_ASSOC);

        // Add the user name to the stockout array only if user is found
        $stockout['created_by_name'] = $user ? $user['Name'] : 'Unknown';
    }
}
?>

<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="#" style="color: rgb(7, 133, 164)" onclick="history.back()">Items Menu</a></li>
                <li class="active">Stock Out List</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title" style="font-weight: bold">STOCK OUT LIST</h3>
                    <div class="pull-right">
                        <a href="index.php?p=item_stock_out_add"><button class="btn btn-info"> <span class="fa fa-plus-circle"></span> Create New</button></a>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                    <div class="table-responsive">
                        <table class="table table-hover datatable">
                            <thead>
                                <tr>
                                    <th>#</th>
                                    <th>Date</th>
                                    <th>Reference</th>
                                    <th>Issued By</th>
                                    <th>Provided to</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                $sn = 1;
                                foreach ($stockouts as $stockout) {
                                    ?>
                                    <tr>
                                        <td><?php echo $sn++; ?></td>
                                        <td><?php echo $stockout['date']; ?></td>
                                        <td><?php echo $stockout['reference']; ?></td>
                                        <td><?php echo $stockout['Name']; ?></td>
                                        <td><?php echo $stockout['providedto']; ?></td>
                                        <td>
                                            <a onclick="return confirm('Are you sure you want to delete this record?');" href="inventory/item_stock_out_delete.php?id=<?php echo $stockout['id']; ?>"><span class="fa fa-trash-o"></span> Delete</a> |
                                            <a href="index.php?p=stockout_edit&id=<?php echo $stockout['id']; ?>"><span class="fa fa-edit"></span> Edit</a> |
                                            <a href="index.php?p=stockout_view&id=<?php echo $stockout['id']; ?>"><span class="fa fa-eye"></span> View items</a>
                                        </td>
                                    </tr>
                                    <?php
                                }
                                ?>
                            </tbody>
                        </table>
                    </div> 
                </div>
            </div>
        </div>
    </div>
    <!-- END TIMELINE --> 
</div>
