<?php
session_start();
include '../db/db.php';

if (isset($_POST['submit'])) {
    $date = $_POST['date'];
    $batchno = $_POST['batchno'];
    $providedto = $_POST['user'];
    $createdby = $_SESSION['id'];
    $note = $_POST['note'];
    $branch = $_SESSION['Branch'];

    try {
        $stmt = $pdo->prepare("INSERT INTO stockout (date, reference, issuedby, providedto, notes, status, initiat_user, branch) VALUES (:date, :reference, :issuedby, :providedto, :notes, :status, :initiat_user, :branch)");
        
        $stmt->execute([
            ':date' => $date,
            ':reference' => $batchno,
            ':issuedby' => $createdby,
            ':providedto' => $providedto,
            ':notes' => $note,
            ':status' => 'Pending',
            ':initiat_user' => $createdby,
            ':branch' => $branch
        ]);

        $stockout_id = $pdo->lastInsertId();

        foreach ($_POST['item'] as $index => $item) {
            $quantity = $_POST['amount'][$index];
            $cost = $_POST['cost'][$index];
               
            $stmt = $pdo->prepare("INSERT INTO stockout_items (itemid, stockoutid, quantity, cost) VALUES (:itemid, :stockoutid, :quantity, :cost)");
            
            $stmt->execute([
                ':itemid' => $item,
                ':stockoutid' => $stockout_id,
                ':quantity' => $quantity,
                ':cost' => $cost
            ]);

            // Corrected UPDATE statement
            $updateStmt = $pdo->prepare("UPDATE product SET quantity = quantity + :quantity WHERE ProductId = :productid");
            $updateStmt->execute([
                ':quantity' => $quantity,
                ':productid' => $item
            ]);
        }

        echo "<script>
            alert('Well done. Stock is Out!');
            window.location.href='index.php?p=item_stock_out';
        </script>";
    } catch (PDOException $e) {
        error_log($e->getMessage());
        echo "<script>
            alert('An error occurred. Please try again later.');
            window.location.href='index.php?p=item_stock_out_add';
        </script>";
    }
}
?>




<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=item_menu" style="color: rgb(7, 133, 164)">Items Menu</a></li>
                <li><a href="#" style="color: rgb(7, 133, 164)" onclick="history.back()">Stock Out List</a></li>
                <li class="active">Add Stock Out</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>STOCK OUT FORM</b></h3>
                </div>
                <div class="panel-body">
                    <form class="form-horizontal" method="post" action="" enctype="multipart/form-data">           
                        <table class="table">
                            <tbody>
                                <tr>
                                    <th>
                                        <div class="form-group">
                                            <label class="col-md-12 col-xs-12">Date *</label>
                                            <div class="col-md-12 col-xs-12">            
                                                <input type="text" class="form-control datepicker" name="date" value="<?php echo date('Y-m-d');?>" />            
                                            </div>
                                        </div> 
                                    </th>
                                    <th>
                                        <div class="form-group">
                                            <label class="col-md-12 col-xs-12">Issued By</label>
                                           <div class="col-md-12 col-xs-12"> 
                                                <select class="form-control select" name="user" onchange="showDis(this.value)">
                                                    <?php
                                                    $stmt = $pdo->prepare("SELECT * FROM inv_users");
                                                    $stmt->execute();
                                                    $users = $stmt->fetchAll(PDO::FETCH_ASSOC);
                                                    foreach ($users as $rows) {
                                                        ?>
                                                        <option value="<?php echo $rows['Name']; ?>"><?php echo $rows['Name']; ?></option>
                                                        <?php
                                                    }
                                                    ?>
                                                </select>
                                            </div>
                                        </div>
                                    </th>
                                    <th>
                                        <div class="form-group">
                                            <label class="col-md-12 col-xs-12">Production Batch No.</label>
                                            <div class="col-md-12 col-xs-12"> 
                                                <select class="form-control select" name="batchno" onchange="showDis(this.value)">
                                                    
                                                        <option value="">--Select--</option>
                                                    
                                                </select>
                                            </div>
                                        </div>
                                    </th>
                                </tr>
                                <tr>
                                    <th colspan="3"> Description *</th>
                                </tr>
                                <tr>
                                    <td colspan="3">
                                        <div class="form-group">
                                            <div class="col-md-12 col-xs-12">                       
                                                <textarea class="form-control" name="note" required></textarea>
                                            </div>
                                        </div>
                                    </td>
                                </tr>
                                <tr>
                                    <th>Item</th>
                                    <th>QOH</th>
                                    <th>Quantity</th>
                                    <th>Cost</th>
                                </tr>
                                <tr>
                                    <td>
                                        <div class="form-group">
                                            <div class="col-md-12 col-xs-12">
                                                <?php
                                                $product = mysqli_query($con,"SELECT * FROM product ORDER BY Name ASC");
                                                ?>                     
                                                <select  class="form-control select" data-live-search="true" name="item[]" required onchange="fetchProductQuantity(this);fetchProductPrice(this)">
                                                    <option value="">Search Item Here</option>
                                                    <?php foreach($product as $rows): ?>
                                                    <option value="<?php echo $rows['ProductId'];?>"><?php echo $rows['Name'];?></option>
                                                    <?php endforeach; ?>
                                                </select>
                                            </div>
                                        </div>
                                    </td>
                                    <td>
                                        <div class="form-group">
                                            <div class="col-md-12 col-xs-12">                       
                                                <input type="text" class="form-control" name="quantity[]"  readonly />
                                            </div>
                                        </div>
                                    </td>
                                    <td>
                                        <div class="form-group">
                                            <div class="col-md-12 col-xs-12">                       
                                                <input type="text"  oninput="validateQuantity(this)" name="amount[]" class="form-control"  />
                                            </div>
                                        </div>
                                    </td>
                                      <td>
                                        <div class="form-group">
                                            <div class="col-md-12 col-xs-12">                       
                                                <input type="text"  id="cost"  name="cost[]" class="form-control"  />
                                            </div>
                                        </div>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <button type="button" class="btn btn-primary" onclick="addAccountLine()" style="background-color: green;color: white;">Add Line</button>
                                    </td>
                                    <td colspan="2" align="right"></td>
                                </tr>
                            </tbody>    
                        </table>
                </div>
                <div class="panel-footer">
                    <button type="submit"  id ="create" name="submit" class="btn btn-info pull-right"><span class="fa fa-plus-circle"></span> Create </button>
                </div>
                </form>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>
<script>
    let voucherCounter = 1; // Initialize the voucher counter

    // Set default date to today
    document.getElementById('datePicker').valueAsDate = new Date();

    // Function to add a new account line
    function addAccountLine() {
        const tableBody = document.querySelector('.table tbody');

        const newRow = document.createElement('tr');
        newRow.innerHTML = `
            <td>
                <div class="form-group">
                    <div class="col-md-12 col-xs-12">
                        <?php
                        $product = mysqli_query($con,"SELECT * FROM product  ORDER BY Name ASC");
                        ?>                     
                        <select class="form-control select" data-live-search="true" name="item[]" required onchange="fetchProductQuantity(this)">
                            <option value="">Search Item Here</option>
                            <?php foreach($product as $rows): ?>
                            <option value="<?php echo $rows['ProductId'];?>"><?php echo $rows['Name'];?></option>
                            <?php endforeach; ?>
                        </select>
                    </div>
                </div>
            </td>
            <td>
                <div class="form-group">
                    <div class="col-md-12 col-xs-12">                       
                        <input type="text" name="quantity[]" class="form-control"  />
                    </div>
                </div>
            </td>
            <td>
                <div class="form-group">
                    <div class="col-md-12 col-xs-12">                       
                        <input type="text"  oninput="validateQuantity(this)" name="amount[]" class="form-control"  />
                    </div>
                </div>
            </td>
            <td>
                <div class="form-group">
                    <div class="col-md-12 col-xs-12">                       
                        <input type="text"  id="cost"  name="cost[]" class="form-control"  />
                    </div>
                </div>
            </td>
            <td style="background-color:#ffffff">
                <button class="btn btn-danger" onclick="removeAccountLine(this)"><i class="fa fa-trash-o"></i></button>
            </td>
        `;
        // Initialize Bootstrap Selectpicker for the first row
        $(newRow.querySelector('.select')).selectpicker();

        // Insert new row just above the "Add Line" and "Create" buttons
        tableBody.insertBefore(newRow, tableBody.lastElementChild);

        // Update the sum of amounts
        updateTotalAmount();
    }

    // Function to update the total amount
    function updateTotalAmount() {
        const amounts = document.querySelectorAll('input[name="amount[]"]');
        let total = 0;

        amounts.forEach(input => {
            total += parseFloat(input.value) || 0;
        });
        const formattedTotal = total.toLocaleString();
        // Display the total amount in an element with id "totalAmount"
        document.getElementById('totalAmount').innerText = formattedTotal;
    }

    // Function to remove an account line
    function removeAccountLine(button) {
        const row = button.closest('tr');
        row.remove();

        // Update the sum of amounts after removing the line
        updateTotalAmount();
    }
</script>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>
//fetching quantity of the product

   function fetchProductQuantity(selectElement) {
    var productId = selectElement.value;
    var row = selectElement.closest('tr'); // Get the row of the select element
    var qahInput = row.querySelector('input[name="quantity[]"]'); // Find the QAH input in the same row

    
    var xhr = new XMLHttpRequest();
    xhr.open('GET', 'fetch_product_quantity.php?productId=' + productId, true);
    xhr.onload = function () {
        if (xhr.status === 200) {
            var quantity = parseFloat(xhr.responseText);
            if (!isNaN(quantity)) {
                qahInput.value = quantity.toFixed(2); 
            } else {
                console.error('Invalid quantity received:', xhr.responseText);
                qahInput.value = '0.00';
            }
        } else {
            console.error('Error fetching quantity:', xhr.status, xhr.statusText);
            qahInput.value = '0.00';
        }
    };
    xhr.onerror = function () {
        console.error('Request error.');
        qahInput.value = '0.00';
    };
    xhr.send();
}

function fetchProductPrice(selectElement) {
    var productId = selectElement.value;
    var row = selectElement.closest('tr'); // Get the row of the select element
    var costInput = row.querySelector('input[name="cost[]"]'); // Find the cost input in the same row

    // Send AJAX request to fetch product price
    var xhr = new XMLHttpRequest();
    xhr.open('GET', 'get_product_cost.php?productId=' + productId, true);
    xhr.onload = function () {
        if (xhr.status === 200) {
            var price = parseFloat(xhr.responseText);
            if (!isNaN(price)) {
                costInput.value = price.toFixed(2); 
            }
        }
    };
    xhr.send();
}


    // Validate the entered quantity against the available quantity
   function validateQuantity(amountInput) {
        const row = amountInput.closest('tr');
        const qahInput = row.querySelector('input[name="quantity[]"]');
        const availableQuantity = parseFloat(qahInput.value) || 0;
        const enteredQuantity = parseFloat(amountInput.value) || 0;
        const btn =document.querySelector('#create');

        if (enteredQuantity > availableQuantity  ) {
            alert('The entered quantity is greater than the available quantity.');
            qahInput.style.color = 'red';
              btn.setAttribute('disabled', 'true');
            
        } else {
            qahInput.style.color = '';
             btn.removeAttribute('disabled');
        }

        // Update the total amount
        updateTotalAmount();
    }


  $(document).ready(function() {
    $('#payeeType').change(function() {
      if ($(this).val() === 'customer') {
        $('#payeeInputWrapper').hide();
        $('#payeeSelect').show();
        $('#payeeSelectSupplier').hide();
      }
      else if($(this).val() === 'supplier'){
           $('#payeeInputWrapper').hide();
           $('#payeeSelect').hide();
          $('#payeeSelectSupplier').show();
      }
      else {
        $('#payeeInputWrapper').show();
        $('#payeeSelect').hide();
        $('#payeeSelectSupplier').hide();
      }
    });
  });
</script>
