<?php
session_start();
include '../../db/db.php';

if (isset($_GET['id'])) {
    $id = intval($_GET['id']); // Use intval to ensure it's an integer
    
    try {
        // Start a transaction
        $con->begin_transaction();

        // Step 1: Delete child records (stockout_items) related to this stockout
        $deleteChild = $con->prepare("DELETE FROM stockout_items WHERE stockoutid = ?");
        $deleteChild->bind_param("i", $id);
        $deleteChild->execute();

        // Step 2: Delete the stockout record
        $deleteParent = $con->prepare("DELETE FROM stockout WHERE id = ?");
        $deleteParent->bind_param("i", $id);
        $deleteParent->execute();

        // If both deletions were successful, commit the transaction
        $con->commit();

        echo '<script>
            window.location = "../index.php?p=item_stock_out&status=deleted";
        </script>';
    } catch (Exception $e) {
        // An exception has been thrown, rollback the transaction
        $con->rollback();
        
        // Display error message
        echo '<script>
            alert("Error deleting stock item: ' . $e->getMessage() . '");
            window.location = "index.php?p=item_stock_out";
        </script>';
    }
}
?>
