<?php
session_start();
include '../db/db.php'; // Update with your actual database connection file

// Get transfer ID from query string
$id = $_GET['id'];
$branch = $_SESSION['Branch'];

if ($id > 0) {
    // Fetch details for the specific transfer ID
    $sql = "SELECT
             ist.quantity,
             ist.cost,
             p.name,
             io.id
            FROM item_stock_table ist
            INNER JOIN item_opening io
            ON ist.open_id = io.id
            INNER JOIN product p 
            ON ist.itemid = p.ProductId
            WHERE io.id = :id
            AND ist.branch=:branch
            ORDER BY ist.date DESC";

    $stmt = $pdo->prepare($sql);
    $stmt->bindParam(':id', $id, PDO::PARAM_INT);
    $stmt->bindParam(':branch', $branch, PDO::PARAM_STR);
    $stmt->execute();
    $openStock = $stmt->fetchAll(PDO::FETCH_ASSOC);
    
} else {
    // Handle case when no valid transfer ID is provided
    $_SESSION['message'] = "Invalid  ID.";
    header("Location: index.php?p=opening_stock_view");
    exit();
}
?>
    <style>
        /* CSS to style the table */
        table {
            border-collapse: collapse;
            border: 1px solid black; /* Set border color and thickness */
            width: 100%; /* Set table width to 100% of its container */
        }

        th {
            border: 1px solid black; /* Set border for table cells */
            padding: 8px; /* Add padding for better readability */
            text-align: center; /* Center-align text within cells */
            height:20px;
            color:black;
        }
        td {
            border: 1px solid black; /* Set border for table cells */
            padding: 8px; /* Add padding for better readability */
            height:20px;
            color:black;
        }
    </style>
<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=opening_stock_view" style="color: rgb(7, 133, 164)">Opening stock list</a></li>
                    <li class="active">Open Stock Items</li>
                        </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>OPEN STOCK DETAILS</b></h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                        <button class="btn btn-default" onclick="printContent()">
                            <span class="fa fa-print"></span> Print Report
                        </button>
                        <button class="btn btn-default" onclick="exportToExcel()">
                            <span class="fa fa-print"></span> Export To Excel
                        </button>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                 <div id="printingArea">    
                  <table id="myTable">
                      <tr>
                          <th colspan=7><?php echo $_SESSION['Company'];?></th>
                      </tr>
                      <tr>
                          <th colspan=7>BRANCH: <?php echo $_SESSION['Branch'];?></th>
                      </tr>
                      <tr style="font-weight:bold">
                        <th>SN</th>
                        <th>Item Name</th>
                        <th>Quantity</th>
                        <th>Cost</th>
                        <th>total Value</th>
                        
                      </tr>
                      <tbody>
                            <?php
                            $sn = 1;
                            foreach ($openStock as $open) {
                                $totalValue = $open['quantity'] * $open['cost'];
                                $grandTotal += $totalValue;
                                echo "<tr>
                                    <td>{$sn}</td>
                                    <td>{$open['name']}</td>
                                    <td>{$open['quantity']}</td>
                                    <td>{$open['cost']}</td>
                                    <td>{$totalValue}</td>
                                </tr>";
                                $sn++;
                            }
                            ?>
                        </tbody>
                        <tfoot>
                        <tr style="font-weight: bold;">
                            <td colspan="4" style="text-align: left;">TOTAL:</td>
                            <td><?php echo number_format($grandTotal,2); ?></td>
                        </tr>
                    </tfoot>
                  </table>      
                 </div>       
                </div>
                <div class="panel-footer">                                    
      
                 </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>
<script>
    function printContent() {
        var content = document.getElementById('printingArea').innerHTML;
        var printWindow = window.open('', '_blank');
        printWindow.document.write('<html><head><title>Print</title>');
        printWindow.document.write('<style>table { border-collapse: collapse; border: 1px solid black; width: 100%; } th, td { border: 1px solid black; padding: 8px; text-align: center; height: 20px; color: black; } a { color: black; text-decoration: none; } </style>');
        printWindow.document.write('</head><body>');
        printWindow.document.write(content);
        printWindow.document.write('</body></html>');
        printWindow.document.close();
        printWindow.print();
    }

    function exportToExcel() {
        // Get the HTML table element
        var table = document.getElementById('printingArea'); // Replace 'tableId' with the ID of your table

        // Convert the HTML table to a worksheet
        var wb = XLSX.utils.table_to_book(table);

        // Generate a binary string from the XLSX workbook
        var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });

        // Create a Blob object representing the data as an Excel file
        var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

        // Create a temporary anchor element and trigger a download
        var link = document.createElement('a');
        link.href = window.URL.createObjectURL(blob);
        link.download = 'bank_statement.xlsx'; // Change 'filename' to your desired filename
        link.click();
    }

    // Utility function to convert a string to an ArrayBuffer
    function s2ab(s) {
        var buf = new ArrayBuffer(s.length);
        var view = new Uint8Array(buf);
        for (var i = 0; i < s.length; i++) {
            view[i] = s.charCodeAt(i) & 0xFF;
        }
        return buf;
    }
</script>
