<?php
session_start();
include '../db/db.php'; // Update with your actual database connection file

error_reporting(E_ALL);
ini_set('display_errors', 1);

// Get transfer ID from query string
$id = $_GET['id'];
$branch = $_SESSION['Branch'];
$user_id = $_SESSION['id'];
  $sql = "SELECT Name 
            FROM inv_users
            WHERE id =:id";
    $userstmt = $pdo->prepare($sql);
    $userstmt->bindParam(':id', $user_id, PDO::PARAM_INT);
    $userstmt->execute();
    $user = $userstmt->fetch(PDO::FETCH_ASSOC);
    
    
// Get stockout ID from query string
$stockout_id = isset($_GET['id']) ? (int)$_GET['id'] : 0;

if ($stockout_id > 0) {
    // Fetch details for the specific stockout ID
    $sql = "SELECT sd.date, 
                   sd.notes, 
                   sd.issuedby AS `from`, 
                   sd.providedto AS `to`, 
                   p.Name AS item_name, 
                   si.quantity, 
                   si.cost
            FROM stockout sd
            LEFT JOIN stockout_items si ON sd.id = si.stockoutid
            INNER JOIN product p ON si.itemid = p.ProductId
            WHERE sd.id = :stockout_id
            ORDER BY sd.date DESC";

    $stmt = $pdo->prepare($sql);
    $stmt->bindParam(':stockout_id', $stockout_id, PDO::PARAM_INT);
    $stmt->execute();
    $stockouts = $stmt->fetchAll(PDO::FETCH_ASSOC);

     
    

} else {
    // Handle case when no valid stockout ID is provided
    $_SESSION['message'] = "Invalid stockout ID.";
    header("Location: index.php?p=item_stock_out");
    exit();
}
?>
    <style>
        /* CSS to style the table */
        table {
            border-collapse: collapse;
            border: 1px solid black; /* Set border color and thickness */
            width: 100%; /* Set table width to 100% of its container */
        }

        th {
            border: 1px solid black; /* Set border for table cells */
            padding: 8px; /* Add padding for better readability */
            text-align: center; /* Center-align text within cells */
            height:20px;
            color:black;
        }
        td {
            border: 1px solid black; /* Set border for table cells */
            padding: 8px; /* Add padding for better readability */
            height:20px;
            color:black;
        }
    </style>
<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=item_menu" style="color: rgb(7, 133, 164)">Items Menu</a></li>
                <li class="active">Stock Out View</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>STOCK OUT DETAILS</b></h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                        <button class="btn btn-default" onclick="printContent()">
                            <span class="fa fa-print"></span> Print Report
                        </button>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                    <div id="printingArea">    
                        <table id="myTable">
                            <tr>
                                <th colspan=5><?php echo $_SESSION['Company'];?></th>
                            </tr>
                            <tr>
                                <th colspan=5>FROM: <?php echo $stockouts[0]['from']; ?> TO: <?php echo $stockouts[0]['to']; ?></th>
                            </tr>
                            <tr>
                                <th colspan=5>CREATED BY: <?php echo $user['Name'];?></th>
                      </tr>
                <th colspan=5>DATE:  <?php echo $stockouts[0]['date']; ?></th>
                      </tr>
                    <th colspan=5>REASON: <?php echo $stockouts[0]['notes']; ?></th>
                            </tr>
                            <tr style="font-weight:bold">
                                <th>SN</th>
                                <th>Date</th>
                                <th>Item Name</th>
                                <th>Quantity</th>
                                <th>Cost</th>
                            </tr>
                            <tbody>
                                <?php
                                $sn = 1;
                                foreach ($stockouts as $stockout) {
                                    echo "<tr>
                                        <td>{$sn}</td>
                                        <td>{$stockout['date']}</td>
                                        <td>{$stockout['item_name']}</td>
                                        <td style='text-align:right'>{$stockout['quantity']}</td>
                                        <td style='text-align:right'>{$stockout['cost']}</td>
                                    </tr>";
                                    $sn++;
                                }
                                ?>
                            </tbody>
                        </table>      
                    </div>       
                </div>
                <div class="panel-footer">                                    
                </div>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>
<script src="https://cdnjs.cloudflare.com/ajax/libs/xlsx/0.17.0/xlsx.full.min.js"></script>
<script>
    function printContent() {
        var content = document.getElementById('printingArea').innerHTML;
        var printWindow = window.open('', '_blank');
        printWindow.document.write('<html><head><title>Print</title>');
        printWindow.document.write('<style>table { border-collapse: collapse; border: 1px solid black; width: 100%; } th, td { border: 1px solid black; padding: 8px; text-align: center; height: 20px; color: black; } a { color: black; text-decoration: none; } </style>');
        printWindow.document.write('</head><body>');
        printWindow.document.write(content);
        printWindow.document.write('</body></html>');
        printWindow.document.close();
        printWindow.print();
    }

    function exportToExcel() {
        // Get the HTML table element
        var table = document.getElementById('myTable'); // Replace 'tableId' with the ID of your table

        // Convert the HTML table to a worksheet
        var wb = XLSX.utils.table_to_book(table);

        // Generate a binary string from the XLSX workbook
        var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });

        // Create a Blob object representing the data as an Excel file
        var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

        // Create a temporary anchor element and trigger a download
        var link = document.createElement('a');
        link.href = window.URL.createObjectURL(blob);
        link.download = 'stockout_report.xlsx'; // Change 'filename' to your desired filename
        link.click();
    }

    // Utility function to convert a string to an ArrayBuffer
    function s2ab(s) {
        var buf = new ArrayBuffer(s.length);
        var view = new Uint8Array(buf);
        for (var i = 0; i < s.length; i++) {
            view[i] = s.charCodeAt(i) & 0xFF;
        }
        return buf;
    }
</script>
