<?php
// Start the session and include the database connection
session_start();
include '../db/db.php';

$branch = $_SESSION['Branch'];
$stmt = $pdo->prepare("SELECT
                        w.id,
                        w.date, 
                        w.notes,
                        w.reference
                        FROM writeoff w
                        LEFT JOIN writeoff_items wi ON w.id = wi.writeoff_id
                        INNER JOIN product p ON wi.itemid = p.ProductId
                        WHERE w.branch = :branch 
                        GROUP BY w.id, w.date, w.reference 
                        ORDER BY w.date DESC");

$stmt->bindParam(':branch', $branch);
$stmt->execute();

$writeoff = $stmt->fetchAll(PDO::FETCH_ASSOC);
?>

<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=item_menu" style="color: rgb(7, 133, 164)">Items Menu</a></li>
                <li class="active">Writeoff List</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>WRITEOFF  LIST</b></h3>
                    <div class="pull-right">
                        <a href="index.php?p=write_off_add"><button class="btn btn-warning"> <span class="fa fa-plus-circle"></span> Create New Writeoff</button></a>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                    <div class="table-responsive">
                        <table class="table table-hover datatable">
                            <thead>
                                <tr>
                                    <th>SN</th>
                                    <th>Date</th>
                                    <th>Reference</th>
                                    <th>Description</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                $sn = 1;
                                foreach ($writeoff as $write) {
                                    ?>
                                    <tr>
                                        <td><?php echo $sn++; ?></td>
                                        <td><?php echo $write['date']; ?></td>
                                        <td><?php echo $write['reference']; ?></td>
                                        <td><?php echo $write['notes']; ?></td>
                                        <td>
                                       <a href="index.php?p=write_off_view&id=<?php echo $write['id']; ?>"><span class="fa fa-eye"></span> View items</a>
                                        </td>
                                    </tr>
                                    <?php
                                }
                                ?>
                            </tbody>
                        </table>
                    </div> 
                </div>
            </div>
        </div>
    </div>
    <!-- END TIMELINE --> 
</div>
