<?php
session_start();
include '../db/db.php'; // Update with your actual database connection file

// Get transfer ID from query string
$id = $_GET['id'];
$branch = $_SESSION['Branch'];
$user_id = $_SESSION['id'];
$sql = "SELECT Name FROM inv_users WHERE id = :id"; // Added WHERE clause
$userstmt = $pdo->prepare($sql);
$userstmt->bindParam(':id', $user_id, PDO::PARAM_INT);
$userstmt->execute();
$user = $userstmt->fetch(PDO::FETCH_ASSOC);

if ($id > 0) {
    // Fetch details for the specific transfer ID
    $sql = "SELECT
             wi.quantity,
             wi.cost,
             p.name,
             w.id,
             w.date,
             w.notes
            FROM writeoff w
            INNER JOIN writeoff_items wi ON w.id = wi.writeoff_id
            INNER JOIN product p ON wi.itemid = p.ProductId
            WHERE w.id = :id
            AND w.branch = :branch
            ORDER BY w.date DESC";

    $stmt = $pdo->prepare($sql);
    $stmt->bindParam(':id', $id, PDO::PARAM_INT);
    $stmt->bindParam(':branch', $branch, PDO::PARAM_STR);
    $stmt->execute();
    $writeoff = $stmt->fetchAll(PDO::FETCH_ASSOC);
} else {
    // Handle case when no valid transfer ID is provided
    $_SESSION['message'] = "Invalid ID.";
    header("Location: index.php?p=write_off");
    exit();
}
?>
<style>
    /* CSS to style the table */
    table {
        border-collapse: collapse;
        border: 1px solid black; /* Set border color and thickness */
        width: 100%; /* Set table width to 100% of its container */
    }

    th {
        border: 1px solid black; /* Set border for table cells */
        padding: 8px; /* Add padding for better readability */
        text-align: center; /* Center-align text within cells */
        height: 20px;
        color: black;
    }

    td {
        border: 1px solid black; /* Set border for table cells */
        padding: 8px; /* Add padding for better readability */
        height: 20px;
        color: black;
    }
</style>
<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=write_off" style="color: rgb(7, 133, 164)">writeoff list</a></li>
                <li class="active">writeoff Items</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>WRITEOFF DETAILS</b></h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                        <button class="btn btn-default" onclick="printContent()">
                            <span class="fa fa-print"></span> Print Report
                        </button>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                    <div id="printingArea">
                        <table id="myTable">
                            <tr>
                                <th colspan=7><?php echo $_SESSION['Company'];?></th>
                            </tr>
                            <tr>
                                <th colspan=7>BRANCH: <?php echo $_SESSION['Branch'];?></th>
                            </tr>
                            <tr>
                                <th colspan=7>CREATED BY: <?php echo $user['Name'];?></th>
                            </tr>
                            <tr>
                                <th colspan=7>DATE: <?php echo $writeoff[0]['date']; ?></th>
                            </tr>
                            <tr>
                                <th colspan=7>REASON: <?php echo $writeoff[0]['notes']; ?></th>
                            </tr>
                            <tr style="font-weight:bold">
                                <th>SN</th>
                                <th>Item Name</th>
                                <th>Quantity</th>
                                <th>Cost</th>
                                <th>Value</th>
                            </tr>
                            <tbody>
                            <?php
                            $sn = 1;
                            $totalValue = 0; // Initialize total value
                            foreach ($writeoff as $write) {
                                $value = $write['quantity'] * $write['cost'];
                                $totalValue += $value; 
                                echo "<tr>
                                    <td>{$sn}</td>
                                    <td>{$write['name']}</td>
                                    <td>{$write['quantity']}</td>
                                    <td>{$write['cost']}</td>
                                    <td>{$value}</td>
                                </tr>";
                                $sn++;
                            }
                            ?>
                            <tr style="font-weight:bold">
                                <td colspan="4" style="text-align:left;">TOTAL </td>
                                <td><?php echo $totalValue; ?></td>
                            </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
                <div class="panel-footer">
                </div>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>
<script>
    function printContent() {
        var content = document.getElementById('printingArea').innerHTML;
        var printWindow = window.open('', '_blank');
        printWindow.document.write('<html><head><title>Print</title>');
        printWindow.document.write('<style>table { border-collapse: collapse; border: 1px solid black; width: 100%; } th, td { border: 1px solid black; padding: 8px; text-align: center; height: 20px; color: black; } a { color: black; text-decoration: none; } </style>');
        printWindow.document.write('</head><body>');
        printWindow.document.write(content);
        printWindow.document.write('</body></html>');
        printWindow.document.close();
        printWindow.print();
    }

    // Utility function to convert a string to an ArrayBuffer
    function s2ab(s) {
        var buf = new ArrayBuffer(s.length);
        var view = new Uint8Array(buf);
        for (var i = 0; i < s.length; i++) {
            view[i] = s.charCodeAt(i) & 0xFF;
        }
        return buf;
    }
</script>
