<?php
require_once '../db/db.php'; // Adjust the path as necessary

if(isset($_POST['submit'])){
    // Retrieve data from the form
    $department_name = mysqli_real_escape_string($con, $_POST['department_name']);
    
    // Check if the department already exists
    $checkQuery = "SELECT * FROM department WHERE Department_name = '$department_name'";
    $checkResult = mysqli_query($con, $checkQuery);
    
    if(mysqli_num_rows($checkResult) > 0) {
        // Department already exists, display error message
        $err = '<div class="alert alert-danger" role="alert">
                    <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                    Department already exists.
                </div>';
    } else {
        // Department does not exist, insert into the database
        $insertQuery = "INSERT INTO department (Department_name) VALUES ('$department_name')";
        $result = mysqli_query($con, $insertQuery);
     
        if ($result) {
            $err = '<div class="alert alert-success" role="alert">
                        <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                        <strong>Well done!</strong> Your Data has been successfully recorded.
                    </div>';
        } else {
            $err = '<div class="alert alert-danger" role="alert">
                        <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button> Error updating data; Please contact the system administrator.
                    </div>';
        }
    }
}
?>


        <div class="col-md-9">

                    <!-- START TIMELINE -->
                    <div class="row">
                        <div class="col-md-12">
                            <?php if(isset($err)) { echo $err; } ?>
                            <div class="panel panel-default">
                                <div class="panel-heading">
                                    <h3 class="panel-title" style="color: rgb(174, 169, 169);"><strong>Departments</strong></h3>
                                                    <button id="openDepartmentModal" class="btn btn-warning pull-right" type="button" name="submit" data-toggle="modal" data-target="#DepartmentModal" style="color:#f3a02a;background-color:#2d2860;">
                                                        <span class="glyphicon glyphicon-plus"></span> Add New Department
                                                    </button>
                                               
                                </div>
                                
                                <!-- Department Table -->
                                <div class="row">
                                    <div class="col-xs-12">
                                        <div class="box">
                                            <div class="panel-body">
                                                <div class="table-responsive">
                                                    <table id="departments" class="table datatable">
                                    <thead>
                                        <tr>
                                            <th class="text-center">S/No.</th>
                                            <th>Department Name</th>
                                            <th>Action</th>
                                        </tr>
                                    </thead>
                            <tbody>
                                <?php
                                $selectQuery = "SELECT * FROM department";
                                $result = mysqli_query($con,$selectQuery);
                                
                            if ($result) {
                                while($row=mysqli_fetch_assoc($result)){
                                    $id=$row['id'];
                                    $department_name=$row['Department_name'];
                                    echo' <tr>
                                            <td class="text-center">'.$id.'</td>
                                            <td>'.$department_name.'</td>
                                            
                                             <td> <a href="index.php?p=department_edit&id='.$row['id'].'" class="edit-icon"><span class="fa fa-edit fa-lg"></span></a>
                                                <a href="department_delete.php?id='.$row['id'].'" class="delete-icon" onclick="return confirm(\'Are you sure you want to delete this record?\')">
                                        <span class="glyphicon glyphicon-remove" style="color:red;font-size: 14px"></span>
                                    </a>
                                              </td>
                                        </tr>';
                                }
                            }
                                ?>
                                       
                                    </tbody>
                                                    </table>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                
                                <!-- Department Modal -->
                                <div class="modal fade in" id="DepartmentModal" tabindex="-1">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                
                                                <h4 class="modal-title">Department</h4>
                                            </div>
                                            <form method="post" action="" role="form" data-toggle="validator" id="department-form">
                                                <div class="modal-body">
                                                    <div class="form-group">
                                                        <label for="department_name">Department Name</label>
                                                        <input type="text" class="form-control" id="department_name" name="department_name" placeholder="Department Name" required />
                                                    </div>
                                                </div>
                                                <div class="modal-footer">
                                                    <input type="hidden" name="department_id" id="department_id" />
                                        <button type="submit" name="submit" class="btn btn-primary">Save Department</button>
                                                </div>
                                            </form>
                                        </div>
                                    </div>
                                </div>
                            <!-- END DEFAULT DATATABLE -->

                <!-- PAGE CONTENT WRAPPER -->                                
            </div>    
            <!-- END PAGE CONTENT -->
        </div>
        
        	<script>
        $(document).ready(function() {
            $("#DepartmentModal").click(function() {
                $("#department-form").modal("show");
            });
        });
		$(document).ready(function(){
    $('#holiday_date').datepicker({
        format: 'mm/dd/yyyy',
        autoclose: true,
        todayHighlight: true
    });
    </script>