<?php
if (isset($_POST['submit'])) {
    $leave_type = mysqli_real_escape_string($con, $_POST['leave_type']);
    $other_leave_type_input = mysqli_real_escape_string($con, $_POST['other_leave_type_input']);
    $leave_start_date = mysqli_real_escape_string($con, $_POST['leave_start_date']);
    $leave_end_date = mysqli_real_escape_string($con, $_POST['leave_end_date']);
    $leave_days_requested = mysqli_real_escape_string($con, $_POST['leave_days_requested']);
    $leave_message = mysqli_real_escape_string($con, $_POST['leave_message']);
    $branch = $_SESSION['Branch'];
    $empid = $_SESSION['id'];
    $status = 1;

    // Handle file upload
    $attachment = '';
    if (isset($_FILES['attachment']) && $_FILES['attachment']['error'] == 0) {
        $target_dir = "../attachments/";
        $attachment = $target_dir . basename($_FILES["attachment"]["name"]);
        if (!is_dir($target_dir)) {
            mkdir($target_dir, 0777, true); // Create directory if it doesn't exist
        }
        if (move_uploaded_file($_FILES["attachment"]["tmp_name"], $attachment)) {
            $attachment = mysqli_real_escape_string($con, $attachment);
        } else {
            $err = '<div class="alert alert-danger" role="alert">
                <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                <strong>Error!</strong> Failed to upload the attachment.
            </div>';
        }
    }

    // Prepare SQL query with proper syntax
    $insertQuery = "INSERT INTO LeaveManagement (leave_type, other_leave_type, start_date, end_date, leave_days, leave_message, empid, attachment, Branch, status)
                    VALUES ('$leave_type', '$other_leave_type_input', '$leave_start_date', '$leave_end_date', '$leave_days_requested', '$leave_message',$empid, '$attachment', '$branch',$status)";

    // Execute the query
    if (mysqli_query($con, $insertQuery)) {
        echo "<script src='https://cdn.jsdelivr.net/npm/sweetalert2@11'></script>";
        echo "<script>
            Swal.fire({
                icon: 'success',
                title: 'Alert Message',
                text: 'Successfully Applied',
                confirmButtonText: 'OK'
            }).then((result) => {
                if (result.isConfirmed) {
                    window.location = 'index.php?p=LeaveManagement';
                }
            });
         </script>";
    } else {
        echo "<script src='https://cdn.jsdelivr.net/npm/sweetalert2@11'></script>";
        echo "<script>
            Swal.fire({
                icon: 'danger',
                title: 'Alert Message',
                text: 'Something wrong',
                confirmButtonText: 'OK'
            });
         </script>";
    }
}

?>

<?php

if (session_status() == PHP_SESSION_NONE) {
    session_start();
}

// Fetch data based on the user's role
$user = $_SESSION['id'];
$role = $_SESSION['role'];

  $query1 = "SELECT * FROM LeaveManagement WHERE empid = '$user'";
  $results = mysqli_query($con, $query1);
  
?>
    
                       <div class="col-md-9">

                            <!-- START TIMELINE -->
                        <div class="row">
                           <div class="col-md-12">

                            <div class="panel panel-default">
							<div class="panel-heading">
                                    <h3 class="panel-title" style="color: rgb(174, 169, 169);"><strong>Applied Leaves</strong></h3>
                                </div>
							<div class="panel-body">
                                    <div class="table-responsive">
									<?php 
									if ( $_SESSION['role'] != '6' ) { 
									?>
                                        
                                         <table id="allleaves" class="table datatable">
										<thead>
											<tr>
												<th>#</th>
												<th>EMP CODE</th>
												<th>EMP NAME</th>
												<th>DATE FROM</th>
												<th>DATE TO</th>
												<th>REASON FOR LEAVE</th>
												<th>TYPE</th>
												<th>DOCUMENT</th>
												<th>STATUS</th>
												<th>ACTIONS</th>
											</tr>
										</thead>
										<tbody>
<?php
$query = "SELECT l.*, er.Name, (er.Ecode) AS empid 
          FROM LeaveManagement l 
          INNER JOIN Employee_Registration er ON l.empid = er.id";
$result = mysqli_query($con, $query);

$count = 1;
while ($row = mysqli_fetch_assoc($result)) {
    $status = $row['status'];
    if ($status == '1') {
        $statusLabel = '<span class="label label-warning">Pending</span>';
    } elseif ($status == '2') {
        $statusLabel = '<span class="label label-success">Approved</span>';
    } elseif ($status == '3') {
        $statusLabel = '<span class="label label-danger">Denied</span>';
    } else {
        $statusLabel = '<span class="label label-default">Unknown</span>';
    }

    echo "<tr>";
    echo "<td>{$count}</td>";
    echo "<td>{$row['empid']}</td>";
    echo "<td>{$row['Name']}</td>";
    echo "<td>{$row['start_date']}</td>";
    echo "<td>{$row['end_date']}</td>";
    echo "<td>{$row['leave_message']}</td>";
    echo "<td>{$row['leave_type']}</td>";

    // Check if there is an attachment and create a link if it exists
    if (!empty($row['attachment'])) {
        echo "<td><a href='../attachments/{$row['attachment']}' target='_blank'>View Document</a></td>";
    } else {
        echo "<td>No Document</td>";
    }

    echo "<td>{$statusLabel}</td>";

    // Display actions based on the leave status
    if ($status != 2 && $status != 3) {
        echo "<td>
                <a href='index.php?id={$row['id']}&p=leave_approve'>Approve</a> | 
                <a href='index.php?id={$row['id']}&p=leave_denie'>Reject</a> | 
                <a href='index.php?id={$row['id']}&p=leave_details'>Details</a>
              </td>";
    } else {
        echo "<td><a href='index.php?id={$row['id']}&p=leave_details'>Details</a></td>";
    }

    echo "</tr>";
    $count++;
}
?>


                            </tbody>
						</table>
                        </div>
                        </div>
                        </div>
                        </div>
                         <br/><br/>
                          <div class="col-md-12">

                            <!-- START TIMELINE -->
                        <div class="row">
                           <div class="col-md-12">

                            <div class="panel panel-default">
							<div class="panel-heading">
                                    <h3 class="panel-title" style="color: rgb(174, 169, 169);"><strong>Applied Leaves</strong></h3>
                                </div>
							<div class="panel-body">
                                    <div class="table-responsive">
						<div class="col-lg-4">
							<div class="box">
								<div class="box-header">
								    <h3 class="box-title" style="color: rgb(174, 169, 169);">Apply Leave</h3>
								</div>
								<div class="box-body">

                                    <form method="post" role="form" action="" enctype="multipart/form-data">
                                        <?php echo isset($err) ? $err : ''; ?>
                                        <div class="form-group">
                                            <label for="leave_type">Leave Type</label>
                                            <select class="form-control" name="leave_type" id="leave_type" required>
                                                <option value="">Please choose</option>
                                                <option value="Annual Leave">Annual Leave</option>
                                                <option value="Sick Leave">Sick Leave</option>
                                                <option value="Maternity Leave">Maternity Leave</option>
                                                <option value="Paternity Leave">Paternity Leave</option>
                                                <option value="Compassionate Leave">Compassionate Leave</option>
                                                <option value="Study Leave">Study Leave</option>
                                                <option value="Emergency Leave">Emergency Leave</option>
                                                <option value="Other">Other</option>
                                            </select>
                                        </div>
                                        <div class="form-group" id="other_leave_type" style="display: none;">
                                            <label for="other_leave_type_input">Specify Other Leave Type</label>
                                            <input type="text" class="form-control" name="other_leave_type_input" id="other_leave_type_input"/>
                                        </div>
                                        <div class="form-group">
                                            <label for="leave_start_date">Leave Start Date</label>
                                            <div class="input-group date">
                                                <input type="text" class="form-control datepicker" name="leave_start_date" id="leave_start_date" required />
                                                <span class="input-group-addon">
                                                    <span class="glyphicon glyphicon-calendar"></span>
                                                </span>
                                            </div>
                                        </div>
                                        <div class="form-group">
                                            <label for="leave_end_date">Leave End Date</label>
                                            <div class="input-group date">
                                                <input type="text" class="form-control datepicker" name="leave_end_date" id="leave_end_date" required />
                                                <span class="input-group-addon">
                                                    <span class="glyphicon glyphicon-calendar"></span>
                                                </span>
                                            </div>
                                        </div>
                                        <div class="form-group">
                                            <label for="leave_days_requested">Number of Days Requested</label>
                                            <input type="text" class="form-control" name="leave_days_requested" style="color:black" id="leave_days_requested" readonly />
                                        </div>
                                        <div class="form-group">
                                            <label for="leave_message">Reason for Leave request</label>
                                            <textarea class="form-control" name="leave_message" id="leave_message" rows="5" required></textarea>
                                        </div>
                                        <div class="form-group">
                                            <label for="attachment">Attachment</label>
                                            <input type="file" class="form-control-file" id="attachment" name="attachment">
                                            <small class="form-text text-muted">Attach any supporting documents (optional)</small>
                                        </div>
                                        <div class="form-group">
                                            <button type="submit" class="btn btn-primary" id="submit_button" name="submit">Apply for Leave</button>
                                        </div>
                                    </form>
								</div>
							</div>
						</div>
						<div class="col-lg-8">
							<div class="box">
								<div class="box-header">
									<h3 class="box-title" style="color: rgb(174, 169, 169);">My Leaves</h3>
								</div>
								<div class="box-body">
									<table id="myleaves" class="table table-bordered table-stripe">
										<thead>
											<tr>
												<th>#</th>
												<th>DATE FROM</th>
												<th>DATE TO</th>
												<th>REASON FOR LEAVE</th>
												<th>TYPE</th>
												<th>STATUS</th>
											</tr>
										</thead>
									<tbody>
                                            <?php
                                            $count = 1;
                                            while ($rows = mysqli_fetch_assoc($results)) {
                                                // Determine the status label
                                                $status = $rows['status'];
                                                if ($status == '1') {
                                                    $statusLabel = '<span class="label label-warning">Pending</span>';
                                                } elseif ($status == '2') {
                                                    $statusLabel = '<span class="label label-success">Approved</span>';
                                                } elseif ($status == '3') {
                                                    $statusLabel = '<span class="label label-danger">Denied</span>';
                                                } else {
                                                    $statusLabel = '<span class="label label-default">Unknown</span>';
                                                }

                                                echo "<tr>";
                                                echo "<td>{$count}</td>";
                                                echo "<td>{$rows['start_date']}</td>";
                                                echo "<td>{$rows['end_date']}</td>";
                                                echo "<td>{$row['leave_message']}</td>";
                                                echo "<td>{$rows['leave_type']}</td>";
                                                echo "<td>{$statusLabel}</td>";
                                                echo "</tr>";
                                                $count++;
                                            }
                                            ?>
                                        </tbody>
									</table>
								</div>
							</div>
						</div>
						<?php 
					 } 
					 ?>
            </div>    
            <!-- END PAGE CONTENT -->
        </div>
        <!-- END PAGE CONTAINER -->       
        </div>
		</div>
    
		</div>
        <!-- END MESSAGE BOX-->


 

	<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.js"></script>

<script>
$(document).ready(function(){
    // Function to calculate the number of days requested
    function calculateDaysRequested() {
        var startDate = $('#leave_start_date').datepicker('getDate');
        var endDate = $('#leave_end_date').datepicker('getDate');
        
        // Calculate the difference in days between the start and end dates
        var daysDifference = Math.ceil((endDate - startDate) / (1000 * 60 * 60 * 24));
        
        // Update the value of the leave days requested input field
        $('#leave_days_requested').val(daysDifference);
    }

    // Datepicker initialization
    $('#leave_start_date, #leave_end_date').datepicker({
        format: 'dd/mm/yyyy',
        autoclose: true,
        todayHighlight: true
    });
    
    // Trigger the calculation when the leave end date changes
    $('#leave_end_date').change(function() {
        calculateDaysRequested();
    });

    

    // Function to show/hide other_leave_type input field
    $('#leave_type').change(function(){
        var selectedOption = $(this).val();
        if(selectedOption === "Other") {
            $('#other_leave_type').show();
        } else {
            $('#other_leave_type').hide();
        }
    });
});
</script>
