<?php
require_once '../db/db.php';

// Check if the form is submitted
if (isset($_POST['submit'])) {

    // Escape user inputs to prevent SQL injection
    $transfer_subject = mysqli_real_escape_string($con, $_POST['transfer_subject']);
    $transfer_type = mysqli_real_escape_string($con, $_POST['transfer_type']);
    $transfer_date = mysqli_real_escape_string($con, $_POST['transfer_date']);
    $transfer_to = mysqli_real_escape_string($con, $_POST['transfer_to']);
    $transfer_reason = mysqli_real_escape_string($con, $_POST['transfer_reason']);
    $user =  $_SESSION['id'];
    $status = 1;
    
    // Check if an attachment is uploaded
    $file_destination = ''; // Initialize with an empty string
    if (!empty($_FILES['transfer_attachment']['name'])) {
        $file_name = $_FILES['transfer_attachment']['name'];
        $file_tmp = $_FILES['transfer_attachment']['tmp_name'];
        $file_destination = '../contract/' . $file_name;
        // Move the uploaded file to the destination directory
        move_uploaded_file($file_tmp, $file_destination);
    }
    
    // Insert data into the database
    $insertQuery = "INSERT INTO TransferManagement (transfer_subject, transfer_type, transfer_date, transfer_to, transfer_reason, transfer_attachment,empid,status)
                    VALUES ('$transfer_subject', '$transfer_type', '$transfer_date', '$transfer_to', '$transfer_reason', '$file_destination','$user','$status')";
    $result = mysqli_query($con, $insertQuery);
    
    // Check if the insertion was successful
    if ($result) {
        $err = '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                    <strong>Well done!</strong> Your Data has been successfully Submitted.
                </div>';
    } else {
        $err = '<div class="alert alert-danger" role="alert">
                    <strong>Error!</strong> Unable to submit transfer request. Please try again.
                </div>';
    }
}
?>

<div class="col-md-9">
    <div class="row">
        <div class="col-md-12">
            <?php if (isset($err)) { echo $err; } ?>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><strong>Employee Transfer List</strong></h3>
                </div>
                <div class="panel-body">
                    <div class="table-responsive">
                        <?php if ($_SESSION['role'] != 6) { ?>
                        <table id="alltransfers" class="table datatable">
                            <thead>
                                <tr>
                                    <th>#</th>
                                    <th>EMP CODE</th>
                                    <th>EMP Name</th>
                                    <th>SUBJECT</th>
                                    <th>TRANSFER DATE</th>
                                    <th>TRANSFER TO</th>
                                    <th>REASON FOR TRANSFER</th>
                                    <th>STATUS</th>
                                    <th>ACTIONS</th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                $selectQuery = "SELECT t.*, er.Name, (er.Ecode) AS empid FROM TransferManagement t  INNER JOIN Employee_Registration er ON t.empid = er.id";
                                $result = mysqli_query($con, $selectQuery);
                                $a = 1;
                                while ($rows = mysqli_fetch_assoc($result)) {
                                    $id = $rows['id'];
                                    $empid = $rows['empid'];
                                    $name = $rows['Name'];
                                    $subject = $rows['transfer_subject'];
                                    $date = $rows['transfer_date'];
                                    $transfer_to = $rows['transfer_to'];
                                    $transfer_reason = $rows['transfer_reason'];
                                    $transfer_type = $rows['transfer_type'];
                                    $status = $rows['status'];

                                    if ($status == '1') {
                                        $statusLabel = '<span class="label label-warning">Pending</span>';
                                    } elseif ($status == '2') {
                                        $statusLabel = '<span class="label label-success">Approved</span>';
                                    } elseif ($status == '3') {
                                        $statusLabel = '<span class="label label-danger">Denied</span>';
                                    } else {
                                        $statusLabel = '<span class="label label-default">Unknown</span>';
                                    }

                                    echo '<tr>
                                            <td>'.$a++.'</td>
                                            <td>'.$empid.'</td>
                                            <td>'.$name.'</td>
                                            <td>'.$subject.'</td>
                                            <td>'.$date.'</td>
                                            <td>'.$transfer_to.'</td>
                                            <td>'.$transfer_reason.'</td>
                                            <td>'.$statusLabel.'</td>';
                                    
                                    if ($status != 2 && $status != 3) {
                                        echo '<td>
                                                <a href="index.php?id='.$id.'&p=transfer_approve">Approve</a> | 
                                                <a href="index.php?id='.$id.'&p=transfer_denie">Reject</a> | 
                                                <a href="index.php?id='.$id.'&p=transfer_details">Details</a>
                                              </td>';
                                    } else {
                                        echo '<td><a href="index.php?id='.$id.'&p=transfer_details">Details</a></td>';
                                    }
                                    
                                    echo '</tr>';
                                }
                                ?>
                            </tbody>
                        </table>
                        </div>
                        </div>
                        </div>
                        </div>
                        </div>
                        </div>
                        <br/><br/>
                   <div class="col-md-9">
                    <div class="row">
                        <div class="col-md-12">
                            <?php if (isset($err)) { echo $err; } ?>
                            <div class="panel panel-default">
                                <div class="panel-heading">
                                    <h3 class="panel-title"><strong>Employee Transfer List</strong></h3>
                                </div>
                                <div class="panel-body">
                                    <div class="table-responsive">
                        <div class="col-lg-4">
                            <div class="box">
                                <div class="box-header">
                                    <h4 class="box-title">Apply for Transfer</h4>
                                </div>
                                <div class="box-body">
                                    <form method="post" role="form" action="" enctype="multipart/form-data">
                                        <div class="form-group">
                                            <label for="transfer_subject">Transfer Subject</label>
                                            <input type="text" class="form-control" value="My Transfer request" name="transfer_subject" id="transfer_subject" required />
                                        </div>
                                        <div class="form-group">
                                            <label for="transfer_type">Transfer Type</label>
                                            <select class="form-control" name="transfer_type" id="transfer_type" required>
                                                <option value="">Please choose</option>
                                                <option value="Internal Transfer">Internal Transfer</option>
                                                <option value="External Transfer">External Transfer</option>
                                                <option value="Inter-branch Transfer">Inter-branch Transfer</option>
                                                <option value="Promotion Transfer">Promotion Transfer</option>
                                                <option value="Location Transfer">Location Transfer</option>
                                                <!-- Add more transfer types relevant to your organization's policies -->
                                            </select>
                                        </div>
                                        <div class="form-group">
                                            <label for="transfer_date">Transfer Date</label>
                                            <div class="input-group date">
                                                <input type="text" class="form-control datepicker" name="transfer_date" value="<?php echo date('d-m-Y')?>" id="transfer_date" required />
                                                <span class="input-group-addon">
                                                    <span class="glyphicon glyphicon-calendar"></span>
                                                </span>
                                            </div>
                                        </div>
                                        <div class="form-group">
                                            <label for="transfer_to">Transfer To</label>
                                            <input type="text" class="form-control" name="transfer_to" id="transfer_to" required />
                                        </div>
                                        <div class="form-group">
                                            <label for="transfer_reason">Reason for Transfer request</label>
                                            <textarea class="form-control" name="transfer_reason" id="transfer_reason" rows="5" required></textarea>
                                        </div>
                                        <div class="form-group">
                                            <label for="transfer_attachment">Attachment</label>
                                            <input type="file" class="form-control-file" id="transfer_attachment" name="transfer_attachment">
                                            <small class="form-text text-muted">Attach any supporting documents (optional)</small>
                                        </div>
                                        <div class="form-group">
                                            <button type="submit" class="btn btn-primary" name="submit">Apply for Transfer</button>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                        <div class="col-lg-8">
                            <div class="box">
                                <div class="box-header">
                                    <h3 class="box-title">My Transfers</h3>
                                </div>
                                <div class="box-body">
                                    <table id="mytransfers" class="table table-bordered table-striped">
                                        <thead>
                                            <tr>
                                                <th>#</th>
                                                <th>SUBJECT</th>
                                                <th>TRANSFER DATE</th>
                                                <th>TRANSFER TO</th>
                                                <th>REASON FOR TRANSFER</th>
                                                <th>TYPE</th>
                                                <th>STATUS</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                        <?php
                                        $sn=1;
                                        $user = $_SESSION['id'];
                                        $selectQuery = "SELECT * FROM TransferManagement WHERE empid='$user';";
                                        $result = mysqli_query($con, $selectQuery);
                                        while ($row = mysqli_fetch_assoc($result)) {
                                            $id = $row['id'];
                                            $subject = $row['transfer_subject'];
                                            $date = $row['transfer_date'];
                                            $transfer_to = $row['transfer_to'];
                                            $transfer_reason = $row['transfer_reason'];
                                            $transfer_type = $row['transfer_type'];
                                            $status = $row['status'];

                                            if ($status == '1') {
                                                $statusLabel = '<span class="label label-warning">Pending</span>';
                                            } elseif ($status == '2') {
                                                $statusLabel = '<span class="label label-success">Approved</span>';
                                            } elseif ($status == '3') {
                                                $statusLabel = '<span class="label label-danger">Denied</span>';
                                            } else {
                                                $statusLabel = '<span class="label label-default">Unknown</span>';
                                            }

                                            echo '<tr>
                                                    <td>'.$sn++.'</td>
                                                    <td>'.$subject.'</td>
                                                    <td>'.$date.'</td>
                                                    <td>'.$transfer_to.'</td>
                                                    <td>'.$transfer_reason.'</td>
                                                    <td>'.$transfer_type.'</td>
                                                    <td>'.$statusLabel.'</td>
                                                  </tr>';
                                        }
                                        ?>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                        <?php } ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>


<!-- Initialize datepicker -->
<script>
$(document).ready(function(){
    $('#transfer_date').datepicker({
        format: 'yyyy/mm/dd',
        autoclose: true,
        todayHighlight: true
    }).on('changeDate', function(e){
        $(this).datepicker('hide');
    });
});
</script>
