<?php
include '../db/connection.php';

if (isset($_POST['department_add'])) {
    $departmentName = strtoupper(trim($_POST['name']));
    
    try {
        // Check if the department already exists
        $checkQuery = "SELECT COUNT(*) FROM department WHERE Department_name = :Department_name";
        $checkStmt = $pdo->prepare($checkQuery);
        $checkStmt->bindParam(':Department_name', $departmentName);
        $checkStmt->execute();
        $departmentExists = $checkStmt->fetchColumn();

        if ($departmentExists > 0) {
            echo "Department already exists.";
        } else {
            // Prepare the SQL statement with placeholders
            $queryy = "INSERT INTO department (Department_name) VALUES (:Department_name)";
            $stmtt = $pdo->prepare($queryy);
            $stmtt->bindParam(':Department_name', $departmentName);
            
            // Execute the statement
            if ($stmtt->execute()) {
                echo "Department added successfully!";
            } else {
                echo "Failed to add Department. Please try again.";
            }
        }
    } catch (PDOException $e) {
        // Handle any errors
        echo "Error: " . $e->getMessage();
    }
}
?>