<?php
require_once '../db/db.php'; // Include your database connection file

if(isset($_POST['submit'])) {
    // Retrieve form data
    $employeeName = mysqli_real_escape_string($con, $_POST['employeeName']);
    $loanAmount = mysqli_real_escape_string($con, $_POST['loanAmount']);
    $type1 = mysqli_real_escape_string($con, $_POST['type1']);
    $institutionName = mysqli_real_escape_string($con, $_POST['institutionName']);
    $monthlyDeductions = mysqli_real_escape_string($con, $_POST['monthlyDeductions']);
    $reason = mysqli_real_escape_string($con, $_POST['reason']);

    // SQL query to insert data into the table
    $insertQuery = "INSERT INTO External_Loans (Employee_Name,type, Amount_Loaned, Institution_Name, Monthly_Deductions, Loan_Description, Date_Recorded)
       VALUES ('$employeeName','$type1', '$loanAmount', '$institutionName', '$monthlyDeductions', '$reason', NOW())";

    // Execute the query
    $result = mysqli_query($con, $insertQuery);

    // Check if the insertion was successful
    if ($result) {
        $err = '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert">&times;</button>
                    Loan record added successfully.
                </div>';
    } else {
        $err = '<div class="alert alert-danger" role="alert">
                    <button type="button" class="close" data-dismiss="alert">&times;</button>
                    Error adding loan record. Please try again.
                </div>';
    }
}
?>

<!-- Your HTML form for adding loan records goes here -->


<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-9">
            <?php if(isset($err)) { echo $err; } ?>
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=Payslipitems" style="color: rgb(7, 133, 164)">Payslip Items</a></li>
                <li><a href="index.php?p=SalaryAdvanceList" style="color: rgb(7, 133, 164)">Salary Advance</a></li>
                <li class="active">New External Loan</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>Record New External Loan</b></h3>
                </div>
                <div class="panel-body" style="background: #fff">
                    <form class="form-horizontal" action="" method="post">
                         <div class="form-group">
				<label for="employeeName">Employee Name</label>
<select class="form-control select" data-live-search="true" name="employeeName" id="employeeName">
    <?php
    // Establish connection and execute the query
    $selectQuery = "SELECT Name FROM Employee_Registration";
    $result = mysqli_query($con, $selectQuery);

    // Check if there are rows returned
    if ($result && mysqli_num_rows($result) > 0) {
        // Loop through each row and populate the dropdown options
        while ($row = mysqli_fetch_assoc($result)) {
            echo '<option value="' . $row['Name'] . '">' . $row['Name'] . '</option>';
        }
    } else {
        echo '<option value="">No employees found</option>';
    }
    ?>
</select>

			  </div>
			  <div class="form-group">
				<label for="loanAmount">Type</label>
				<input type="text" class="form-control" name="type1" id="type" value="External Loan" readonly>
			  </div>
			  <div class="form-group">
				<label for="loanAmount">Amount Loaned</label>
				<input type="number" class="form-control" name="loanAmount" id="loanAmount" placeholder="Enter loan amount">
			  </div>
			  <div class="form-group">
				<label for="institutionName">Institution Name</label>
				<input type="text" class="form-control" name="institutionName" id="institutionName" placeholder="Enter institution name">
			  </div>
			  <div class="form-group">
				<label for="monthlyDeductions">Monthly Deductions</label>
				<input type="number" class="form-control" name="monthlyDeductions" id="monthlyDeductions" placeholder="Enter monthly deductions">
			  </div>
			  <div class="form-group">
				<label for="reason">Loan description</label>
				<textarea class="form-control" name="reason" id="reason" placeholder="Enter loan details here"></textarea>
			  </div>
        </div>
                <div class="panel-footer">                                    
                 
		 	   <button type="submit" class="btn btn-primary" name="submit">Submit</button>
              </form>      
            </div>
    </div>
    <!-- END TIMELINE -->
</div>