<?php
require_once '../db/db.php'; // Include your database connection file

if(isset($_POST['submit'])) {
    // Retrieve form data
    $employeeName = mysqli_real_escape_string($con, $_POST['employeeName']);
$amount = mysqli_real_escape_string($con, $_POST['amount']);
$date = mysqli_real_escape_string($con, $_POST['date']);
$category = mysqli_real_escape_string($con, $_POST['category']);

$timestamp = strtotime($date);  
$month = date('n', $timestamp); 
$year = date('Y', $timestamp);  
		
 // SQL query to insert data into the table
    $stmt = $pdo->prepare("INSERT INTO allowances (employee_id,category,amount,date,month,year)
                        VALUES (:id,:category,:amount,:date,:month,:year)");
     $result = $stmt->execute([
            ':id'=>$employeeName,
            ':category'=>$category,
            ':amount'=>$amount,
            ':date'=>$date,
            ':month'=>$month,
            ':year'=>$year
         ])  ;                 
        
    // Check if the insertion was successful
    if ($result) {
        $err = '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert">&times;</button>
                    Allowance recorded successfully.
                </div>';
    } else {
        $err = '<div class="alert alert-danger" role="alert">
                    <button type="button" class="close" data-dismiss="alert">&times;</button>
                    Error adding loan record. Please try again.
                </div>';
    }
}
?>

<!-- Your HTML form for adding loan records goes here -->

<div class="col-md-9">
 <div class="row">
            <div class="col-md-10">
            <?php 
            if(isset($err)) { echo $err; } ?>
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=Payslipitems" style="color: rgb(7, 133, 164)">Payslip Items</a></li>
                <li><a href="index.php?p=allowances" style="color: rgb(7, 133, 164)">Allowances List</a></li>
                <li class="active">New Allowance</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>Record New Allowance</b></h3>
                </div>
                <div class="panel-body" style="background: #fff">
    <form class="form-horizontal" action="" method="post">
        <!-- First Row -->
        <div class="row">
            <div class="col-md-6">
                <div class="form-group">
                    <label for="employeeName">Employee Name</label>
                    <select class="form-control select" name="employeeName" id="employeeName">
                        <?php
                        // Establish connection and execute the query
                        $selectQuery = "SELECT id, CONCAT(Fname, ' ', Lname) AS FullName FROM Employee_Registration";
                        $result = mysqli_query($con, $selectQuery);
                        // Check if there are rows returned
                        if ($result && mysqli_num_rows($result) > 0) {
                            // Loop through each row and populate the dropdown options
                            while ($row = mysqli_fetch_assoc($result)) {
                                echo '<option value="' . $row['id'] . '">' . $row['FullName'] . '</option>';
                            }
                        } else {
                            echo '<option value="">No employees found</option>';
                        }
                        ?>
                    </select>
                </div>
            </div>
              <div class="col-md-6">
                <div class="form-group">
                    <label for="institutionName">Category</label>
                    <select class="form-control select" data-live-search="true" name="category" id="category">
					    <option value="">Select Allowance</option>
                        <option value="housing">Housing Allowance</option>
                        <option value="transport">Transport Allowance</option>
                        <option value="meal">Meal Allowance</option>
                        <option value="medical">Medical Allowance</option>
                        <option value="education">Education Allowance</option>
                        <option value="responsibility">Responsibility Allowance</option>
                        <option value="travel">Travel Allowance</option>
                        <option value="hardship">Hardship Allowance</option>
                        <option value="shift">Shift Allowance</option>
                        <option value="overtime">Overtime Allowance</option>
                        <option value="acting">Acting Allowance</option>
                        <option value="uniform">Uniform Allowance</option>

					</select>                
					</div>
            </div>
        </div><br/>

        <!-- Second Row -->
        <div class="row">
            <div class="col-md-6">
                <div class="form-group">
                    <label for="deductionStartDate">Date</label>
                    <input type="text" class="form-control datepicker datepicker-from" value="<?php echo date('Y-m-d');?>" name="date">
                </div>
            </div>
            <div class="col-md-6">
                <div class="form-group">
                    <label for="loanAmount">Amount</label>
                    <input type="number" class="form-control" name="amount" placeholder="Enter Amount">
                </div>
            </div>
        </div>
         
        </div>
        <div class="panel-footer">
            <button type="submit" class="btn btn-primary pull-right" name="submit">Submit</button>
        </div>
    </form>
</div>

    </div>
    <!-- END TIMELINE -->
</div>