<?php
require_once '../db/db.php';

$q = mysqli_query($con, "SELECT * FROM department ORDER BY Department_name ASC");
$num = mysqli_num_rows($q);
?>

<!-- Include SweetAlert JavaScript -->
<script src="https://cdn.jsdelivr.net/npm/sweetalert2@11"></script>

<?php if (isset($_GET['deleted']) && $_GET['deleted'] == 'true'): ?>
<script>
    Swal.fire({
        title: 'Deleted!',
        text: 'Department has been deleted successfully.',
        icon: 'success',
        timer: 2000, // Alert will auto-close after 2 seconds
        showConfirmButton: false
    });
</script>
<?php endif; ?>

<!-- Your existing HTML code -->
<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">COMPANY DEPARTMENT</h3>
                    <div class="pull-right">
                        <a href="index.php?p=add_department">
                            <button class="btn btn-warning">
                                <span class="fa fa-plus-circle"></span> Create New Department
                            </button>
                        </a>
                    </div>
                </div>
                <div class="panel-body">
                    <?php if ($num == 0): ?>
                        <p class='alert alert-info'>No any record added yet!!!</p>
                    <?php endif; ?>
                    <div class="table-responsive">
                        <table class="table datatable">
                            <thead>
                                <tr>
                                    <th>#</th>
                                    <th>Company Name</th> 
                                    <th>Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                $a = 1;
                                while ($rws = mysqli_fetch_array($q)) {
                                ?>
                                <tr>
                                    <td><?php echo $a; ?></td>
                                    <td><?php echo $rws['Department_name']; ?></td>
                                    <td>
                                        <a href="index.php?p=edit_department&id=<?php echo $rws['id']; ?>">
                                            <span class="fa fa-edit"></span> Edit
                                        </a> | 
                                        <a href="#" class="delete-btn" data-id="<?php echo $rws['id']; ?>">Delete</a>
                                    </td>
                                </tr>
                                <?php
                                $a++;
                                }
                                ?>
                            </tbody>
                        </table>   
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->                            
</div>

<!-- SweetAlert for Delete Confirmation -->
<script>
    document.querySelectorAll('.delete-btn').forEach(button => {
        button.addEventListener('click', function(event) {
            event.preventDefault(); // Prevent the default anchor behavior

            const Id = this.getAttribute('data-id');

            Swal.fire({
                title: 'Are you sure?',
                text: "You won't be able to revert this!",
                icon: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Yes, delete it!'
            }).then((result) => {
                if (result.isConfirmed) {
                    // Redirect to the PHP delete file with the department ID
                    window.location.href = 'delete_department.php?id=' + Id;
                }
            });
        });
    });
</script>
