<?php
if (isset($_GET['id'])) {
    $id = $_GET['id'];

   
    try {
        $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

        $stmt = $pdo->prepare("SELECT Department_name FROM department WHERE id = :id");
        $stmt->bindParam(':id', $id);
        $stmt->execute();
        $department = $stmt->fetch(PDO::FETCH_ASSOC);
       echo  $department_name = $department['Department_name'];

    } catch (PDOException $e) {
        $err = "<p class='alert alert-danger'>Database Error: " . $e->getMessage() . "</p>";
    }
}

if (isset($_POST['submit'])) {
    $department_name = $_POST['department'];

    if ($department_name == '') {
        $err = "<p class='alert alert-danger'>Please fill in the department name field.</p>";
    } else {
        try {
            $stmt = $pdo->prepare("UPDATE department SET Department_name = :department WHERE id = :id");
            $stmt->bindParam(':department', $department_name);
            $stmt->bindParam(':id', $id);
            $success = $stmt->execute();

            if ($success) {
                echo "<script src='https://cdn.jsdelivr.net/npm/sweetalert2@11'></script>";
                echo "<script>
                    Swal.fire({
                        icon: 'success',
                        title: 'Success',
                        text: 'Department updated successfully.',
                        confirmButtonText: 'OK'
                    }).then(function(){
                          window.location.href = 'index.php?p=department';
                    });
                </script>";
            } else {
                $err = "<p class='alert alert-danger'>Something went wrong! Contact system administrator.</p>";
            }
        } catch (PDOException $e) {
            $err = "<p class='alert alert-danger'>Database Error: " . $e->getMessage() . "</p>";
        }
    }
}
?>
<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>EDIT DEPARTMENT</b></h3>
                </div>
                <div class="panel-body" style="background: #fff">
                    <?php if(isset($err)){ echo $err;}?>
                    <form class="form-horizontal" method="post" action="">
                        <div class="form-group">
                            <label class="col-md-3 control-label">Department Name *</label>
                            <div class="col-md-6 col-xs-12">
                                <div class="input-group">
                                    <span class="input-group-addon"><span class="fa fa-pencil"></span></span>
                                    <input type="text" name="department" class="form-control" value="<?php echo isset($department_name) ? htmlspecialchars($department_name) : ''; ?>"/>
                                </div>
                            </div>
                        </div>
                </div>
                <div class="panel-footer">
                    <button class="btn btn-warning pull-right" type="submit" name="submit"><span class="fa fa-save"></span> Update</button>
                </div>
                </form>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>
