<?php
error_reporting(E_ALL);
ini_set('display_errors', 1);

if (isset($_POST['submit'])) {
    $month = $_POST['month'];
    $year = $_POST['year'];
    $currentDate = date('Y-m-d');
    
    $totalSalary = 0;
    $totalAllowances = 0;
    $totalDeductions = 0;
    
    $allowances = 0;
    $salaryArrears = 0;
    $paye = 0;
    $salaryAdvance = 0;
    $loans = 0;

    // Check if payroll exists
    $stmtcheck = $pdo->prepare("SELECT * FROM payroll WHERE payrollMonth = :month AND year = :year");
    $stmtcheck->bindValue(':month', $month);
    $stmtcheck->bindValue(':year', $year);
    $stmtcheck->execute();
    $checkResult = $stmtcheck->fetch(PDO::FETCH_ASSOC);

    if ($checkResult) {
        echo "<script src='https://cdn.jsdelivr.net/npm/sweetalert2@11'></script>";
        echo "<script>
            Swal.fire({
                icon: 'warning',
                title: 'Payroll Exists',
                text: 'Payroll for this month and year already exists!',
                confirmButtonText: 'OK'
            });
        </script>";
    } else {
        try {
            // Insert into payroll
            $payrollstmt = $pdo->prepare("INSERT INTO payroll 
                (payrollMonth, year, salary, allowances, deduction, created_at, created_by)
                VALUES (:month, :year, :salary, :allowances, :deduction, :created_at, :created_by)");
            
            $payrollstmt->bindValue(':month', $month);
            $payrollstmt->bindValue(':year', $year);
            $payrollstmt->bindValue(':salary', $totalSalary);
            $payrollstmt->bindValue(':allowances', $totalAllowances);
            $payrollstmt->bindValue(':deduction', $totalDeductions);
            $payrollstmt->bindValue(':created_at', $currentDate);
            $payrollstmt->bindValue(':created_by', $_SESSION['id']);
            
            $payrollstmt->execute();
            $payrollId = $pdo->lastInsertId();

            // Selecting all employees
            $stmtemployee = $pdo->prepare("SELECT * FROM Employee_Registration");
            $stmtemployee->execute();
            $employees = $stmtemployee->fetchAll(PDO::FETCH_ASSOC);

            foreach ($employees as $employee) {
                $baseSalary = $employee['amount'];
                $employeeId = $employee['id'];
                $tradeUni = $employee['trade_union_amount'] ?? '';
                $tradeUniCategory = $employee['trade_union_category'] ?? '';
                
                $totalSalary += $baseSalary;
                $nhif = $employee['employee_nhif_per']; 
                $fund = $employee['fund_employee_per']; 
                
                //calculate trade union amount
                 
                $tradeUnion = ($tradeUniCategory == 'Percent') ? $baseSalary * $tradeUni / 100 : $tradeUni;

                
                
                 //calculate allowance
                 
                $allowancestmt = $pdo->prepare("SELECT SUM(amount) as amount  FROM allowances WHERE employee_id = :employee_id
                                                AND month =:month AND year =:year");
                $allowancestmt -> bindValue(':employee_id',$employeeId);
                $allowancestmt -> bindValue(':month',$month);
                $allowancestmt -> bindValue(':year',$year);
                $allowancestmt ->execute();
                $allowance = $allowancestmt->fetch(PDO::FETCH_ASSOC);
                $allowances +=$allowance['amount'] ;
                
                $totalAllowances += $allowances;
                
                $grossSalary = $baseSalary + $allowances;
                
                $pension = $grossSalary * $fund/100; 
                
                $insurance = $grossSalary * $nhif/100;
                
                //calculate sdl
                $sdl = $grossSalary * 3.5/100;
                
                //calculate wcf
                if($employee['wcf']===1){
                $wcf = $grossSalary * 0.5/100;
                }
                else{
                   $wcf = ''; 
                }
                //calculate paye
                $taxableIncome = $grossSalary-$insurance-$pension;
                
                if($taxableIncome <= 270000){
                    $paye = 0;
                }
                elseif($taxableIncome >270000 && $taxableIncome <= 520000){
                    $paye = ($taxableIncome -270000)*8/100 ;
                }
                elseif($taxableIncome > 520000 && $taxableIncome <= 760000){
                    $paye = ($taxableIncome -520000)*20/100 + 20000;
                    
                }
                elseif($taxableIncome > 760000 && $taxableIncome <= 1000000){
                    $paye = ($taxableIncome -760000)*25/100 + 68000;
                }
                else{
                     $paye = ($taxableIncome -1000000)*30/100 + 128000 ;
                }
                
                $totalDeductions = $paye + $pension + $insurance;
                
                // Insert into payroll_employees
                $payrollempstmt = $pdo->prepare("INSERT INTO payroll_employees 
                    (payrollId, employeeId, grossSalary, allowances, salaryArrears, paye, pension, insuarance, salaryAdvance, loans,tradeUnion,sdl,wcf)
                    VALUES (:payrollId, :employeeId, :grossSalary, :allowances, :salaryArrears, :paye, :pension, :insuarance, :salaryAdvance, :loans,:tradeUnion,:sdl,:wcf)");

                $payrollempstmt->bindValue(':payrollId', $payrollId);
                $payrollempstmt->bindValue(':employeeId', $employeeId);
                $payrollempstmt->bindValue(':grossSalary', $grossSalary);
                $payrollempstmt->bindValue(':allowances', $allowances);
                $payrollempstmt->bindValue(':salaryArrears', $salaryArrears);
                $payrollempstmt->bindValue(':paye', $paye);
                $payrollempstmt->bindValue(':pension', $pension);
                $payrollempstmt->bindValue(':insuarance', $insurance);
                $payrollempstmt->bindValue(':salaryAdvance', $salaryAdvance);
                $payrollempstmt->bindValue(':loans', $loans);
                $payrollempstmt->bindValue(':tradeUnion',$tradeUnion);
                $payrollempstmt->bindValue(':sdl',$sdl);
                $payrollempstmt->bindValue(':wcf',$wcf);
                
                $payrollempstmt->execute();
            }

            // Update payroll with total salary
            $updateStmt = $pdo->prepare("UPDATE payroll SET salary = :salary, allowances = :allowances, deduction = :deduction WHERE id = :payrollId");
            $updateStmt->bindValue(':salary', $totalSalary);
            $updateStmt->bindValue(':payrollId', $payrollId);
            $updateStmt->bindValue(':allowances', $totalAllowances);
            $updateStmt->bindValue(':deduction', $totalDeductions);
            $updateStmt->execute();

            // Success message
            echo "<script src='https://cdn.jsdelivr.net/npm/sweetalert2@11'></script>";
            echo "<script>
                Swal.fire({
                    icon: 'success',
                    title: 'Payroll Created Successfully',
                    text: 'Payroll created successfully.',
                    confirmButtonText: 'OK'
                }).then(function() {
                    window.location.href='index.php?p=salarySlips'; // Redirect to the list page
                });
            </script>";

        } catch (PDOException $e) {
            echo "Error: " . $e->getMessage();
        }
    }
}
?>
<div class="col-md-9">  
<div class="row">
    <div class="col-md-12">
        <div class="panel panel-default">
            <div class="panel-heading">
            <ul class="breadcrumb" style="height: 40px;padding-top: 10px;">
                <li><a href="index.php?p=salarySlips" style="color: rgb(7, 133, 164)"> Payroll</a></li>
                <li class="active">Payroll Report</li>
            </ul>
                <h3 class="panel-title"><b>CREATE PAYROLL</b></h3>
            </div>
          <div class="panel-body">
               <center>
                    <img src="../logo/load.gif" id="loading" style="display:none">
                </center> 
               <div class="row">
                <form action="" method="post">
                    <div class="form-group col-md-4">
                        <label for="month">Month</label>
                        <select class="form-control select" id="month" name="month" required>
                            <option value="" disabled selected>Select Month</option>
                            <option value="1">January</option>
                            <option value="2">February</option>
                            <option value="3">March</option>
                            <option value="4">April</option>
                            <option value="5">May</option>
                            <option value="6">June</option>
                            <option value="7">July</option>
                            <option value="8">August</option>
                            <option value="9">September</option>
                            <option value="10">October</option>
                            <option value="11">November</option>
                            <option value="12">December</option>
                        </select>
                    </div>
                    <div class="form-group col-md-4" >
                        <label for="year">Year</label>
                        <select class="form-control select" id="year" name="year" required>
                        </select>
                    </div>
          </div>
        </div>
         <div class="panel-footer">
             <button type="submit" name = "submit" class="btn btn-primary pull-right" style="background: #f39121;border: none;">
            <span class="fa fa-plus-circle"></span> Create Payroll
        </button>
        </div>
    </form>
</div>
 <script>
        // JavaScript to dynamically populate the year dropdown
        document.addEventListener('DOMContentLoaded', function () {
            const yearSelect = document.getElementById('year');
            const currentYear = new Date().getFullYear();
            for (let year = currentYear; year >= 2010; year--) {
                const option = document.createElement('option');
                option.value = year;
                option.text = year;
                yearSelect.appendChild(option);
            }
        });
    </script>
