<?php

if (isset($_GET['month']) && isset($_GET['year'])) {
    $month = $_GET['month'];
    $year = $_GET['year'];

    try {
        // Fetch payroll data using a prepared statement
        $stmt = $pdo->prepare("
            SELECT 
                pe.*, 
                er.Fname, er.Lname, er.Bank_Name, er.Bank_Account_No 
            FROM 
                payroll_employees pe 
            INNER JOIN 
                Employee_Registration er ON pe.employeeId = er.id 
            INNER JOIN 
                payroll pa ON pa.id = pe.payrollId
            WHERE 
                pa.payrollMonth = :month AND pa.year = :year
        ");
        $stmt->execute(['month' => $month, 'year' => $year]);
        $payrollData = $stmt->fetchAll(PDO::FETCH_ASSOC);
        
    } catch (Exception $e) {
        echo "Error: " . $e->getMessage();
    }
}
?>

    <style>
        /* CSS to style the table */
        table {
            border-collapse: collapse;
            border: 1px solid black; /* Set border color and thickness */
            width: 100%; /* Set table width to 100% of its container */
        }

        th {
            border: 1px solid black; /* Set border for table cells */
            padding: 8px; /* Add padding for better readability */
            text-align: center; /* Center-align text within cells */
            height:20px;
            color:black;
        }
        td {
            border: 1px solid black; /* Set border for table cells */
            padding: 8px; /* Add padding for better readability */
            height:20px;
            color:black;
        }
    </style>
<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>PAYROLL REPORT</b></h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                        <button class="btn btn-default" onclick="printContent()">
                            <span class="fa fa-print"></span> Print Report
                        </button>
                        <button class="btn btn-default" onclick="exportToExcel()">
                            <span class="fa fa-print"></span> Export To Excel
                        </button>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                 <div id="printingArea">    
                  <table id="myTable">
    <tr>
        <th colspan=16><?php echo $_SESSION['Company'];?></th>
    </tr>
    <tr>
        <th colspan=16>BRANCH: <?php echo $_SESSION['Branch'];?></th>
    </tr>
    <tr>
        <th colspan=16>PAYROLL REPORT</th>
    </tr>
    <tr style="font-weight:bold">
        <th rowspan="2">#</th>
        <th rowspan="2">Name</th>
        <th colspan="2" align="center">Earnings</th>
        <th rowspan="2">Gross Earnings</th>
        <th colspan="5" align="center">Deductions</th>
        <th rowspan="2">Total<br/>Deductions</th>
        <th rowspan="2">Net Salary</th>
        <th colspan="2" align="center">Bank Details</th>
    </tr>
    <tr>
        <th>Basic Salary</th>
        <th>Allowances</th>
        <th>PAYE</th>
        <th>Pension<br/>(NSSF / PSSSF)</th>
        <th>Insurance<br/>(NHIF)</th>
        <th>Salary<br/>Advance</th>
        <th>Loans</th>
        <th>Bank</th>
        <th>Account</th>
    </tr>
    
    <?php if (!empty($payrollData)): ?>
        <?php foreach ($payrollData as $index => $row): ?>
        <tr>
            <td><?php echo $index + 1; ?></td>
            <td><?php echo $row['Fname'] . ' ' . $row['Lname']; ?></td>
            <td><?php echo $row['grossSalary']; ?></td>
            <td><?php echo $row['allowances']; ?></td>
            <td><?php echo $row['grossSalary'] + $row['allowances']; ?></td>
            <td><?php echo $row['paye']; ?></td>
            <td><?php echo $row['pension']; ?></td>
            <td><?php echo $row['insuarance']; ?></td>
            <td><?php echo $row['salaryAdvance']; ?></td>
            <td><?php echo $row['loans']; ?></td>
            <td><?php echo $row['paye'] + $row['pension'] + $row['insurance'] + $row['salaryAdvance'] + $row['loans']; ?></td>
            <td><?php echo ($row['grossSalary'] + $row['allowances']) - ($row['paye'] + $row['pension'] + $row['insurance'] + $row['salaryAdvance'] + $row['loans']); ?></td>
            <td><?php echo $row['Bank_Name']; ?></td>
            <td><?php echo $row['Bank_Account_No']; ?></td>
        </tr>
        <?php endforeach; ?>
    <?php else: ?>
        <tr>
            <td colspan="16">No records found for the selected month and year.</td>
        </tr>
    <?php endif; ?>
</table>
     
                 </div>       
                </div>
                <div class="panel-footer">                                    
      
                 </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>
<script>
    var currentDate = new Date();
    var formattedDate = currentDate.toISOString().slice(0, 10);

    document.querySelector('.datepicker-from').value = formattedDate;
    document.querySelector('.datepicker-to').value = formattedDate;

</script>
<script>
    function printContent() {
        var content = document.getElementById('printingArea').innerHTML;
        var printWindow = window.open('', '_blank');
        printWindow.document.write('<html><head><title>Print</title>');
        printWindow.document.write('<style>table { border-collapse: collapse; border: 1px solid black; width: 100%; } th, td { border: 1px solid black; padding: 8px; text-align: center; height: 20px; color: black; } a { color: black; text-decoration: none; } </style>');
        printWindow.document.write('</head><body>');
        printWindow.document.write(content);
        printWindow.document.write('</body></html>');
        printWindow.document.close();
        printWindow.print();
    }

    function exportToExcel() {
        // Get the HTML table element
        var table = document.getElementById('printingArea'); // Replace 'tableId' with the ID of your table

        // Convert the HTML table to a worksheet
        var wb = XLSX.utils.table_to_book(table);

        // Generate a binary string from the XLSX workbook
        var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });

        // Create a Blob object representing the data as an Excel file
        var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

        // Create a temporary anchor element and trigger a download
        var link = document.createElement('a');
        link.href = window.URL.createObjectURL(blob);
        link.download = 'purchase_supplier_trans.xlsx'; // Change 'filename' to your desired filename
        link.click();
    }

    // Utility function to convert a string to an ArrayBuffer
    function s2ab(s) {
        var buf = new ArrayBuffer(s.length);
        var view = new Uint8Array(buf);
        for (var i = 0; i < s.length; i++) {
            view[i] = s.charCodeAt(i) & 0xFF;
        }
        return buf;
    }
</script>
