<?php
require_once '../db/db.php'; // Include your database connection file

if(isset($_POST['submit'])) {
    // Retrieve form data
    $employeeName = mysqli_real_escape_string($con, $_POST['employeeName']);
    $type1 = mysqli_real_escape_string($con, $_POST['type1']);
    $advanceAmount = mysqli_real_escape_string($con, $_POST['advanceAmount']);
    $date = mysqli_real_escape_string($con, $_POST['date']);
    $paidFrom = mysqli_real_escape_string($con, $_POST['sourceAccount']);
    $ledgerAccount = mysqli_real_escape_string($con, $_POST['ledgerAccount']);
    $amtPay = mysqli_real_escape_string($con, $_POST['amtPay']);;
    $paid = 0;
    $due = $advanceAmount;
   $institutionName = $_SESSION['Company'];
    
    
 // SQL query to insert data into the table
    $stmt = $pdo->prepare("INSERT INTO loans_salary (emplId,type,amount,amtPay,paid,due,institution,Date)
                        VALUES (:id,:type,:amount,:amtPay,:paid,:due,:institution,:date)");
     $result = $stmt->execute([
            ':id'=>$employeeName,
            ':type'=>$type1,
            ':amount'=>$advanceAmount,
            ':amtPay'=>$amtPay,
            ':paid'=>$paid,
            ':due'=>$due,
            ':institution'=>$institutionName,
            ':date'=>$date
         ])  ;                 
        
    // Check if the insertion was successful
    if ($result) {
        $err = '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert">&times;</button>
                    Salary advance recorded successfully.
                </div>';
    } else {
        $err = '<div class="alert alert-danger" role="alert">
                    <button type="button" class="close" data-dismiss="alert">&times;</button>
                    Error adding loan record. Please try again.
                </div>';
    }
}
?>

<!-- Your HTML form for adding loan records goes here -->

<div class="col-md-9">
 <div class="row">
            <div class="col-md-10">
            <?php 
            if(isset($err)) { echo $err; } ?>
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=Payslipitems" style="color: rgb(7, 133, 164)">Payslip Items</a></li>
                <li><a href="index.php?p=SalaryAdvanceList" style="color: rgb(7, 133, 164)">Salary Advance</a></li>
                <li class="active">New Salary Advance</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>Record New Salary Advance</b></h3>
                </div>
                <div class="panel-body" style="background: #fff">
    <form class="form-horizontal" action="" method="post">
        <!-- First Row -->
        <div class="row">
            <div class="col-md-6">
                <div class="form-group">
                    <label for="employeeName">Employee Name</label>
                    <select class="form-control select" data-live-search="true" name="employeeName" id="employeeName">
                        <?php
                        // Establish connection and execute the query
                        $selectQuery = "SELECT id, Name FROM Employee_Registration";
                        $result = mysqli_query($con, $selectQuery);
                        // Check if there are rows returned
                        if ($result && mysqli_num_rows($result) > 0) {
                            // Loop through each row and populate the dropdown options
                            while ($row = mysqli_fetch_assoc($result)) {
                                echo '<option value="' . $row['id'] . '">' . $row['Name'] . '</option>';
                            }
                        } else {
                            echo '<option value="">No employees found</option>';
                        }
                        ?>
                    </select>
                </div>
            </div>
            <div class="col-md-6">
                <div class="form-group">
                    <label for="loanAmount">Type</label>
                    <input type="text" class="form-control" name="type1" id="type" value="Salary Advance" readonly>
                </div>
            </div>
        </div><br/>

        <!-- Second Row -->
        <div class="row">
            <div class="col-md-6">
                <div class="form-group">
                    <label for="deductionStartDate">Date</label>
                    <input type="text" class="form-control datepicker datepicker-from" value="<?php echo date('Y-m-d');?>" name="date" id="deductionStartDate" placeholder="Enter deduction start date">
                </div>
            </div>
            <div class="col-md-6">
                <div class="form-group">
                    <label for="loanAmount">Amount Advanced</label>
                    <input type="number" class="form-control" name="advanceAmount" id="advanceAmount" placeholder="Enter Advanced amount">
                </div>
            </div>
        </div>

        <!-- Third Row -->
        <div class="row"><br/>
            <div class="col-md-6">
                <div class="form-group">
                    <label for="institutionName">Paid From</label>
                    <select class="form-control select" data-live-search="true" name="sourceAccount" id="sourceAccount">
					  <option value="account1">-Select Account-</option>
					  <?php
                        // Establish connection and execute the query
                        $select = "SELECT * FROM bank_accounts";
                        $result = mysqli_query($con, $select);
                        // Check if there are rows returned
                        if ($result && mysqli_num_rows($result) > 0) {
                            // Loop through each row and populate the dropdown options
                            while ($row = mysqli_fetch_assoc($result)) {
                                echo '<option value="' . $row['account_code'] . '">' . $row['bank_account_name'] . '</option>';
                            }
                        } else {
                            echo '<option value="">No employees found</option>';
                        }
                        ?>
					</select>                
					</div>
            </div>
            <div class="col-md-6">
                <div class="form-group">
                    <label for="monthlyDeductions">Ledger Account</label>
                    <select class="form-control select" data-live-search="true" name="ledgerAccount" id="ledgerAccount">
					  <option value="account1">-Select Account-</option>
					  <?php
                        // Establish connection and execute the query
                        $selectQ = "SELECT * FROM chart_master";
                        $results = mysqli_query($con, $selectQ);
                        // Check if there are rows returned
                        if ($result && mysqli_num_rows($results) > 0) {
                            // Loop through each row and populate the dropdown options
                            while ($rows = mysqli_fetch_assoc($results)) {
                                echo '<option value="' . $rows['account_code'] . '">' . $rows['account_name'] . '</option>';
                            }
                        } else {
                            echo '<option value="">No employees found</option>';
                        }
                        ?>
					</select>         
				</div>
            </div>
        </div>
          <!-- Fourth Row -->
        <div class="row"><br/>
            <div class="col-md-6">
                <div class="form-group">
                    <label for="loanAmount">Amount To Pay</label>
                    <input type="number" class="form-control" name="amtPay" id="amtPay" placeholder="Enter amount">
                </div>
            </div>
        </div>
        </div>
        <div class="panel-footer">
            <button type="submit" class="btn btn-primary pull-right" name="submit">Submit</button>
        </div>
    </form>
</div>

    </div>
    <!-- END TIMELINE -->
</div>