<?php
try {
    $pdo = new PDO($dsn, $username, $password);
    $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    if (isset($_GET['id'])) {
        $id = $_GET['id'];

        $query = "SELECT * FROM TransferManagement lm INNER JOIN Employee_Registration us ON lm.empid = us.id WHERE lm.id = :id ";
        $stmt = $pdo->prepare($query);
        $stmt->bindParam(':id', $id);
        $stmt->execute();

        $rows = $stmt->fetch(PDO::FETCH_ASSOC);
        
        $status = $rows['status'];
            if ($status == '1') {
                $statusLabel = '<span class="label label-warning">Pending</span>';
            } elseif ($status == '2') {
                $statusLabel = '<span class="label label-success">Approved</span>';
            } elseif ($status == '3') {
                $statusLabel = '<span class="label label-danger">Denied</span>';
            } else {
                $statusLabel = '<span class="label label-default">Unknown</span>';
            }

    } 
} catch (PDOException $e) {
    http_response_code(500);
    echo json_encode(['message' => 'Database error', 'status' => 500, 'error' => $e->getMessage()]);
}
?>

<div class="col-md-9">
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><strong>Transfer Details</strong></h3>
                </div>
                <div class="panel-body">
                    <div class="col-lg-5">
                        <div class="box">
                            <div class="box-body">
                                <table class="table table-striped">
                                    <tr>
                                        <?php
                                         $ename = explode(' ', $rows['Name']);
                                         $name = ucfirst(strtolower($ename[0]))." ".ucfirst(strtolower($ename[1]));
                                         
                                         $aname = explode(' ', $rows['user']);
                                         $nameapp = ucfirst(strtolower($aname[0]))." ".ucfirst(strtolower($aname[1]));
                                        ?>
                                        <td>Employee Name</td>
                                        <td><?php echo $name; ?></td>
                                    </tr>
                                    <!--<tr>
                                        <td>Employee No.</td>
                                        <td>ID.<?php //echo $rows['id'];?></td>
                                    </tr>-->
                                    <tr>
                                        <td>Reason</td>
                                        <td><?php echo $rows['transfer_reason'];?></td>
                                    </tr>
                                    <tr>
                                        <td>Transfer Date</td>
                                        <td><?php echo $rows['transfer_date'];?></td>
                                    </tr>
                                    <tr>
                                        <td>Transfer To</td>
                                        <td><?php echo $rows['transfer_to'];?></td>
                                    </tr>
                                    <tr>
                                        <td>Leave Type</td>
                                        <td><?php echo $rows['transfer_type'];?></td>
                                    </tr>
                                    <tr>
                                        <td>Documents</td>
                                        <td><a target = '_blank' href = "<?php echo $rows['transfer_attachment'];?>"><span class="fa fa-file"></span> View Document</a></td>
                                    </tr>
                                 </table>
                            </div>
                        </div>
                    </div>
                    
                    <div class="col-lg-5">
                        <div class="box">
                          <div class="box-body">
                            <div class="tasks">
                              <?php
                               if($rows['status'] == 1){
                              ?>
                              <div class="task-item task-info task-complete">                                    
                                <div class="task-text">Leave Application</div>
                                <div class="task-footer">
                                    <div class="pull-left"><?php echo $statusLabel;?></div>                                    
                                </div>                                    
                             </div>
                             <?php
                               }elseif($rows['status'] == 2){
                             ?>
                             <div class="task-item task-success task-complete">                                    
                                <div class="task-text"><?php echo $rows['note'];?></div>
                                <div class="task-footer">
                                    <div class="pull-left"><span class="fa fa-user"></span> <?php echo $nameapp;?></div>
                                    <div class="pull-right"><?php echo $statusLabel;?></div>
                                </div>                                    
                             </div>
                             <?php
                               }else{
                             ?>
                             <div class="task-item task-danger task-complete">                                    
                                <div class="task-text"><?php echo $rows['note'];?></div>
                                <div class="task-footer">
                                    <div class="pull-left"><span class="fa fa-user"></span> <?php echo $nameapp;?></div>
                                    <div class="pull-right"><?php echo $statusLabel;?></div>                                   
                                </div>                                    
                             </div>
                             <?php
                               }
                             ?>
                           </div> 
                        </div>
                    </div>
                </div>    
            </div>
        </div>
    </div>
</div>