<?php
$supplier = mysqli_real_escape_string($con, $_GET['supplier']);
$date1 = mysqli_real_escape_string($con, $_GET['date1']);
$date2 = mysqli_real_escape_string($con, $_GET['date2']);

// SQL Query to fetch purchases by supplier
$sql = "SELECT
            s.name AS supplier_name, 
            p.purchase_id, 
            p.purchase_date, 
            p.total_amount, 
            p.paid, 
            p.due 
        FROM 
            supplier AS s
        INNER JOIN 
            purchase_invoice AS p 
        ON 
            s.id = p.supplier_id 
            AND p.branchno = '" . $_SESSION['Branch'] . "' 
            AND p.purchase_date BETWEEN '$date1' AND '$date2'";

if (!empty($supplier)) {
    $sql .= " WHERE s.id = '$supplier'";
}

$sql .= " ORDER BY s.name";
$result = $con->query($sql);
?>
<style>
    /* CSS to style the table */
    table {
        border-collapse: collapse;
        border: 1px solid black; /* Set border color and thickness */
        width: 100%; /* Set table width to 100% of its container */
    }

    th {
        border: 1px solid black; /* Set border for table cells */
        padding: 8px; /* Add padding for better readability */
        text-align: center; /* Center-align text within cells */
        height:20px;
        color:black;
    }
    td {
        border: 1px solid black; /* Set border for table cells */
        padding: 8px; /* Add padding for better readability */
        height:20px;
        color:black;
    }
</style>
<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=purchases" style="color: rgb(7, 133, 164)">Purchases Menu</a></li>
                <li class="active">Purchases By Supplier Report</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>PURCHASES BY SUPPLIER REPORT</b></h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                        <button class="btn btn-default" onclick="printTable()">
                            <span class="fa fa-print"></span> Print Report
                        </button>
                        <button class="btn btn-default" onclick="exportToExcel()">
                            <span class="fa fa-download"></span> Export To Excel
                        </button>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                    <center id="printingArea">
                     
                        <table id="myTable">
                            <thead>
                                <tr>
                                   <th  colspan="6" style="text-align:center">
                                       <?php echo $_SESSION['Company']; ?>
                                   </th> 
                                </tr>
                                <tr>
                                    <th colspan="6" style="text-align:center">
                                      <?php echo strtoupper($_SESSION['Branch']); ?>
                                    </th>
                                </tr>
                                <tr>
                                    <th colspan="6" style="text-align:center">
                                        PURCHASES BY SUPPLIER REPORT
                                    </th>
                                </tr>
                                <tr style="height:30px;">
                                    <th style="width:20%">Supplier Name</th>
                                    <th style="width:10%">Purchase No#</th>
                                    <th style="width:15%">Purchase Date</th>
                                    <th style="width:15%">Total Amount</th>
                                    <th style="width:15%">Paid</th>
                                    <th style="width:15%">Due</th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                $total_amount = 0;
                                $total_paid = 0;
                                $total_due = 0;

                                while ($row = mysqli_fetch_assoc($result)) {
                                    $supplierName = $row["supplier_name"];
                                    $purchaseNo = $row["purchase_id"];
                                    $purchaseDate = $row["purchase_date"];
                                    $totalAmount = $row["total_amount"];
                                    $paid = $row["paid"];
                                    $due = $row["due"];

                                    $total_amount += $totalAmount;
                                    $total_paid += $paid;
                                    $total_due += $due;
                                    ?>
                                    <tr>
                                        <td style="padding-left:10px;"><?php echo htmlspecialchars($supplierName); ?></td>
                                        <td style="padding-left:10px;"><?php echo htmlspecialchars($purchaseNo); ?></td>
                                        <td style="padding-left:10px;"><?php echo htmlspecialchars($purchaseDate); ?></td>
                                        <td align="right" style="padding-right:10px;"><?php echo number_format($totalAmount, 2); ?></td>
                                        <td align="right" style="padding-right:10px;"><?php echo number_format($paid, 2); ?></td>
                                        <td align="right" style="padding-right:10px;"><?php echo number_format($due, 2); ?></td>
                                    </tr>
                                <?php
                                }
                                ?>
                                <tr>
                                    <td colspan="3" style="text-align:left"><b>TOTAL:</b></td>
                                    <td align="right"><b><?php echo number_format($total_amount, 2); ?></b></td>
                                    <td align="right"><b><?php echo number_format($total_paid, 2); ?></b></td>
                                    <td align="right"><b><?php echo number_format($total_due, 2); ?></b></td>
                                </tr>
                            </tbody>
                        </table>
                    </center>
                </div>
                <div class="panel-footer"></div>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>
<script>
function printTable() {
    var content = document.getElementById('printingArea').innerHTML;
    var printWindow = window.open('', '_blank');
    printWindow.document.write('<html><head><title>Print Table</title></head><body>');
    printWindow.document.write('<style>table { border-collapse: collapse; width: 100%; } th, td { border: 1px solid black; padding: 8px; }</style>');
    printWindow.document.write(content);
    printWindow.document.write('</body></html>');
    printWindow.document.close();
    printWindow.print();
}

function exportToExcel() {
    var table = document.getElementById('myTable'); // Correct ID of the table

    var wb = XLSX.utils.table_to_book(table);
    var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });
    var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

    var link = document.createElement('a');
    link.href = window.URL.createObjectURL(blob);
    link.download = 'purchase_by_supplier_report.xlsx'; // Change 'filename' to your desired filename
    link.click();
}

function s2ab(s) {
    var buf = new ArrayBuffer(s.length);
    var view = new Uint8Array(buf);
    for (var i = 0; i < s.length; i++) {
        view[i] = s.charCodeAt(i) & 0xFF;
    }
    return buf;
}
</script>
