<?php
if (isset($_POST['general_ledger'])) {
    $supplier = mysqli_real_escape_string($con, $_POST['supplier']);
    $date1 = mysqli_real_escape_string($con, $_POST['date1']);
    $date2 = mysqli_real_escape_string($con, $_POST['date2']);
    
    if (empty($supplier)) {
        echo "
        <script src='https://cdn.jsdelivr.net/npm/sweetalert2@11'></script>
        <script>
            Swal.fire({
                icon: 'warning',
                title: 'Supplier Required',
                text: 'Please select supplier before proceeding.',
                confirmButtonText: 'OK'
            }).then(() => {
                window.history.back(); // Redirects user back to the form
            });
        </script>";
        exit; // Stop further execution
    }
    // Constructing the URL with form attributes
    $redirectURL = 'index.php?p=purchase_analysis_report&supplier=' . urlencode($supplier) . '&date1=' . urlencode($date1) . '&date2=' . urlencode($date2);
    // Redirect to the report page
    echo "<script>window.location='$redirectURL';</script>";
}
?>

<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
            <li><a href="index.php?p=purchases" style="color: rgb(7, 133, 164)">Purchases Menu</a></li>
                    <li class="active">Purchases Analysis by Item</li>
                        </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>PURCHASE ANALYSIS BY ITEM</b></h3>
                </div>
                <div class="panel-body" style="background: #fff">
                    <form class="form-horizontal" action="" method="post">
                        <div class="form-group">                                
                            <div class="col-md-6 col-xs-12">
                                <select class="form-control select" data-live-search="true" name="supplier">
                                    <option value="">--- Select Supplier ---</option>
                                    <?php
                                    $supplierQuery = mysqli_query($con, "SELECT * FROM supplier WHERE branchno = '".$_SESSION['Branch']."'");
                                    foreach ($supplierQuery as $rs) {
                                    ?>
                                        <option value="<?php echo $rs['id']; ?>"><?php echo $rs['name']; ?></option>
                                    <?php
                                    }
                                    ?>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">
                            <div class="col-md-3">From
                                <div class="input-group">
                                    <span class="input-group-addon"><span class="fa fa-calendar"></span></span>
                                    <input type="text" class="form-control datepicker datepicker-from" value="<?php echo date('Y-m-d'); ?>" name="date1">
                                </div>
                            </div>
                            <div class="col-md-3">To
                                <div class="input-group">
                                    <span class="input-group-addon"><span class="fa fa-calendar"></span></span>
                                    <input type="text" class="form-control datepicker datepicker-to" value="<?php echo date('Y-m-d'); ?>" name="date2">
                                </div>
                            </div>
                        </div>
                        <div class="panel-footer">
                            <button class="btn btn-warning pull-right" type="submit" name="general_ledger"><span class="fa fa-plus-circle"></span> Create</button>
                        </div>
                    </form>      
                </div>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>
<script>
    var currentDate = new Date();
    var formattedDate = currentDate.toISOString().slice(0, 10);

    document.querySelector('.datepicker-from').value = formattedDate;
    document.querySelector('.datepicker-to').value = formattedDate;
</script>
