<?php
$date1 = $_GET['date1'];
$date2 = $_GET['date2'];
$branch = $_GET['branch'];
$status = 'Purchase Invoice';
$date3 = date('d-m-Y', strtotime($_GET['date1']));
$date4 = date('d-m-Y', strtotime($_GET['date2']));

if ($date1 !== $date2) {
    $date_condition = "p.purchase_date BETWEEN '$date1' AND '$date2'";
    $note = "PURCHASES FROM {$date3} TO {$date4}";
} else {
    $date_condition = "p.purchase_date = '$date1'";
    $note = "PURCHASES FOR DATE: {$date3}";
}

if ($branch == 'All') {
    $sql = "SELECT
                SUM(p.total_amount) as total_amount,
                s.name,
                p.supplier_id,
                p.branchno
            FROM
                purchase_invoice AS p
            INNER JOIN
                supplier AS s ON p.supplier_id = s.id
            WHERE
                $date_condition AND p.status = ?
            GROUP BY
                p.supplier_id";

    $stmt = $con->prepare($sql);
    $stmt->bind_param("s", $status);
    $stmt->execute();
    $result = $stmt->get_result();
} else { // For a specific branch
    $sql = "SELECT
                SUM(p.total_amount) as total_amount,
                s.name,
                p.supplier_id,
                p.branchno
            FROM
                purchase_invoice AS p
            INNER JOIN
                supplier AS s ON p.supplier_id = s.id
            WHERE
                $date_condition AND p.branchno = ? AND p.status = ?
            GROUP BY
                p.supplier_id";

    $stmt = $con->prepare($sql);
    $stmt->bind_param("ss", $branch, $status);
    $stmt->execute();
    $result = $stmt->get_result();
}
?>

<style>
    /* CSS to style the table */
    table {
        border-collapse: collapse;
        border: 1px solid black;
        width: 100%;
    }

    th, td {
        border: 1px solid black;
        padding: 8px;
        text-align: center;
        height: 20px;
        color: black;
    }
</style>

<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=purchases" style="color: rgb(7, 133, 164)">Purchases Menu</a></li>
                <li class="active">Supplier Summary Report</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>PURCHASE INVOICE TOTALS BY SUPPLIER REPORT</b></h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                        <button class="btn btn-default" onclick="printContent()">
                            <span class="fa fa-print"></span> Print Report
                        </button>
                        <button class="btn btn-default" onclick="exportToExcel()">
                            <span class="fa fa-download"></span> Export To Excel
                        </button>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                    <div id="printingArea">    
                        <table id="myTable">
                            <tr>
                                <th colspan=7><?php echo $_SESSION['Company']; ?></th>
                            </tr>
                            <tr>
                                <th colspan=7>BRANCH: <?php echo $_GET['branch']; ?></th>
                            </tr>
                            <tr>
                                <th colspan=7><?php echo $_GET['description']; ?></th>
                            </tr>
                            <tr>
                                <th colspan=7><?php echo $note; ?></th>
                            </tr>
                            <tr style="font-weight:bold">
                                <td colspan="6">SUPPLIER</td>
                                <td align="right">AMOUNT</td>
                            </tr>
                            <?php
                            $total_amount = 0;
                            $total_paid = 0;
                            foreach ($result as $rows) {
                                $total_amount += $rows['total_amount'];
                                $total_paid += $rows['paid'];
                                $balance = $total_amount - $total_paid;
                            ?>
                            <tr>
                                <td colspan="6" style="text-align: left"><?php echo $rows['name']; ?></td>
                                <td align="right"><a href="index.php?p=purchases_supplier_invoices&date1=<?php echo $date1; ?>&date2=<?php echo $date2; ?>&branch=<?php echo $rows['branchno']; ?>&supplier_id=<?php echo $rows['supplier_id']; ?>&supplier_name=<?php echo $rows['name']; ?>"><?php echo number_format($rows['total_amount'], 2); ?></a></td>
                            </tr>
                            <?php
                            }
                            ?>
                            <tr>
                                <td colspan="6" style="text-align: left"><b>Total</b></td>
                                <td align="right"><b><?php echo number_format($total_amount, 2); ?></b></td>
                            </tr>
                        </table>      
                    </div>       
                </div>
                <div class="panel-footer"></div>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>

<script>
    var currentDate = new Date();
    var formattedDate = currentDate.toISOString().slice(0, 10);

    document.querySelector('.datepicker-from').value = formattedDate;
    document.querySelector('.datepicker-to').value = formattedDate;

    function printContent() {
        var content = document.getElementById('printingArea').innerHTML;
        var printWindow = window.open('', '_blank');
        printWindow.document.write('<html><head><title>Print</title>');
        printWindow.document.write('<style>table { border-collapse: collapse; border: 1px solid black; width: 100%; } th, td { border: 1px solid black; padding: 8px; text-align: center; height: 20px; color: black; } a { color: black; text-decoration: none; } </style>');
        printWindow.document.write('</head><body>');
        printWindow.document.write(content);
        printWindow.document.write('</body></html>');
        printWindow.document.close();
        printWindow.print();
    }

    function exportToExcel() {
        var table = document.getElementById('printingArea');
        var wb = XLSX.utils.table_to_book(table);
        var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });
        var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });
        var link = document.createElement('a');
        link.href = window.URL.createObjectURL(blob);
        link.download = 'supplier_summary_report.xlsx';
        link.click();
    }

    function s2ab(s) {
        var buf = new ArrayBuffer(s.length);
        var view = new Uint8Array(buf);
        for (var i = 0; i < s.length; i++) {
            view[i] = s.charCodeAt(i) & 0xFF;
        }
        return buf;
    }
</script>
