<?php
$cuid = $_GET['supplier'];
$date1 = $_GET['date1'];
$date2 = $_GET['date2'];

$cuquery = mysqli_query($con, "SELECT * FROM supplier WHERE id = $cuid");
$cudata = mysqli_fetch_assoc($cuquery);
$customer = $cudata['name'];

?>

<style>
    table {
        border-collapse: collapse;
        width: 100%;
    }

    th, td {
        border: 1px solid black;
        padding: 8px;
    }

    th {
        background-color: #fff;
    }

    .right-align {
        text-align: right;
    }
</style>

<div class="col-md-9">
    <div class="panel panel-default">
        <div class="panel-heading">
            <h3 class="panel-title"><b>CUSTOMER TRANSACTIONS</b></h3>
            <div class="pull-right">
                <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                <button class="btn btn-default" onclick="exportToExcel()">
                    <span class="fa fa-print"></span> Export To Excel
                </button>
                <button class="btn btn-default" onclick="printTable()">
                    <span class="fa fa-print"></span> Export To PDF
                </button>
            </div>
        </div>
        <div class="panel-body" style="background: #fff">
            <table id="myTable">
                <tr>
                    <th colspan="5" style="text-align: center;"><b><?php echo $_SESSION['Company']; ?></b></th>
                </tr>
                <tr>
                    <th colspan="5" style="text-align: center;"><b>BRANCH: <?php echo $_SESSION['Branch']; ?></b></th>
                </tr>
                <tr>
                    <th colspan="5" style="text-align: center;"><b>SUPPLIER: <?php echo $customer; ?></b></th>
                </tr>
                <tr>
                    <th colspan="5" style="text-align: center;"><b>TRANSACTIONS REPORT FROM: <?php echo $date1; ?> TO <?php echo $date2; ?></b></th>
                </tr>
                <tr>
                    <th style="text-align: center">Date</th>
                    <th style="text-align: center">Description</th>
                    <th class="right-align">Invoiced</th>
                    <th class="right-align">Payments</th>
                    <th class="right-align">Balance</th>
                </tr>

                <?php
                $sum_debit = 0;
                $sum_credit = 0;
                $balance = 0;

                // Fetch invoices (Debit)
                $sql = mysqli_query($con, "SELECT * FROM purchase_invoice WHERE supplier_id='$cuid' AND status = 'Purchase Invoice'");
                foreach ($sql as $row) {
                    $debit = $row['total_amount'];
                    $sum_debit += $debit;
                    $balance += $debit;
                ?>
                    <tr>
                        <td><?php echo $row['purchase_date']; ?></td>
                        <td>Invoice#<?php echo $row['purchase_id']; ?> --- <?php echo $row['note']; ?></td>
                        <td class="right-align"><?php echo number_format($debit, 2); ?></td>
                        <td class="right-align">-</td>
                        <td class="right-align"><?php echo number_format($balance, 2); ?></td>
                    </tr>

                    <?php
                    // Fetch receipt (if any) for this invoice
                    $receipt_sql = mysqli_query($con, "SELECT * FROM payment_transactions_details WHERE reference='" . $row['purchase_id'] . "' AND payee='$cuid'");
                    while ($receipt = mysqli_fetch_assoc($receipt_sql)) {
                        $credit = $receipt['total'];
                        $sum_credit += $credit;
                        $balance -= $credit;
                    ?>
                        <tr>
                            <td><?php echo $receipt['date']; ?></td>
                            <td>Receipt#<?php echo $receipt['id']; ?> --- <?php echo $receipt['note']; ?></td>
                            <td class="right-align">-</td>
                            <td class="right-align"><?php echo number_format($credit, 2); ?></td>
                            <td class="right-align"><?php echo number_format($balance, 2); ?></td>
                        </tr>
                    <?php
                    }
                    ?>

                <?php
                }
                ?>

                <tr>
                    <td colspan="2" class="right-align"><b>Total</b></td>
                    <td class="right-align"><b><?php echo number_format($sum_debit, 2); ?></b></td>
                    <td class="right-align"><b><?php echo number_format($sum_credit, 2); ?></b></td>
                    <td class="right-align"><b><?php echo number_format($balance, 2); ?></b></td>
                </tr>
                <tr>
                    <td colspan="4" class="right-align"><b>Total Invoiced</b></td>
                    <td class="right-align"><b><?php echo number_format($sum_debit, 2); ?></b></td>
                </tr>
                <tr>
                    <td colspan="4" class="right-align"><b>Total Payments</b></td>
                    <td class="right-align"><b><?php echo number_format($sum_credit, 2); ?></b></td>
                </tr>
                <tr>
                    <td colspan="4" class="right-align"><b>Remaining Balance</b></td>
                    <td class="right-align"><b><?php echo number_format($balance, 2); ?></b></td>
                </tr>
            </table>
        </div>
    </div>
</div>

<script>
    var currentDate = new Date();
    var formattedDate = currentDate.toISOString().slice(0, 10);

    document.querySelector('.datepicker-from').value = formattedDate;
    document.querySelector('.datepicker-to').value = formattedDate;


function exportToExcel() {
    // Get the HTML table element
    var table = document.querySelector('table');
    
    // Set the border color to black for all table cells
    var cells = table.querySelectorAll('th, td');
    cells.forEach(function(cell) {
        cell.style.border = "1px solid black";
    });

    // Convert the HTML table to a worksheet
    var wb = XLSX.utils.table_to_book(table, {sheet: "Sheet1", raw: true});

    // Style the Excel sheet with borders
    wb.Sheets["Sheet1"]["!cols"] = [{wch: 15}, {wch: 30}, {wch: 15}]; // Adjust column widths as needed
    wb.Sheets["Sheet1"]["!rows"] = [{hpx: 20}]; // Set row height

    // Generate a binary string from the XLSX workbook
    var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });

    // Create a Blob object representing the data as an Excel file
    var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

    // Create a temporary anchor element and trigger a download
    var link = document.createElement('a');
    link.href = window.URL.createObjectURL(blob);
    link.download = 'customer_transactions.xlsx'; // Change 'filename' to your desired filename
    link.click();
}

// Utility function to convert a string to an ArrayBuffer
function s2ab(s) {
    var buf = new ArrayBuffer(s.length);
    var view = new Uint8Array(buf);
    for (var i = 0; i < s.length; i++) {
        view[i] = s.charCodeAt(i) & 0xFF;
    }
    return buf;
}

function exportToPDF() {
    // Get the HTML table element
    var table = document.querySelector('table');

    // Initialize jsPDF
    var doc = new jsPDF();

    // Add header
    doc.setFontSize(16);
    doc.text("CUSTOMER TRANSACTIONS", 10, 10);

    // Add table using autotable plugin
    doc.autoTable({
        html: table,
        startY: 20,
        theme: 'plain', // Use 'grid' for borders
        styles: { fillColor: [255, 255, 255], textColor: [0, 0, 0], lineWidth: 0.1 },
        headStyles: { fillColor: [200, 200, 200], textColor: [0, 0, 0], lineWidth: 0.1 },
        bodyStyles: { textColor: [0, 0, 0], lineWidth: 0.1 }
    });

    // Save the PDF
    doc.save('table.pdf');
    }

    function printTable() {
        // Apply border style to table cells
        var cells = document.querySelectorAll('td, th');
        cells.forEach(function(cell) {
            cell.style.border = '1px solid black';
        });

        // Print only the table
        var printWindow = window.open('', '_blank');
        printWindow.document.open();
        printWindow.document.write('<html><head><title>Print Table</title></head><body>');
        printWindow.document.write('<style>table { border-collapse: collapse; width: 100%; } th, td { border: 1px solid black; padding: 8px; }</style>');
        printWindow.document.write(document.getElementById('myTable').outerHTML);
        printWindow.document.write('</body></html>');
        printWindow.document.close();
        printWindow.print();

        // Remove border style after printing
        cells.forEach(function(cell) {
            cell.style.border = '';
        });
    }
</script>
