<?php

$date1 = $_GET['date1'];
$date2 = $_GET['date2'];
$branch = $_GET['branch'];
$account = $_GET['account'];
$status = 'Purchase Invoice';
$date3 = date('d-m-Y', strtotime($_GET['date1']));
$date4 = date('d-m-Y', strtotime($_GET['date2']));

if ($date1 !== $date2) {
    $date_condition = "p.purchase_date BETWEEN '$date1' AND '$date2'";
    $note = "PURCHASE FROM {$date3} TO {$date4}";
} else {
    $date_condition = "p.purchase_date = '$date1'";
    $note = "PURCHASE FOR DATE: {$date3}";
}

if ($branch == 'All') {
    $sql = "SELECT
                *
            FROM
                purchase_invoice AS p
            INNER JOIN
                supplier AS s ON p.supplier_id = s.id
            WHERE
                $date_condition  AND p.status=? AND due > 0
            ORDER BY
                p.purchase_date ASC";

    $stmt = $con->prepare($sql);
    $stmt->bind_param("s", $status);
} else { // For a specific branch
    $sql = "SELECT
                *
            FROM
                purchase_invoice AS p
            INNER JOIN
                supplier AS s ON p.supplier_id = s.id
            WHERE
                $date_condition AND p.branchno = ? AND p.status=? AND due > 0
            ORDER BY
                p.purchase_date ASC";

    $stmt = $con->prepare($sql);
    $stmt->bind_param("ss", $branch, $status);
}

$stmt->execute();
$result = $stmt->get_result();
?>

<style>
    table {
        border-collapse: collapse;
        border: 1px solid black;
        width: 100%;
    }

    th, td {
        border: 1px solid black;
        padding: 8px;
        height: 20px;
        color: black;
        text-align: center;
    }
</style>

<div class="col-md-9">
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=purchases" style="color: rgb(7, 133, 164)">Purchases Menu</a></li>
                <li class="active">Supplier Unpaid Invoices Reports</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>PURCHASE SUPPLIER UNPAID INVOICES</b></h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()"><span class="fa fa-arrow-left"></span> Go Back</button>
                        <button class="btn btn-default" onclick="printContent()"><span class="fa fa-print"></span> Print Report</button>
                        <button class="btn btn-default" onclick="exportToExcel()"><span class="fa fa-download"></span> Export To Excel</button>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                    <div id="printingArea">
                        <table id="myTable">
                            <tr>
                                <th colspan=7><?php echo $_SESSION['Company']; ?></th>
                            </tr>
                            <tr>
                                <th colspan=7>BRANCH: <?php echo $_GET['branch']; ?></th>
                            </tr>
                            <tr>
                                <th colspan=7><?php echo $_GET['description']; ?></th>
                            </tr>
                            <tr>
                                <th colspan=7><?php echo $note; ?></th>
                            </tr>
                            <tr style="font-weight: bold">
                                <td>DATE</td>
                                <td>CUSTOMER</td>
                                <td>INVOICE#</td>
                                <td>AMOUNT</td>
                            </tr>

                            <?php
                            $balance = 0;
                            foreach ($result as $rows) {
                                $purchase_id = $rows['purchase_id'];
                                $qr = mysqli_query($con, "SELECT SUM(total) AS total FROM payment_transactions_details WHERE reference = $purchase_id AND category='payment'");
                                $rss = mysqli_fetch_assoc($qr);
                                $amount_due = $rows['total_amount'] - $rss['total'];

                                if ($amount_due > 0) { // Only display rows with amount greater than 0
                                    $balance += $amount_due;
                                    ?>
                                    <tr>
                                        <td><?php echo date('d-m-Y', strtotime($rows['invoice_date'])); ?></td>
                                        <td><?php echo $rows['name']; ?></td>
                                        <td>INVOICE# - <?php echo $rows['purchase_id']; ?></td>
                                        <td>
                                            <a href="index.php?p=purchase_items&id=<?php echo $rows['purchase_id']; ?>&supplier=<?php echo $rows['supplier_id']; ?>">
                                                <?php echo number_format($amount_due, 2); ?>
                                            </a>
                                        </td>
                                    </tr>
                                    <?php
                                }
                            }
                            ?>
                            <tr>
                                <td colspan="3" align="left"><b>Total</b></td>
                                <td align="right"><b><?php echo number_format($balance, 2); ?></b></td>
                            </tr>
                        </table>
                    </div>
                </div>
                <div class="panel-footer"></div>
            </div>
        </div>
    </div>
</div>
<script>
    var currentDate = new Date();
    var formattedDate = currentDate.toISOString().slice(0, 10);

    document.querySelector('.datepicker-from').value = formattedDate;
    document.querySelector('.datepicker-to').value = formattedDate;

    function printContent() {
        var content = document.getElementById('printingArea').innerHTML;
        var printWindow = window.open('', '_blank');
        printWindow.document.write('<html><head><title>Print</title>');
        printWindow.document.write('<style>table { border-collapse: collapse; border: 1px solid black; width: 100%; } th, td { border: 1px solid black; padding: 8px; text-align: center; height: 20px; color: black; } a { color: black; text-decoration: none; } </style>');
        printWindow.document.write('</head><body>');
        printWindow.document.write(content);
        printWindow.document.write('</body></html>');
        printWindow.document.close();
        printWindow.print();
    }

    function exportToExcel() {
        // Get the HTML table element
        var table = document.getElementById('printingArea'); // Replace 'tableId' with the ID of your table

        // Convert the HTML table to a worksheet
        var wb = XLSX.utils.table_to_book(table);

        // Generate a binary string from the XLSX workbook
        var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });

        // Create a Blob object representing the data as an Excel file
        var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

        // Create a temporary anchor element and trigger a download
        var link = document.createElement('a');
        link.href = window.URL.createObjectURL(blob);
        link.download = 'PURCHASE SUPPLIER UNPAID INVOICES.xlsx'; // Change 'filename' to your desired filename
        link.click();
    }

    // Utility function to convert a string to an ArrayBuffe
    function s2ab(s) {
        var buf = new ArrayBuffer(s.length);
        var view = new Uint8Array(buf);
        for (var i = 0; i < s.length; i++) {
            view[i] = s.charCodeAt(i) & 0xFF;
        }
        return buf;
    }
</script>
