<?php

$date1 = $_GET['date1'];
$date2 = $_GET['date2'];
$branch = $_GET['branch'];
$account = $_GET['account'];
$status = 'Purchase Invoice';
$date3 = date('d-m-Y', strtotime($date1));
$date4 = date('d-m-Y', strtotime($date2));

if ($date1 !== $date2) {
    $date_condition = "p.purchase_date BETWEEN '$date1' AND '$date2'";
    $note = "PURCHASES FROM {$date3} TO {$date4}";
} else {
    $date_condition = "p.purchase_date = '$date1'";
    $note = "PURCHASES FOR DATE: {$date3}";
}

if ($branch == 'All') {
    $sql = "(
                SELECT
                    p.purchase_date, s.name AS supplier_name, 
                    p.purchase_id, p.total_amount, IFNULL(SUM(td.total), 0) AS total,  -- Sum of all payments for the same purchase_id
                    'Purchase Invoice' AS type
                FROM
                    purchase_invoice AS p
                INNER JOIN
                    supplier AS s ON p.supplier_id = s.id
                LEFT JOIN payment_transactions_details td ON p.purchase_id = td.reference
                    AND td.category = 'payment'
                WHERE
                    $date_condition
                AND p.status = ?
                GROUP BY p.purchase_id  -- Group by purchase_id to sum payments for the same invoice
            )
            UNION
            (
                SELECT
                    p.purchase_date, s.name AS supplier_name, 
                    p.purchase_id, p.total_amount, IFNULL(SUM(td.total), 0) AS total,  -- Sum of all payments for the same purchase_id
                    'Cash Purchase' AS type
                FROM
                    purchases AS p
                INNER JOIN
                    supplier AS s ON p.supplier_id = s.id
                LEFT JOIN payment_transactions_details td ON p.purchase_id = td.reference
                    AND td.category = 'Cash Purchase'
                WHERE
                    $date_condition
                GROUP BY p.purchase_id  -- Group by purchase_id to sum payments for the same invoice
            )
            ORDER BY purchase_date ASC";

    $stmt = $con->prepare($sql);
    $stmt->bind_param("s", $status);
    $stmt->execute();
    $result = $stmt->get_result();
} else { // For a specific branch
    $sql = "(
                SELECT
                    p.purchase_date, s.name AS supplier_name, 
                    p.purchase_id, p.total_amount, IFNULL(SUM(td.total), 0) AS total,  -- Sum of all payments for the same purchase_id
                    'Purchase Invoice' AS type
                FROM
                    purchase_invoice AS p
                INNER JOIN
                    supplier AS s ON p.supplier_id = s.id
                LEFT JOIN payment_transactions_details td ON p.purchase_id = td.reference
                    AND td.category = 'payment'
                WHERE
                    $date_condition
                AND p.branchno = ?
                AND p.status = ?
                GROUP BY p.purchase_id  -- Group by purchase_id to sum payments for the same invoice
            )
            UNION
            (
                SELECT
                    p.purchase_date, s.name AS supplier_name, 
                    p.purchase_id, p.total_amount, IFNULL(SUM(td.total), 0) AS total,  -- Sum of all payments for the same purchase_id
                    'Cash Purchase' AS type
                FROM
                    purchases AS p
                INNER JOIN
                    supplier AS s ON p.supplier_id = s.id
                LEFT JOIN payment_transactions_details td ON p.purchase_id = td.reference
                    AND td.category = 'Cash Purchase'
                WHERE
                    $date_condition
                AND p.branchno = ?
                GROUP BY p.purchase_id  -- Group by purchase_id to sum payments for the same invoice
            )
            ORDER BY purchase_date ASC";

    $stmt = $con->prepare($sql);
    $stmt->bind_param("sss", $branch, $status, $branch);
    $stmt->execute();
    $result = $stmt->get_result();
}
?>


<style>
    /* CSS to style the table */
    table {
        border-collapse: collapse;
        border: 1px solid black; /* Set border color and thickness */
        width: 100%; /* Set table width to 100% of its container */
    }

    th {
        border: 1px solid black; /* Set border for table cells */
        padding: 8px; /* Add padding for better readability */
        text-align: center; /* Center-align text within cells */
        height:20px;
        color:black;
    }
    td {
        border: 1px solid black; /* Set border for table cells */
        padding: 8px; /* Add padding for better readability */
        height:20px;
        color:black;
    }
</style>

<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=purchases" style="color: rgb(7, 133, 164)">Purchases Menu</a></li>
                <li class="active">Purchase Report</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>PURCHASE REPORT</b></h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                        <button class="btn btn-default" onclick="printTable()">
                            <span class="fa fa-print"></span> Print Report
                        </button>
                        <button class="btn btn-default" onclick="exportToExcel()">
                            <span class="fa fa-download"></span> Export To Excel
                        </button>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                    <div id="printingArea">    
                        <table id="myTable">
                            <tr>
                                <th colspan=8><?php echo $_SESSION['Company'];?></th>
                            </tr>
                            <tr>
                                <th colspan=8>BRANCH: <?php echo $_GET['branch'];?></th>
                            </tr>
                            <tr>
                                <th colspan=8><?php echo $_GET['description'];?></th>
                            </tr>
                            <tr>
                                <th colspan=8><?php echo $note;?></th>
                            </tr>
                            <tr style="font-weight:bold">
                                <td>DATE</td>
                                <td>SUPPLIER</td>
                                <td>TRANSID</td>
                                <td>AMOUNT</td>
                                <td>PAID</td>
                                <td>DUE</td>
                                <td>TYPE</td>
                            </tr>
                            <?php
                            $total_amount = 0;
                            $total_paid = 0;
                            $balance = 0;

                            while($rows = $result->fetch_assoc()) {
                                $total_amount += $rows['total_amount'];
                                $total_paid += $rows['total'];
                                $balance = $total_amount - $total_paid;
                            ?>
                            <tr>
                                <td><?php echo date('d-m-Y',strtotime($rows['purchase_date']));?></td>
                                <td><?php echo $rows['supplier_name'];?></td>
                                <td>TRANSID - #<?php echo $rows['purchase_id'];?></td>
                                <td><?php echo number_format($rows['total_amount'],2);?></td>
                                <td><?php echo number_format($rows['total'],2);?></td>
                                <td><?php echo number_format($rows['total_amount']-$rows['total'],2);?></td>
                                <td><?php echo $rows['type'];?></td>
                            </tr>
                            <?php
                            }
                            ?>
                            <tr>
                                <td colspan="3"><b>Total</b></td>
                                <td><b><?php echo number_format($total_amount,2);?></b></td>
                                <td><b><?php echo number_format($total_paid,2);?></b></td>
                                <td><b><?php echo number_format($balance,2);?></b></td>
                                <td><b></b></td>
                            </tr>
                        </table>      
                    </div>       
                </div>
                <div class="panel-footer"></div>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>

<script src="https://cdnjs.cloudflare.com/ajax/libs/xlsx/0.18.5/xlsx.full.min.js"></script>
<script>
function printTable() {
    var content = document.getElementById('printingArea').innerHTML;
    var printWindow = window.open('', '_blank');
    printWindow.document.write('<html><head><title>Print Table</title></head><body>');
    printWindow.document.write('<style>table { border-collapse: collapse; width: 100%; } th, td { border: 1px solid black; padding: 8px; }</style>');
    printWindow.document.write(content);
    printWindow.document.write('</body></html>');
    printWindow.document.close();
    printWindow.print();
}

function exportToExcel() {
    var table = document.getElementById('myTable'); // Correct ID of the table

    var wb = XLSX.utils.table_to_book(table);
    var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });
    var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

    var link = document.createElement('a');
    link.href = window.URL.createObjectURL(blob);
    link.download = 'purchase_report.xlsx'; // Change 'filename' to your desired filename
    link.click();
}

function s2ab(s) {
    var buf = new ArrayBuffer(s.length);
    var view = new Uint8Array(buf);
    for (var i = 0; i < s.length; i++) {
        view[i] = s.charCodeAt(i) & 0xFF;
    }
    return buf;
}
</script>
