<?php
session_start(); // Start the session to use $_SESSION['Branch']


    if (isset($_POST['submit'])) {
        $name = strtoupper(filter_input(INPUT_POST, 'name', FILTER_SANITIZE_STRING));
        $branch = $_SESSION['Branch'];
        $tzcode = '255';
        $location = strtoupper(filter_input(INPUT_POST, 'area', FILTER_SANITIZE_STRING));
        $phone11 = filter_input(INPUT_POST, 'phone1', FILTER_SANITIZE_STRING);
        $email = filter_input(INPUT_POST, 'email', FILTER_SANITIZE_EMAIL);
        $tin = filter_input(INPUT_POST, 'tin', FILTER_SANITIZE_STRING);
        $vrn = filter_input(INPUT_POST, 'vrn', FILTER_SANITIZE_STRING);
        $phone1 = $tzcode . $phone11;

        if ($name == '') {
            $err = "<p class='alert alert-danger'>Fill all fields please !!!</p>";
        } elseif (strlen($phone11) != 9) {
            $err = "<p class='alert alert-danger'>Invalid phone number !!! Don't Start with +255 or 0 </p>";
        } else {
            $stmt = $pdo->prepare("SELECT COUNT(*) FROM supplier WHERE name = :name AND phone = :phone");
            $stmt->bindParam(':name', $name);
            $stmt->bindParam(':phone', $phone1);
            $stmt->execute();
            $count = $stmt->fetchColumn();

            if ($count > 0) {
                $err = "<p class='alert alert-warning'>Supplier Exist !!!</p>";
            } else {
                $stmt = $pdo->prepare("INSERT INTO supplier (name, location, phone, email, branchno, tin, vrn) 
                VALUES (:name, :location, :phone, :email, :branchno, :tin, :vrn)");
                $stmt->bindParam(':name', $name);
                $stmt->bindParam(':location', $location);
                $stmt->bindParam(':phone', $phone1);
                $stmt->bindParam(':email', $email);
                $stmt->bindParam(':branchno', $branch);
                $stmt->bindParam(':tin', $tin);
                $stmt->bindParam(':vrn', $vrn);

                if ($stmt->execute()) {
                    $err = "<p class='alert alert-success'>Supplier Submitted successfully.</p>";
                } else {
                    $err = "<p class='alert alert-danger'>Something wrong!!! Contact your system Administrator</p>";
                }
            }
        }
    }

?>


                            <div class="col-md-9">

                            <!-- START TIMELINE -->
                            <div class="row">
                            <div class="col-md-12">
                                <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                                <li><a href="index.php?p=purchases" style="color: rgb(7, 133, 164)">Purchase Menu</a></li>
                                <li><a href="index.php?p=supplier" style="color: rgb(7, 133, 164)">Suppliers List</a></li>
                                <li class="active">Suppliers Add</li>
                                </ul>

                               <div class="panel panel-default">
                                <div class="panel-heading">
                                    <h3 class="panel-title"><b>CREATE NEW SUPPLIER</b></h3>
                                    <div class="pull-right">
                                        <a href="index.php?p=supplier"><button class="btn btn-warning"> <span class="fa fa-plus-circle"></span> View Suppliers</button></a>
                                    </div>
                                </div>
                                <div class="panel-body" style="background: #fff">
                                    <?php if(isset($err)){ echo $err;}?>
                                    <!--<center><img src="../logo/load.gif" id="loading" style="display:none"></center>    -->
                                    <form action="" method="post">
                                    <div class="row"> 
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                        <div class="col-md-12 col-xs-12">                      
                                            <div class="input-group">
                                                <span class="input-group-addon">Name</span>
                                                <input type="text" name = "name" class="form-control" placeholder="Enter Name or Business" />
                                            </div>                                            
                                        </div>
                                       </div>                     
                                     </div>
                                      <div class="col-md-4">  
                                      <div class="form-group">
                                        <div class="col-md-12 col-xs-12">                                     
                                            <div class="input-group">
                                                <span class="input-group-addon"><b>+255(0)</b></span>
                                                <input type="text" name = "phone1" class="form-control" placeholder="Enter Mobile Number" />
                                            </div>                                            
                                        </div>
                                      </div>                     
                                     </div>
                                   </div>

                                    <br/><br/>
                                    <div class="row"> 
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon">Address</span>
                                                <input type="text" name = "area" class="form-control" placeholder="Enter Address" />
                                            </div>              
                                        </div>
                                     </div>                    
                                     </div>
                                      <div class="col-md-4">  
                                      <div class="form-group">
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon">Email</span>
                                                <input type="text" name = "email" class="form-control" placeholder="Enter Email" />
                                            </div>              
                                        </div>
                                     </div>                    
                                     </div>

                                    </div>
                                   <br><br/>
                                   <div class="row"> 
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon">TIN</span>
                                                <input type="text" name = "tin" class="form-control" placeholder="Enter TIN" />
                                            </div>              
                                        </div>
                                     </div>                    
                                     </div>
                                      <div class="col-md-4">  
                                      <div class="form-group">
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon">VRN</span>
                                                <input type="text" name = "vrn" class="form-control" placeholder="Enter VRN" />
                                            </div>              
                                        </div>
                                     </div>                    
                                     </div>

                                    </div>
                                   <br><br/>
                                </div>
                                <div class="panel-footer">               
                                    <button class="btn btn-info pull-right" type = "submit" name = "submit"><span class="fa fa-plus-circle"></span> Add</button>
                                </div>
                            </form>
                            </div>
                          </div>
                        </div>
                            <!-- END TIMELINE -->                            
                        </div>