<?php
// Get input parameters
$date1 = $_GET['date1'];
$branch = $_GET['branch'];
$description = $_GET['description'];
$status = 'Purchase Invoice';

// Ensure input parameters are properly escaped
$date1 = mysqli_real_escape_string($con, $date1);
$branch = mysqli_real_escape_string($con, $branch);

$date_condition = "i.purchase_date <= '$date1'";

// SQL query to fetch customer names and related invoice details
if ($branch == 'All') {
    $customerQuery = "SELECT
                i.purchase_date,
                i.due_date,
                c.name AS customer_name,
                c.id AS customer_id,
                i.purchase_id,
                i.total_amount,
                IFNULL(SUM(td.total), 0) AS amount_paid,
                (i.total_amount - IFNULL(SUM(td.total), 0)) AS unpaid_amount
            FROM
                purchase_invoice AS i
            INNER JOIN
                supplier AS c ON i.supplier_id = c.id
            LEFT JOIN payment_transactions_details td ON i.purchase_id = td.reference
                AND td.category = 'payment'
            WHERE
                $date_condition
                AND i.status = '$status'
            GROUP BY i.purchase_id
            HAVING unpaid_amount > 0
            ORDER BY
                i.purchase_date ASC";
} else {
    $customerQuery = "SELECT
                i.purchase_date,
                i.due_date,
                c.name AS customer_name,
                c.id AS customer_id,
                i.purchase_id,
                i.total_amount,
                IFNULL(SUM(td.total), 0) AS amount_paid,
                (i.total_amount - IFNULL(SUM(td.total), 0)) AS unpaid_amount
            FROM
                purchase_invoice AS i
            INNER JOIN
                supplier AS c ON i.supplier_id = c.id
            LEFT JOIN payment_transactions_details td ON i.purchase_id = td.reference
                AND td.category = 'payment'
            WHERE
                $date_condition
                AND i.branchno = '$branch'
                AND i.status = '$status'
            GROUP BY i.purchase_id
            HAVING unpaid_amount > 0
            ORDER BY
                i.purchase_date ASC";
}

$customerResult = mysqli_query($con, $customerQuery);
?>

<style>
    /* CSS to style the table */
    table {
        border-collapse: collapse;
        border: 1px solid black; /* Set border color and thickness */
        width: 100%; /* Set table width to 100% of its container */
    }

    th {
        border: 1px solid black; /* Set border for table cells */
        padding: 8px; /* Add padding for better readability */
        text-align: center; /* Center-align text within cells */
        height:20px;
        color:black;
    }
    td {
        border: 1px solid black; /* Set border for table cells */
        padding: 8px; /* Add padding for better readability */
        height:20px;
        color:black;
    }

    @media print {
        thead { display: table-header-group; }
    }
</style>

<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=sales" style="color: rgb(7, 133, 164)">Services Menu</a></li>
                <li class="active">Customer Aged Report</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>CUSTOMER AGED RECEIVED REPORT</b></h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                       <button class="btn btn-default" onclick="printTable()">
                            <span class="fa fa-print"></span> Print Report
                        </button>
                        <button class="btn btn-default" onclick="exportToExcel()">
                            <span class="fa fa-print"></span> Export To Excel
                        </button>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                     <div id="myTable" class="table-responsive">
                        <table id="printingArea">
                            <tr>
                                <th colspan=15><?php echo $_SESSION['Company'];?></th>
                            </tr>
                            <tr>
                                <th colspan=15>BRANCH: <?php echo strtoupper($branch);?></th>
                            </tr>
                            <tr>
                                <th colspan=15><?php echo $description;?></th>
                            </tr>
                            <tr>
                                <th colspan=15>DATE AS TO: <?php echo $date1;?></th>
                            </tr>
                            <tr style="font-weight:bold">
                                <td style="text-align:left">Customer</td>
                                <td>PurchaseNo#</td>
                                <td>Purchase Date</td>
                                <td>Purchase Days</td>
                                <td>Days Outstanding</td>
                                <td>Not Due</td>
                                <td>1-30 Days</td>
                                <td>31-60 Days</td>
                                <td>61-90 Days</td>
                                <td>91-120 Days</td>
                                <td>121-150 Days</td>
                                <td>151-180 Days</td>
                                <td>Over 180 Days</td>
                                <td>Status</td>
                            </tr>
                            <?php
                                $total_0_30 = 0;
                                $total_31_60 = 0;
                                $total_61_90 = 0;
                                $total_91_120 = 0;
                                $total_121_150 = 0;
                                $total_151_180 = 0;
                                $total_over_180 = 0;
                                $total_invoice_days = 0; // New total for invoice days
                                
                                while ($row = mysqli_fetch_array($customerResult)) {
                                    $name = $row["customer_name"];
                                    $invoice = $row["purchase_id"];
                                    $dueDate = $row["due_date"];
                                    $invoiceDate = $row["purchase_date"];
                                    $due = $row["unpaid_amount"];
                                
                                    $daysPastMaturity = floor((strtotime($date1) - strtotime($dueDate)) / (60 * 60 * 24));
                                if ($daysPastMaturity < 0) {
                                        $daysPastMaturity = 0;
                                    }
                                    // Calculate the difference between due_date and invoice_date
                                    $paymentDays = floor((strtotime($dueDate) - strtotime($invoiceDate)) / (60 * 60 * 24));
                                
                                    if ($daysPastMaturity <= 0) {
                                        $agingBracket = 'Not Due';
                                        $total_invoice_days += $due; // Accumulate the total for invoices still within their due period
                                        $status = '<button type="button" class="btn btn-success btn-xs">Current</button>';
                                    } elseif ($daysPastMaturity <= 30) {
                                        $agingBracket = '0-30 Days';
                                        $total_0_30 += $due;
                                        $status = '<button type="button" class="btn btn-success btn-xs">Overdue</button>';
                                    } elseif ($daysPastMaturity <= 60) {
                                        $agingBracket = '31-60 Days';
                                        $total_31_60 += $due;
                                        $status = '<button type="button" class="btn btn-warning btn-xs">Slightly overdue</button>';
                                    } elseif ($daysPastMaturity <= 90) {
                                        $agingBracket = '61-90 Days';
                                        $total_61_90 += $due;
                                        $status = '<button type="button" class="btn btn-warning btn-xs">Moderately overdue</button>';
                                    } elseif ($daysPastMaturity <= 120) {
                                        $agingBracket = '91-120 Days';
                                        $total_91_120 += $due;
                                        $status = '<button type="button" class="btn btn-danger btn-xs">Significantly overdue</button>';
                                    } elseif ($daysPastMaturity <= 150) {
                                        $agingBracket = '121-150 Days';
                                        $total_121_150 += $due;
                                        $status = '<button type="button" class="btn btn-danger btn-xs">Seriously overdue</button>';
                                    } elseif ($daysPastMaturity <= 180) {
                                        $agingBracket = '151-180 Days';
                                        $total_151_180 += $due;
                                        $status = '<button type="button" class="btn btn-danger btn-xs">Critical overdue</button>';
                                    } else {
                                        $agingBracket = 'Over 180 Days';
                                        $total_over_180 += $due;
                                        $status = '<button type="button" class="btn btn-dark btn-xs" style="color:red"><b>Potential write-off</b></button>';
                                    }
                                
                                    echo '
                                    <tr>
                                        <td style="text-align:left">'.$name.'</td>
                                        <td>'.$invoice.'</td>
                                        <td>'.$invoiceDate.'</td>
                                        <td>'.$paymentDays.'</td>
                                        <td>'.$daysPastMaturity.'</td>
                                        <td align="right">'.($agingBracket === "Not Due" ? number_format($due, 2) : '').'</td>
                                        <td align="right">'.($agingBracket === "0-30 Days" ? number_format($due, 2) : '').'</td>
                                        <td align="right">'.($agingBracket === "31-60 Days" ? number_format($due, 2) : '').'</td>
                                        <td align="right">'.($agingBracket === "61-90 Days" ? number_format($due, 2) : '').'</td>
                                        <td align="right">'.($agingBracket === "91-120 Days" ? number_format($due, 2) : '').'</td>
                                        <td align="right">'.($agingBracket === "121-150 Days" ? number_format($due, 2) : '').'</td>
                                        <td align="right">'.($agingBracket === "151-180 Days" ? number_format($due, 2) : '').'</td>
                                        <td align="right">'.($agingBracket === "Over 180 Days" ? number_format($due, 2) : '').'</td>
                                        <td>'.$status.'</td>
                                    </tr>';
                                }
                                ?>
                                
                                <!-- Totals row -->
                                <tr>
                                    <td colspan="4" align="left"><b>TOTAL:</b></td>
                                    <td></td>
                                    <td align="right"><b><?php echo number_format($total_invoice_days, 2); ?></b></td> <!-- Total for Invoice Days -->
                                    
                                    <td align="right"><b><?php echo number_format($total_0_30, 2); ?></b></td> <!-- Total for 0-30 Days -->
                                    <td align="right"><b><?php echo number_format($total_31_60, 2); ?></b></td> <!-- Total for 31-60 Days -->
                                    <td align="right"><b><?php echo number_format($total_61_90, 2); ?></b></td> <!-- Total for 61-90 Days -->
                                    <td align="right"><b><?php echo number_format($total_91_120, 2); ?></b></td> <!-- Total for 91-120 Days -->
                                    <td align="right"><b><?php echo number_format($total_121_150, 2); ?></b></td> <!-- Total for 121-150 Days -->
                                    <td align="right"><b><?php echo number_format($total_151_180, 2); ?></b></td> <!-- Total for 151-180 Days -->
                                    <td align="right"><b><?php echo number_format($total_over_180, 2); ?></b></td>
                                </tr>
                                <!-- Total Balance row -->
                                <tr>
                                    <td colspan="12" align="left"><b>TOTAL BALANCE:</b></td>
                                    <td align="right"><b><?php echo number_format($total_invoice_days + $total_0_30 + $total_31_60 + $total_61_90 + $total_91_120 + $total_121_150 + $total_151_180 + $total_over_180, 2); ?></b></td>
                                </tr>

                        </table>      
                    </div>       
                </div>
                <div class="panel-footer"></div>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>

<script>
    function printContent() {
        var content = document.getElementById('printingArea').innerHTML;
        var printWindow = window.open('', '_blank');
        printWindow.document.write('<html><head><title>Print</title></head><body>');
        printWindow.document.write(content);
        printWindow.document.write('</body></html>');
        printWindow.document.close();
        printWindow.print();
    }
</script>
<script>
    function exportToExcel() {
        // Get the HTML table element
        var table = document.getElementById('printingArea'); // Replace 'tableId' with the ID of your table

        // Convert the HTML table to a worksheet
        var wb = XLSX.utils.table_to_book(table);

        // Generate a binary string from the XLSX workbook
        var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });

        // Create a Blob object representing the data as an Excel file
        var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

        // Create a temporary anchor element and trigger a download
        var link = document.createElement('a');
        link.href = window.URL.createObjectURL(blob);
        link.download = 'customer_aged_report.xlsx'; // Change 'filename' to your desired filename
        link.click();
    }

    // Utility function to convert a string to an ArrayBuffer
    function s2ab(s) {
        var buf = new ArrayBuffer(s.length);
        var view = new Uint8Array(buf);
        for (var i = 0; i < s.length; i++) {
            view[i] = s.charCodeAt(i) & 0xFF;
        }
        return buf;
    }

    function printTable() {
        // Apply border style to table cells
        var cells = document.querySelectorAll('td, th');
        cells.forEach(function(cell) {
            cell.style.border = '1px solid black';
        });

        // Print only the table
        var printWindow = window.open('', '_blank');
        printWindow.document.open();
        printWindow.document.write('<html><head><title>Print Table</title></head><body>');
        printWindow.document.write('<style>table { border-collapse: collapse; width: 100%; } th, td { border: 1px solid black; padding: 8px; }</style>');
        printWindow.document.write(document.getElementById('myTable').outerHTML);
        printWindow.document.write('</body></html>');
        printWindow.document.close();
        printWindow.print();

        // Remove border style after printing
        cells.forEach(function(cell) {
            cell.style.border = '';
        });
    }
</script>
