 <?php
require_once '../db/connection.php';
  $pdo = new PDO($dsn, $username, $password);
  $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION); 
if(isset($_GET['id'])) {
    
    $id = $_GET['id'];
    // Fetch the existing data from the database to populate the form for editing
    $stmt = $pdo->prepare("SELECT * FROM supplier WHERE id = ?");
    $stmt->execute([$id]);
    $row = $stmt->fetch(PDO::FETCH_ASSOC);
    if(!$row) {
        // Handle if no record is found for the provided ID
        echo "Record not found!";
        exit;
    }
    // Extract fetched data to populate the form fields for editing
    $name = $row['name'];
    $phone = $row['phone'];
    $location = $row['location'];
    $email = $row['email'];
    $tin = $row['tin'];
    $vrn = $row['vrn'];
}
// Update record in the database on form submission
if(isset($_POST['submit'])) {
    $id = $_GET['id'];
    
    // Retrieve form data
    $name = strtoupper($_POST['name']);
    $location = $_POST['location'];
    $email = $_POST['email'];
    $phone = $_POST['phone'];
    $tin = $_POST['tin'];
    $vrn = $_POST['vrn'];
    
    if(strlen($phone)<>12){
        $err = "<p class = 'alert alert-danger'>Invalid phone number !!!</p>";  
    }else{

    // Update the record
    $stmt = $pdo->prepare("UPDATE supplier SET name = ?, location = ?, phone = ?, email = ?, tin= ?, vrn= ? WHERE id = ?");
    $stmt->execute([$name, $location, $phone, $email,$tin, $vrn, $id]);

    if($stmt->rowCount() > 0) {
        // Handle successful update
       // echo "<p class='alert alert-success'>Record updated successfully!</p>";
        echo "<script> alert('Supplier Updated successfully!')
              window.location='index.php?p=supplier';
        </script>";
        
    } else {
        // Handle update failure
        $err = "<p class='alert alert-danger'>Failed to update the record!</p>";
    }
}
}
?>
                            <div class="col-md-9">

                            <!-- START TIMELINE -->
                            <div class="row">
                            <div class="col-md-12">
                                <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                                <li><a href="index.php?p=purchases" style="color: rgb(7, 133, 164)">Purchase Menu</a></li>
                                <li><a href="index.php?p=supplier" style="color: rgb(7, 133, 164)">Suppliers List</a></li>
                                <li class="active">Suppliers Edit</li>
                                </ul>

                             <div class="panel panel-default">
                                <div class="panel-heading">
                                    <h3 class="panel-title"><b>EDIT SUPPLIER</b></h3>
                                    <div class="pull-right">
                                        <a href="index.php?p=supplier"><button class="btn btn-warning"> <span class="fa fa-plus-circle"></span> View Suppliers</button></a>
                                    </div>
                                </div>
                                <div class="panel-body" style="background: #fff">
                                    <?php if(isset($err)){ echo $err;}?>
                                    <form action = "" method="post">
                                    <div class="row"> 
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                        <div class="col-md-12 col-xs-12">                      
                                            <div class="input-group">
                                                <span class="input-group-addon">Name</span>
                                                <input type="text" name = "name" class="form-control" placeholder="Enter Name or Business" value = "<?php echo $name;?>"/>
                                            </div>                                            
                                        </div>
                                       </div>                     
                                     </div>
                                      <div class="col-md-4">  
                                      <div class="form-group">
                                        <div class="col-md-12 col-xs-12">                                     
                                            <div class="input-group">
                                                <span class="input-group-addon">Phone#</span>
                                                <input type="text" name = "phone" class="form-control" placeholder="Enter Mobile Number" value = "<?php echo $phone;?>"/>
                                            </div>                                            
                                        </div>
                                      </div>                     
                                     </div>
                                   </div>

                                    <br/><br/>
                                    <div class="row"> 
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon">Address</span>
                                                <input type="text" name = "location" class="form-control" placeholder="Enter Address" value = "<?php echo $location;?>"/>
                                            </div>              
                                        </div>
                                     </div>                    
                                     </div>
                                      <div class="col-md-4">  
                                      <div class="form-group">
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon">Email</span>
                                                <input type="text" name = "email" class="form-control" placeholder="Enter Email" value = "<?php echo $email;?>"/>
                                            </div>              
                                        </div>
                                     </div>                    
                                     </div>

                                    </div>
                                   <br><br/>
                                   <div class="row"> 
                                     <div class="col-md-4">  
                                      <div class="form-group">
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon">TIN</span>
                                                <input type="text" name = "tin" class="form-control" placeholder="" value = "<?php echo $tin;?>"/>
                                            </div>              
                                        </div>
                                     </div>                    
                                     </div>
                                      <div class="col-md-4">  
                                      <div class="form-group">
                                        <div class="col-md-12 col-xs-12">                                            
                                            <div class="input-group">
                                                <span class="input-group-addon">VRN</span>
                                                <input type="text" name = "vrn" class="form-control" placeholder="" value = "<?php echo $vrn;?>"/>
                                            </div>              
                                        </div>
                                     </div>                    
                                     </div>

                                    </div><br/><br/>
                                </div>
                                <div class="panel-footer">               
                                    <button class="btn btn-info pull-right" type = "submit" name = "submit"><span class="fa fa-edit"></span> Update</button>
                                </div>
                            </form>
                            </div>
                          </div>
                        </div>
                            <!-- END TIMELINE -->                            
                            
                        </div>