<?php
include '../db/db.php'; // Include your database connection files

$supplier_id = $_GET['supplier_id'];

// Fetch supplier details
$supplier_query = mysqli_query($con, "SELECT * FROM supplier WHERE id='$supplier_id'");
$supplier = mysqli_fetch_assoc($supplier_query);

// Fetch transactions for the supplier with paid amount from transactions_details
$transactions_query = mysqli_query($con, "
    SELECT 
        p.purchase_date, 
        p.due_date, 
        p.total_amount, 
        p.status,
        IFNULL(SUM(CASE WHEN td.category = 'Cash Purchase' THEN td.total ELSE 0 END), 0) AS paid, -- Sum payments for purchases
        (p.total_amount - IFNULL(SUM(CASE WHEN td.category = 'Cash Purchase' THEN td.total ELSE 0 END), 0)) AS due,
        p.discount, 
        p.tax_amount, 
        p.tax_type
    FROM 
        purchases p
    LEFT JOIN 
        payment_transactions_details td 
    ON 
        p.purchase_id = td.reference AND td.category = 'Cash Purchase'
    WHERE 
        p.supplier_id = '$supplier_id'
    GROUP BY 
        p.purchase_id

    UNION ALL

    SELECT 
        pi.purchase_date, 
        pi.due_date, 
        pi.total_amount, 
        pi.status,
        IFNULL(SUM(CASE WHEN td.category = 'payment' THEN td.total ELSE 0 END), 0) AS paid, -- Sum payments for invoices
        (pi.total_amount - IFNULL(SUM(CASE WHEN td.category = 'payment' THEN td.total ELSE 0 END), 0)) AS due,
        pi.discount, 
        pi.tax_amount, 
        pi.tax_type
    FROM 
        purchase_invoice pi
    LEFT JOIN 
        payment_transactions_details td 
    ON 
        pi.purchase_id = td.reference AND td.category = 'payment'
    WHERE 
        pi.supplier_id = '$supplier_id'
    GROUP BY 
        pi.purchase_id
");


?>
<style>
    /* CSS to style the table */
    table {
        border-collapse: collapse;
        border: 1px solid black; /* Set border color and thickness */
        width: 100%; /* Set table width to 100% of its container */
    }

    th {
        border: 1px solid black; /* Set border for table cells */
        padding: 8px; /* Add padding for better readability */
        text-align: center; /* Center-align text within cells */
        height:20px;
        color:black;
    }
    td {
        border: 1px solid black; /* Set border for table cells */
        padding: 8px; /* Add padding for better readability */
        height:20px;
        color:black;
    }
</style>

    <div class="col-md-9">
    
        <!-- START TIMELINE -->
        <div class="row">
            <div class="col-md-12">
                <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                                <li><a href="index.php?p=purchases" style="color: rgb(7, 133, 164)">Purchase Menu</a></li>
                                <li><a href="index.php?p=supplier" style="color: rgb(7, 133, 164)">Suppliers List</a></li>
                                <li class="active">Supplier Transactions</li>
                                </ul>
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title"><b>Supplier Transactions</b></h3>
                        <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                        <button class="btn btn-default" onclick="printTable()">
                            <span class="fa fa-print"></span> Print Report
                        </button>
                        <button class="btn btn-default" onclick="exportToExcel()">
                            <span class="fa fa-download"></span> Export To Excel
                        </button>
                    </div>
                    </div>
                       
                    <div class="panel-body" style="background: #fff" id = "printingArea">
                         
                        <div class="table-responsive">
                        <table id="myTable">
                            <thead>
                                <tr>
                                    <th colspan="8">
                                        Transactions for Supplier: <?php echo strtoupper($supplier['name']); ?>
                                        </th>
                                    </tr>
                                    <tr style="text-align: center;">
                                        <th>Purchase Date</th>
                                        <th>Due Date</th>
                                        <th>Type</th>
                                        <th>Total Amount</th>
                                        <th>Paid</th>
                                        <th>Due</th>
                                        <th>Discount</th>
                                        <th>Tax Amount</th>
                                        <th>Tax Type</th>
                                    </tr>
                                </thead>
                                <tbody>
                                     <?php
                                // Initialize totals
                                $total_amount = 0;
                                $total_paid = 0;
                                $total_due = 0;
                                $total_discount = 0;
                                $total_tax_amount = 0;

                                while($transaction = mysqli_fetch_assoc($transactions_query)) {
                                    // Accumulate totals
                                    $total_amount += $transaction['total_amount'];
                                    $total_paid += $transaction['paid'];
                                    $total_due += $transaction['total_amount'] - $transaction['paid'];
                                    $total_discount += $transaction['discount'];
                                    $total_tax_amount += $transaction['tax_amount'];
                                ?>
                                <tr>
                                    <td><?php echo $transaction['purchase_date']; ?></td>
                                    <td><?php echo ($transaction['due_date'] == '0000-00-00') ? 'No Due Date' : $transaction['due_date']; ?></td>
                                    <td><?php echo $transaction['status'];?></td>
                                    <td><?php echo number_format($transaction['total_amount'], 2); ?></td>
                                    <td><?php echo number_format($transaction['paid'], 2); ?></td>
                                    <td><?php echo number_format($transaction['total_amount'] - $transaction['paid'], 2); ?></td>
                                    <td><?php echo number_format($transaction['discount'], 2); ?></td>
                                    <td><?php echo number_format($transaction['tax_amount'], 2); ?></td>
                                    <td><?php echo htmlspecialchars($transaction['tax_type']); ?></td>
                                </tr>
                                <?php
                                }
                                ?>
                            </tbody>
                            <tfoot>
                                <tr>
                                    <th colspan="3">Total</th>
                                    <th><?php echo number_format($total_amount, 2); ?></th>
                                    <th><?php echo number_format($total_paid, 2); ?></th>
                                    <th><?php echo number_format($total_due, 2); ?></th>
                                    <th><?php echo number_format($total_discount, 2); ?></th>
                                    <th><?php echo number_format($total_tax_amount, 2); ?></th>
                                    <th></th>
                                </tr>
                            </tfoot>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
  <script>
function printTable() {
    var content = document.getElementById('printingArea').innerHTML;
    var printWindow = window.open('', '_blank');
    printWindow.document.write('<html><head><title>Print Table</title></head><body>');
    printWindow.document.write('<style>table { border-collapse: collapse; width: 100%; } th, td { border: 1px solid black; padding: 8px; }</style>');
    printWindow.document.write(content);
    printWindow.document.write('</body></html>');
    printWindow.document.close();
    printWindow.print();
}

function exportToExcel() {
    var table = document.getElementById('myTable'); // Correct ID of the table

    var wb = XLSX.utils.table_to_book(table);
    var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });
    var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

    var link = document.createElement('a');
    link.href = window.URL.createObjectURL(blob);
    link.download = 'purchase_report.xlsx'; // Change 'filename' to your desired filename
    link.click();
}

function s2ab(s) {
    var buf = new ArrayBuffer(s.length);
    var view = new Uint8Array(buf);
    for (var i = 0; i < s.length; i++) {
        view[i] = s.charCodeAt(i) & 0xFF;
    }
    return buf;
}
</script>
