<?php
require_once '../db/db.php';

if (isset($_POST['submit'])) {
    try {
        $name = strtoupper($_POST['name']);
        $branch = $_SESSION['Branch'];
        $tzcode = '255';
        $location = strtoupper($_POST['area']);
        $phone11 = $_POST['phone1'];
        $email = $_POST['email'];
        $tin = $_POST['tin'];
        $vrn = $_POST['vrn'];
        $phone1 = $tzcode . $phone11;

        if ($name == '') {
            
            echo'<script src="https://cdn.jsdelivr.net/npm/sweetalert2@11"></script>';
            
            echo "<script>
                    Swal.fire({
                        icon: 'error',
                        title: 'Error',
                        text: 'Fill all fields please! Ensure you have provided all required information before submitting.',
                        confirmButtonText: 'OK'
                    });
                  </script>";
        } else if (strlen($phone11) != 9) {
            echo "<script>
                    Swal.fire({
                        icon: 'error',
                        title: 'Invalid Phone Number',
                        text: 'Please ensure the phone number contains exactly 9 digits.',
                        confirmButtonText: 'OK'
                    });
                  </script>";
        } else {
            $stmt = $pdo->prepare("INSERT INTO ngm_customer (name, location, phone1, email, branch, tin, vrn) VALUES (:name, :location, :phone1, :email, :branch, :tin, :vrn)");
            $stmt->bindParam(':name', $name);
            $stmt->bindParam(':location', $location);
            $stmt->bindParam(':phone1', $phone1);
            $stmt->bindParam(':email', $email);
            $stmt->bindParam(':branch', $branch);
            $stmt->bindParam(':tin', $tin);
            $stmt->bindParam(':vrn', $vrn);

            if ($stmt->execute()) {
                echo "<script>
                        Swal.fire({
                            icon: 'success',
                            title: 'Success',
                            text: 'Customer created successfully!',
                            confirmButtonText: 'OK'
                        });
                      </script>";
            } else {
                echo "<script>
                        Swal.fire({
                            icon: 'error',
                            title: 'Error',
                            text: 'Something went wrong! There was a problem on the server.',
                            confirmButtonText: 'OK'
                        });
                      </script>";
            }
        }
    } catch (PDOException $e) {
        echo "<script>
                Swal.fire({
                    icon: 'error',
                    title: 'Connection Error',
                    text: 'Connection failed: " . $e->getMessage() . "',
                    confirmButtonText: 'OK'
                });
              </script>";
    }
}
?>

<div class="col-md-9">

    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=sales" style="color: rgb(7, 133, 164)">Sales Menu</a></li>
                <li><a href="index.php?p=customers" style="color: rgb(7, 133, 164)">Customers List</a></li>
                <li class="active">Customers Create</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>CREATE NEW CUSTOMER</b></h3>
                    <div class="pull-right">
                        <a href="index.php?p=customers">
                            <button class="btn btn-warning">
                                <span class="fa fa-plus-circle"></span> View Customers
                            </button>
                        </a>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                    <?php if (isset($err)) { echo $err; } ?>
                    <form action="" method="post">
                        <div class="row">
                            <div class="col-md-4">
                                <div class="form-group">
                                    <div class="col-md-12 col-xs-12">
                                        <div class="input-group">
                                            <span class="input-group-addon">Name</span>
                                            <input type="text" name="name" class="form-control" placeholder="Enter Name or Business" />
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="col-md-4">
                                <div class="form-group">
                                    <div class="col-md-12 col-xs-12">
                                        <div class="input-group">
                                            <span class="input-group-addon"><b>+255(0)</b></span>
                                            <input type="text" name="phone1" class="form-control" placeholder="Enter Mobile Number" />
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <br /><br />
                        <div class="row">
                            <div class="col-md-4">
                                <div class="form-group">
                                    <div class="col-md-12 col-xs-12">
                                        <div class="input-group">
                                            <span class="input-group-addon">Address</span>
                                            <input type="text" name="area" class="form-control" placeholder="Enter Location" />
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="col-md-4">
                                <div class="form-group">
                                    <div class="col-md-12 col-xs-12">
                                        <div class="input-group">
                                            <span class="input-group-addon">Email</span>
                                            <input type="text" name="email" class="form-control" placeholder="Enter Email" />
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <br /><br />
                        <div class="row">
                            <div class="col-md-4">
                                <div class="form-group">
                                    <div class="col-md-12 col-xs-12">
                                        <div class="input-group">
                                            <span class="input-group-addon">TIN</span>
                                            <input type="text" name="tin" class="form-control" placeholder="Enter TIN" />
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="col-md-4">
                                <div class="form-group">
                                    <div class="col-md-12 col-xs-12">
                                        <div class="input-group">
                                            <span class="input-group-addon">VRN</span>
                                            <input type="text" name="vrn" class="form-control" placeholder="Enter VRN" />
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <br /><br />
                </div>
                <div class="panel-footer">
                    <button class="btn btn-info pull-right" type="submit" name="submit">
                        <span class="fa fa-plus-circle"></span> Add
                    </button>
                </div>
                </form>
            </div>
        </div>
    </div>

    <!-- END TIMELINE -->

</div>
