<?php
if (isset($_POST['general_ledger'])) {
    $description = mysqli_real_escape_string($con, $_POST['description']);
    $branch = mysqli_real_escape_string($con, $_POST['branch']);
    $date1 = mysqli_real_escape_string($con, $_POST['date1']);

    // Constructing the URL with form attributes
    $redirectURL = 'index.php?p=customer_aged_report&description=' . urlencode($description) . '&branch=' . urlencode($branch) . '&date1=' . urlencode($date1);
    // Redirecting to the report page
    echo "<script>window.location='$redirectURL';</script>";
}
?>

<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=sales" style="color: rgb(7, 133, 164)">Sales Menu</a></li>
                <li class="active">Customer Aged Receivables</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>Customer Aged Receivables</b></h3>
                </div>
                <div class="panel-body" style="background: #fff">
                    <form class="form-horizontal" action="" method="post">
                        <div class="form-group">
                            <label class="col-md-3 control-label col-label" for="description">Description</label>
                            <div class="col-md-6 form-group has-success">
                                <input type="text" class="form-control" name="description" id="description" value="Customer Aged Report">
                            </div>
                        </div>
                        <div class="form-group">
                            <label class="col-md-3 control-label col-label">Select Branch</label>
                            <div class="col-md-4">
                                <select class="form-control select" name="branch" onchange="showDis(this.value)">
                                    <option value="All">All</option>
                                    <?php
                                    $stmt = $pdo->prepare("SELECT * FROM branch ORDER BY name");
                                    $stmt->execute();
                                    $branches = $stmt->fetchAll(PDO::FETCH_ASSOC);
                                    foreach ($branches as $branch) {
                                        ?>
                                        <option value="<?php echo $branch['name']; ?>"><?php echo $branch['name']; ?></option>
                                    <?php
                                    }
                                    ?>
                                </select>
                            </div> 
                        </div>
                        <div class="form-group">
                            <label class="col-md-3 control-label col-label">Date up To</label>
                            <div class="col-md-3">
                                <div class="input-group">
                                    <span class="input-group-addon"><span class="fa fa-calendar"></span></span>
                                    <input type="text" class="form-control datepicker datepicker-from" value="<?php echo date('Y-m-d');?>" name="date1">          
                                </div>
                            </div>
                        </div>     
                </div>
                <div class="panel-footer">                                    
                    <button class="btn btn-warning pull-right" type="submit" name="general_ledger"><span class="fa fa-plus-circle"></span> Create</button>
                </div>
            </form> 
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>
