<?php
include '../db/db.php'; // Include your database connection file

$customer_id = decrypt($_GET['customer_id'],$encryption_key,$encryption_method);

// Fetch supplier details
$customer_query = mysqli_query($con, "SELECT * FROM ngm_customer WHERE id='$customer_id'");
$customer = mysqli_fetch_assoc($customer_query);

// Fetch transactions for the supplier
$transactions_query = mysqli_query($con, "SELECT * FROM invoices WHERE customer_id='$customer_id'");

// Initialize totals
$total_amount = 0;
$total_paid = 0;
$total_due = 0;
$total_discount = 0;
$total_tax_amount = 0;
?>

<style>
        /* Additional styling for the buttons */
        .panel-footer button {
            margin-top: 10px;
        }
    
        .container {
            width: 100%;
            margin-left: 10px;
            text-align: center;
            margin-top: 10px;
        }
    
        h2 {
            font-size: 20px;
            font-weight: bold;
        }
    
        h3 {
            font-size: 15px;
            font-weight: bold;
        }
    
        p {
            font-size: 13px;
            font-weight: bold;
        }
    
        table {
            border: 1px solid #ccc;
            width: 100%;
            margin-top: 20px;
        }
    
        /* Add border to table cells */
        table th,
        table td {
            border: 1px solid #ccc;
            padding: 8px;
            text-align: left;
        }
    </style>

    <div class="col-md-9">
    
        <!-- START TIMELINE -->
        <div class="row">
            <div class="col-md-12">
                <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                                <li><a href="index.php?p=sales" style="color: rgb(7, 133, 164)">Sales Menu</a></li>
                                <li><a href="index.php?p=customers" style="color: rgb(7, 133, 164)">Customer List</a></li>
                                <li class="active">Customer Transactions</li>
                                </ul>
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title"><b>Customer Transactions</b></h3>
                        <div class="pull-right">
                            <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                            <button class="btn btn-default" onclick="printTable()">
                                <span class="fa fa-print"></span> Print Report
                            </button>
                            <button class="btn btn-default" onclick="exportToExcel()">
                                <span class="fa fa-download"></span> Export To Excel
                            </button>
                        </div>
                    </div>
                       
                    <div class="panel-body" style="background: #fff">
                        <div class="container">
                            <h2>Transactions for Customer: <?php echo strtoupper($customer['name']); ?></h2>
                        </div> 
                        <div class="table-responsive">
                            <table class="table table-striped">
                                <thead>
                                    <tr style="text-align: center;">
                                        <th>Sales Date</th>
                                        <th>Due Date</th>
                                        <th>Total Amount</th>
                                        <th>Paid</th>
                                        <th>Due</th>
                                        <th>Discount</th>
                                        <th>Tax Amount</th>
                                     
                                    </tr>
                                </thead>
                                <tbody>
                                    <?php
                                    while($transaction = mysqli_fetch_assoc($transactions_query)) {
                                        // Calculate totals
                                        $total_amount += $transaction['total_amount'];
                                        $total_paid += $transaction['paid'];
                                        $total_due += $transaction['due'];
                                        $total_discount += $transaction['discount'];
                                        $total_tax_amount += $transaction['tax_amount'];
                                    ?>
                                    <tr>
                                        <td><?php echo $transaction['invoice_date']; ?></td>
                                        <td><?php echo $transaction['due_date']; ?></td>
                                        <td><?php echo number_format($transaction['total_amount'],2); ?></td>
                                        <td><?php echo number_format($transaction['paid'],2); ?></td>
                                        <td><?php echo number_format($transaction['due'],2); ?></td>
                                        <td><?php echo number_format($transaction['discount'],2); ?></td>
                                        <td><?php echo number_format($transaction['tax_amount'],2); ?></td>
                                      
                                    </tr>
                                    <?php
                                    }
                                    ?>
                                </tbody>
                                <tfoot>
                                    <tr>
                                        <th colspan="2"><b>Total</b></th>
                                        <th><b><?php echo number_format($total_amount,2); ?></b></th>
                                        <th><b><?php echo number_format($total_paid,2); ?></b></th>
                                        <th><b><?php echo number_format($total_due,2); ?></b></th>
                                        <th><b><?php echo number_format($total_discount,2); ?></b></th>
                                        <th><b><?php echo number_format($total_tax_amount,2); ?></b></th>
                                        <th></th>
                                    </tr>
                                </tfoot>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script> <!-- Include Bootstrap JS -->
    <script>
        function printTable() {
            var divToPrint = document.querySelector('.table-responsive');
            var newWin = window.open('', 'Print-Window');
            newWin.document.open();
            newWin.document.write('<html><head><title>Customer Transactions</title><style>table { border: 1px solid #ccc; width: 100%; margin-top: 20px; } table th, table td { border: 1px solid #ccc; padding: 8px; text-align: left; } </style></head><body onload="window.print()">' + divToPrint.innerHTML + '</body></html>');
            newWin.document.close();
            setTimeout(function() { newWin.close(); }, 10);
        }

        function exportToExcel() {
            var table = document.querySelector('.table-responsive table');
            var wb = XLSX.utils.table_to_book(table, {sheet: "supplierTransactions"});
            XLSX.writeFile(wb, 'customer_transactions.xlsx');
        }
    </script>
