<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

$date1 = $_GET['date1'];
$date2 = $_GET['date2'];
$branch = $_SESSION['Branch'];
$id = $_GET['customer'];
$date3 = date('d-m-Y', strtotime($date1));
$date4 = date('d-m-Y', strtotime($date2));
$cat = 'Cash';
$category = 'Invoice';
$note = ($date1 !== $date2)
    ? "CUSTOMER LEDGER REPORT FROM {$date3} TO {$date4}"
    : "CUSTOMER LEDGER REPORT FOR DATE: {$date3}";

// Secure the SQL date condition
$date_condition = ($date1 !== $date2) 
    ? "invoice_date BETWEEN ? AND ?"
    : "invoice_date = ?";

// Fetch customer name
$select_query = mysqli_query($con, "SELECT name FROM ngm_customer WHERE id = $id");
$name = mysqli_fetch_assoc($select_query);


$data = []; // Store combined data

// Invoice query
$sqlInvoice = "
    SELECT
        iv.invoice_date, 
        p.Name, 
        it.quantity, 
        p.Unit,
        'Sales invoice' AS type,
        it.unit_price,
        iv.invoice_id, 
        iv.total_amount,
        SUM(COALESCE(td.total, 0)) AS received_amount
    FROM
        invoices AS iv
    INNER JOIN
        invoice_items AS it ON iv.invoice_id = it.invoice_no
    INNER JOIN
        product AS p ON it.product_id = p.ProductId
    LEFT JOIN
        transactions_details AS td ON iv.invoice_id = td.reference AND td.category=? 
    WHERE 
        iv.customer_id = ? 
        AND $date_condition
    GROUP BY
        iv.invoice_id, iv.invoice_date, p.Name, p.Unit, it.unit_price, iv.total_amount
    ORDER BY
        iv.invoice_date ASC";

$stmt = $con->prepare($sqlInvoice);

if ($date1 !== $date2) {
    $stmt->bind_param("siss",$category, $id, $date1, $date2);
} else {
    $stmt->bind_param("sis",$category, $id, $date1);
}

$stmt->execute();
$Invoiceresult = $stmt->get_result();

while ($row = $Invoiceresult->fetch_assoc()) {
    $data[] = $row;
}

// Cash sales query
$sqlCash = "
    SELECT
        sc.invoice_date, 
        p.Name, 
        sci.quantity, 
        p.Unit, 
        sci.unit_price,
        'Cash Sales' AS type,
        sc.sales_cash_id AS invoice_id, 
        sc.total_amount,
        SUM(COALESCE(td.total, 0)) AS received_amount
    FROM
        sales_cash AS sc
    INNER JOIN
        sales_cash_items AS sci ON sc.sales_cash_id = sci.cash_no
    INNER JOIN
        product AS p ON sci.product_id = p.ProductId
    LEFT JOIN
        transactions_details AS td ON sc.sales_cash_id = td.reference
    WHERE 
        sc.customer_id = ? 
        AND $date_condition
        AND td.category = ?
    GROUP BY
        sc.sales_cash_id, sc.invoice_date, p.Name, p.Unit, sci.unit_price, sc.total_amount
    ORDER BY
        sc.invoice_date ASC";

$stmt = $con->prepare($sqlCash);

if ($date1 !== $date2) {
    $stmt->bind_param("isss", $id, $date1, $date2,$cat);
} else {
    $stmt->bind_param("iss", $id, $date1,$cat);
}

$stmt->execute();
$Cashresult = $stmt->get_result();

while ($row = $Cashresult->fetch_assoc()) {
    $data[] = $row;
}

?>


<style>
    table {
        border-collapse: collapse;
        border: 1px solid black;
        width: 100%;
    }

    th, td {
        border: 1px solid black;
        padding: 8px;
        text-align: center;
        height: 20px;
        color: black;
    }
</style>

<div class="col-md-9">
    <div class="panel panel-default">
        <div class="panel-heading">
            <h3 class="panel-title"><b>CUSTOMER LEDGER REPORT</b></h3>
            <div class="pull-right">
                <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                <button class="btn btn-default" onclick="printContent()">
                    <span class="fa fa-print"></span> Print Report
                </button>
                <button class="btn btn-default" onclick="exportToExcel()">
                    <span class="fa fa-print"></span> Export To Excel
                </button>
            </div>
        </div>
        <div class="panel-body" style="background: #fff">
            <div id="printingArea">
                <table id="myTable">
                    <tr><th colspan=11><?php echo $_SESSION['Company']; ?></th></tr>
                    <tr><th colspan=11>BRANCH: <?php echo $branch; ?></th></tr>
                    <tr><th colspan=11>CUSTOMER NAME: <?php echo $name['name']; ?></th></tr>
                    <tr><th colspan=11><?php echo $note; ?></th></tr>
                    <tr style="font-weight:bold">
                        <td>DATE</td>
                        <td>ITEMS/SERVICE</td>
                        <td>QTY</td>
                        <td>UOM</td>
                        <td>UNIT PRICE</td>
                        <td>TOTAL</td>
                        <td>TYPE</td>
                        <td>TRANS. NO.</td>
                        <td>INVOICED AMT.</td>
                        <td>RECEIVED AMT.</td>
                        <td>BALANCE</td>
                    </tr>
                    <?php
                    $sum_line_total = 0; // Sum of individual line item totals
                    $sum_total_amount = 0; // Sum of invoice amounts
                    $sum_received_amount = 0; // Sum of received payments
                    $sum_balance_amount = 0; // Sum of balance amounts
                    
                    $previous_invoice_id = null;
                    $invoice_spans = [];

                    foreach ($data as $rows) {
                        $line_total = $rows['quantity'] * $rows['unit_price'];
                        $balance_amount = $rows['total_amount'] - $rows['received_amount'];

                        // Accumulate individual line totals
                        $sum_line_total += $line_total;

                        if ($rows['invoice_id'] != $previous_invoice_id) {
                            // Only add once per invoice
                            $previous_invoice_id = $rows['invoice_id'];
                            $invoice_spans[$previous_invoice_id] = [
                                'total_amount' => $rows['total_amount'],
                                'received_amount' => $rows['received_amount'],
                                'balance' => $balance_amount,
                                'row_count' => 1,
                            ];
                            $sum_total_amount += $rows['total_amount'];
                            $sum_received_amount += $rows['received_amount'];
                            $sum_balance_amount += $balance_amount;
                        } else {
                            $invoice_spans[$previous_invoice_id]['row_count']++;
                        }
                    }

                    // Reset previous invoice_id for printing rows
                    $previous_invoice_id = null;

                    foreach ($data as $rows) {
                        $line_total = $rows['quantity'] * $rows['unit_price'];
                        ?>
                    <tr>
                        <td><?php echo date('d-m-Y', strtotime($rows['invoice_date'])); ?></td>
                        <td style="text-align:left"><?php echo $rows['Name']; ?></td>
                        <td><?php echo number_format($rows['quantity']); ?></td>
                        <td><?php echo $rows['Unit']; ?></td>
                        <td><?php echo number_format($rows['unit_price'], 2); ?></td>
                        <td><?php echo number_format($line_total, 2); ?></td>
                        <td><?php echo $rows['type']; ?></td>
                        <td><?php echo $rows['type']; ?> #.<?php echo $rows['invoice_id']; ?></td>
                        <?php
                        if ($rows['invoice_id'] != $previous_invoice_id) {
                            echo "<td rowspan='{$invoice_spans[$rows['invoice_id']]['row_count']}'>" . number_format($invoice_spans[$rows['invoice_id']]['total_amount'], 2) . "</td>";
                            echo "<td rowspan='{$invoice_spans[$rows['invoice_id']]['row_count']}'>" . number_format($invoice_spans[$rows['invoice_id']]['received_amount'], 2) . "</td>";
                            echo "<td rowspan='{$invoice_spans[$rows['invoice_id']]['row_count']}'>" . number_format($invoice_spans[$rows['invoice_id']]['balance'], 2) . "</td>";
                            $previous_invoice_id = $rows['invoice_id'];
                        }
                        ?>
                    </tr>
                    <?php } ?>
                    <tr>
                        <td><b>TOTAL</b></td>
                        <td></td>
                        <td></td>
                        <td></td>
                        <td></td>
                        <td><b><?php echo number_format($sum_line_total, 2); ?></b></td>
                        <td></td>
                        <td></td>
                        <td><b><?php echo number_format($sum_total_amount, 2); ?></b></td>
                        <td><b><?php echo number_format($sum_received_amount, 2); ?></b></td>
                        <td><b><?php echo number_format($sum_balance_amount, 2); ?></b></td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</div>

 <script>
    var currentDate = new Date();
    var formattedDate = currentDate.toISOString().slice(0, 10);

    document.querySelector('.datepicker-from').value = formattedDate;
    document.querySelector('.datepicker-to').value = formattedDate;

</script>
<script>
    function printContent() {
        var content = document.getElementById('printingArea').innerHTML;
        var printWindow = window.open('', '_blank');
        printWindow.document.write('<html><head><title>Print</title>');
        printWindow.document.write('<style>table { border-collapse: collapse; border: 1px solid black; width: 100%; } th, td { border: 1px solid black; padding: 8px; text-align: center; height: 20px; color: black; } a { color: black; text-decoration: none; } </style>');
        printWindow.document.write('</head><body>');
        printWindow.document.write(content);
        printWindow.document.write('</body></html>');
        printWindow.document.close();
        printWindow.print();
    }

    function exportToExcel() {
        // Get the HTML table element
        var table = document.getElementById('printingArea'); // Replace 'tableId' with the ID of your table

        // Convert the HTML table to a worksheet
        var wb = XLSX.utils.table_to_book(table);

        // Generate a binary string from the XLSX workbook
        var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });

        // Create a Blob object representing the data as an Excel file
        var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

        // Create a temporary anchor element and trigger a download
        var link = document.createElement('a');
        link.href = window.URL.createObjectURL(blob);
        link.download = '<?php echo $name['name']; ?>.xlsx'; // Change 'filename' to your desired filename
        link.click();
    }

    // Utility function to convert a string to an ArrayBuffer
    function s2ab(s) {
        var buf = new ArrayBuffer(s.length);
        var view = new Uint8Array(buf);
        for (var i = 0; i < s.length; i++) {
            view[i] = s.charCodeAt(i) & 0xFF;
        }
        return buf;
    }
</script>
