<?php
include "../db/db.php";
if (session_status() == PHP_SESSION_NONE) {
    session_start();
}

// Calculate today's sales details
$today = date('Y-m-d');
$query = "SELECT 
            invoices.invoice_id,
            invoices.status,
            ngm_customer.name AS customer_name,
            invoices.total_amount,
            invoices.invoice_date 
          FROM 
            invoices 
          JOIN 
            ngm_customer 
          ON 
            invoices.customer_id = ngm_customer.id
          WHERE 
            invoices.invoice_date = '$today' 
          AND 
            invoices.branchno = '" . $_SESSION['Branch'] . "' 
          AND 
            invoices.status = 'Sales Invoice'";

$result = mysqli_query($con, $query);
$sales_data = [];

while ($row = mysqli_fetch_assoc($result)) {
    // Calculate paid amount for this invoice
    $inv_id = $row['invoice_id'];
    $qr = mysqli_query($con, "SELECT SUM(total) AS total_paid FROM transactions_details WHERE reference = $inv_id AND category = 'receipt'");
    $paid_row = mysqli_fetch_assoc($qr);
    $paid_amount = $paid_row['total_paid'] ?? 0; // If no payment, set paid to 0

    // Calculate due amount
    $due_amount = $row['total_amount'] - $paid_amount;

    // Add calculated fields to the row
    $row['paid'] = $paid_amount;
    $row['due'] = $due_amount;

    $sales_data[] = $row;
}
?>

<div class="col-md-9">

    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">Total Sales Today</h3>
                </div>
                <div class="panel-body" style="background: #fff">
                    <div class="table-responsive">
                        <table class="table table-hover datatable">
                            <thead>
                                <tr>
                                    <th>Invoice</th>
                                    <th>Customer</th>
                                    <th>Amount</th>
                                    <th>Paid</th>
                                    <th>Due</th>
                                    <th>Date</th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php foreach ($sales_data as $sale): ?>
                                <tr>
                                    <td><?php echo $sale['status']; ?> No.<?php echo $sale['invoice_id']; ?></td>
                                    <td><?php echo htmlspecialchars($sale['customer_name'], ENT_QUOTES, 'UTF-8'); ?></td>
                                    <td><?php echo number_format($sale['total_amount'], 2); ?></td>
                                    <td><?php echo number_format($sale['paid'], 2); ?></td>
                                    <td><?php echo number_format($sale['due'], 2); ?></td>
                                    <td><?php echo $sale['invoice_date']; ?></td>
                                </tr>
                                <?php endforeach; ?>
                            </tbody>
                        </table>
                    </div> 
                </div>
            </div>
        </div>
    </div>
    <!-- END TIMELINE --> 
</div>
