<?php
session_start();
include "../db/connection.php";
error_reporting(E_ALL);
ini_set('display_errors', 1);

$id = isset($_GET['id']) ? (int)$_GET['id'] : 0;
if ($id <= 0) {
    die("Invalid transaction ID.");
}

$ql = mysqli_query($con, "SELECT * FROM gl_transaction WHERE transid = $id AND cat = 'Sales' AND account = 1050");
if (!$ql) {
    die("Query Failed: " . mysqli_error($con));
}

$rr = mysqli_fetch_assoc($ql);
if (!$rr) {
    error_log("No data found for transaction ID: $id with category 'Sales' and account 1050.");
    $amt = 0; // Default to 0 if no data found
} else {
    $amt = isset($rr['amount']) ? $rr['amount'] : 0;
}

if (isset($_POST['submit_journal'])) {
    $debit_account = $_POST['debit'];
    $credit_account = $_POST['credit'];
    $amount = $_POST['amount'];
    $notes = $_POST['notes'];
    $date = $_POST['date'];
    $user = $_SESSION['id'];
    $fyear = date('Y');
    $branchno = $_SESSION['Branch'];

    if (empty($debit_account) || empty($credit_account) || empty($amount) || empty($notes) || empty($date)) {
        echo "<script>alert('Fill all empty blanks --- Hakikisha umejaza sehemu zote zenye alama ya nyota');</script>";
    } else {
        try {
            // Initialize PDO
            $pdo = new PDO($dsn, $username, $password);
            $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
            
            // Start transaction
            $pdo->beginTransaction();
            
            // After inserting into the journal table
            $stmtJournal = $pdo->prepare("INSERT INTO journal (Date, Note, Debit, Credit, User, Reference, Branch) VALUES (:Date, :Note, :Debit, :Credit, :User, :Reference, :Branch)");
            $stmtJournal->execute([
                ':Date' => $date,
                ':Note' => $notes,
                ':Debit' => $amount,
                ':Credit' => $amount,
                ':User' => $user,
                ':Reference' => $id,
                ':Branch' => $branchno
            ]);
            
            // Get the last inserted ID from journal
            $lastJournalId = $pdo->lastInsertId(); // Capture last journal ID
            
            // Fetch debit account details
            $stmtDebitAccount = $pdo->prepare("SELECT * FROM chart_master WHERE account_code = ?");
            $stmtDebitAccount->execute([$debit_account]);
            $debit_account_details = $stmtDebitAccount->fetch(PDO::FETCH_ASSOC);
            $fsli = $debit_account_details['account_type'];
            $group = $debit_account_details['class'];
            
            // Fetch credit account details
            $stmtCreditAccount = $pdo->prepare("SELECT * FROM chart_master WHERE account_code = ?");
            $stmtCreditAccount->execute([$credit_account]);
            $credit_account_details = $stmtCreditAccount->fetch(PDO::FETCH_ASSOC);
            $fsli2 = $credit_account_details['account_type'];
            $group2 = $credit_account_details['class'];
            
            // Insert debit entry into gl_transaction with lastJournalId as transid
            $stmtDebit = $pdo->prepare("INSERT INTO gl_transaction (account, fsli, maingroup, amount, nature, transid, user, notes, fyear, date, branchno, cat) VALUES (:debit_account, :fsli, :group, :amount, 'Debit', :transid, :user, :notes, :fyear, :date, :branchno, 'Tax Journal')");
            $stmtDebit->execute([
                ':debit_account' => $debit_account,
                ':fsli' => $fsli,
                ':group' => $group,
                ':amount' => $amount,
                ':transid' => $lastJournalId, // Use the last inserted journal ID here
                ':user' => $user,
                ':notes' => $notes,
                ':fyear' => $fyear,
                ':date' => $date,
                ':branchno' => $branchno
            ]);
            
            // Insert credit entry into gl_transaction with lastJournalId as transid
            $stmtCredit = $pdo->prepare("INSERT INTO gl_transaction (account, fsli, maingroup, amount, nature, transid, user, notes, fyear, date, branchno, cat) VALUES (:credit_account, :fsli2, :group2, :amount, 'Credit', :transid, :user, :notes, :fyear, :date, :branchno, 'Tax Journal')");
            $stmtCredit->execute([
                ':credit_account' => $credit_account,
                ':fsli2' => $fsli2,
                ':group2' => $group2,
                ':amount' => $amount,
                ':transid' => $lastJournalId, // Use the last inserted journal ID here
                ':user' => $user,
                ':notes' => $notes,
                ':fyear' => $fyear,
                ':date' => $date,
                ':branchno' => $branchno
            ]);


            // Commit transaction
            $pdo->commit();
            
            echo "<script>alert('Double-entry transaction recorded successfully');</script>";
        } catch (PDOException $e) {
            // Rollback on error
            $pdo->rollBack();
            error_log("Error in transaction: " . $e->getMessage()); // Log error for debugging
            echo "Error: " . $e->getMessage();
        }
    }
}
?>


<div class="col-md-9">
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a onclick="history.back()" style="color: rgb(7, 133, 164)">Service Invoice</a></li>
                <li class="active">Journal Entry</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title">MANUAL JOURNAL ENTRIES</h3>
                    <div class="pull-right">
                      <a href="index.php?p=journal_entries_list"><button class="btn btn-success"> <span class="fa fa-plus-circle"></span> View Transactions</button></a>
                     </div>
                </div>
                <div class="panel-body">
                    <form class="form-horizontal" method="post" action="">
                        <div class="panel-body tab-content">
                            <div class="tab-pane active" id="tab-first">
                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label">Debit Account *</label>
                                    <div class="col-md-6 col-xs-12">
                                        <select class="form-control select" name="debit" data-live-search="true">
                                            <?php
                                            $query_group = mysqli_query($con, "SELECT * FROM chart_master WHERE account_code = 5050");
                                            while ($rows = mysqli_fetch_assoc($query_group)) {
                                            ?>
                                                <option value="<?php echo $rows['account_code']; ?>"><?php echo $rows['account_name']; ?> - <?php echo $rows['account_code']; ?></option>
                                            <?php
                                            }
                                            ?>
                                        </select>
                                    </div>
                                </div>
                                
                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label">Credit Account *</label>
                                    <div class="col-md-6 col-xs-12">
                                        <select class="form-control select" name="credit" data-live-search="true">
                                            <?php
                                            $query_group = mysqli_query($con, "SELECT * FROM chart_master WHERE account_code = 1050");
                                            while ($rows = mysqli_fetch_assoc($query_group)) {
                                            ?>
                                                <option value="<?php echo $rows['account_code']; ?>"><?php echo $rows['account_name']; ?> - <?php echo $rows['account_code']; ?></option>
                                            <?php
                                            }
                                            ?>
                                        </select>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label">Amount *</label>
                                    <div class="col-md-6 col-xs-12">
                                        <input class="form-control" name="amount" value="<?php echo isset($amt) ? $amt : ''; ?>" readonly/>
                                    </div>
                                </div>

                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label">Date *</label>
                                    <div class="col-md-6 col-xs-12">                                            
                                        <div class="input-group">
                                            <span class="input-group-addon"><span class="fa fa-calendar"></span></span>
                                            <input type="text" name="date" class="form-control datepicker" value="<?php echo date('Y-m-d');?>">
                                        </div>                                            
                                    </div>
                                </div> 

                                <div class="form-group">
                                    <label class="col-md-3 col-xs-12 control-label">Notes *</label>
                                    <div class="col-md-6 col-xs-12">
                                        <textarea class="form-control" name="notes">Paid withholding Tax of Invoice No. <?php echo $id;?></textarea>
                                    </div>
                                </div>
                            </div>
                        </div>
                </div>
                <div class="panel-footer">
                    <button type="submit" name="submit_journal" class="btn btn-info pull-right">Submit <span class="fa fa-plus-circle"></span></button>
                </div>
                </form>
            </div>
        </div>
    </div>
</div>