<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

$date1 = mysqli_real_escape_string($con, $_GET['date1']);
$branch = mysqli_real_escape_string($con, $_GET['branch']);
$status = 'Sales Invoice';

// Format date
$date3 = date('d-m-Y', strtotime($date1));


    $note = "SALES UP TO DATE: {$date3}";


// Fetch customers
if ($branch == 'All') {
        $customer = mysqli_query($con, "SELECT * FROM ngm_customer ");

} else {
        $customer = mysqli_query($con, "SELECT * FROM ngm_customer WHERE branch = '$branch' ");
}
?>


<style>
    table {
        border-collapse: collapse;
        border: 1px solid black;
        width: 100%;
    }

    th, td {
        border: 1px solid black;
        padding: 8px;
        text-align: center;
        height: 20px;
        color: black;
    }
</style>

<div class="col-md-9">
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=sales" style="color: rgb(7, 133, 164)">Sales Menu</a></li>
                <li class="active">Customer Balance Report</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>CUSTOMER BALANCES REPORT</b></h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()"><span class="fa fa-arrow-left"></span> Go Back</button>
                        <button class="btn btn-default" onclick="printContent()"><span class="fa fa-print"></span> Print Report</button>
                        <button class="btn btn-default" onclick="exportToExcel()"><span class="fa fa-print"></span> Export To Excel</button>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                    <div id="printingArea">
                        <table id="myTable">
                            <tr>
                                <th colspan=7><?php echo $_SESSION['Company']; ?></th>
                            </tr>
                            <tr>
                                <th colspan=7>BRANCH: <?php echo $branch; ?></th>
                            </tr>
                            <tr>
                                <th colspan=7><?php echo $_GET['description']; ?></th>
                            </tr>
                            <tr>
                                <th colspan=7><?php echo $note; ?></th>
                            </tr>
                            <tr style="font-weight: bold">
                                <td>SN</td>
                                <td>CUSTOMER</td>
                                <th>Total Amount Invoiced</th>
                                <th>Amount Paid</th>
                                <th>Balance</th>
                            </tr>
                            <?php
                            $a = 1;
                            $sum_total_amount = 0;
                            $sum_total_paid = 0;
                            $sum_total_due = 0;
                            
                            while ($cust = mysqli_fetch_assoc($customer)) {
                                $custid = $cust['id'];
                                $custname = $cust['name'];
                            
                                // Query for invoice amount
                                $query_invoice = "
                                    SELECT SUM(total_amount) AS invoice_amount 
                                    FROM invoices 
                                    WHERE customer_id = '$custid' 
                                    AND status = 'Sales Invoice'
                                ";
                                $invoice_amount = mysqli_query($con, $query_invoice);
                                $total = mysqli_fetch_assoc($invoice_amount);
                                $total_amountInvoice = $total['invoice_amount'] ?? 0;
                            
                                // Total amount after credit note adjustment
                                $total_amount = $total_amountInvoice;
                            
                                // Query for paid amount
                                $query_paid = "
                                    SELECT SUM(total) AS paid_amount 
                                    FROM transactions_details 
                                    WHERE payee = '$custid' 
                                    AND category = 'Invoice'
                                ";
                                $paid_amount = mysqli_query($con, $query_paid);
                                $paid = mysqli_fetch_assoc($paid_amount);
                                $total_paid = $paid['paid_amount'] ?? 0;
                            
                                // Calculate due amount
                                $total_due = $total_amount - $total_paid;
                            
                                // Skip customers with a balance of zero
                                if ($total_due == 0) {
                                    continue; // Skip this customer
                                }
                            
                                // Sum totals for all customers
                                $sum_total_amount += $total_amount;
                                $sum_total_paid += $total_paid;
                                $sum_total_due += $total_due;
                            ?>
                            <tr>
                                <td><?php echo $a++; ?></td>
                                <td style="text-align:left"><?php echo $custname; ?></td>
                                <td><?php echo number_format($total_amount, 2); ?></td>
                                <td><?php echo number_format($total_paid, 2); ?></td>
                                <td><?php echo number_format($total_due, 2); ?></td>
                            </tr>
                            <?php
                            }
                            ?>
                            <tr>
                                <td colspan="2" align="left"><b>Total</b></td>
                                <td><b><?php echo number_format($sum_total_amount, 2); ?></b></td>
                                <td><b><?php echo number_format($sum_total_paid, 2); ?></b></td>
                                <td><b><?php echo number_format($sum_total_due, 2); ?></b></td>
                            </tr>

                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<script>
    function printContent() {
        var content = document.getElementById('printingArea').innerHTML;
        var printWindow = window.open('', '_blank');
        printWindow.document.write('<html><head><title>Print</title>');
        printWindow.document.write('<style>table { border-collapse: collapse; border: 1px solid black; width: 100%; } th, td { border: 1px solid black; padding: 8px; text-align: center; height: 20px; color: black; }</style>');
        printWindow.document.write('</head><body>');
        printWindow.document.write(content);
        printWindow.document.write('</body></html>');
        printWindow.document.close();
        printWindow.print();
    }

    function exportToExcel() {
        var table = document.getElementById('printingArea');
        var wb = XLSX.utils.table_to_book(table);
        var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });
        var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });
        var link = document.createElement('a');
        link.href = window.URL.createObjectURL(blob);
        link.download = 'sales_invoice_report.xlsx';
        link.click();
    }

    function s2ab(s) {
        var buf = new ArrayBuffer(s.length);
        var view = new Uint8Array(buf);
        for (var i = 0; i < s.length; i++) {
            view[i] = s.charCodeAt(i) & 0xFF;
        }
        return buf;
    }
</script>
