<?php

session_start();

// Initialize variables from GET parameters
$date1 = isset($_GET['date1']) ? $_GET['date1'] : '';
$date2 = isset($_GET['date2']) ? $_GET['date2'] : '';
$branch = isset($_GET['branch']) ? $_GET['branch'] : '';
$product = isset($_GET['product']) ? $_GET['product'] : '';
$user = isset($_GET['user']) ? $_GET['user'] : '';

// Function to sanitize user input (preventing SQL injection)
  function sanitize($input) {
    global $con;
    return mysqli_real_escape_string($con, $input);
}



// Sanitize inputs
$date1 = sanitize($date1);
$date2 = sanitize($date2);
$branch = sanitize($branch);
$product = sanitize($product);
$user = sanitize($user);

// Format dates for display
$date3 = date('d-m-Y', strtotime($date1));
$date4 = date('d-m-Y', strtotime($date2));

// Generate note based on date range
if ($date1 !== $date2) {
    $note = "REPORTING DATE FROM {$date3} TO {$date4}";
} else {
    $note = "REPORTING DATE {$date3}";
}

// Fetch user details based on selection
if ($user == 'All') {
    $users = mysqli_query($con, "SELECT * FROM inv_users");
} else {
    $users = mysqli_query($con, "SELECT * FROM inv_users WHERE id='$user'");
}

if (!$users) {
    die('Error fetching user data: ' . mysqli_error($con));
}

?>

    <style>
        /* CSS to style the table */
        table {
            border-collapse: collapse;
            border: 1px solid black; /* Set border color and thickness */
            width: 100%; /* Set table width to 100% of its container */
        }

        th, td {
            border: 1px solid black; /* Set border for table cells */
            padding: 8px; /* Add padding for better readability */
            text-align: center; /* Center-align text within cells */
            height: 20px;
            color: black;
        }

        @media print {
            thead {
                display: table-header-group;
            }
        }
    </style>
  <div class="col-md-9">
        <!-- START TIMELINE -->
        <div class="row">
            <div class="col-md-12">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title"><b> Sales per Sales Executive Report</b></h3>
                        <div class="pull-right">
                            <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                            <button class="btn btn-default" onclick="printTable()"> <span class="fa fa-print"></span> Print Report</button>
                            <button class="btn btn-default" onclick="exportToExcel()"> <span class="fa fa-print"></span> Export To Excel</button>
                        </div>
                    </div>
                    <div class="panel-body" style="background: #fff">
                        <div id="myTable" class="table-responsive">
                            <table>
                                <thead>
                                     <tr>
                                        <th colspan="14"><?php echo $_GET['description']; ?></th>
                                    </tr>
                                    <tr>
                                        <th colspan="14"><?php echo $_SESSION['Company']; ?></th>
                                    </tr>
                                    <tr>
                                        <th colspan="14">BRANCH: <?php echo htmlspecialchars($branch); ?></th>
                                    </tr>
                                     <tr>
                                        <th colspan="14">FROM <?php echo $note; ?> </th>
                                    </tr>
                                    <tr style="font-weight: bold">
                                        <td>INVOICE</td>
                                        <td>DATE</td>
                                        <td>CUSTOMER</td>
                                        <td>AMOUNT</td>
                                        <td>PAID</td>
                                        <td>BALACE</td>
                                        
                                    </tr>
                                </thead>
                               <tbody>
                                    <?php
                                    $sum3 = 0;
                                    $sum4 = 0;
                                    $count=1;                     
                                    while ($user = mysqli_fetch_assoc($users)) {
                                        
                                      $user_id =$user['id'];
                                      //$branchCondition = $branch === 'All' ? "" : "AND inv.branchno= '$branch'";
                                      $sale = mysqli_query($con,
                                      "SELECT
                                      nc.name,
                                      inv.invoice_date,
                                      inv.total_amount,
                                      td.total AS paid,
                                      inv.invoice_id
                                      FROM invoices inv 
                                      INNER JOIN ngm_customer nc 
                                      ON nc.id = inv.customer_id
                                      LEFT JOIN transactions_details td
                                      ON inv.invoice_id = td.reference
                                      WHERE  inv.status='Sales Invoice' 
                                      AND inv.invoice_date BETWEEN '$date1' AND '$date2'
                                      AND inv.user=$user_id
                                      ORDER BY inv.invoice_date DESC");  
                           

                                        if (!$sale) {
                                            die('Error fetching data: ' . mysqli_error($con));
                                        }

                                        if (mysqli_num_rows($sale) > 0) {
                                            $sales_invo = mysqli_num_rows($sale);
                                            echo "<tr><td colspan='12'><b>{$user['Name']} (TOTAL {$sales_invo})</b></td></tr>";
                                            $sum1 = 0;
                                            $sum2 = 0;

                                            while ($sales = mysqli_fetch_assoc($sale)) {
                                               
                                                ?>
                                                <tr>
                                                    <td>Invoice #<?php echo htmlspecialchars($sales['invoice_id']); ?></td>
                                                    <td><?php echo htmlspecialchars($sales['invoice_date']); ?></td>
                                                    <td><?php echo htmlspecialchars($sales['name']); ?></td>
                                                    <td><?php echo number_format($sales['total_amount'],2); ?></td>
                                                    <td><?php echo number_format($sales['paid'],2); ?></td>
                                                    <td align="right"><?php echo number_format($sales['total_amount']-$sales['paid'], 2); ?></td>
                                                    
                                                </tr>
                                                <?php
                                            }
                                        }
                                    }
                                    ?>
                                </tbody>
                            </table>
                        </div>
                    </div>
                    <div class="panel-footer">
                    </div>
                </div>
            </div>
        </div>
        <!-- END TIMELINE -->
    </div>

    <script>
        function printTable() {
            // Apply border style to table cells
            var cells = document.querySelectorAll('td, th');
            cells.forEach(function (cell) {
                cell.style.border = '1px solid black';
            });

            // Print only the table
            var printWindow = window.open('', '_blank');
            printWindow.document.open();
            printWindow.document.write('<html><head><title>Print Table</title></head><body>');
            printWindow.document.write('<style>table { border-collapse: collapse; width: 100%; } th, td { border: 1px solid black; padding: 8px; }</style>');
            printWindow.document.write(document.getElementById('myTable').outerHTML);
            printWindow.document.write('</body></html>');
            printWindow.document.close();
            printWindow.print();

            // Remove border style after printing
            cells.forEach(function (cell) {
                cell.style.border = '';
            });
        }

        function exportToExcel() {
            // Get the HTML table element
            var table = document.getElementById('myTable');

            // Convert the HTML table to a worksheet
            var wb = XLSX.utils.table_to_book(table);

            // Generate a binary string from the XLSX workbook
            var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });

            // Convert the binary string to a Blob
            var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

            // Save the Blob as an Excel file using FileSaver.js
            saveAs(blob, 'disbursement_report.xlsx');
        }

        // Utility function to convert a string to an ArrayBuffer
        function s2ab(s) {
            var buf = new ArrayBuffer(s.length);
            var view = new Uint8Array(buf);
            for (var i = 0; i < s.length; i++) {
                view[i] = s.charCodeAt(i) & 0xFF;
            }
            return buf;
        }
    </script>