<?php
$date1 = $_GET['date1'];
$date2 = $_GET['date2'];
$branch = $_GET['branch'];
$account = 'All';
$status = 'Sales Invoice';
$date3 = date('d-m-Y', strtotime($date1));
$date4 = date('d-m-Y', strtotime($date2));

if ($date1 !== $date2) {
    $date_condition = "iv.invoice_date BETWEEN '$date1' AND '$date2'";
    $note = "SALES FROM {$date3} TO {$date4}";
} else {
    $date_condition = "iv.invoice_date = '$date1'";
    $note = "SALES FOR DATE: {$date3}";
}

if ($branch == 'All') {
    $sql = "SELECT
                *
            FROM
                invoices AS iv
            INNER JOIN
                invoice_items AS it ON iv.invoice_id = it.invoice_no
            INNER JOIN
                product AS p ON it.product_id = p.ProductId    
            WHERE
                $date_condition AND iv.status=?
            ORDER BY
                iv.invoice_date ASC";

    $stmt = $con->prepare($sql);
    $stmt->bind_param("s", $status);
} else { // For a specific branch
    $sql = "SELECT
                *
            FROM
                invoices AS iv
            INNER JOIN
                invoice_items AS it ON iv.invoice_id = it.invoice_no
            INNER JOIN
                product AS p ON it.product_id = p.ProductId
            WHERE
                $date_condition AND iv.status=? AND iv.branchno = ?
            ORDER BY
                iv.invoice_date ASC";

    $stmt = $con->prepare($sql);
    $stmt->bind_param("ss", $status, $branch);
}

$stmt->execute();
$result = $stmt->get_result();
?>

    <style>
        /* CSS to style the table */
        table {
            border-collapse: collapse;
            border: 1px solid black; /* Set border color and thickness */
            width: 100%; /* Set table width to 100% of its container */
        }

        th {
            border: 1px solid black; /* Set border for table cells */
            padding: 8px; /* Add padding for better readability */
            text-align: center; /* Center-align text within cells */
            height:20px;
            color:black;
        }
        td {
            border: 1px solid black; /* Set border for table cells */
            padding: 8px; /* Add padding for better readability */
            height:20px;
            color:black;
        }
    </style>
<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=sales" style="color: rgb(7, 133, 164)">Sales Menu</a></li>
                    <li class="active">Sales By Item Report</li>
                        </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>SALES BY ITEMS/SERVICE REPORT</b></h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                        <button class="btn btn-default" onclick="printTableData()">
                        <span class="fa fa-print"></span> Print Report
                            </button>
                            <button class="btn btn-default" onclick="exportToExcel()">
                        <span class="fa fa-print"></span> Export To Excel
                        </button>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                 <div id="printingArea">    
                  <table id="myTable">
                      <tr>
                          <th colspan=7><?php echo $_SESSION['Company'];?></th>
                      </tr>
                      <tr>
                          <th colspan=7>BRANCH: <?php echo $_GET['branch'];?></th>
                      </tr>
                      <tr>
                          <th colspan=7><?php echo $_GET['description'];?></th>
                      </tr>
                      <tr>
                          <th colspan=7><?php echo $note;?></th>
                      </tr>
                      <tr style="font-weight:bold">
                          <td>DATE</td>
                          <td>ITEMS/SERVICE</td>
                          <td>QTY</td>
                          <td>UOM</td>
                          <td>UNIT PRICE</td>
                          <td>TOTAL</td>
                      </tr>
                      <?php
                      $sum1 = 0;
                      $sum2 = 0;
                      foreach($result as $rows){
                         // $account = mysqli_query($con,"SELECT * FROM chart_master WHERE account_code = '".$rows['account_code']."'"); 
                        //$rs = mysqli_fetch_array($account);
                        
                        $sum1 += $rows['unit_price'];
                        $sum2 += $rows['total_price'];

                      ?>
                      <tr>
                          <td><?php echo date('d-m-Y',strtotime($rows['invoice_date']));?></td>
                          <td><?php echo $rows['Name'];?></td>
                          <td><?php echo number_format($rows['quantity']);?></td>
                          <td><?php echo $rows['Unit'];?></td>
                          <td><?php echo number_format($rows['unit_price'],2);?></td>
                          <td><?php echo number_format($rows['total_price'],2);?></td>
                      </tr>
                      <?php
                      }
                      ?>
                      <tr>
                          <td><b>TOTAL SALES</b></td>
                          <td></td>
                          <td></td>
                          <td></td>
                          <td></td>
                          <td><b><?php echo number_format($sum2,2);?></b></td>
                      </tr>
                  </table>      
                 </div>       
                </div>
                <div class="panel-footer">                                    
      
                 </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>
<script>
    var currentDate = new Date();
    var formattedDate = currentDate.toISOString().slice(0, 10);

    document.querySelector('.datepicker-from').value = formattedDate;
    document.querySelector('.datepicker-to').value = formattedDate;

</script>
<script>
function printContent() {
    var content = document.getElementById('printingArea').innerHTML;
    var printWindow = window.open('', '_blank');
    printWindow.document.write('<html><head><title>Print</title></head><body>');
    printWindow.document.write(content);
    printWindow.document.write('</body></html>');
    printWindow.document.close();
    printWindow.print();
}
</script>
<script>
function exportToExcel() {
    // Get the HTML table element
    var table = document.getElementById('printingArea'); // Replace 'tableId' with the ID of your table

    // Convert the HTML table to a worksheet
    var wb = XLSX.utils.table_to_book(table);

    // Generate a binary string from the XLSX workbook
    var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });

    // Create a Blob object representing the data as an Excel file
    var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });

    // Create a temporary anchor element and trigger a download
    var link = document.createElement('a');
    link.href = window.URL.createObjectURL(blob);
    link.download = 'sales_by_item.xlsx'; // Change 'filename' to your desired filename
    link.click();
}

// Utility function to convert a string to an ArrayBuffer
function s2ab(s) {
    var buf = new ArrayBuffer(s.length);
    var view = new Uint8Array(buf);
    for (var i = 0; i < s.length; i++) {
        view[i] = s.charCodeAt(i) & 0xFF;
    }
    return buf;
}
</script>