<?php
    
    $date1 = $_GET['date1'];
    $date2 = $_GET['date2'];
    $branchId = $_GET['branch'] ? $_GET['branch'] : 0 ;
    $account = $_GET['account'];
    $status = 'Sales Invoice';
    $date3 = date('d-m-Y', strtotime($date1));
    $date4 = date('d-m-Y', strtotime($date2));
    
    //-----Get branch name -----
    $branchStmt = $pdo->prepare("SELECT name FROM branch WHERE id = :id");
    $branchStmt->bindParam(':id',$branchId);
    $branchStmt->execute();
    $branchResult = $branchStmt->fetch(PDO::FETCH_ASSOC);
    $branch = $branchResult['name'] ? $branchResult['name'] : 'All';
    
    
    if ($date1 !== $date2) {
        $date_condition = "i.invoice_date BETWEEN '$date1' AND '$date2'";
        $note = "SALES FROM {$date3} TO {$date4}";
    } else {
        $date_condition = "i.invoice_date = '$date1'";
        $note = "SALES FOR DATE: {$date3}";
    }
    
    if ($branch == 'All') {
        
        $invoices = [];
        
        $sql = "SELECT
                    i.invoice_date,
                    c.name,
                    i.invoice_id as invoice_id,
                    i.total_amount,
                    'Sales Invoice' AS type,
                    IFNULL(SUM(td.total), 0) AS total
                FROM
                    invoices AS i
                INNER JOIN
                    ngm_customer AS c ON i.customer_id = c.id
                LEFT JOIN transactions_details td ON i.invoice_id = td.reference
                AND td.category = 'Invoice'   
                WHERE
                    $date_condition
                GROUP BY i.invoice_id
                ORDER BY
                    i.invoice_date ASC";
    
        $stmt = $con->prepare($sql);
        
        $stmt->execute();
        
        $result = $stmt->get_result();
        
        while ($row = $result->fetch_assoc()) {
        $row['status'] = 'INVOICE';    
        $invoices[] = $row;
       }
       
       $sql2 = "SELECT
                    i.invoice_date,
                    c.name,
                    i.sales_cash_id as invoice_id,
                    i.total_amount,
                    'Cash Sales' AS type,
                    IFNULL(SUM(td.total), 0) AS total
                FROM
                    sales_cash AS i
                INNER JOIN
                    ngm_customer AS c ON i.customer_id = c.id
                LEFT JOIN transactions_details td ON i.sales_cash_id = td.reference
                AND td.category = 'Cash'
                WHERE
                    $date_condition
                GROUP BY i.sales_cash_id
                ORDER BY
                    i.invoice_date ASC";
    
        $stmt1 = $con->prepare($sql2);
        
        $stmt1->execute();
        
        $result2 = $stmt1->get_result();
        
        while ($row = $result2->fetch_assoc()) {
        $row['status'] = 'CASH';    
        $invoices[] = $row;
       }

    } 
       else{
        // For a specific branch and subbranch;
              $invoices = [];
        
        $sql = "SELECT
                    i.invoice_date,
                    c.name,
                    i.invoice_id as invoice_id,
                    i.total_amount,
                    'Sales Invoice' AS type,
                    IFNULL(SUM(td.total), 0) AS total
                FROM
                    invoices AS i
                INNER JOIN
                    ngm_customer AS c ON i.customer_id = c.id
                LEFT JOIN transactions_details td ON i.invoice_id = td.reference
                AND td.category = 'Invoice'   
                WHERE
                    $date_condition AND i.branchno = '$branch' AND i.subbranch = '$subbranch'
                GROUP BY i.invoice_id
                ORDER BY
                    i.invoice_date ASC";
    
        $stmt = $con->prepare($sql);
        
        $stmt->execute();
        
        $result = $stmt->get_result();
        
        while ($row = $result->fetch_assoc()) {
        $row['status'] = 'INVOICE';    
        $invoices[] = $row;
       }
       
       $sql2 = "SELECT
                    i.invoice_date,
                    c.name,
                    i.sales_cash_id as invoice_id,
                    i.total_amount,
                    'Cash Sales' AS type,
                    IFNULL(SUM(td.total), 0) AS total
                FROM
                    sales_cash AS i
                INNER JOIN
                    ngm_customer AS c ON i.customer_id = c.id
                LEFT JOIN transactions_details td ON i.sales_cash_id = td.reference
                AND td.category = 'Cash'
                WHERE
                    $date_condition AND i.branchno = '$branch' AND i.subbranch = '$subbranch'
                GROUP BY i.sales_cash_id
                ORDER BY
                    i.invoice_date ASC";
    
        $stmt1 = $con->prepare($sql2);
        
        $stmt1->execute();
        
        $result2 = $stmt1->get_result();
        
        while ($row = $result2->fetch_assoc()) {
        $row['status'] = 'CASH';    
        $invoices[] = $row;
       }
    }
    
?>

<style>
    table {
        border-collapse: collapse;
        border: 1px solid black;
        width: 100%;
    }
    th, td {
        border: 1px solid black;
        padding: 8px;
        text-align: center;
        color: black;
    }
</style>

<div class="col-md-9">
    <!-- START TIMELINE -->
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=sales" style="color: rgb(7, 133, 164)">Services and Revenue Menu</a></li>
                <li class="active">Services Revenue Report</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><b>SERVICES REVENUE REPORT</b></h3>
                    <div class="pull-right">
                        <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                        <button class="btn btn-default" onclick="printTable()">
                            <span class="fa fa-print"></span> Print Report
                        </button>
                        <button class="btn btn-default" onclick="exportToExcel()">
                            <span class="fa fa-print"></span> Export To Excel
                        </button>
                    </div>
                </div>
                <div class="panel-body" style="background: #fff">
                    <div id="printingArea">
                        <table id="myTable">
                            <tr>
                                <th colspan="7"><?php echo $_SESSION['Company']; ?></th>
                            </tr>
                            <tr>
                                <th colspan="7">BRANCH: <?php echo htmlspecialchars($branch ? $branch : 'All' ); ?></th>
                            </tr>
                            <tr>
                                <th colspan="7"><?php echo htmlspecialchars($_GET['description']); ?></th>
                            </tr>
                            <tr>
                                <th colspan="7"><?php echo $note; ?></th>
                            </tr>
                            <tr style="font-weight:bold">
                                <td>DATE</td>
                                <td>CUSTOMER</td>
                                <td>TRANS NO.</td>
                                <td>SALES TYPE.</td>
                                <td>AMOUNT</td>
                                <td>PAID</td>
                                <td>DUE</td>
                            </tr>
                            <?php
                            $total_amount = 0;
                            $total_paid = 0;
                            foreach ($invoices as $rows) {
                                $total_amount += $rows['total_amount'];
                                $total_paid += $rows['total'];
                                $balance = $total_amount - $total_paid;
                            ?>
                            <tr>
                                <td><?php echo date('d-m-Y', strtotime($rows['invoice_date'])); ?></td>
                                <td style="text-align:left"><?php echo htmlspecialchars($rows['name']); ?></td>
                                <td><?php echo $rows['status'];?> - #<?php echo htmlspecialchars($rows['invoice_id']); ?></td>
                                <td><?php echo htmlspecialchars($rows['type']); ?></td>
                                <td><?php echo number_format($rows['total_amount'], 2); ?></td>
                                <td><?php echo number_format($rows['total'], 2); ?></td>
                                <td><?php echo number_format($rows['total_amount'] - $rows['total'], 2); ?></td>
                            </tr>
                            <?php
                            }
                            ?>
                            <tr>
                                <td colspan="4"><b>Total</b></td>
                                <td><b><?php echo number_format($total_amount, 2); ?></b></td>
                                <td><b><?php echo number_format($total_paid, 2); ?></b></td>
                                <td><b><?php echo number_format($balance ? $balance : 0, 2); ?></b></td>
                            </tr>
                        </table>
                    </div>
                </div>
                <div class="panel-footer">
                </div>
            </div>
        </div>
    </div>
    <!-- END TIMELINE -->
</div>

<script>
function printTable() {
    var cells = document.querySelectorAll('td, th');
    cells.forEach(function(cell) {
        cell.style.border = '1px solid black';
    });

    var printWindow = window.open('', '_blank');
    printWindow.document.open();
    printWindow.document.write('<html><head><title>Print Table</title></head><body>');
    printWindow.document.write('<style>table { border-collapse: collapse; width: 100%; } th, td { border: 1px solid black; padding: 8px; }</style>');
    printWindow.document.write(document.getElementById('myTable').outerHTML);
    printWindow.document.write('</body></html>');
    printWindow.document.close();
    printWindow.print();

    cells.forEach(function(cell) {
        cell.style.border = '';
    });
}

function exportToExcel() {
    var table = document.getElementById('printingArea');
    var wb = XLSX.utils.table_to_book(table);
    var wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'binary' });
    var blob = new Blob([s2ab(wbout)], { type: 'application/octet-stream' });
    var link = document.createElement('a');
    link.href = window.URL.createObjectURL(blob);
    link.download = 'sales_revenue_report.xlsx';
    link.click();
}

function s2ab(s) {
    var buf = new ArrayBuffer(s.length);
    var view = new Uint8Array(buf);
    for (var i = 0; i < s.length; i++) {
        view[i] = s.charCodeAt(i) & 0xFF;
    }
    return buf;
}
</script>
