<?php

require_once '../db/db.php';

if(isset($_POST['submit'])) {
    // Escape user inputs to prevent SQL injection
    $business_name = mysqli_real_escape_string($con, $_POST['businessName']);
    $telephone_number = mysqli_real_escape_string($con, $_POST['telephoneNumber']);
    $tin = mysqli_real_escape_string($con, $_POST['tin']);
    $po_box = mysqli_real_escape_string($con, $_POST['poBox']);
    $physical_location = mysqli_real_escape_string($con, $_POST['physicalLocation']);
    $email = mysqli_real_escape_string($con, $_POST['email']);
    $vran = mysqli_real_escape_string($con, $_POST['vran']);
    $footer_description = mysqli_real_escape_string($con, $_POST['footerDescription']);

    // Check if the file input field is not empty
    if (!empty($_FILES["businessLogo"]["name"])) {
        // File upload code
        $target_directory = "../logo/"; // Specify the directory where you want to store uploaded files
        $target_file = $target_directory . basename($_FILES["businessLogo"]["name"]); // Construct the file path
        $uploadOk = 1;
        $imageFileType = strtolower(pathinfo($target_file,PATHINFO_EXTENSION));

        // Check if file already exists
        if (file_exists($target_file)) {
            $err = '<div class="alert alert-danger" role="alert">
                        <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                        <strong>Error!</strong> Sorry, file already exists.
                    </div>';
            $uploadOk = 0;
        }

        // Check file size
        else if ($_FILES["businessLogo"]["size"] > 100000) {
            $err = '<div class="alert alert-warning" role="alert">
                        <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                        <strong>Error!</strong> Sorry, your file is too large.
                    </div>';
            $uploadOk = 0;
        }

        // Allow certain file formats
        else if($imageFileType != "jpg" && $imageFileType != "png" && $imageFileType != "jpeg"
        && $imageFileType != "gif" ) {
            $err = '<div class="alert alert-warning" role="alert">
                        <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                        <strong>Error!</strong> Sorry, only JPG, JPEG, PNG & GIF files are allowed.
                    </div>';
            $uploadOk = 0;
        }

        // Check if $uploadOk is set to 0 by an error
        else if ($uploadOk == 0) {
            $err = '<div class="alert alert-danger" role="alert">
                        <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                        <strong>Error!</strong> Sorry, your file was not uploaded.
                    </div>';
        } else {
            // File upload is successful, continue with database update
        }
    }

    // Check if record with ID 1 exists
    $checkQuery = "SELECT id FROM BusinessInfo WHERE id = 1";
    $checkResult = mysqli_query($con, $checkQuery);
    $existingRecord = mysqli_fetch_assoc($checkResult);

    if ($existingRecord) {
        // Update existing record
        $updateQuery = "UPDATE BusinessInfo SET business_name = '$business_name', telephone_number = '$telephone_number', tin = '$tin', po_box = '$po_box', physical_location = '$physical_location', email = '$email', vran = '$vran', footer_description = '$footer_description'";
        if (!empty($_FILES["businessLogo"]["name"])) {
            // Add file update to the query if a new file is uploaded
            $updateQuery .= ", business_logo = '$target_file'";
        }
        $updateQuery .= " WHERE id = 1";
        $result = mysqli_query($con, $updateQuery);
    } else {
        // Insert new record with ID 1
        $insertQuery = "INSERT INTO BusinessInfo (id, business_name, telephone_number, tin, po_box, physical_location, email, vran, footer_description) VALUES (1, '$business_name', '$telephone_number', '$tin', '$po_box', '$physical_location', '$email', '$vran', '$footer_description')";
        if (!empty($_FILES["businessLogo"]["name"])) {
            // Add file insertion to the query if a file is uploaded
            $insertQuery .= ", business_logo = '$target_file'";
        }
        $result = mysqli_query($con, $insertQuery);
    }

    if($result) {
        if (!empty($_FILES["businessLogo"]["name"])) {
            // Move uploaded file if it exists
            move_uploaded_file($_FILES["businessLogo"]["tmp_name"], $target_file);
        }
        // Display success message or redirect to another page
        $err = '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                    <strong>Well done!</strong> Business Information updated successfully!
                </div>';
    } else {
        // Display error message
        $err = '<div class="alert alert-danger" role="alert">
                    <strong>Error!</strong> Error updating Business Information. Please try again.
                </div>';
    }
}

?>



  <div class="col-md-9">
                            <!-- Start Dashboard for settings -->
                            <div class="row">
                                <div class="col-md-12">
                                    <?php if(isset($err)) { echo $err; } ?>
                                    <div class="panel panel-default">
                                        <div class="panel-heading">
                                            <h3 class="panel-title"><b>Business Details</b></h3>
                                        </div>
                                        <div class="panel-body" style="background: #fff">
                                            <div class="col-md-6">

                                                <form method="post" action="" enctype="multipart/form-data">
                                                    <div class="form-group">
                                                        <label for="businessName">Business Name</label>
                                                        <input type="text" class="form-control" name="businessName" id="businessName" placeholder="Enter business name">
                                                    </div>
                                                   
                                                    <div class="form-group">
                                                        <label for="businessName">Telephone Number</label>
                                                        <input type="text" class="form-control" name="telephoneNumber" id="businessName" placeholder="Enter Telephone Number">
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="businessName">Tax Identification Number (TIN)</label>
                                                        <input type="text" class="form-control" name="tin" id="businessName" placeholder="Enter TIN">
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="businessDescription">P.O.Box</label>
                                                        <textarea class="form-control" id="businessDescription" rows="3" name="poBox" placeholder="Enter P.O.Box"></textarea>
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="businessLogo">Business Logo</label>
                                                        <input type="file" class="form-control-file" name="businessLogo" id="businessLogo">
                                                    </div>
                                        
                                            </div>
                                            <div class="col-md-6">

                                                    <div class="form-group">
                                                        <label for="businessName">Physical Location</label>
                                                        <input type="text" class="form-control" id="businessName" name="physicalLocation" placeholder="Business Physical Location">
                                                    </div>
                                                    
                                                    <div class="form-group">
                                                        <label for="businessName">Email</label>
                                                        <input type="text" class="form-control" name="email" id="businessName" placeholder="Enter business Email">
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="businessName">VAT Registration Number (VRAN)</label>
                                                        <input type="text" class="form-control" name="vran" id="businessName" placeholder="Enter VAT">
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="businessDescription">Footer Description</label>
                                                        <textarea class="form-control" id="businessDescription" name="footerDescription" rows="3" placeholder="Enter VAT"></textarea>
                                                    </div>
                                                    
                                            </div>
                                        </div>
                                </div>
                            </div>
                            <!-- End Dashboard for settings -->
                        </div>
                        <div class="panel-footer">                                    
                            <button class="btn btn-warning pull-right" type="submit" name="submit"><span class="fa fa-plus-circle"></span> Create</button>
                        </div>
                        
                            </form>
                            </div>