<?php
session_start();
include'functions/permisions.php';

function hasPermission($role, $permission) {
    global $pdo;

    
    $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    $stmt = $pdo->prepare("
        SELECT p.permission_name 
        FROM role_permissions rp
        JOIN permissions p ON rp.permission_id = p.id
        WHERE rp.role_id = ?
    ");


    $stmt->execute([$role]);
    $permissions = array_map('trim', $stmt->fetchAll(PDO::FETCH_COLUMN));

    if (in_array($permission, $permissions)) {
        return true;
    } else {
        return false;
    }
}

 
?>


                        <div class="col-md-9">

                            <!-- START TIMELINE -->
                            <div class="row">
                            <div class="col-md-12">

                               <div class="panel panel-default">
                                <div class="panel-heading">
                                    <h3 class="panel-title"><b>SYSTEM USERS</b></h3>
                                    <div class="pull-right">
                                        <a href="index.php?p=new_user"><button class="btn btn-warning"> <span class="fa fa-plus-circle"></span> Create New User</button></a>
                                    </div>
                                </div>
                                <div class="panel-body">
                                    <?php
                                    $q = mysqli_query($con,"SELECT * FROM inv_users WHERE Role < 5 ORDER BY Name ASC");
                                    $num = mysqli_num_rows($q);
                                    if($num == 0){
                                        echo "<p class = 'alert alert-info'>No any record added yet!!!</p>";
                                    }
                                    ?>
                                    <div class="table-responsive">
                                         <table class="table datatable">
                                            <thead>
                                                <tr>
                                                    <th>SN</th>
                                                    <th>Name</th>
                                                    <th>Email</th>
                                                    <th>Phone</th>
                                                    <th>Role</th>
                                                    <th>Action</th>
                                                </tr>
                                            </thead>
                                            <tbody>
                                                <?php
                                                $a = 1;
                                                while($rws = mysqli_fetch_array($q)){
                                          switch ($rws['Role']) {
                                             case '1':
                                               $role = 'Administrator';
                                               break;
                                             case '2':
                                               $role = 'Sales Person';
                                               break;
                                             case '3':
                                               $role = 'Accountant';
                                               break;
                                             case '4':
                                               $role = 'Stock Person';
                                               break;
                                             default:
                                               $role = 'Front Desk';
                                              }
                                                ?>
                                                <tr>
                                                    <td><?php echo $a;?></td>
                                                    <td><?php echo $rws['Name'];?></td>
                                                    <td><?php echo $rws['Email'];?></td>
                                                    <td><?php echo $rws['Phone'];?></td>
                                                    <td><?php echo $role;?></td>
                                                    <td>
                            <?if(hasPermission($_SESSION['role'], 'Edit')):?>
                                        <a href="index.php?p=edit_user&cid=<?php echo $rws['id'];?>"><span class = "fa fa-edit"></span> Activate/Deactivate/Edit</a> |
                                        <?php endif; ?>
                                        <a href="reset_password.php?uid=<?php echo $rws['id'];?>"><span class = "fa fa-trash-o"></span> Reset Password</a> |
                            <?if(hasPermission($_SESSION['role'], 'Delete')):?>
                                        <a onclick="return confirm('Are You Sure You Want To Delete User');" href="delete_user.php?cid=<?php echo $rws['id'];?>"><span class = "fa fa-trash-o"></span> Delete</a>
                                        <?php endif; ?>
                                        </td>
                                                </tr>
                                                <?php
                                                 $a++;
                                                 }
                                                ?>
                                            </tbody>
                                        </table>   
                                    </div>
                                </div>
                            </div>
                          </div>
                        </div>
                            <!-- END TIMELINE -->                            
                            
                        </div>
                        <?php
if ($_GET['status'] === 'deleted') {
    echo "<script>
    document.addEventListener('DOMContentLoaded', function() {
        Swal.fire({
            position: 'top',
            icon: 'success',
            title: ' Deleted Successfully',
            showConfirmButton: false,
            timer: 1500
        }).then(function() {
            location.reload(); 
        }).then(function() {
          window.location.href = 'index.php?p=users'; 
      });
     });
    </script>";
}