<?php
require_once '../db/db.php';

// Retrieve the payment details based on the provided ID
$payment = mysqli_query($con, "SELECT * FROM transactions_details WHERE id='" . mysqli_real_escape_string($con, $_GET['id']) . "' AND category='payment'");
$payment_row = mysqli_fetch_array($payment);

?>
<div class="col-md-9">
    <div class="row">
        <div class="col-md-12">
            <ul class="breadcrumb" style="height: 40px; padding-top: 10px;">
                <li><a href="index.php?p=payments" style="color: rgb(7, 133, 164)">Payments</a></li>
                <li class="active">Payment Details</li>
            </ul>
            <div class="panel panel-default">
                <div class="panel-body">                            
                    <h3>PAYMENT DETAILS</h3>
                    <div class="push-down-10 pull-right">
                        <button class="btn btn-default" onclick="history.back()"> <span class="fa fa-arrow-left"></span> Go Back</button>
                        <a href="../pdf/reports/payment_details.php?id=<?php echo $payment_row['id'];?>" target="_blank">
                            <button class="btn btn-warning"><span class="fa fa-print"></span> Print Document</button>
                        </a>
                    </div>
                    <!-- PAYMENT DETAILS -->
                    <div class="invoice">
                        <div class="row">
                            <div class="col-md-6">
                                <div class="invoice-address">
                                    <h5>Payment To</h5>
                                    <h6><?php echo $payment_row['payee']; ?></h6>
                                    <p><?php echo $payment_row['branch']; ?></p>
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="invoice-address">
                                    <table class="table table-striped">
                                        <tr>
                                            <td width="200">Reference Number:</td><td class="text-right">#<?php echo $payment_row['reference']; ?></td>
                                        </tr>
                                        <tr>
                                            <td>Payment Date:</td><td class="text-right"><?php echo $payment_row['date']; ?></td>
                                        </tr>
                                        <tr>
                                            <td><strong>Total:</strong></td><td class="text-right"><strong><?php echo number_format($payment_row['total'], 2); ?></strong></td>
                                        </tr>
                                    </table>
                                </div>                                        
                            </div>
                        </div>
                        
                        <div class="table-invoice">
                            <table class="table">
                                <tr>
                                    <th>Category</th>
                                    <th class="text-center">Note</th>
                                    <th class="text-center">Attachment</th>
                                </tr>
                                <tr>
                                    <td><?php echo $payment_row['category']; ?></td>
                                    <td class="text-center"><?php echo $payment_row['note']; ?></td>
                                    <td class="text-center">
                                        <?php if($payment_row['attachment']): ?>
                                            <a href="<?php echo $payment_row['attachment']; ?>" target="_blank">View Attachment</a>
                                        <?php else: ?>
                                            No Attachment
                                        <?php endif; ?>
                                    </td>
                                </tr>
                            </table>
                        </div>
                        
                        <div class="row">
                            <div class="col-md-6">
                                <h4>Approved By:</h4>
                            </div>
                            <div class="col-md-6">
                                <h4>Total</h4>
                                
                                <table class="table table-striped">
                                    <tr class="total">
                                        <td>Total Amount:</td><td class="text-right"><?php echo number_format($payment_row['total'], 2); ?></td>
                                    </tr>
                                </table>                                                
                            </div>
                        </div>
                    </div>
                    <!-- END PAYMENT DETAILS -->
                </div>
            </div>
        </div>
    </div>
</div>

<script>
function printTable() {
    var printWindow = window.open('', '_blank');
    printWindow.document.write('<html><head><title>Print Payment Voucher</title>');
    printWindow.document.write('<link rel="stylesheet" type="text/css" href="../css/theme-default.css">');
    printWindow.document.write('</head><body>');
    printWindow.document.write(document.getElementById('printabletable').outerHTML);
    printWindow.document.write('</body></html>');
    printWindow.document.close();
    printWindow.print();
}

function exportToPDF() {
    var pdf = new jsPDF();
    pdf.autoTable({ html: '#printabletable' });
    pdf.save('table_export.pdf');
}
</script>
