<?php
session_start();
require_once '../../db/db.php';

$currentDate = date("Y-m-d");
// Fetch borrowers and their loans
$sql = "SELECT * FROM ngm_customer, invoices WHERE id = customer_id AND due > 0 AND branch = '".$_SESSION['Branch']."' AND category='customer' ORDER BY name";
$result = $con->query($sql);

$html = '<center>
<h4 style="text-align:center;font-size:30px;color:#999">'.$_SESSION['Company'].'</h4>
<h4 style="text-align:center;font-size:24px;color:#999">'.strtoupper($_SESSION['Branch']).'</h4>
<h4 style="text-align:center;font-size:0px;color:#999">CUSTOMER BALANCES REPORT</h4>
<hr>
<table border="1" width="100%" cellspacing="0" cellpadding="0" repeat_header="1">
<thead>
<tr style="height:30px;background:orange;">
<th style="width:15%">Name</th>
<th style="width:10%">InvoiceNo#</th>
<th style="width:10%">Invoice Date</th>
<th style="width:5%">Days</th>
<th style="width:10%">0-30 Days</th>
<th style="width:10%">31-60 Days</th>
<th style="width:10%">61-90 Days</th>
<th style="width:10%">91-120 Days</th>
<th style="width:10%">121-150 Days</th>
<th style="width:10%">151-180 Days</th>
<th style="width:10%">Over 180 Days</th>
<th style="width:10%">Status</th>
</tr>
</thead>';

$total_0_30 = 0;
$total_31_60 = 0;
$total_61_90 = 0;
$total_91_120 = 0;
$total_121_150 = 0;
$total_151_180 = 0;
$total_over_180 = 0;

while ($row = mysqli_fetch_array($result)) {
    $name = $row["name"];
    $invoice = $row["invoice_id"];
    $maturityDate = $row["invoice_date"];
    $daysPastMaturity = floor((strtotime($currentDate) - strtotime($maturityDate)) / (60 * 60 * 24));

    // Fetch outstanding balance based on days past maturity
    $sqlBalance = "SELECT SUM(due) as total_balance FROM invoices WHERE invoice_id = '".$row["invoice_id"]."' AND due > 0";
    $resultBalance = $con->query($sqlBalance);
    $outstandingBalances = $resultBalance->fetch_assoc();
    $balance = $outstandingBalances['total_balance'];

    // Categorize the balance into aging brackets and status
    $agingBracket = '';
    $status = '';
    if ($daysPastMaturity <= 30) {
        $agingBracket = '0-30 Days';
        $status = 'Current (not overdue)';
    } elseif ($daysPastMaturity <= 60) {
        $agingBracket = '31-60 Days';
        $status = 'Slightly overdue';
    } elseif ($daysPastMaturity <= 90) {
        $agingBracket = '61-90 Days';
        $status = 'Moderately overdue';
    } elseif ($daysPastMaturity <= 120) {
        $agingBracket = '91-120 Days';
        $status = 'Significantly overdue';
    } elseif ($daysPastMaturity <= 150) {
        $agingBracket = '121-150 Days';
        $status = 'Seriously overdue';
    } elseif ($daysPastMaturity <= 180) {
        $agingBracket = '151-180 Days';
        $status = 'Critical overdue';
    } else {
        $agingBracket = 'Over 180 Days';
        $status = 'Potential write-off';
    }

    // Increment the totals based on aging brackets
    switch ($agingBracket) {
        case '0-30 Days':
            $total_0_30 += $balance;
            break;
        case '31-60 Days':
            $total_31_60 += $balance;
            break;
        case '61-90 Days':
            $total_61_90 += $balance;
            break;
        case '91-120 Days':
            $total_91_120 += $balance;
            break;
        case '121-150 Days':
            $total_121_150 += $balance;
            break;
        case '151-180 Days':
            $total_151_180 += $balance;
            break;
        case 'Over 180 Days':
            $total_over_180 += $balance;
            break;
    }

    $total_outstanding = $total_0_30 + $total_31_60 + $total_61_90 + $total_91_120 + $total_121_150 + $total_151_180 + $total_over_180;

    $html .= '
    <tbody>
    <tr>
    <td style="padding-left:10px;">'.$name.'</td>
    <td style="padding-left:10px;">'.$invoice.'</td>
    <td style="padding-left:10px;">'.$maturityDate.'</td>
    <td style="padding-left:10px;">'.$daysPastMaturity.'</td>
    <td align="right" style="padding-right:10px;">'.($agingBracket === "0-30 Days" ? number_format($balance, 2) : '').'</td>
    <td align="right" style="padding-right:10px;">'.($agingBracket === "31-60 Days" ? number_format($balance, 2) : '').'</td>
    <td align="right" style="padding-right:10px;">'.($agingBracket === "61-90 Days" ? number_format($balance, 2) : '').'</td>
    <td align="right" style="padding-right:10px;">'.($agingBracket === "91-120 Days" ? number_format($balance, 2) : '').'</td>
    <td align="right" style="padding-right:10px;">'.($agingBracket === "121-150 Days" ? number_format($balance, 2) : '').'</td>
    <td align="right" style="padding-right:10px;">'.($agingBracket === "151-180 Days" ? number_format($balance, 2) : '').'</td>
    <td align="right" style="padding-right:10px;">'.($agingBracket === "Over 180 Days" ? number_format($balance, 2) : '').'</td>
    <td style="padding-left:10px;">'.$status.'</td>
    </tr>';
}

$html .= '
<tr style="background:yellow;">
<td colspan="4" align="left"><b>TOTAL:</b></td>
<td align="right"><b>'.number_format($total_0_30, 2).'</b></td>
<td align="right"><b>'.number_format($total_31_60, 2).'</b></td>
<td align="right"><b>'.number_format($total_61_90, 2).'</b></td>
<td align="right"><b>'.number_format($total_91_120, 2).'</b></td>
<td align="right"><b>'.number_format($total_121_150, 2).'</b></td>
<td align="right"><b>'.number_format($total_151_180, 2).'</b></td>
<td align="right"><b>'.number_format($total_over_180, 2).'</b></td>
<td></td>
</tr>
<tr style="background:green;">
<td colspan="11" align="left"><b>TOTAL BALANCE:</b></td>
<td align="right"><b>'.number_format($total_outstanding, 2).'</b></td>
</tr>
</tbody>';

$html .= '</table>';

include("../mpdf.php");
$mpdf = new mPDF('c', 'A4', '', '', 15, 15, 20, 25, 16, 13);
//$mpdf=new mPDF('c','A3','','',20,20,27,25,16,13); 
$mpdf->setFooter("Page {PAGENO} of {nb}");
$mpdf->SetDisplayMode('fullpage');

// LOAD a stylesheet
$stylesheet = file_get_contents('mpdfstyletables.css');
$mpdf->WriteHTML($stylesheet, 1); // The parameter 1 tells that this is css/style only and no body/html/text

$mpdf->WriteHTML($html);

$mpdf->jSWord = 0; // Proportion (/1) of space (when justifying margins) to allocate to Word vs. Character
$mpdf->jSmaxChar = 0; // Maximum spacing to allocate to character spacing. (0 = no maximum)

$mpdf->Output();
exit;
?>
