<?php
session_start();
require_once '../../db/db.php';
include '../../pages/encode_decode/randomString.php';

// Sanitize input to prevent SQL injection
$idd = $_GET['id'];

$id = decrypt($idd, $encryption_key, $encryption_method);

$selectQuery = "SELECT * FROM BusinessInfo";
$result = mysqli_query($con,$selectQuery);
$row = mysqli_fetch_assoc($result);
$telephone = $row['telephone_number'];
$business = $row['business_name'];
$tin_no = $row['tin'];
$po_box = $row['po_box'];
$vran = $row['vran'];
$footer_description = $row['footer_description'];
$business_logo = $row['business_logo'];
$physical_location = $row['physical_location'];
$email = $row['email'];

$selectQuery = "SELECT * FROM ColorSettings";
$result = mysqli_query($con,$selectQuery);
$row = mysqli_fetch_assoc($result);

$bg_color = $row['bg_color'];
$color = $row['font_color'];

// Check if the ID is valid
if ($id <= 0) {
    echo "Invalid ID";
    exit;
}

$journal = mysqli_query($con, "SELECT * FROM journal WHERE Id=$id");
if (!$journal) {
    // Query execution failed, handle the error
    $error_message = mysqli_error($con);
    echo "Error: " . $error_message;
    exit;
} else {
    // Query executed successfully
    $rows = mysqli_fetch_array($journal);
    // Process the retrieved data
}

$html = '
    <table width="100%">
    <thead>    
        <tr bgcolor="'.$bg_color.'">
            <td colspan=3 style="height:50px;padding-top:15px"><h4 style="color:white;">JOURNAL VOUCHER</h4></td>
        </tr>
        <tr bgcolor="#ffffff">
            <td align="left" style="font-size:16px;font-weight:bold;padding-top:20px;color:black" colspan=2>
                <p>
                    Date <br/>
                    <span style="color:#999;padding-left:30px;">' . $rows['Date'] . '</span> <br/>
                    Reference. <br/>
                    <span style="color:#999;padding-left:30px;">JV #' . $rows['Id'] . '</span> <br/>
                </p>
            </td>
            <td align="right">
            <img src="../'.$business_logo.'" width="150" height="150"><br/>
            '.$_SESSION['Company'].'<br/>
            BRANCH: '.strtoupper($_SESSION['Branch']).'
            </td>
        </tr>
    </thead>';

$html .= '
    <tbody>
        <tr bgcolor="#fff">
            <td><p style="font-size:13px;">' . $rows['Note'] . '</p></td>
        </tr>  
        <tr bgcolor="'.$bg_color.'">
            <td align="left" style="height:50px;padding-top:15px;"><h4 style="color:white">Account</h4></td>
            <td align="right" style="height:50px;padding-top:15px;"><h4 style="color:white">Debit</h4></td>
            <td align="right" style="height:50px;padding-top:15px;"><h4 style="color:white">Credit</h4></td>
        </tr>';

$payment_lines = mysqli_query($con, "SELECT 
        gl.account,gl.nature,gl.amount,cm.account_name,
        CASE WHEN gl.nature = 'Debit' THEN gl.amount ELSE '0' END AS Debit_Amount,
        CASE WHEN gl.nature = 'Credit' THEN gl.amount ELSE '0' END AS Credit_Amount
        FROM gl_transaction as gl INNER JOIN chart_master as cm ON gl.account = cm.account_code
        WHERE gl.transid = $id AND gl.cat = 'Journal'");
if ($payment_lines) {
    $debitTotal=0;
    $creditTotal=0;
    while ($rs = mysqli_fetch_array($payment_lines)) {
        
        $debitTotal+=$rs['Debit_Amount'];
        $creditTotal+=$rs['Credit_Amount'];

        $html .= '
            <tr bgcolor="#fff">
                <td align="left" style="height:30px"><p style="color:#000;font-size:13px">' . $rs['account_name'] . '</p></td>
                <td align="right" style="height:30px"><p style="color:#000;font-size:13px">' . number_format($rs['Debit_Amount'], 2) . '</p></td>
                <td align="right" style="height:30px"><p style="color:#000;font-size:13px">' . number_format($rs['Credit_Amount'], 2) . '</p></td>
            </tr>';
    }
}

$html .= '
    <tr bgcolor="'.$bg_color.'">
            <td align="right" style="color:white;font-size:16px"></td>
            <td align="right" style="color:white;font-size:16px" colspan="1">' . number_format($debitTotal, 2) . '</td>
            <td align="right" style="color:white;font-size:16px" colspan="1">' . number_format($creditTotal, 2) . '</td>
        </tr>
    </tbody>
</table>
<br/>
<table>
 <tr>
    <td>
       Prepared By:<br/><br/>
       Name: <br/>.......................................................<br/><br/>
       Position: <br/>.......................................................<br/><br/>
       Signature: <br/>.......................................................<br/><br/>

    </td>
    <td>
       Reviewed By:<br/><br/>
       Name: <br/>.......................................................<br/><br/>
       Position: <br/>.......................................................<br/><br/>
       Signature: <br/>.......................................................<br/><br/>

    </td>
    <td style="">
       Approved By:<br/><br/>
       Name: <br/>.......................................................<br/><br/>
       Position: <br/>.......................................................<br/><br/>
       Signature: <br/>.......................................................<br/><br/>

    </td>
 </tr>
</table>
';

include("../mpdf.php");

$paid_by_name = strtoupper(preg_replace('/[^A-Za-z0-9 ]/', '', strtoupper($customer_rws['name'])));
$filename = $paid_by_name . ".pdf";

$mpdf = new mPDF('c', 'A4', '', '', 15, 15, 25, 25, 16, 13);
$mpdf->setFooter("Page {PAGENO} of {nb}");
$mpdf->SetDisplayMode('fullpage');

$stylesheet = file_get_contents('mpdfstyletables.css');
$mpdf->WriteHTML($stylesheet, 1);

$mpdf->WriteHTML($html);

$mpdf->Output($filename, 'I');
exit;
?>