<?php
session_start();
require_once '../../db/db.php';

// Function to convert number to words
function convert_number_to_words($number) {
    $words = new NumberFormatter("en", NumberFormatter::SPELLOUT);
    return $words->format($number);
}

// Sanitize input to prevent SQL injection
$id = isset($_GET['id']) ? intval($_GET['id']) : 0;

// Check if the ID is valid
if ($id <= 0) {
    echo "Invalid ID";
    exit;
}

$payment = mysqli_query($con, "SELECT * FROM journal WHERE Id='" . mysqli_real_escape_string($con, $id) . "'");
if (!$payment) {
    // Query execution failed, handle the error
    $error_message = mysqli_error($con);
    echo "Error: " . $error_message;
    exit;
} else {
    // Query executed successfully
    $rows = mysqli_fetch_array($payment);
    // Process the retrieved data
}

$selectQuery = "SELECT * FROM BusinessInfo";
$result = mysqli_query($con, $selectQuery);
$row = mysqli_fetch_assoc($result);
$telephone = $row['telephone_number'];
$business = $row['business_name'];
$tin_no = $row['tin'];
$po_box = $row['po_box'];
$vran = $row['vran'];
$footer_description = $row['footer_description'];
$business_logo = $row['business_logo'];
$physical_location = $row['physical_location'];
$email = $row['email'];

$selectQuery = "SELECT * FROM ColorSettings";
$result = mysqli_query($con, $selectQuery);
$row = mysqli_fetch_assoc($result);

$bg_color = $row['bg_color'];
$color = $row['font_color'];

$gl_stmt = mysqli_query($con,"SELECT 
        gl.account,gl.nature,gl.amount,cm.account_name,
        CASE WHEN gl.nature = 'Debit' THEN gl.amount ELSE '0' END AS Debit_Amount,
        CASE WHEN gl.nature = 'Credit' THEN gl.amount ELSE '0' END AS Credit_Amount
        FROM gl_transaction as gl INNER JOIN chart_master as cm ON gl.account = cm.account_code
        WHERE gl.transid = $id AND gl.cat IN ('Journal','Tax Journal')");
$html = '
<div style="border: 2px solid ' . $bg_color . '; border-radius: 10px; padding: 20px; background-color: #fff;">
    <div style="text-align: center; margin-bottom: 20px;">
        <img src="../' . $business_logo . '" width="200" height="150" style="border-radius: 10px; margin-bottom: 10px;">
        <h4 style="color:#fff; background-color:' . $bg_color . '; padding: 12px; border-radius: 10px; display: inline-block;">JOURNAL ENTRY STATEMENT</h4>
    </div>
    <table width="100%">
    <thead>    
        <tr>
            <td align="left" style="font-size:16px;font-weight:bold;padding-top:20px;color:#2d2860">
                <p>
                    Reference Number: <br/>
                    <span style="color:#000;padding-left:30px;"> JE' . $id . '</span> <br/>
                    Journal entry date: <br/>
                    <span style="color:#000;padding-left:30px;">' . $rows['Date'] . '</span> <br/>
                </p>
            </td>
            <td align="right">
                ' . $_SESSION['Company'] . '<br/>
                BRANCH: ' . strtoupper($_SESSION['Branch']) . '
            </td>
            
        </tr>
    </thead>';

$html .= '
    <tbody>
        <tr>
            <td colspan=2><h4 style="color:black;"><b>Journal Description:</b>' . $rows['Note'] . '</p></td>
        </tr>
        <tr>
        <td colspan=2></td>
        </tr><br>
        <tr style="background-color:#2d2860; height:30px;">
            <td align="left"><h4 style="color:#F3A02A;font-weight:bold;">Account Name</h4></td>
            <td align="left"><h4 style="color:#F3A02A;font-weight:bold;">Account</h4></td>
            <td align="right"><h4 style="color:#F3A02A;font-weight:bold;">Amount</h4></td>
        </tr>';

    $debitTotal=0;
    $creditTotal=0;
if ($gl_stmt) {
    while ($rs = mysqli_fetch_array($gl_stmt)) {
          $debitTotal+=$rs['Debit_Amount'];
          $creditTotal+=$rs['Credit_Amount'];
        $html .= '
       <tr bgcolor="#fff">
            <td align="left" style="height:30px"><p style="color:#000 ;font-size:13px">' . $rs['account_name'] . '</p></td>
            <td align="left" style="height:30px"><p style="color:#000 ;font-size:13px">' . number_format($rs['Debit_Amount'],2) . '</p></td>
            <td align="right" style="height:30px"><p style="color: #000 ;font-size:13px">' . number_format($rs['Credit_Amount'], 2) . '</p></td>
        </tr>';
    }
}

$html .= '
    <tr bgcolor="' . $bg_color . '">
            <td align="left"><p style="color:white; font-size:14px;font-weight:bold">Total</p></td>
            <td style="color:white; font-size:14px;font-weight:bold">' . number_format($debitTotal, 2) . '</td>
            <td style="color:white; font-size:14px;font-weight:bold">' . number_format($creditTotal, 2) . '</td>
        </tr>
    </tbody>
    </table>
    <table>
    <tr>
        <td>
           Prepared By:<br/><br/>
           Name: <br/>.......................................................<br/><br/>
           Position: <br/>.......................................................<br/><br/>
           Signature: <br/>.......................................................<br/><br/>
        </td>
        <td>
           Reviewed By:<br/><br/>
           Name: <br/>.......................................................<br/><br/>
           Position: <br/>.......................................................<br/><br/>
           Signature: <br/>.......................................................<br/><br/>
        </td>
        <td>
           Approved By:<br/><br/>
           Name: <br/>.......................................................<br/><br/>
           Position: <br/>.......................................................<br/><br/>
           Signature: <br/>.......................................................<br/><br/>
        </td>
    </tr>
    </table>
</div>';

include("../mpdf.php");

$mpdf = new mPDF('c', 'A4', '', '', 15, 15, 25, 25, 16, 13);
$mpdf->setFooter("Page {PAGENO} of {nb}");
$mpdf->SetDisplayMode('fullpage');

$stylesheet = file_get_contents('mpdfstyletables.css');
$mpdf->WriteHTML($stylesheet, 1);

$mpdf->WriteHTML($html);

$mpdf->Output();
exit;
?>
