<?php
session_start();
require_once '../../db/db.php';

// Function to convert number to words
function convert_number_to_words($number) {
    $words = new NumberFormatter("en", NumberFormatter::SPELLOUT);
    return $words->format($number);
}

// Sanitize input to prevent SQL injection
$id = isset($_GET['id']) ? intval($_GET['id']) : 0;
$bank = isset($_GET['bank']) ? htmlspecialchars($_GET['bank']) : '';

// Check if the ID is valid
if ($id <= 0) {
    echo "Invalid ID";
    exit;
}

$payment = mysqli_query($con, "SELECT * FROM transactions_details WHERE id='" . mysqli_real_escape_string($con, $id) . "'");
if (!$payment) {
    // Query execution failed, handle the error
    $error_message = mysqli_error($con);
    echo "Error: " . $error_message;
    exit;
} else {
    // Query executed successfully
    $rows = mysqli_fetch_array($payment);
    // Process the retrieved data
}

$selectQuery = "SELECT * FROM BusinessInfo";
$result = mysqli_query($con, $selectQuery);
$row = mysqli_fetch_assoc($result);
$telephone = $row['telephone_number'];
$business = $row['business_name'];
$tin_no = $row['tin'];
$po_box = $row['po_box'];
$vran = $row['vran'];
$footer_description = $row['footer_description'];
$business_logo = $row['business_logo'];
$physical_location = $row['physical_location'];
$email = $row['email'];

$selectQuery = "SELECT * FROM ColorSettings";
$result = mysqli_query($con, $selectQuery);
$row = mysqli_fetch_assoc($result);

$bg_color = $row['bg_color'];
$color = $row['font_color'];

// Fetch the customer's name
$customer_query = mysqli_query($con, "SELECT name FROM ngm_customer WHERE id = '" . $rows['payee'] . "'");
$customer_rws = mysqli_fetch_assoc($customer_query);

$total = 0;
$payment_lines = mysqli_query($con, "SELECT * FROM transactions_details_items WHERE receipt_id = '" . $_GET['id'] . "'");
if ($payment_lines) {
    while ($rs = mysqli_fetch_array($payment_lines)) {
        $chart_master = mysqli_query($con, "SELECT account_name FROM chart_master WHERE account_code = '" . $rs['account'] . "'");
        $row = mysqli_fetch_array($chart_master);
        $total += $rs['amount'];
    }
}

// Convert total amount to words
$total_in_words = ucwords(strtolower((convert_number_to_words($total))));

$html = '
<div style="border: 2px solid ' . $bg_color . '; border-radius: 10px; padding: 20px; background-color: #fff;">
    <div style="text-align: center; margin-bottom: 20px;">
        <img src="../' . $business_logo . '" width="200" height="150" style="border-radius: 10px; margin-bottom: 10px;">
        <h4 style="color:#fff; background-color:' . $bg_color . '; padding: 12px; border-radius: 10px; display: inline-block;">RECEIPT VOUCHER</h4>
    </div>
    <table width="100%">
    <thead>    
        <tr>
            <td align="left" style="font-size:16px;font-weight:bold;padding-top:20px;color:#2d2860">
                <p>
                    Date <br/>
                    <span style="color:#000;padding-left:30px;">' . $rows['date'] . '</span> <br/>
                    Reference <br/>
                    <span style="color:#000;padding-left:30px;">' . $rows['id'] . '</span> <br/>
                    Means of Payment<br/>
                    <span style="color:#000;padding-left:30px;">' . strtoupper($bank) . '</span>
                </p>
            </td>
            <td align="right">
                ' . $_SESSION['Company'] . '<br/>
                BRANCH: ' . strtoupper($_SESSION['Branch']) . '
            </td>
        </tr>
    </thead>';

$html .= '
    <tbody>
        <tr>
            <td colspan=2><p style="font-size:13px;">' . $rows['note'] . '</p></td>
        </tr>  
        <tr bgcolor="' . $bg_color . '">
            <td align="left" style="height:50px;padding-top:15px;"><h4 style="color:white">Account</h4></td>
            <td align="right" style="height:50px;padding-top:15px;"><h4 style="color:white">Amount</h4></td>
        </tr>';

$total = 0;
$payment_lines = mysqli_query($con, "SELECT * FROM transactions_details_items WHERE receipt_id = '" . $_GET['id'] . "'");
if ($payment_lines) {
    while ($rs = mysqli_fetch_array($payment_lines)) {
        $chart_master = mysqli_query($con, "SELECT account_name FROM chart_master WHERE account_code = '" . $rs['account'] . "'");
        $row = mysqli_fetch_array($chart_master);
        $total += $rs['amount'];
        $html .= '
       <tr bgcolor="#fff">
            <td align="left" style="height:30px"><p style="color:#000 ;font-size:13px">' . $row['account_name'] . '</p></td>
            <td align="right" style="height:30px"><p style="color: #000 ;font-size:13px">' . number_format($rs['amount'], 2) . '</p></td>
        </tr>';
    }
}

$html .= '
    <tr bgcolor="' . $bg_color . '">
        <td align="right" style="color:#fff;font-size:16px; font-weight:bold" colspan="2">
            Total ' . (!empty($rows['currency']) ? $rows['currency'] : 'TZS') . ' ' . number_format($total, 2) . '
        </td>
    </tr>
    <tr bgcolor="' . $bg_color . '">
        <td align="right" style="color:#fff;font-size:16px" colspan="2">
            Total in Words: ' . $total_in_words . ' ' . (!empty($rows['currency']) ? $rows['currency'] : 'TZS') . '
        </td>
    </tr>
</tbody>
</table>
<table>
<tr>
    
</tr>
<tr>
    <td>
      <br/>
       <span style="color:#000">Paid By</span>: ' . strtoupper($customer_rws['name']) . '<br/><br/>
    </td>
</tr>
</table>
</div>';


include("../mpdf.php");

$paid_by_name = strtoupper(preg_replace('/[^A-Za-z0-9 ]/', '', strtoupper($customer_rws['name'])));
$filename = $paid_by_name . ".pdf";

$mpdf = new mPDF('c', 'A4', '', '', 15, 15, 25, 25, 16, 13);
$mpdf->setFooter("Page {PAGENO} of {nb}");
$mpdf->SetDisplayMode('fullpage');

$stylesheet = file_get_contents('mpdfstyletables.css');
$mpdf->WriteHTML($stylesheet, 1);

$mpdf->WriteHTML($html);

$mpdf->Output($filename, 'I');
exit;
?>
