<?php
session_start();
require_once '../../db/db.php';

$currentDate = date("Y-m-d");

// Fetch suppliers and their purchases
$sql = "SELECT supplier.name, purchases.purchase_id, purchases.purchase_date, purchases.due 
        FROM supplier, purchases 
        WHERE supplier.id = purchases.supplier_id 
        AND purchases.due > 0 
        AND purchases.branch = '" . $_SESSION['Branch'] . "' 
        ORDER BY supplier.name";
$result = $con->query($sql);

$html = '<center>
        <h4 style="text-align:center;font-size:30px;color:#999">' . $_SESSION['Company'] . '</h4>
        <h4 style="text-align:center;font-size:24px;color:#999">' . strtoupper($_SESSION['Branch']) . '</h4>
        <h4 style="text-align:center;font-size:0px;color:#999">SUPPLIER BALANCES REPORT</h4>
        <hr>
        <table border="1" width="100%" cellspacing="0" cellpadding="0" repeat_header="1">
            <thead>
            <tr style="height:30px;background:orange;">
                <th style="width:15%">Supplier Name</th>
                <th style="width:10%">Purchase No#</th>
                <th style="width:10%">Purchase Date</th>
                <th style="width:5%">Days</th>
                <th style="width:15%">0-30 Days</th>
                <th style="width:15%">31-60 Days</th>
                <th style="width:15%">61-90 Days</th>
                <th style="width:15%">Greater than 91 Days</th>
            </tr>
            </thead>';

$total_0_30 = 0;
$total_31_60 = 0;
$total_61_90 = 0;
$total_greater_91 = 0;
$total_outstanding = 0;

while ($row = mysqli_fetch_array($result)) {
    $supplierName = $row["name"];
    $purchaseNo = $row["purchase_id"];
    $purchaseDate = $row["purchase_date"];
    $daysPastMaturity = floor((strtotime($currentDate) - strtotime($purchaseDate)) / (60 * 60 * 24));

    // Fetch outstanding balance based on days past maturity
    $sql = "SELECT SUM(due) as total_balance FROM purchases WHERE purchase_id = '" . $row["purchase_id"] . "' AND due > 0";
    $resultBalance = $con->query($sql);
    $outstandingBalances = $resultBalance->fetch_assoc();
    $balance = $outstandingBalances['total_balance'];

    // Categorize the balance into aging brackets
    $agingBracket = '';
    if ($daysPastMaturity <= 30) {
        $agingBracket = '0-30 Days';
    } elseif ($daysPastMaturity <= 60) {
        $agingBracket = '31-60 Days';
    } elseif ($daysPastMaturity <= 90) {
        $agingBracket = '61-90 Days';
    } else {
        $agingBracket = '>91 Days';
    }

    // Increment the totals based on aging brackets
    switch ($agingBracket) {
        case '0-30 Days':
            $total_0_30 += $balance;
            break;
        case '31-60 Days':
            $total_31_60 += $balance;
            break;
        case '61-90 Days':
            $total_61_90 += $balance;
            break;
        case '>91 Days':
            $total_greater_91 += $balance;
            break;
    }

    $total_outstanding = $total_0_30 + $total_31_60 + $total_61_90 + $total_greater_91;

    // Output supplier data in the table
    $html .= '
        <tbody>
        <tr>
            <td style="padding-left:10px;">' . $supplierName . '</td>
            <td style="padding-left:10px;">' . $purchaseNo . '</td>
            <td style="padding-left:10px;">' . $purchaseDate . '</td>
            <td style="padding-left:10px;">' . $daysPastMaturity . '</td>
            <td align="right" style="padding-right:10px;">' . ($agingBracket === "0-30 Days" ? number_format($balance, 2) : '') . '</td>
            <td align="right" style="padding-right:10px;">' . ($agingBracket === "31-60 Days" ? number_format($balance, 2) : '') . '</td>
            <td align="right" style="padding-right:10px;">' . ($agingBracket === "61-90 Days" ? number_format($balance, 2) : '') . '</td>
            <td align="right" style="padding-right:10px;">' . ($agingBracket === ">91 Days" ? number_format($balance, 2) : '') . '</td>
        </tr>';
}

$html .= '
        <tr style="background:yellow;">
            <td colspan="4" align="right"><b>TOTAL:</b></td>
            <td align="right"><b>' . number_format($total_0_30, 2) . '</b></td>
            <td align="right"><b>' . number_format($total_31_60, 2) . '</b></td>
            <td align="right"><b>' . number_format($total_61_90, 2) . '</b></td>
            <td align="right"><b>' . number_format($total_greater_91, 2) . '</b></td>
        </tr>
        <tr style="background:green;">
            <td colspan="7" align="right"><b>TOTAL BALANCE:</b></td>
            <td align="right"><b>' . number_format($total_outstanding, 2) . '</b></td>
        </tr>
        </tbody>';

$html .= '</table>';

include("../mpdf.php");
$mpdf = new mPDF('c', 'A4', '', '', 15, 15, 20, 25, 16, 13);
//$mpdf=new mPDF('c','A3','','',20,20,27,25,16,13); 
$mpdf->setFooter("Page {PAGENO} of {nb}");
$mpdf->SetDisplayMode('fullpage');

// LOAD a stylesheet
$stylesheet = file_get_contents('mpdfstyletables.css');
$mpdf->WriteHTML($stylesheet, 1); // The parameter 1 tells that this is css/style only and no body/html/text

$mpdf->WriteHTML($html);

$mpdf->jSWord = 0; // Proportion (/1) of space (when justifying margins) to allocate to Word vs. Character
$mpdf->jSmaxChar = 0; // Maximum spacing to allocate to character spacing. (0 = no maximum)

$mpdf->Output();
exit;
?>
